unit UnitData;

interface

uses
   UnitFunc, UnitFuncCurve, UnitClipping ;

const
   LAYER_MAX_NUM = 256 ;   // Cő吔
   COLOR_MAX_NUM = 256 ;   // F@ő吔
   LTYPE_MAX_NUM =  32 ;   // ő吔
   WIDTH_MAX_NUM =  16 ;   // ő吔
   MFONT_MAX_NUM =1024 ;   // tHgő吔
   HATCH_LINE_MAX = 20000; // nb`Oő吔

type
   TZumenTitle = record       // }ʏb}ʕ\藓
      P_Name : string ;       // Ɩ
      C_Name : string ;       // H
      C_type : string ;       // _敪
      D_title : string ;      // }ʖ
      D_number : string ;     // }ʔԍ
                              // }ʔԍ + $$ + }ʐō\B$$ȍ~̓IvV
      D_type : string ;       // }ʎ
      D_Scale : string ;      // ړx
      D_Year : integer ;      // }ʍ쐬Nij
      D_Month : integer ;     // V     112
      D_Day : integer ;       // V     131
      C_Contractor : string ; // 󒍉Ж
      C_Owner : string ;      // ƎҖ
   end;

   TZumenPaper = record       // }ʍ\bp
      name : string ;         // }ʖ
      typ : integer ;         // pTCY(0:A0, 1:A1, 2:A2, 3:A3, 4:A4, 9:FREE)
      orient : integer;       // c^敪(0:c,1:)
      x : integer ;           // Rp(Pmm)
      y : integer ;           // Rpc(Pmm)
   end;

   TOpeHistory = record       // 엚
      opt : integer ;         // ^Cv 1:ݒǉ 2:ݒ폜 3:`ǉ 4:`폜 5:vfǉ 6:vf폜 7:Ȑvfǉ 8:Ȑvf폜
      opn : integer ;         // ԍ(1-)
      ope : integer ;         // ݒ) 1:C 2:F 3: 4: 5:tHg
                              // `) 1:Ȑ 2:V{}` 3:}`
                              // vf) 0:\Lvf +:􉽗vf -:V{
                              // ) Ȑvfindex 0-
      ord : integer ;         // } xOrdւ̔ԍ
   end;

   TZumenLayer = record       // }ʍ\bC
      exf   : Boolean ;       // ݃tO(True:L@False:)
      no    : integer ;       // Cԍ(1-256)
      name  : string ;        // C
      Lflag : Integer ;       // 0:\ 1:\
      Color : Integer ;       // CF
      Ltype : Integer ;       // C
      Width : Integer ;       // C
      Mfont : Integer ;       // CtHg
      cnt   : Integer ;       // Cvf
      Fcnt  : Integer ;       // }``̃Cvf
   end;

   TZumenColor = record       // }ʍ\bF
      exf   : Boolean ;       // ݃tO(True:L@False:)
      no    : integer ;       // Fԍ(1-256)
      Red   : Integer ;       // ql
      Green : Integer ;       // fl
      Blue  : Integer ;       // al
      cnt   : Integer ;       // Fvf
      Fcnt  : Integer ;       // }``̃Cvf
   end;

   TZumenLtype = record       // }ʍ\b
      exf   : Boolean ;       // ݃tO(True:L@False:)
      no    : integer ;       // ԍ(1-32)
      name  : string ;        // 햼
      Segment : Integer ;     // ZOg `F0,2,4,8,10@[U`F2,4,6,8
      Pitch : array[0..9] of double ;  // esb`
      SpaceMax : double ;     // ]ősb`
      cnt   : Integer ;       // vf
      Fcnt  : Integer ;       // }``̃Cvf
   end;

   TZumenWidth = record       // }ʍ\b
      exf   : Boolean ;       // ݃tO(True:L@False:)
      no    : integer ;       // ԍ(1-16)
      Width : double ;        // 
      cnt   : Integer ;       // vf
      Fcnt  : Integer ;       // }``̃Cvf
   end;

   TZumenFont = record        // }ʍ\btHg
      exf   : Boolean ;       // ݃tO(True:L@False:)
      no    : integer ;       // tHgԍ(1-1024)
      name  : string ;        // tHg
      cnt   : Integer ;       // tHgvf
      Fcnt  : Integer ;       // }``̃Cvf
   end;

   THojoOrder = record        // ⏕f[^}
      DataType : Integer ;    // f[^^Cv (1:_}[J 2: 3:ܐ...)
      DataNo	: Integer ;    // f[^vfNo (0-)
   end;

   THojoTenMarker = record    // Ǝvfb⏕b_}[J
      Layer : Integer ;       // C(1`256)
      start_x : double ;      // zu_wW
      start_y : double ;      // zu_xW
      marker_code : Integer ; // }[JR[h(1: 2: 3:E 4:{ 5: 6: 7:~)
      rotate_angle : double ; // ]p[]
      Scale : double ;        // ړx
   end;

   THojoLine = record         // Ǝvfb⏕b
      Layer : Integer ;       // C(1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      start_x : double ;      // n_wW
      start_y : double ;      // n_xW
      end_x : double ;        // I_wW
      end_y : double ;        // I_xW
   end;

   THojoLines = record        // Ǝvfb⏕bܐ
      Layer : Integer ;       // C(1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      Number : Integer ;      // _
      X : array of double ;   // _wW
      Y : array of double ;   // _xW
   end;

   THojoCircle = record       // Ǝvfb⏕b~
      Layer : Integer ;       // C(1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      sep   : Integer ;       // (3`3600)
      Center_x : double ;     // S_wW
      Center_y : double ;     // S_xW
      Radius : double ;       // a
   end;

   THojoArc = record          // Ǝvfb⏕b~
      Layer : Integer ;       // C(1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      sep   : Integer ;       // (3`3600)
      Center_x : double ;     // S_wW
      Center_y : double ;     // S_xW
      Radius : double ;       // a
      Direction : Integer ;   // @(0:v,1:v)
      start_angle : double ;  // np[]
      end_angle : double ;    // Ip[]
   end;

   THojoEllipse = record      // Ǝvfb⏕bȉ~
      Layer : Integer ;       // C(1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      sep   : Integer ;       // (3`3600)
      Center_x : double ;     // S_wW
      Center_y : double ;     // S_xW
      Radius_x : double ;     // wa
      Radius_y : double ;     // xa
      rotation_angle:double ; // ]p[]
   end;

   THojoEllipseArc = record   // Ǝvfb⏕bȉ~
      Layer : Integer ;       // C(1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      sep   : Integer ;       // (3`3600)
      Center_x : double ;     // S_wW
      Center_y : double ;     // S_xW
      Radius_x : double ;     // wa
      Radius_y : double ;     // xa
      Direction: Integer ;    // @(0:v,1:v)
      rotation_angle:double ; // ]p[]
      start_angle : double ;  // np[]
      end_angle   : double ;  // Ip[]
   end;

   THojoText = record         // Ǝvfb⏕b
      Layer : Integer ;       // C(1`256)
      Font  : Integer ;       // tHg (0:CtHg 1`1024)
      str   : string ;        //    (ő256oCg)
      text_x: double ;        // zu_wW
      text_y: double ;        // zu_xW
      Height: double ;        // ͈͍
      Width : double ;        // ͈͕
      Spc   : double ;        // Ԋu
      Angle : double ;        // ]p[]
      Slant : double ;        // Xgp[]
      b_pnt : Integer ;       // zu_(1:,2:,3:E,4:,5:,6:E,7:,8:,9:E)
      Direct: Integer ;       // oi1:, 2:cj
   end;

   TDataOrder = record        // f[^}
      DataType : Integer ;    // f[^^Cv (1:_}[J 2: 3:ܐ...)
      DataNo	: Integer ;    // f[^vfNo (0-)
   end;

   TDataTenMarker = record    // 􉽗vf^\Lvfb_}[J
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@1`256)
      start_x : double ;      // zu_wW
      start_y : double ;      // zu_xW
      marker_code : Integer ; // }[JR[h(1: 2: 3:E 4:{ 5: 6: 7:~)
      rotate_angle : double ; // ]p[]
      Scale : double ;        // ړx
   end;

   TDataLine = record         // 􉽗vf^\Lvfb
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      start_x : double ;      // n_wW
      start_y : double ;      // n_xW
      end_x : double ;        // I_wW
      end_y : double ;        // I_xW
   end;

   TDataLines = record        // 􉽗vf^\Lvfbܐ
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      Number : Integer ;      // _
      X : array of double ;   // _wW
      Y : array of double ;   // _xW
   end;

   TDataCircle = record       // 􉽗vf^\Lvfb~
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      sep   : Integer ;       // (3`3600)
      Center_x : double ;     // S_wW
      Center_y : double ;     // S_xW
      Radius : double ;       // a
   end;

   TDataArc = record          // 􉽗vf^\Lvfb~
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      sep   : Integer ;       // (3`3600)
      Center_x : double ;     // S_wW
      Center_y : double ;     // S_xW
      Radius : double ;       // a
      Direction : Integer ;   // @(0:v,1:v)
      start_angle : double ;  // np[]
      end_angle : double ;    // Ip[]
   end;

   TDataEllipse = record      // 􉽗vf^\Lvfbȉ~
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      sep   : Integer ;       // (3`3600)
      Center_x : double ;     // S_wW
      Center_y : double ;     // S_xW
      Radius_x : double ;     // wa
      Radius_y : double ;     // xa
      rotation_angle:double ; // ]p[]
   end;

   TDataEllipseArc = record   // 􉽗vf^\Lvfbȉ~
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      sep   : Integer ;       // (3`3600)
      Center_x : double ;     // S_wW
      Center_y : double ;     // S_xW
      Radius_x : double ;     // wa
      Radius_y : double ;     // xa
      Direction: Integer ;    // @(0:v,1:v)
      rotation_angle:double ; // ]p[]
      start_angle : double ;  // np[]
      end_angle   : double ;  // Ip[]
   end;

   TDataText = record         // 􉽗vf^\Lvfb
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F       (0:CF@ 1`256)
      Font  : Integer ;       // tHg (0:CtHg 1`1024)
      str   : string ;        //    (ő256oCg)
      text_x: double ;        // zu_wW
      text_y: double ;        // zu_xW
      Height: double ;        // ͈͍
      Width : double ;        // ͈͕
      Spc   : double ;        // Ԋu
      Angle : double ;        // ]p[]
      Slant : double ;        // Xgp[]
      b_pnt : Integer ;       // zu_(1:,2:,3:E,4:,5:,6:E,7:,8:,9:E)
      Direct: Integer ;       // oi1:, 2:cj
   end;

   TDataBezier = record       // 􉽗vf^\LvfbXvCixWFȐj
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      open_close : Integer ;  // J敪F0: 1:J
      sep : Integer ;         // _ԕ (1`1000)
      Number : Integer ;      // _
      X : array of double ;   // _wW
      Y : array of double ;   // _xW
   end;

   TDataBspline = record      // Ǝb􉽗vf^\LvfbaXvCȐ
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      open_close : Integer ;  // J敪F0: 1:J
      sep : Integer ;         // _ԕ (1`1000)
      Number : Integer ;      // _
      X : array of double ;   // _wW
      Y : array of double ;   // _xW
   end;

   TDataSpline = record       // Ǝb􉽗vf^\LvfbXvCȐ
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      Stype : Integer ;       // Ȑ^Cv (1:CXvC 2:xWF 3:NUBS)
      Aval  : double ;        // CXvĈ`l(0-1 ʏ0.5)
      open_close : Integer ;  // J敪F0: 1:J
      sep : Integer ;         // _ԕ (1`1000)
      Number : Integer ;      // _
      X : array of double ;   // _wW
      Y : array of double ;   // _xW
   end;

   TDataClothoid = record     // 􉽗vf^\LvfbN\ChȐ
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      base_x: double ;        // zu_wW
      base_y: double ;        // zu_xW
      Aval  : double ;        // p[^@N\Cĥ`l (0)
      Direction: Integer ;    // @(0:v,1:v)
      Angle : double ;        // ]p[]
      start_length : double ; // JnȐ (0ȏ)
      end_length : double ;   // IȐ (0ȏ)
      sep : Integer ;         //  (1`10000)
   end;

   TDataArrow = record        // Ǝb􉽗vf^\Lvfb
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@1`256)
      start_x : double ;      // zu_wW
      start_y : double ;      // zu_xW
      arrow_code : Integer ;  // R[h(1:blanked arrow 2:blanked box 3:blanked dot
                              //            4:dimension origin 5:filled box 6:filled arrow
                              //            7:filled dot 8:integral symbol 9:open arrow
                              //            10:slash 11:unfilled arrow)
      rotate_angle : double ; // ]p[]
      Scale : double ;        // ړx
   end;

   TDataImage = record        // Ǝb\Lvfb摜
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Alpha : Integer ;       // At@l(0`255)
      start_x : double ;      // zu_wWi摜_j
      start_y : double ;      // zu_xW
      size_x  : double ;      // wTCY[mm]
      size_y  : double ;      // xTCY[mm]
      Angle   : double ;      // ]p[]
      ImgFileName : string ;  // 摜t@C
   end;

   TDataDocument = record     // Ǝb􉽗vf^\Lvfb
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      str   : string ;        // t
      text_x: double ;        // zu_wW
      text_y: double ;        // zu_xW
      Dpi   : double ;        // sNZ(hbg)mmϊ䗦(W72)
      Width : double ;        // ͔͈͕
      Spc   : double ;        // Ԋu
      Lspc  : double ;        // sԊu
      Angle : double ;        // ͉]p[]
      b_pnt : Integer ;       // zu_(1:,2:,3:E,4:,5:,6:E,7:,8:,9:E)
      Direct: Integer ;       // ͏oi1:, 2:cj
   end;

   TDataTable = record        // Ǝb􉽗vf^\Lvfb\
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      start_x : double ;      // zu_wW
      start_y : double ;      // zu_xW
      b_pnt : Integer ;       // zu_
      Cols  : Integer ;       // 
      Rows  : Integer ;       // s
      FixCols : Integer ;     // Œ
      FixRows : Integer ;     // Œs
      ColWidth : array of double ;  // 
      RowHeight: array of double ;  // s
      Gap   : double ;        // rƕ̊Ԃ̊Ԋu
      line_color : Integer ;  // r̐F@(0:CF@ 1`256)
      line_ltype : Integer ;  // r̐(0:C 1`32)
      line_width : Integer ;  // r̐(0:C 1`16)
      cell_color1: Integer ;  // ZhאF(0:CF@ 1`256)
      flg1  : Integer ;       // Z̓hׂ̗L(0:A1:L)
      cell_color2: Integer ;  // ŒZhאF(0:CF@1`256)
      flg2  : Integer ;       // ŒZ̓hׂ̗L(0:A1:L)
      text_color : Integer ;  // ̐F (0:CF@ 1`256)
      Font  : Integer ;       // tHg (0:CtHg 1`1024)
      Spc   : double ;        // Ԋu
      align : array of Integer ;          // ʒu(1: 2: 3:E)
      str   : TStrGrid ;      //  (ő256oCg)
      calc  : TStrGrid ;      // vZ (ő256oCg)
   end;

   TDataDimLine = record      // \vfb@
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      sun_x1 : double ;       // @n_wW
      sun_y1 : double ;       // @n_xW
      sun_x2 : double ;       // @I_wW
      sun_y2 : double ;       // @I_xW
      flg2   : integer ;      // ⏕P̗LtO(0:A1:L)
      ho1_x0 : double ;       // ⏕P_wW
      ho1_y0 : double ;       // ⏕P_xW
      ho1_x1 : double ;       // ⏕Pn_wW
      ho1_y1 : double ;       // ⏕Pn_xW
      ho1_x2 : double ;       // ⏕PI_wW
      ho1_y2 : double ;       // ⏕PI_xW
      flg3   : integer ;      // ⏕Q̗LtO(0:A1:L)
      ho2_x0 : double ;       // ⏕Q_wW
      ho2_y0 : double ;       // ⏕Q_xW
      ho2_x1 : double ;       // ⏕Qn_wW
      ho2_y1 : double ;       // ⏕Qn_xW
      ho2_x2 : double ;       // ⏕QI_wW
      ho2_y2 : double ;       // ⏕QI_xW
      arr1_code1 : integer ;  // n_R[h(1-11)
      arr1_code2 : integer ;  // n_OR[h(0:Ȃ,1:O,2:)
      arr1_x : double ;       // n_zu_wW
      arr1_y : double ;       // n_zu_xW
      arr1_r : double ;       // n_zu{
      arr2_code1 : integer ;  // I_R[h(1-11)
      arr2_code2 : integer ;  // I_OR[h(0:Ȃ,1:O,2:)
      arr2_x : double ;       // I_zu_wW
      arr2_y : double ;       // I_zu_xW
      arr2_r : double ;       // I_zu{
      flg4   : integer ;      // @l̗LtO(0:A1:L)
      Font   : Integer ;      // tHgR[h (0:CtHg 1`1024)
      str    : string ;       //    (ő256oCg)
      text_x : double ;       // zu_wW
      text_y : double ;       // zu_xW
      Height : double ;       // ͈͍
      Width  : double ;       // ͈͕
      Spc    : double ;       // Ԋu
      Angle  : double ;       // ]p[]
      Slant  : double ;       // Xgp[]
      b_pnt  : Integer ;      // zu_(1:,2:,3:E,4:,5:,6:E,7:,8:,9:E)
      Direct : Integer ;      // oi1:, 2:cj
   end;

   TDataDimArc = record       // \vfbʒ@Epx@
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      sep   : Integer ;       // (3`3600)
      sun_x  : double ;       // @_wW
      sun_y  : double ;       // @_xW
      sun_radius : double ;   // @a
      sun_angle0 : double ;   // @np[]
      sun_angle1 : double ;   // @Ip[]
      flg2   : integer ;      // ⏕P̗LtO(0:A1:L)
      ho1_x0 : double ;       // ⏕P_wW
      ho1_y0 : double ;       // ⏕P_xW
      ho1_x1 : double ;       // ⏕Pn_wW
      ho1_y1 : double ;       // ⏕Pn_xW
      ho1_x2 : double ;       // ⏕PI_wW
      ho1_y2 : double ;       // ⏕PI_xW
      flg3   : integer ;      // ⏕Q̗LtO(0:A1:L)
      ho2_x0 : double ;       // ⏕Q_wW
      ho2_y0 : double ;       // ⏕Q_xW
      ho2_x1 : double ;       // ⏕Qn_wW
      ho2_y1 : double ;       // ⏕Qn_xW
      ho2_x2 : double ;       // ⏕QI_wW
      ho2_y2 : double ;       // ⏕QI_xW
      arr1_code1 : integer ;  // n_R[h(1-11)
      arr1_code2 : integer ;  // n_OR[h(0:Ȃ,1:O,2:)
      arr1_x : double ;       // n_zu_wW
      arr1_y : double ;       // n_zu_xW
      arr1_r : double ;       // n_zu{
      arr2_code1 : integer ;  // I_R[h(1-11)
      arr2_code2 : integer ;  // I_OR[h(0:Ȃ,1:O,2:)
      arr2_x : double ;       // I_zu_wW
      arr2_y : double ;       // I_zu_xW
      arr2_r : double ;       // I_zu{
      flg4   : integer ;      // @l̗LtO(0:A1:L)
      Font   : Integer ;      // tHgR[h (0:CtHg 1`1024)
      str    : string ;       //    (ő256oCg)
      text_x : double ;       // zu_wW
      text_y : double ;       // zu_xW
      Height : double ;       // ͈͍
      Width  : double ;       // ͈͕
      Spc    : double ;       // Ԋu
      Angle  : double ;       // ]p[]
      Slant  : double ;       // Xgp[]
      b_pnt  : Integer ;      // zu_(1:,2:,3:E,4:,5:,6:E,7:,8:,9:E)
      Direct : Integer ;      // oi1:, 2:cj
   end;

   TDataDimRadius = record    // \vfba@
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      sun_x1 : double ;       // @n_wW
      sun_y1 : double ;       // @n_xW
      sun_x2 : double ;       // @I_wW
      sun_y2 : double ;       // @I_xW
      arr_code1 : integer ;   // R[h(1-11)
      arr_code2 : integer ;   // OR[h(0:Ȃ,1:O,2:)
      arr_x : double ;        // zu_wW
      arr_y : double ;        // zu_xW
      arr_r : double ;        // zu{
      flg    : integer ;      // @l̗LtO(0:A1:L)
      Font   : Integer ;      // tHgR[h (0:CtHg 1`1024)
      str    : string ;       //    (ő256oCg)
      text_x : double ;       // zu_wW
      text_y : double ;       // zu_xW
      Height : double ;       // ͈͍
      Width  : double ;       // ͈͕
      Spc    : double ;       // Ԋu
      Angle  : double ;       // ]p[]
      Slant  : double ;       // Xgp[]
      b_pnt  : Integer ;      // zu_(1:,2:,3:E,4:,5:,6:E,7:,8:,9:E)
      Direct : Integer ;      // oi1:, 2:cj
   end;

   TDataDimDiameter = record  // \vfba@
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      sun_x1 : double ;       // @n_wW
      sun_y1 : double ;       // @n_xW
      sun_x2 : double ;       // @I_wW
      sun_y2 : double ;       // @I_xW
      arr1_code1 : integer ;  // n_R[h(1-11)
      arr1_code2 : integer ;  // n_OR[h(0:Ȃ,1:O,2:)
      arr1_x : double ;       // n_zu_wW
      arr1_y : double ;       // n_zu_xW
      arr1_r : double ;       // n_zu{
      arr2_code1 : integer ;  // I_R[h(1-11)
      arr2_code2 : integer ;  // I_OR[h(0:Ȃ,1:O,2:)
      arr2_x : double ;       // I_zu_wW
      arr2_y : double ;       // I_zu_xW
      arr2_r : double ;       // I_zu{
      flg    : integer ;      // @l̗LtO(0:A1:L)
      Font   : Integer ;      // tHgR[h (0:CtHg 1`1024)
      str    : string ;       //    (ő256oCg)
      text_x : double ;       // zu_wW
      text_y : double ;       // zu_xW
      Height : double ;       // ͈͍
      Width  : double ;       // ͈͕
      Spc    : double ;       // Ԋu
      Angle  : double ;       // ]p[]
      Slant  : double ;       // Xgp[]
      b_pnt  : Integer ;      // zu_(1:,2:,3:E,4:,5:,6:E,7:,8:,9:E)
      Direct : Integer ;      // oi1:, 2:cj
   end;

   TDataDimLeader = record    // \vfbo
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      vertex_number :integer; // _ (2`)
      vertex_x : array of double ;  // _wW
      vertex_y : array of double ;  // _xW
      arr_code : integer ;    // R[h(1-11)
      arr_r    : double ;     // zu{
      flg    : integer ;      // @l̗LtO(0:A1:L)
      Font   : Integer ;      // tHgR[h (0:CtHg 1`1024)
      str    : string ;       //    (ő256oCg)
      text_x : double ;       // zu_wW
      text_y : double ;       // zu_xW
      Height : double ;       // ͈͍
      Width  : double ;       // ͈͕
      Spc    : double ;       // Ԋu
      Angle  : double ;       // ]p[]
      Slant  : double ;       // Xgp[]
      b_pnt  : Integer ;      // zu_(1:,2:,3:E,4:,5:,6:E,7:,8:,9:E)
      Direct : Integer ;      // oi1:, 2:cj
   end;

   TDataDimBalloon = record   // \vfbo[
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(1`256)
      Color : Integer ;       // F    (0:CF@ 1`256)
      Ltype : Integer ;       // @(0:C 1`32)
      line_width: Integer ;   // @(0:C 1`16)
      sep   : Integer ;       // (3`3600)
      vertex_number :integer; // _ (2`)
      vertex_x : array of double ;  // _wW
      vertex_y : array of double ;  // _xW
      center_x : double ;     // SwW
      center_y : double ;     // SxW
      Radius : double ;       // a
      arr_code : integer ;    // R[h(1-11)
      arr_r    : double ;     // zu{
      flg    : integer ;      // @l̗LtO(0:A1:L)
      Font   : Integer ;      // tHgR[h (0:CtHg 1`1024)
      str    : string ;       //    (ő256oCg)
      text_x : double ;       // zu_wW
      text_y : double ;       // zu_xW
      Height : double ;       // ͈͍
      Width  : double ;       // ͈͕
      Spc    : double ;       // Ԋu
      Angle  : double ;       // ]p[]
      Slant  : double ;       // Xgp[]
      b_pnt  : Integer ;      // zu_(1:,2:,3:E,4:,5:,6:E,7:,8:,9:E)
      Direct : Integer ;      // oi1:, 2:cj
   end;

   TCompositeCurveDefData = record  // \vfbȐ`̗vff[^
      mOrd  : array of TDataOrder ;       // }
      mOrdN : Integer ;                   // 
      mLns  : array of TDataLines;        // 􉽗vfbܐ
      mLnsN : Integer ;                   // 
      mArc  : array of TDataArc;          // 􉽗vfb~
      mArcN : Integer ;                   // 
      mEAr  : array of TDataEllipseArc;   // 􉽗vfbȉ~
      mEArN : Integer ;                   // 
      mBez  : array of TDataBezier;       // 􉽗vfbXvCxWFȐ
      mBezN : Integer ;                   // 
      mBsp  : array of TDataBspline;      // 􉽗vfbaXvCȐ
      mBspN : Integer ;                   // 
      mSpl  : array of TDataSpline;       // 􉽗vfbXvCȐ
      mSplN : Integer ;                   // 
   end;

   TCompositeCurveDef = record   // \vfbȐ`
      exf   : Boolean ;          // ݃tO(True:L@False:)
      number: Integer ;          // IDԍ (1`)
      Color : Integer ;          // F    (0:CF@ 1`256)
      Ltype : Integer ;          // @(0:C 1`32)
      line_width: Integer ;      // @(0:C 1`16)
      invisibility : integer;    // \^\tO (0:\,1:\)
      cnt   : Integer ;          // QƐ
      datn  : Integer ;          // Ȑ`̗vff[^Index
   end;

   THatchNameDef = record        // `nb`O`
      name : string ;            // nb`O(ő256oCg)
      hatch1_number  : integer ;                // nb`Õp^[(1-4)
      hatch1_color   : array[0..3] of integer ; // nb`O̐FR[h  (0,1-256,-1:C)
      hatch_type     : array[0..3] of integer ; // nb`O̐R[h(0,1-32)
      hatch_line_width:array[0..3] of integer ; // nb`O̐R[h(0,1-16)
      hatch_spacing  : array[0..3] of double ;  // nb`O̊Ԋu
      hatch_angle    : array[0..3] of double ;  // nb`O̊px[]
   end;

   THatchLine = record           // nb`O
      Color : Integer ;          // F    (0:CF@ 1`256)
      Ltype : Integer ;          // @(0:C 1`32)
      line_width: Integer ;      // @(0:C 1`16)
      x1,y1 : double ;           // n_W
      x2,y2 : double ;           // I_W
   end;

   TDataHatch1 = record          // \vfbnb`O(`)
      exf : Boolean ;            // ݃tO(True:L@False:)
      Layer : Integer ;          // C(1`256)
      Color : Integer ;          // nb`O̐F (0:CF 1`256) `nb`O`ŔCӂ̏ꍇɂ̂ݗL
      name : string ;            // nb`O(ő256oCg)
      out_id : Integer ;         // O`̕Ȑ̃tB[`R[h
      Number : Integer ;         // ̕̈搔(0`)
      in_id : array of Integer;  // ̕Ȑ̃tB[`R[h
      hln : integer ;            // nb`O
      hl : array of THatchLine;  // nb`O
   end;

   TDataHatch2 = record          // \vfbnb`O(h)
      exf : Boolean ;            // ݃tO(True:L@False:)
      Layer : Integer ;          // C(1`256)
      Color : Integer ;          // hׂF (0:CF 1`256)
      out_id : Integer ;         // O`̕Ȑ̃tB[`R[h
      Number : Integer ;         // ̕̈搔(0`)
      in_id : array of Integer;  // ̕Ȑ̃tB[`R[h
   end;

   TDataHatch3 = record          // \vfbnb`O([U`)
      exf : Boolean ;            // ݃tO(True:L@False:)
      Layer : Integer ;          // C(1`256)
      hatch1_number  : integer ;                // nb`Õp^[(1-4)
      hatch1_color   : array[0..3] of integer ; // nb`O̐FR[h  (0,1-256,-1:C)
      hatch_type     : array[0..3] of integer ; // nb`O̐R[h(0,1-32)
      hatch_line_width:array[0..3] of integer ; // nb`O̐R[h(0,1-16)
      hatch_start_x  : array[0..3] of double ;  // nb`O̒ʉߓ_wW
      hatch_start_y  : array[0..3] of double ;  // nb`O̒ʉߓ_xW
      hatch_spacing  : array[0..3] of double ;  // nb`O̊Ԋu
      hatch_angle    : array[0..3] of double ;  // nb`O̊px[]
      out_id : Integer ;         // O`̕Ȑ̃tB[`R[h
      Number : Integer ;         // ̕̈搔(0`)
      in_id : array of Integer;  // ̕Ȑ̃tB[`R[h
      hln : integer ;            // nb`O
      hl : array of THatchLine;  // nb`O
   end;

   TDataHatch4 = record          // \vfbnb`O(p^[)
      exf : Boolean ;            // ݃tO(True:L@False:)
      Layer : Integer ;          // C(1`256)
      name : string ;            // `V{ @(ő256oCg)
      hatch_color : Integer ;    // nb`p^[̐F (0:CF 1`256)
      hatch_pattern_x            : double ;  // nb`p^[zuʒuwW
      hatch_pattern_y            : double ;  // nb`p^[zuʒuxW
      hatch_pattern_vector1      : double ;  // nb`p^[̌JԂxNgP̑傫
      hatch_pattern_vector1_angle: double ;  // nb`p^[̌JԂxNgP̊px[]
      hatch_pattern_vector2      : double ;  // nb`p^[̌JԂxNgQ̑傫
      hatch_pattern_vector2_angle: double ;  // nb`p^[̌JԂxNgQ̊px[]
      hatch_pattern_scale_x      : double ;  // nb`p^[Xړx
      hatch_pattern_scale_y      : double ;  // nb`p^[Yړx
      hatch_pattern_angle        : double ;  // nb`p^[̌̊px[]
      out_id : Integer ;         // O`̕Ȑ̃tB[`R[h
      Number : Integer ;         // ̕̈搔(0`)
      in_id : array of Integer;  // ̕Ȑ̃tB[`R[h
      hln : integer ;            // nb`O
      hl : array of THatchLine;  // nb`O
   end;

   TDataHatch5 = record          // Ǝb\vfbnb`O(ߓh)
      exf : Boolean ;            // ݃tO(True:L@False:)
      Layer : Integer ;          // C(1`256)
      Color : Integer ;          // hׂF    (0:CF 1`256)
      Alpha : Integer ;          // hAt@l(0`255)
      out_id : Integer ;         // O`̕Ȑ̃tB[`R[h
      Number : Integer ;         // ̕̈搔(0`)
      in_id : array of Integer;  // ̕Ȑ̃tB[`R[h
   end;

   TDataHatch6 = record          // Ǝb\vfbnb`O(Of[Vh)
      exf : Boolean ;            // ݃tO(True:L@False:)
      Layer : Integer ;          // C(1`256)
      Color1 : Integer ;         // hׂF @ (0:CF 1`256) n_^˓_
      Color2 : Integer ;         // hׂF@@(0:CF 1`256) I_^͑
      Alpha : Integer ;          // hAt@l(0`255)
      Gtype : Integer ;          // Of[V^Cv(0:` 1:~`(˓_S) 2:~`(˓_C))
      Angle : double ;           // `Of[Vpx[]
      housya_x : double ;        // ˓_XW
      housya_y : double ;        // ˓_YW
      out_id : Integer ;         // O`̕Ȑ̃tB[`R[h
      Number : Integer ;         // ̕̈搔(0`)
      in_id : array of Integer;  // ̕Ȑ̃tB[`R[h
   end;

   TDataHatch7 = record          // Ǝb\vfbnb`O(摜h)
      exf : Boolean ;            // ݃tO(True:L@False:)
      Layer : Integer ;          // C(1`256)
      Color : Integer ;          // hׂF (0:CF 1`256)
      ImgFileName : string ;     // 摜t@C
      out_id : Integer ;         // O`̕Ȑ̃tB[`R[h
      Number : Integer ;         // ̕̈搔(0`)
      in_id : array of Integer;  // ̕Ȑ̃tB[`R[h
   end;

   TDataSymbolZukei = record  // \vfbV{}`zu
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(0:`Ȃ 1`256)
      color_flag : Integer ;  // FR[htO(0: 1:L)
      Color : Integer ;       // F    (0:CF@ 1`256)
      name  : string ;        // V{}`
      start_x : double ;      // zuʒuXW
      start_y : double ;      // zuʒuYW
      rotate_angle : double ; // ]p[]
      Scale : double ;        // {
   end;

   TSymbolZukeiDefData = record  // \vfbV{}``̗vff[^
      mOrd  : array of TDataOrder ;       // }
      mOrdN : Integer ;                   // 
      mTen  : array of TDataTenMarker;    // 􉽗vfb_}[J
      mTenN : Integer ;                   // 
      mLin  : array of TDataLine;         // 􉽗vfb
      mLinN : Integer ;                   // 
      mLns  : array of TDataLines;        // 􉽗vfbܐ
      mLnsN : Integer ;                   // 
      mCir  : array of TDataCircle;       // 􉽗vfb~
      mCirN : Integer ;                   // 
      mArc  : array of TDataArc;          // 􉽗vfb~
      mArcN : Integer ;                   // 
      mEll  : array of TDataEllipse;      // 􉽗vfbȉ~
      mEllN : Integer ;                   // 
      mEAr  : array of TDataEllipseArc;   // 􉽗vfbȉ~
      mEArN : Integer ;                   // 
      mTxt  : array of TDataText;         // 􉽗vfb
      mTxtN : Integer ;                   // 
      mBez  : array of TDataBezier;       // 􉽗vfbXvCxWFȐ
      mBezN : Integer ;                   // 
      mBsp  : array of TDataBspline;      // 􉽗vfbaXvCȐ
      mBspN : Integer ;                   // 
      mSpl  : array of TDataSpline;       // 􉽗vfbXvCȐ
      mSplN : Integer ;                   // 
      mClo  : array of TDataClothoid;     // 􉽗vfbN\ChȐ
      mCloN : Integer ;                   // 
      mArw  : array of TDataArrow;        // 􉽗vfb
      mArwN : Integer ;                   // 
      mDoc  : array of TDataDocument;     // 􉽗vfb
      mDocN : Integer ;                   // 
      mTbl  : array of TDataTable ;       // 􉽗vfb\
      mTblN : Integer ;                   // 
      mDLn  : array of TDataDimLine;      // \vfb@
      mDLnN : Integer ;                   // 
      mDAr  : array of TDataDimArc;       // \vfbʒ@
      mDArN : Integer ;                   // 
      mDAn  : array of TDataDimArc;       // \vfbpx@
      mDAnN : Integer ;                   // 
      mDRa  : array of TDataDimRadius;    // \vfba@
      mDRaN : Integer ;                   // 
      mDDi  : array of TDataDimDiameter;  // \vfba@
      mDDiN : Integer ;                   // 
      mDLe  : array of TDataDimLeader;    // \vfbo
      mDLeN : Integer ;                   // 
      mDBa  : array of TDataDimBalloon;   // \vfbo[
      mDBaN : Integer ;                   // 
      mHa1  : array of TDataHatch1;       // \vfbnb`O(`)
      mHa1N : Integer ;                   // 
      mHa2  : array of TDataHatch2;       // \vfbnb`O(h)
      mHa2N : Integer ;                   // 
      mHa3  : array of TDataHatch3;       // \vfbnb`O([U`)
      mHa3N : Integer ;                   // 
      mHa4  : array of TDataHatch4;       // \vfbnb`O(p^[)
      mHa4N : Integer ;                   // 
      mHa5  : array of TDataHatch5;       // \vfbnb`O(ߓh)
      mHa5N : Integer ;                   // 
      mHa6  : array of TDataHatch6;       // \vfbnb`O(Of[Vh)
      mHa6N : Integer ;                   // 
      mHa7  : array of TDataHatch7;       // \vfbnb`O(摜h)
      mHa7N : Integer ;                   // 
   end;

   TSymbolZukeiDef = record   // \vfbV{}``
      exf   : Boolean ;       // ݃tO(True:L@False:)
      name  : string ;        // V{
      cnt   : Integer ;       // zu
      datn  : Integer ;       // V{}``̗vff[^Index
   end;

   TDataFukugoZukei = record  // \vfb}`zu
      exf   : Boolean ;       // ݃tO(True:L@False:)
      Layer : Integer ;       // C(0:`Ȃ 1`256)
      name  : string ;        // }`
      X     : double ;        // zuʒuXW
      Y     : double ;        // zuʒuYW
      Angle : double ;        // ]p[]
      ratio_x : double ;      // Xړx
      ratio_y : double ;      // Yړx
   end;

   TFukugoZukeiDefData = record  // \vfb}``̗vff[^
      hOrd  : array of THojoOrder ;       // ⏕}
      hOrdN : Integer ;                   // 
      hTen  : array of THojoTenMarker;    // ⏕b_}[J
      hTenN : Integer ;                   // 
      hLin  : array of THojoLine;         // ⏕b
      hLinN : Integer ;                   // 
      hLns  : array of THojoLines;        // ⏕bܐ
      hLnsN : Integer ;                   // 
      hCir  : array of THojoCircle;       // ⏕b~
      hCirN : Integer ;                   // 
      hArc  : array of THojoArc;          // ⏕b~
      hArcN : Integer ;                   // 
      hEll  : array of THojoEllipse;      // ⏕bȉ~
      hEllN : Integer ;                   // 
      hEAr  : array of THojoEllipseArc;   // ⏕bȉ~
      hEArN : Integer ;                   // 
      hTxt  : array of THojoText;         // ⏕b
      hTxtN : Integer ;                   // 

      mOrd  : array of TDataOrder ;       // }
      mOrdN : Integer ;                   // 
      mTen  : array of TDataTenMarker;    // 􉽗vfb_}[J
      mTenN : Integer ;                   // 
      mLin  : array of TDataLine;         // 􉽗vfb
      mLinN : Integer ;                   // 
      mLns  : array of TDataLines;        // 􉽗vfbܐ
      mLnsN : Integer ;                   // 
      mCir  : array of TDataCircle;       // 􉽗vfb~
      mCirN : Integer ;                   // 
      mArc  : array of TDataArc;          // 􉽗vfb~
      mArcN : Integer ;                   // 
      mEll  : array of TDataEllipse;      // 􉽗vfbȉ~
      mEllN : Integer ;                   // 
      mEAr  : array of TDataEllipseArc;   // 􉽗vfbȉ~
      mEArN : Integer ;                   // 
      mTxt  : array of TDataText;         // 􉽗vfb
      mTxtN : Integer ;                   // 
      mBez  : array of TDataBezier;       // 􉽗vfbXvCxWFȐ
      mBezN : Integer ;                   // 
      mBsp  : array of TDataBspline;      // 􉽗vfbaXvCȐ
      mBspN : Integer ;                   // 
      mSpl  : array of TDataSpline;       // 􉽗vfbXvCȐ
      mSplN : Integer ;                   // 
      mClo  : array of TDataClothoid;     // 􉽗vfbN\ChȐ
      mCloN : Integer ;                   // 
      mArw  : array of TDataArrow;        // 􉽗vfb
      mArwN : Integer ;                   // 
      mDoc  : array of TDataDocument;     // 􉽗vfb
      mDocN : Integer ;                   // 
      mTbl  : array of TDataTable ;       // 􉽗vfb\
      mTblN : Integer ;                   // 
      mDLn  : array of TDataDimLine;      // \vfb@
      mDLnN : Integer ;                   // 
      mDAr  : array of TDataDimArc;       // \vfbʒ@
      mDArN : Integer ;                   // 
      mDAn  : array of TDataDimArc;       // \vfbpx@
      mDAnN : Integer ;                   // 
      mDRa  : array of TDataDimRadius;    // \vfba@
      mDRaN : Integer ;                   // 
      mDDi  : array of TDataDimDiameter;  // \vfba@
      mDDiN : Integer ;                   // 
      mDLe  : array of TDataDimLeader;    // \vfbo
      mDLeN : Integer ;                   // 
      mDBa  : array of TDataDimBalloon;   // \vfbo[
      mDBaN : Integer ;                   // 
      mHa1  : array of TDataHatch1;       // \vfbnb`O(`)
      mHa1N : Integer ;                   // 
      mHa2  : array of TDataHatch2;       // \vfbnb`O(h)
      mHa2N : Integer ;                   // 
      mHa3  : array of TDataHatch3;       // \vfbnb`O([U`)
      mHa3N : Integer ;                   // 
      mHa4  : array of TDataHatch4;       // \vfbnb`O(p^[)
      mHa4N : Integer ;                   // 
      mHa5  : array of TDataHatch5;       // \vfbnb`O(ߓh)
      mHa5N : Integer ;                   // 
      mHa6  : array of TDataHatch6;       // \vfbnb`O(Of[Vh)
      mHa6N : Integer ;                   // 
      mHa7  : array of TDataHatch7;       // \vfbnb`O(摜h)
      mHa7N : Integer ;                   // 
      mSzk  : array of TDataSymbolZukei;  // \vfbV{}`zu
      mSzkN : Integer ;                   // 
      mFzk  : array of TDataFukugoZukei;  // \vfb}`zu
      mFzkN : Integer ;                   // 
   end;

   TFukugoZukeiDef = record   // \vfb}``
      exf   : Boolean ;       // ݃tO(True:L@False:)
      name  : string ;        // }`
      Flag  : Integer ;       // ʃtO(1:}(wWn)A2: }(nWn)
                              //            3:}O[vA4:}i)
      cnt   : Integer ;       // zu
      datn  : Integer ;       // }``̗vff[^Index
   end;

   TAttributeData = record    // 
      name  : string ;        // 
      value : string ;        // l
      atype : string ;        // ^Cv
      aunit : string ;        // P
   end;

   TAttibuteList = record     // Xg
      zid   : integer ;       // }`ʔԍ
      Number: Integer ;       // ̐
      att   : array of TAttributeData ;   // 
   end;

   TFukugoZukeiTree = record  // }`c[\
      name  : string ;        // }`
      level : integer ;       // Kwx(0:Root=p(̃f[^ɂ͊܂܂Ȃ) 1`)
      par   : integer ;       // eNo
      mtx   : TMatrix ;       // ϊs
   end;

   TWorkHatchArea = record    // Ɨpbnb`Öp
      an : integer ;
      a  : array of TPointD ;
   end;
   TWorkHatchCrossP = record  // Ɨpbnb`O_vZp
      x , y : double ;
      dir : integer ;
   end;

   TDataClass = class
   public
      { Public 錾 }
      BackColor : Integer ;               // wiF
      PwakColor : Integer ;               // pgF
      HojoColor : Integer ;               // ⏕Fԍ

      zt : TZumenTitle;                   // }ʏb}ʕ\藓
      zp : TZumenPaper;                   // }ʍ\bp
      zLay : array of TZumenLayer;        // }ʍ\bC
      zLayN,zLayMax : Integer ;           // C
      zCol : array of TZumenColor;        // }ʍ\bF
      zColN,zColMax : Integer ;           // F
      zLtp : array of TZumenLtype;        // }ʍ\b
      zLtpN,zLtpMax : Integer ;           // 퐔
      zWid : array of TZumenWidth;        // }ʍ\b
      zWidN,zWidMax : Integer ;           // 
      zFnt : array of TZumenFont;         // }ʍ\btHg
      zFntN,zFntMax : Integer ;           // tHg

      hOrd  : array of THojoOrder ;       // ⏕}
      hOrdN : Integer ;                   // 
      hTen  : array of THojoTenMarker;    // ⏕b_}[J
      hTenN : Integer ;                   // 
      hLin  : array of THojoLine;         // ⏕b
      hLinN : Integer ;                   // 
      hLns  : array of THojoLines;        // ⏕bܐ
      hLnsN : Integer ;                   // 
      hCir  : array of THojoCircle;       // ⏕b~
      hCirN : Integer ;                   // 
      hArc  : array of THojoArc;          // ⏕b~
      hArcN : Integer ;                   // 
      hEll  : array of THojoEllipse;      // ⏕bȉ~
      hEllN : Integer ;                   // 
      hEAr  : array of THojoEllipseArc;   // ⏕bȉ~
      hEArN : Integer ;                   // 
      hTxt  : array of THojoText;         // ⏕b
      hTxtN : Integer ;                   // 

      OpeHistory : array of TOpeHistory ; // 엚
      OpeHistoryN, OpeNumber, OpeUndoN : integer ;

      dOrd  : array of TDataOrder ;       // }
      dOrdN : Integer ;                   // 
      dTen : array of TDataTenMarker;     // \Lvfb_}[J
      dTenN: Integer ;                    // 
      dLin : array of TDataLine;          // \Lvfb
      dLinN: Integer ;                    // 
      dLns : array of TDataLines;         // \Lvfbܐ
      dLnsN: Integer ;                    // 
      dCir : array of TDataCircle;        // \Lvfb~
      dCirN: Integer ;                    // 
      dArc : array of TDataArc;           // \Lvfb~
      dArcN: Integer ;                    // 
      dEll  : array of TDataEllipse;      // \Lvfbȉ~
      dEllN : Integer ;                   // 
      dEAr  : array of TDataEllipseArc;   // \Lvfbȉ~
      dEArN : Integer ;                   // 
      dTxt  : array of TDataText;         // \Lvfb
      dTxtN : Integer ;                   // 
      dBez  : array of TDataBezier;       // \LvfbXvCxWFȐ
      dBezN : Integer ;                   // 
      dBsp  : array of TDataBspline;      // \LvfbaXvCȐ
      dBspN : Integer ;                   // 
      dSpl  : array of TDataSpline;       // \LvfbXvCȐ
      dSplN : Integer ;                   // 
      dClo  : array of TDataClothoid;     // \LvfbN\ChȐ
      dCloN : Integer ;                   // 
      dArw  : array of TDataArrow;        // \Lvfb
      dArwN : Integer ;                   // 
      dImg  : array of TDataImage;        // \Lvfb摜
      dImgN : Integer ;                   // 
      dDoc  : array of TDataDocument;     // \Lvfb
      dDocN : Integer ;                   // 
      dTbl  : array of TDataTable ;       // \Lvfb\
      dTblN : Integer ;                   // 
      dDLn  : array of TDataDimLine;      // \vfb@
      dDLnN : Integer ;                   // 
      dDAr  : array of TDataDimArc;       // \vfbʒ@
      dDArN : Integer ;                   // 
      dDAn  : array of TDataDimArc;       // \vfbpx@
      dDAnN : Integer ;                   // 
      dDRa  : array of TDataDimRadius;    // \vfba@
      dDRaN : Integer ;                   // 
      dDDi  : array of TDataDimDiameter;  // \vfba@
      dDDiN : Integer ;                   // 
      dDLe  : array of TDataDimLeader;    // \vfbo
      dDLeN : Integer ;                   // 
      dDBa  : array of TDataDimBalloon;   // \vfbo[
      dDBaN : Integer ;                   // 
      dHa1  : array of TDataHatch1;       // \vfbnb`O(`)
      dHa1N : Integer ;                   // 
      dHa2  : array of TDataHatch2;       // \vfbnb`O(h)
      dHa2N : Integer ;                   // 
      dHa3  : array of TDataHatch3;       // \vfbnb`O([U`)
      dHa3N : Integer ;                   // 
      dHa4  : array of TDataHatch4;       // \vfbnb`O(p^[)
      dHa4N : Integer ;                   // 
      dHa5  : array of TDataHatch5;       // \vfbnb`O(ߓh)
      dHa5N : Integer ;                   // 
      dHa6  : array of TDataHatch6;       // \vfbnb`O(Of[Vh)
      dHa6N : Integer ;                   // 
      dHa7  : array of TDataHatch7;       // \vfbnb`O(摜h)
      dHa7N : Integer ;                   // 
      dSzk  : array of TDataSymbolZukei;        // \vfbV{}`zu
      dSzkN : Integer ;                         // 
      sDef  : array of TSymbolZukeiDef;         // \vfbV{}``
      sDefN : Integer ;                         // 
      sDefD : array of TSymbolZukeiDefData;     // \vfbV{}``̗vff[^
      sDefDN: Integer ;                         // 
      cDef  : array of TCompositeCurveDef;      // \vfbȐ`
      cDefN : Integer ;                         // 
      cDefD : array of TCompositeCurveDefData;  // \vfbȐ`̗vff[^
      cDefDN: Integer ;                         // 
      dFzk  : array of TDataFukugoZukei;        // \vfb}`zu
      dFzkN : Integer ;                         // 
      fDef  : array of TFukugoZukeiDef;         // \vfb}``
      fDefN : Integer ;                         // 
      fDefD : array of TFukugoZukeiDefData;     // \vfb}``̗vff[^
      fDefDN: Integer ;                         // 
      zAtt  : array of TAttibuteList ;    // Xg
      zAttN : Integer ;                   // 
      zFzt  : array of TFukugoZukeiTree;  // }`c[\
      zFztN : Integer ;                   // 
      hDef  : array of THatchNameDef ;    // `nb`O`
      hDefN : Integer ;                   // 
      zHAr  : array of TWorkHatchArea ;   // Ɨpbnb`Ö
      zHArN : Integer ;
      zHCp  : array of TPointD ;           // Ɨpbnb`O_Q
      zHCpN : Integer ;
      zHLn  : array of THatchLine ;        // Ɨpbnb`OQ
      zHLnN : Integer ;
      constructor Create;
      destructor Free;
      procedure DataClear ;
      procedure DataClearZukei ;
      procedure DataClearZukeiMember(i:integer) ;
      procedure DataClearCCurveMember(i:integer) ;
      procedure DataClearSymbol ;
      procedure DataClearSymbolMember(i:integer) ;
      procedure DataClearHAr ;
      procedure DataClearHLn ;
      procedure DataClearAttribute ;
      procedure DataInit;
      procedure DataInitSymbol ;
      procedure DataInitHatchName ;
      function  StrBytes(s:string) : integer;
      function  StrCheck(s:string) : Boolean;
      procedure PaperSet(t,o,x,y:integer);
      function  OpAdd(tp,et,en:integer) : Boolean ;
      function  CheckOpUndo : Boolean ;
      function  CheckOpRedo : Boolean ;
      procedure OpUndo ;
      procedure OpRedo ;
      procedure OpNext ;
      function  GetLayerNum : Integer;
      function  GetLayerIdx(n:integer) : Integer;
      function  LayerNameCheck(n:integer;s:string) : Integer;
      function  LayerNameIdx(n:integer;s:string) : Integer;
      function  AddLayer(n:integer;s:string;fla,col,ltp,wid,fnt,cn1,cn2:integer) : Boolean;
      function  DelLayer(n:integer) : Boolean;
      function  GetLayer(n:integer;var s:string;var fla,col,ltp,wid,fnt,cn1,cn2:integer) : Boolean;
      function  EditLayer(n:integer;s:string;fla,col,ltp,wid,fnt:integer) : Boolean;
      function  GetColorNum : Integer;
      function  GetColorIdx(n:integer) : Integer;
      function  AddColor(n,r,g,b,cn1,cn2:integer) : Boolean;
      function  DelColor(n:integer) : Boolean;
      function  GetColor(n:integer;var r,g,b,cn1,cn2:integer) : Boolean;
      function  EditColor(n:integer;r,g,b:integer) : Boolean;
      function  GetLtypeNum : Integer;
      function  GetLtypeIdx(n:integer) : Integer;
      function  LtypeNameCheck(n:integer;s:string) : Integer;
      function  LtypeNameIdx(n:integer;s:string) : Integer;
      function  AddLtype(n:integer;s:string;seg:integer;pit:array of double;cn1,cn2:integer) : Boolean;
      function  DelLtype(n:integer) : Boolean;
      function  GetLtype(n:integer;var s:string;var seg:integer;var pit:array of double;var cn1,cn2:integer) : Boolean;
      function  EditLtype(n:integer;s:string;seg:integer;pit:array of double) : Boolean;
      function  GetWidthNum : Integer;
      function  GetWidthIdx(n:integer) : Integer;
      function  AddWidth(n:integer;w:double;cn1,cn2:integer) : Boolean;
      function  DelWidth(n:integer) : Boolean;
      function  GetWidth(n:integer;var w:double;var cn1,cn2:integer) : Boolean;
      function  EditWidth(n:integer;w:double) : Boolean;
      function  GetFontNum : Integer;
      function  GetFontIdx(n:integer) : Integer;
      function  FontNameCheck(n:integer;s:string) : Integer;
      function  AddFont(n:integer;s:string;cn1,cn2:integer) : Boolean;
      function  DelFont(n:integer) : Boolean;
      function  GetFont(n:integer;var s:string;var cn1,cn2:integer) : Boolean;
      function  EditFont(n:integer;s:string) : Boolean;
      function  FZukeiNameCheck(n:integer;s:string) : Integer;
      function  AddFZukeiDef(s:string;f:integer) : Boolean;
      function  DelFZukeiDef(n:integer) : Boolean;
      function  GetFZukeiDef(n:integer;var ex:Boolean;var s:string;var f,cn,dn:integer) : Boolean;
      function  EditFZukeiDef(n:integer;s:string;f,cn,dn:integer) : Boolean;
      function  AddDataFZukei(s:string;lay:integer;nam:string;px,py,an,sx,sy:double) : Boolean;
      function  GetDataFZukei(s:string;n:integer;var ex:Boolean;var lay:integer;var nam:string;var px,py,an,sx,sy:double) : Boolean;
      function  EditDataFZukei(s:string;n:integer;lay:integer;nam:string;px,py,an,sx,sy:double) : Boolean;
      procedure MakeFZukeiTree ;
      function  AddSymbolDef(s:string) : Boolean;
      function  DelSymbolDef(n:integer) : Boolean;
      function  GetSymbolDef(n:integer;var ex:Boolean;var s:string;var cn,dn:integer) : Boolean;
      function  EditSymbolDef(n:integer;s:string;cn,dn:integer) : Boolean;
      function  AddDataSZukei(s:string;lay,cf,col:integer;nam:string;px,py,an,sc:double) : Boolean;
      function  GetDataSZukei(s:string;n:integer;var ex:Boolean;var lay,cf,col:integer;var nam:string;var px,py,an,sc:double) : Boolean;
      function  EditDataSZukei(s:string;n:integer;lay,cf,col:integer;nam:string;px,py,an,sc:double) : Boolean;
      function  HatchNameCheck(s:string) : Integer;
      function  AddHatchNameDef(s:string;num:integer;col,ltp,wid:array of integer;sp,an:array of double) : Boolean ;
      function  AddHojoOrder(m,tp,no:integer) : Boolean;
      function  AddHojoTen(s:string;lay,mc:integer;px,py,an,sc:double) : Boolean;
      function  AddHojoLine(s:string;lay,ltp,wid:integer;x1,y1,x2,y2:double) : Boolean;
      function  AddHojoLines(s:string;lay,ltp,wid,num:integer;vx,vy:array of double) : Boolean;
      function  AddHojoCircle(s:string;lay,ltp,wid,sp:integer;cx,cy,cr:double) : Boolean;
      function  AddHojoArc(s:string;lay,ltp,wid,sp,dir:integer;cx,cy,cr,sa,ea:double) : Boolean;
      function  AddHojoEllipse(s:string;lay,ltp,wid,sp:integer;cx,cy,rx,ry,ra:double) : Boolean;
      function  AddHojoEllipseArc(s:string;lay,ltp,wid,sp,dir:integer;cx,cy,rx,ry,ra,sa,ea:double) : Boolean;
      function  AddHojoText(s,st:string;lay,fnt,bp,dir:integer;px,py,ph,pw,ps,an,sl:double) : Boolean;
      procedure DelHojoPrev(s:string) ;   overload ;
      procedure DelHojoPrev(m:integer) ;  overload ;
      procedure DelHojoAll ;              overload ;
      procedure DelHojoAll(s:string) ;    overload ;
      procedure DelHojoAll(m:integer) ;   overload ;
      function  AddDataOrder(m,tp,no:integer) : Boolean;
      function  AddDataTen(s:string;lay,col,mc:integer;px,py,an,sc:double) : Boolean;
      function  AddDataLine(s:string;lay,col,ltp,wid:integer;x1,y1,x2,y2:double) : Boolean;
      function  AddDataLines(s:string;lay,col,ltp,wid,num:integer;vx,vy:array of double) : Boolean;
      function  AddDataCircle(s:string;lay,col,ltp,wid,sp:integer;cx,cy,cr:double) : Boolean;
      function  AddDataArc(s:string;lay,col,ltp,wid,sp,dir:integer;cx,cy,cr,sa,ea:double) : Boolean;
      function  AddDataEllipse(s:string;lay,col,ltp,wid,sp:integer;cx,cy,rx,ry,ra:double) : Boolean;
      function  AddDataEllipseArc(s:string;lay,col,ltp,wid,sp,dir:integer;cx,cy,rx,ry,ra,sa,ea:double) : Boolean;
      function  AddDataText(s,st:string;lay,col,fnt,bp,dir:integer;px,py,ph,pw,ps,an,sl:double) : Boolean;
      function  AddDataBezier(s:string;lay,col,ltp,wid,sp,num:integer;vx,vy:array of double) : Boolean;
      function  AddDataBspline(s:string;lay,col,ltp,wid,sp,num:integer;vx,vy:array of double) : Boolean;
      function  AddDataSpline(s:string;lay,col,ltp,wid,stp,sp,num:integer;av:double;vx,vy:array of double) : Boolean;
      function  AddDataClothoid(s:string;lay,col,ltp,wid,dir,sp:integer;bx,by,av,an,l1,l2:double) : Boolean;
      function  AddDataArrow(s:string;lay,col,ac:integer;px,py,an,sc:double) : Boolean;
      function  AddDataImage(fn:string;lay,al:integer;px,py,sx,sy,an:double) : Boolean;
      function  AddDataDocument(s,st:string;lay,bp,dir:integer;px,py,pd,pw,ps,pl,an:double) : Boolean;
      function  AddDataTable(s:string;lay,bp,co1,ro1,co2,ro2,lco,llt,lwd,cc1,fl1,cc2,fl2,tco,fnt:integer; px,py,pg,ps:double;cw,rh:array of double;al:array of Integer; st,ca:TStrGrid) : Boolean;
      function  AddDataDimLine(s,st:string;lay,col,ltp,wid,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx1,sy1,sx2,sy2, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
      function  AddDataDimArc(s,st:string;lay,col,ltp,wid,sp,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx,sy,sr,sa0,sa1, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
      function  AddDataDimAngle(s,st:string;lay,col,ltp,wid,sp,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx,sy,sr,sa0,sa1, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
      function  AddDataDimRadius(s,st:string;lay,col,ltp,wid,fl,ar1,ar2,fnt,bp,dir:integer;sx1,sy1,sx2,sy2, arx,ary,arr, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
      function  AddDataDimDiameter(s,st:string;lay,col,ltp,wid,fl,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx1,sy1,sx2,sy2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
      function  AddDataDimLeader(s,st:string;lay,col,ltp,wid,fl,num,ar,fnt,bp,dir:integer;vx,vy:array of double;arr, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
      function  AddDataDimBalloon(s,st:string;lay,col,ltp,wid,sp,fl,num,ar,fnt,bp,dir:integer;vx,vy:array of double;cx,cy,cr,arr, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
      function  AddDataHatch1(s,st:string;lay,col,oid,num:integer;iid:array of integer) : Boolean ;
      function  AddDataHatch2(s:string;lay,col,oid,num:integer;iid:array of integer) : Boolean ;
      function  AddDataHatch3(s:string;lay,hnum:integer;hcol,hltp,hwid:array of integer;hx,hy,hs,ha:array of double;oid,num:integer;iid:array of integer) : Boolean ;
      function  AddDataHatch4(s,st:string;lay,col:integer;px,py,pv1,pv1a,pv2,pv2a,psx,psy,pa:double; oid,num:integer;iid:array of integer) : Boolean ;
      function  AddDataHatch5(s:string;lay,col,al,oid,num:integer;iid:array of integer) : Boolean ;
      function  AddDataHatch6(s:string;lay,col1,col2,al,gtp:integer;an,hx,hy:double;oid,num:integer;iid:array of integer) : Boolean ;
      function  AddDataHatch7(s,fn:string;lay,col,oid,num:integer;iid:array of integer) : Boolean ;
      procedure DelDataNo(s:string;o1,o2:integer) ;   overload ;
      procedure DelDataNo(m,o1,o2:integer) ;          overload ;
      procedure DelDataPrev(s:string) ;               overload ;
      procedure DelDataPrev(m:integer) ;              overload ;
      procedure DelDataAll ;                          overload ;
      procedure DelDataAll(s:string) ;                overload ;
      procedure DelDataAll(m:integer) ;               overload ;
      function  GetDataTen(s:string;n:integer;var ex:Boolean;var lay,col,mc:integer;var px,py,an,sc:double) : Boolean;
      function  GetDataLine(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid:integer;var x1,y1,x2,y2:double) : Boolean;
      function  GetDataLines(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,num:integer;var vx,vy:array of double) : Boolean;
      function  GetDataCircle(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,sp:integer;var cx,cy,cr:double) : Boolean;
      function  GetDataArc(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,sp,dir:integer;var cx,cy,cr,sa,ea:double) : Boolean;
      function  GetDataEllipse(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,sp:integer;var cx,cy,rx,ry,ra:double) : Boolean;
      function  GetDataEllipseArc(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,sp,dir:integer;var cx,cy,rx,ry,ra,sa,ea:double) : Boolean;
      function  GetDataText(s:string;n:integer;var ex:Boolean;var lay,col,fnt,bp,dir:integer;var px,py,ph,pw,ps,an,sl:double;var st:string) : Boolean;
      function  GetDataBezier(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,oc,sp,num:integer;var vx,vy:array of double) : Boolean;
      function  GetDataBspline(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,oc,sp,num:integer;var vx,vy:array of double) : Boolean;
      function  GetDataSpline(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,stp,oc,sp,num:integer;var av:double;var vx,vy:array of double) : Boolean;
      function  GetDataClothoid(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,dir,sp:integer;var bx,by,av,an,l1,l2:double) : Boolean;
      function  GetDataArrow(s:string;n:integer;var ex:Boolean;var lay,col,ac:integer;var px,py,an,sc:double) : Boolean;
      function  GetDataImage(n:integer;fn:string;var ex:Boolean;var lay,al:integer;var px,py,sx,sy,an:double) : Boolean;
      function  GetDataDocument(s:string;n:integer;var ex:Boolean;var lay,bp,dir:integer;var px,py,pd,pw,ps,pl,an:double;var st:string) : Boolean;
      function  GetDataTable(s:string;n:integer;var ex:Boolean;var lay,bp,co1,ro1,co2,ro2,lco,llt,lwd,cc1,fl1,cc2,fl2,tco,fnt:integer;var px,py,pg,ps:double;var cw,rh:array of double;var al:array of Integer;var st,ca:TStrGrid) : Boolean;
      function  GetDataDimLine(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;var sx1,sy1,sx2,sy2, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double;var st:string) : Boolean ;
      function  GetDataDimArc(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,sp,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;var sx,sy,sr,sa0,sa1, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double;var st:string) : Boolean ;
      function  GetDataDimAngle(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,sp,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;var sx,sy,sr,sa0,sa1, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double;var st:string) : Boolean ;
      function  GetDataDimRadius(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,fl,ar1,ar2,fnt,bp,dir:integer;var sx1,sy1,sx2,sy2, arx,ary,arr, tx,ty,th,tw,ts,an,sl:double;var st:string) : Boolean ;
      function  GetDataDimDiameter(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,fl,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;var sx1,sy1,sx2,sy2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double;var st:string) : Boolean ;
      function  GetDataDimLeader(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,fl,num,ar,fnt,bp,dir:integer;var vx,vy:array of double;var arr, tx,ty,th,tw,ts,an,sl:double;var st:string) : Boolean ;
      function  GetDataDimBalloon(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,sp,fl,num,ar,fnt,bp,dir:integer;var vx,vy:array of double;var cx,cy,cr,arr, tx,ty,th,tw,ts,an,sl:double;var st:string) : Boolean ;
      function  GetDataHatch1(s:string;n:integer;var ex:Boolean;var lay,col,oid,num:integer;var iid:array of integer;var st:string) : Boolean ;
      function  GetDataHatch2(s:string;n:integer;var ex:Boolean;var lay,col,oid,num:integer;var iid:array of integer) : Boolean ;
      function  GetDataHatch3(s:string;n:integer;var ex:Boolean;var lay,hnum:integer;var hcol,hltp,hwid:array of integer;var hx,hy,hs,ha:array of double;var oid,num:integer;var iid:array of integer) : Boolean ;
      function  GetDataHatch4(s:string;n:integer;var ex:Boolean;var lay,col:integer;var px,py,pv1,pv1a,pv2,pv2a,psx,psy,pa:double;var oid,num:integer;var iid:array of integer;var st:string) : Boolean ;
      function  GetDataHatch5(s:string;n:integer;var ex:Boolean;var lay,col,al,oid,num:integer;var iid:array of integer) : Boolean ;
      function  GetDataHatch6(s:string;n:integer;var ex:Boolean;var lay,col1,col2,al,gtp:integer;var an,hx,hy:double;var oid,num:integer;var iid:array of integer) : Boolean ;
      function  GetDataHatch7(s:string;n:integer;var ex:Boolean;var lay,col,oid,num:integer;var iid:array of integer;var fn:string) : Boolean ;
      function  EditDataTen(s:string;n:integer;lay,col,mc:integer;px,py,an,sc:double) : Boolean;
      function  EditDataLine(s:string;n:integer;lay,col,ltp,wid:integer;x1,y1,x2,y2:double) : Boolean;
      function  EditDataLines(s:string;n:integer;lay,col,ltp,wid,num:integer;vx,vy:array of double) : Boolean;
      function  EditDataCircle(s:string;n:integer;lay,col,ltp,wid,sp:integer;cx,cy,cr:double) : Boolean;
      function  EditDataArc(s:string;n:integer;lay,col,ltp,wid,sp,dir:integer;cx,cy,cr,sa,ea:double) : Boolean;
      function  EditDataEllipse(s:string;n:integer;lay,col,ltp,wid,sp:integer;cx,cy,rx,ry,ra:double) : Boolean;
      function  EditDataEllipseArc(s:string;n:integer;lay,col,ltp,wid,sp,dir:integer;cx,cy,rx,ry,ra,sa,ea:double) : Boolean;
      function  EditDataText(s,st:string;n:integer;lay,col,fnt,bp,dir:integer;px,py,ph,pw,ps,an,sl:double) : Boolean;
      function  EditDataBezier(s:string;n:integer;lay,col,ltp,wid,sp,num:integer;vx,vy:array of double) : Boolean;
      function  EditDataBspline(s:string;n:integer;lay,col,ltp,wid,sp,num:integer;vx,vy:array of double) : Boolean;
      function  EditDataSpline(s:string;n:integer;lay,col,ltp,wid,stp,sp,num:integer;av:double;vx,vy:array of double) : Boolean;
      function  EditDataClothoid(s:string;n:integer;lay,col,ltp,wid,dir,sp:integer;bx,by,av,an,l1,l2:double) : Boolean;
      function  EditDataArrow(s:string;n:integer;lay,col,ac:integer;px,py,an,sc:double) : Boolean;
      function  EditDataImage(n:integer;fn:string;lay,al:integer;px,py,sx,sy,an:double) : Boolean;
      function  EditDataDocument(s,st:string;n:integer;lay,bp,dir:integer;px,py,pd,pw,ps,pl,an:double) : Boolean;
      function  EditDataTable(s:string;n:integer;lay,bp,co1,ro1,co2,ro2,lco,llt,lwd,cc1,fl1,cc2,fl2,tco,fnt:integer; px,py,pg,ps:double;cw,rh:array of double;al:array of Integer; st,ca:TStrGrid) : Boolean;
      function  EditDataDimLine(s,st:string;n:integer;lay,col,ltp,wid,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx1,sy1,sx2,sy2, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
      function  EditDataDimArc(s,st:string;n:integer;lay,col,ltp,wid,sp,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx,sy,sr,sa0,sa1, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
      function  EditDataDimAngle(s,st:string;n:integer;lay,col,ltp,wid,sp,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx,sy,sr,sa0,sa1, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
      function  EditDataDimRadius(s,st:string;n:integer;lay,col,ltp,wid,fl,ar1,ar2,fnt,bp,dir:integer;sx1,sy1,sx2,sy2, arx,ary,arr, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
      function  EditDataDimDiameter(s,st:string;n:integer;lay,col,ltp,wid,fl,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx1,sy1,sx2,sy2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
      function  EditDataDimLeader(s,st:string;n:integer;lay,col,ltp,wid,fl,num,ar,fnt,bp,dir:integer;vx,vy:array of double;arr, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
      function  EditDataDimBalloon(s,st:string;n:integer;lay,col,ltp,wid,sp,fl,num,ar,fnt,bp,dir:integer;vx,vy:array of double;cx,cy,cr,arr, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
      function  EditDataHatch1(s,st:string;n:integer;lay,col,oid,num:integer;iid:array of integer) : Boolean ;
      function  EditDataHatch2(s:string;n:integer;lay,col,oid,num:integer;iid:array of integer) : Boolean ;
      function  EditDataHatch3(s:string;n:integer;lay,hnum:integer;hcol,hltp,hwid:array of integer;hx,hy,hs,ha:array of double;oid,num:integer;iid:array of integer) : Boolean ;
      function  EditDataHatch4(s,st:string;n:integer;lay,col:integer;px,py,pv1,pv1a,pv2,pv2a,psx,psy,pa:double; oid,num:integer;iid:array of integer) : Boolean ;
      function  EditDataHatch5(s:string;n:integer;lay,col,al,oid,num:integer;iid:array of integer) : Boolean ;
      function  EditDataHatch6(s:string;n:integer;lay,col1,col2,al,gtp:integer;an,hx,hy:double;oid,num:integer;iid:array of integer) : Boolean ;
      function  EditDataHatch7(s,fn:string;n:integer;lay,col,oid,num:integer;iid:array of integer) : Boolean ;
      function  AddDataAttribute(id:integer;na,va,tp,un:string) : Boolean ;
      function  AttrZukeiIDcheck(id:integer) : integer ;
      function  AddCCurveDef(id,col,ltp,wid,inv:integer) : Boolean;
      function  DelCCurveDef(n:integer) : Boolean;
      function  GetCCurveDef(n:integer;var ex:Boolean;var id,col,ltp,wid,inv,cn,dn:integer) : Boolean;
      function  EditCCurveDef(n,id,col,ltp,wid,inv,cn,dn:integer) : Boolean;
      function  AddCCrvDataOrder(idn,tp,no:integer) : Boolean;
      function  AddCCrvDataLines(id,num:integer;vx,vy:array of double) : Boolean;
      function  AddCCrvDataArc(id,sp,dir:integer;cx,cy,cr,sa,ea:double) : Boolean;
      function  AddCCrvDataEllipseArc(id,sp,dir:integer;cx,cy,rx,ry,ra,sa,ea:double) : Boolean;
      function  AddCCrvDataBezier(id,sp,num:integer;vx,vy:array of double) : Boolean;
      function  AddCCrvDataBspline(id,sp,num:integer;vx,vy:array of double) : Boolean;
      function  AddCCrvDataSpline(id,stp,sp,num:integer;av:double;vx,vy:array of double) : Boolean;
      procedure DelCCrvDataId(id,o1,o2:integer) ;
      procedure DelCCrvDataNo(n,o1,o2:integer) ;
      function  GetCCrvDataLines(id,n:integer;var ex:Boolean;var num:integer;var vx,vy:array of double) : Boolean;
      function  GetCCrvDataArc(id,n:integer;var ex:Boolean;var sp,dir:integer;var cx,cy,cr,sa,ea:double) : Boolean;
      function  GetCCrvDataEllipseArc(id,n:integer;var ex:Boolean;var sp,dir:integer;var cx,cy,rx,ry,ra,sa,ea:double) : Boolean;
      function  GetCCrvDataBezier(id,n:integer;var ex:Boolean;var oc,sp,num:integer;var vx,vy:array of double) : Boolean;
      function  GetCCrvDataBspline(id,n:integer;var ex:Boolean;var oc,sp,num:integer;var vx,vy:array of double) : Boolean;
      function  GetCCrvDataSpline(id,n:integer;var ex:Boolean;var stp,oc,sp,num:integer;var av:double;var vx,vy:array of double) : Boolean;
      function  EditCCrvDataLines(id,n,num:integer;vx,vy:array of double) : Boolean;
      function  EditCCrvDataArc(id,n,sp,dir:integer;cx,cy,cr,sa,ea:double) : Boolean;
      function  EditCCrvDataEllipseArc(id,n,sp,dir:integer;cx,cy,rx,ry,ra,sa,ea:double) : Boolean;
      function  EditCCrvDataBezier(id,n,sp,num:integer;vx,vy:array of double) : Boolean;
      function  EditCCrvDataBspline(id,n,sp,num:integer;vx,vy:array of double) : Boolean;
      function  EditCCrvDataSpline(id,n,stp,sp,num:integer;av:double;vx,vy:array of double) : Boolean;
      function  CCrvIDCheck(id:integer) : integer ;   overload ;
      function  CCrvIDCheck(n,id:integer) : integer ; overload ;
      function  CCrvDataCheck(id:integer) : Boolean ;
      function  CCrvDataToHAr(id,no:integer) : Boolean ;
      function  HArDataSelfIntersectCheck(no:integer) : Boolean ;
      function  HArDataOverlapCheck1 : Boolean ;
      function  HArDataOverlapCheck2 : Boolean ;
      function  CalcHatch1Point(px,py,pl,pa:double) : integer ;
      function  CalcHatch1Line(x1,y1,x2,y2,px,py,pa:double) : integer ;
      procedure MakeHatch1(s:string) ;
      procedure MakeHatch3(hnum:integer;hcol,hltp,hwid:array of integer;hx,hy,hs,ha:array of double) ;
      procedure MakeHatch4(n,col:integer; px,py,pv1,pv1a,pv2,pv2a,psx,psy,pa:double) ;
   private
      { Private 錾 }
      function  OpUndoRedoSub : Boolean ;
      procedure MakeFZukeiTreeSub(no,lv,pa:integer) ;
      procedure AddLayerCnt(lay,col,ltp,wid,fnt:integer);
      procedure AddLayerFCnt(lay,col,ltp,wid,fnt:integer);
      function  CheckHatchSub_CCrv_HAr(oid,num:integer;iid:array of integer) : Boolean ;
      procedure MakeHatch4sub(col,ltp,wid:integer; lx1,ly1,lx2,ly2, wx1,wy1,wx2,wy2, pv1,pv1an,pv2,pv2an,py1,py2:double) ;
   end;

implementation

// 
constructor TDataClass.Create;
begin
   DataInit ;
   DataInitSymbol ;
   DataInitHatchName ;
end;

// 
destructor TDataClass.Free;
begin
   DataClear ;
end;

// 
procedure TDataClass.DataClear;
begin
   zLay  := nil;
   zLayN := 0;    zLayMax := 0;
   zCol  := nil;
   zColN := 0;    zColMax := 0;
   zLtp  := nil;
   zLtpN := 0;    zLtpMax := 0;
   zWid  := nil;
   zWidN := 0;    zWidMax := 0;
   zFnt  := nil;
   zFntN := 0;    zFntMax := 0;
   DataClearZukei ;
   DataClearSymbol ;
   hDef  := nil;
   hDefN := 0;
end;

//   }`f[^̂
procedure TDataClass.DataClearZukei ;
var
   i : integer ;
begin
   // ⏕f[^
   hOrd  := nil;
   hOrdN := 0;
   hTen  := nil;
   hTenN := 0;
   hLin  := nil;
   hLinN := 0;
   for i:=0 to hLnsN-1 do begin
      with hLns[i] do begin
         X := nil;
         Y := nil;
      end;
   end;
   hLns  := nil;
   hLnsN := 0;
   hCir  := nil;
   hCirN := 0;
   hArc  := nil;
   hArcN := 0;
   hEll  := nil;
   hEllN := 0;
   hEAr  := nil;
   hEArN := 0;
   hTxt  := nil;
   hTxtN := 0;

   // 엚
   OpeHistory  := nil ;
   OpeHistoryN := 0 ;
   OpeNumber   := 0 ;
   OpeUndoN    := 0 ;

   // \Lvff[^
   dOrd  := nil;
   dOrdN := 0;
   dTen  := nil;
   dTenN := 0;
   dLin  := nil;
   dLinN := 0;
   for i:=0 to dLnsN-1 do begin
      with dLns[i] do begin
         X := nil;
         Y := nil;
      end;
   end;
   dLns  := nil;
   dLnsN := 0;
   dCir  := nil;
   dCirN := 0;
   dArc  := nil;
   dArcN := 0;
   dEll  := nil;
   dEllN := 0;
   dEAr  := nil;
   dEArN := 0;
   dTxt  := nil;
   dTxtN := 0;
   for i:=0 to dBezN-1 do begin
      with dBez[i] do begin
         X := nil;
         Y := nil;
      end;
   end;
   dBez  := nil;
   dBezN := 0;
   for i:=0 to dBspN-1 do begin
      with dBsp[i] do begin
         X := nil;
         Y := nil;
      end;
   end;
   dBsp  := nil;
   dBspN := 0;
   for i:=0 to dSplN-1 do begin
      with dSpl[i] do begin
         X := nil;
         Y := nil;
      end;
   end;
   dSpl  := nil;
   dSplN := 0;
   dClo  := nil;
   dCloN := 0;
   dArw  := nil;
   dArwN := 0;
   dImg  := nil;
   dImgN := 0;
   dDoc  := nil;
   dDocN := 0;
   for i:=0 to dTblN-1 do begin
      with dTbl[i] do begin
         ColWidth := nil;
         RowHeight:= nil;
         align    := nil;
         str      := nil;
         calc     := nil;
      end;
   end;
   dTbl  := nil;
   dTblN := 0;
   dDLn  := nil;
   dDLnN := 0;
   dDAr  := nil;
   dDArN := 0;
   dDAn  := nil;
   dDAnN := 0;
   dDRa  := nil;
   dDRaN := 0;
   dDDi  := nil;
   dDDiN := 0;
   for i:=0 to dDLeN-1 do begin
      with dDLe[i] do begin
         vertex_x := nil;
         vertex_y := nil;
      end;
   end;
   dDLe  := nil;
   dDLeN := 0;
   for i:=0 to dDBaN-1 do begin
      with dDBa[i] do begin
         vertex_x := nil;
         vertex_y := nil;
      end;
   end;
   dDBa  := nil;
   dDBaN := 0;
   for i:=0 to dHa1N-1 do begin
      with dHa1[i] do begin
         in_id := nil;
         hl    := nil;
      end;
   end;
   dHa1  := nil;
   dHa1N := 0;
   for i:=0 to dHa2N-1 do begin
      with dHa2[i] do begin
         in_id := nil;
      end;
   end;
   dHa2  := nil;
   dHa2N := 0;
   for i:=0 to dHa3N-1 do begin
      with dHa3[i] do begin
         in_id := nil;
         hl    := nil;
      end;
   end;
   dHa3  := nil;
   dHa3N := 0;
   for i:=0 to dHa4N-1 do begin
      with dHa4[i] do begin
         in_id := nil;
         hl    := nil;
      end;
   end;
   dHa4  := nil;
   dHa4N := 0;
   for i:=0 to dHa5N-1 do begin
      with dHa5[i] do begin
         in_id := nil;
      end;
   end;
   dHa5  := nil;
   dHa5N := 0;
   for i:=0 to dHa6N-1 do begin
      with dHa6[i] do begin
         in_id := nil;
      end;
   end;
   dHa6  := nil;
   dHa6N := 0;
   for i:=0 to dHa7N-1 do begin
      with dHa7[i] do begin
         in_id := nil;
      end;
   end;
   dHa7  := nil;
   dHa7N := 0;
   dSzk  := nil;
   dSzkN := 0;
   dFzk  := nil;
   dFzkN := 0;
   // }`
   for i:=0 to fDefDN-1 do begin
      DataClearZukeiMember(i) ;
   end;
   fDefD := nil;
   fDefDN:= 0;
   fDef  := nil;
   fDefN := 0;
   zFzt  := nil;
   zFztN := 0;
   // Ȑ
   for i:=0 to cDefDN-1 do begin
      DataClearCCurveMember(i) ;
   end;
   cDefD := nil;
   cDefDN:= 0;
   cDef  := nil;
   cDefN := 0;
   // EƗp
   DataClearAttribute ;
   DataClearHAr ;
   DataClearHLn ;
   zHCp  := nil ;
   zHCpN := 0 ;
end;

//  }`o
procedure TDataClass.DataClearZukeiMember(i:integer) ;
var
   j : integer ;
begin
   with fDefD[i] do begin
      hOrdN := 0; hOrd := nil;
      hTenN := 0; hTen := nil;
      hLinN := 0; hLin := nil;
      for j:=0 to hLnsN-1 do begin
         with hLns[j] do begin
            X := nil;
            Y := nil;
         end;
      end;
      hLnsN := 0; hLns := nil;
      hCirN := 0; hCir := nil;
      hArcN := 0; hArc := nil;
      hEllN := 0; hEll := nil;
      hEArN := 0; hEAr := nil;
      hTxtN := 0; hTxt := nil;

      mOrdN := 0; mOrd := nil;
      mTenN := 0; mTen := nil;
      mLinN := 0; mLin := nil;
      for j:=0 to mLnsN-1 do begin
         with mLns[j] do begin
            X := nil;
            Y := nil;
         end;
      end;
      mLnsN := 0; mLns := nil;
      mCirN := 0; mCir := nil;
      mArcN := 0; mArc := nil;
      mEllN := 0; mEll := nil;
      mEArN := 0; mEAr := nil;
      mTxtN := 0; mTxt := nil;
      for j:=0 to mBezN-1 do begin
         with mBez[j] do begin
            X := nil;
            Y := nil;
         end;
      end;
      mBezN := 0; mBez := nil;
      for j:=0 to mBspN-1 do begin
         with mBsp[j] do begin
            X := nil;
            Y := nil;
         end;
      end;
      mBspN := 0; mBsp := nil;
      for j:=0 to mSplN-1 do begin
         with mSpl[j] do begin
            X := nil;
            Y := nil;
         end;
      end;
      mSplN := 0; mSpl := nil;
      mCloN := 0; mClo := nil;
      mArwN := 0; mArw := nil;
      mDocN := 0; mDoc := nil;
      for j:=0 to mTblN-1 do begin
         with mTbl[j] do begin
            ColWidth := nil;
            RowHeight:= nil;
            align    := nil;
            str      := nil;
            calc     := nil;
         end;
      end;
      mTblN := 0; mTbl := nil;
      mDLnN := 0; mDLn := nil;
      mDArN := 0; mDAr := nil;
      mDAnN := 0; mDAn := nil;
      mDRaN := 0; mDRa := nil;
      mDDiN := 0; mDDi := nil;
      for j:=0 to mDLeN-1 do begin
         with mDLe[j] do begin
            vertex_x := nil;
            vertex_y := nil;
         end;
      end;
      mDLeN := 0; mDLe := nil;
      for j:=0 to mDBaN-1 do begin
         with mDBa[j] do begin
            vertex_x := nil;
            vertex_y := nil;
         end;
      end;
      mDBaN := 0; mDBa := nil;
      for j:=0 to mHa1N-1 do begin
         with mHa1[j] do begin
            in_id := nil;
            hl    := nil;
         end;
      end;
      mHa1N := 0; mHa1 := nil;
      for j:=0 to mHa2N-1 do begin
         with mHa2[j] do begin
            in_id := nil;
         end;
      end;
      mHa2N := 0; mHa2 := nil;
      for j:=0 to mHa3N-1 do begin
         with mHa3[j] do begin
            in_id := nil;
            hl    := nil;
         end;
      end;
      mHa3N := 0; mHa3 := nil;
      for j:=0 to mHa4N-1 do begin
         with mHa4[j] do begin
            in_id := nil;
            hl    := nil;
         end;
      end;
      mHa4N := 0; mHa4 := nil;
      for j:=0 to mHa5N-1 do begin
         with mHa5[j] do begin
            in_id := nil;
         end;
      end;
      mHa5N := 0; mHa5 := nil;
      for j:=0 to mHa6N-1 do begin
         with mHa6[j] do begin
            in_id := nil;
         end;
      end;
      mHa6N := 0; mHa6 := nil;
      for j:=0 to mHa7N-1 do begin
         with mHa7[j] do begin
            in_id := nil;
         end;
      end;
      mHa7N := 0; mHa7 := nil;
      mSzkN := 0; mSzk := nil;
      mFzkN := 0; mFzk := nil;
   end;
end;

//  Ȑo
procedure TDataClass.DataClearCCurveMember(i:integer) ;
var
   j : integer ;
begin
   with cDefD[i] do begin
      mOrdN := 0; mOrd := nil;
      mLnsN := 0; mLns := nil;
      mArcN := 0; mArc := nil;
      mEArN := 0; mEAr := nil;
      for j:=0 to mBezN-1 do begin
         with mBez[j] do begin
            X := nil;
            Y := nil;
         end;
      end;
      mBezN := 0; mBez := nil;
      for j:=0 to mBspN-1 do begin
         with mBsp[j] do begin
            X := nil;
            Y := nil;
         end;
      end;
      mBspN := 0; mBsp := nil;
      for j:=0 to mSplN-1 do begin
         with mSpl[j] do begin
            X := nil;
            Y := nil;
         end;
      end;
      mSplN := 0; mSpl := nil;
   end;
end;

//   V{`f[^̂
procedure TDataClass.DataClearSymbol ;
var
   i : integer ;
begin
   for i:=0 to sDefDN-1 do begin
      DataClearSymbolMember(i) ;
   end;
   sDefD := nil;
   sDefDN:= 0;
   sDef  := nil;
   sDefN := 0;
end;

//   V{`f[^o
procedure TDataClass.DataClearSymbolMember(i:integer) ;
var
   j : integer ;
begin
   with sDefD[i] do begin
      mOrdN := 0; mOrd := nil;
      mTenN := 0; mTen := nil;
      mLinN := 0; mLin := nil;
      for j:=0 to mLnsN-1 do begin
         with mLns[j] do begin
            X := nil;
            Y := nil;
         end;
      end;
      mLnsN := 0; mLns := nil;
      mCirN := 0; mCir := nil;
      mArcN := 0; mArc := nil;
      mEllN := 0; mEll := nil;
      mEArN := 0; mEAr := nil;
      mTxtN := 0; mTxt := nil;
      for j:=0 to mBezN-1 do begin
         with mBez[j] do begin
            X := nil;
            Y := nil;
         end;
      end;
      mBezN := 0; mBez := nil;
      for j:=0 to mBspN-1 do begin
         with mBsp[j] do begin
            X := nil;
            Y := nil;
         end;
      end;
      mBspN := 0; mBsp := nil;
      for j:=0 to mSplN-1 do begin
         with mSpl[j] do begin
            X := nil;
            Y := nil;
         end;
      end;
      mSplN := 0; mSpl := nil;
      mCloN := 0; mClo := nil;
      mArwN := 0; mArw := nil;
      mDocN := 0; mDoc := nil;
      for j:=0 to mTblN-1 do begin
         with mTbl[j] do begin
            ColWidth := nil;
            RowHeight:= nil;
            align    := nil;
            str      := nil;
            calc     := nil;
         end;
      end;
      mTblN := 0; mTbl := nil;
      mDLnN := 0; mDLn := nil;
      mDArN := 0; mDAr := nil;
      mDAnN := 0; mDAn := nil;
      mDRaN := 0; mDRa := nil;
      mDDiN := 0; mDDi := nil;
      for j:=0 to mDLeN-1 do begin
         with mDLe[j] do begin
            vertex_x := nil;
            vertex_y := nil;
         end;
      end;
      mDLeN := 0; mDLe := nil;
      for j:=0 to mDBaN-1 do begin
         with mDBa[j] do begin
            vertex_x := nil;
            vertex_y := nil;
         end;
      end;
      mDBaN := 0; mDBa := nil;
      for j:=0 to mHa1N-1 do begin
         with mHa1[j] do begin
            in_id := nil;
            hl    := nil;
         end;
      end;
      mHa1N := 0; mHa1 := nil;
      for j:=0 to mHa2N-1 do begin
         with mHa2[j] do begin
            in_id := nil;
         end;
      end;
      mHa2N := 0; mHa2 := nil;
      for j:=0 to mHa3N-1 do begin
         with mHa3[j] do begin
            in_id := nil;
            hl    := nil;
         end;
      end;
      mHa3N := 0; mHa3 := nil;
      for j:=0 to mHa4N-1 do begin
         with mHa4[j] do begin
            in_id := nil;
            hl    := nil;
         end;
      end;
      mHa4N := 0; mHa4 := nil;
      for j:=0 to mHa5N-1 do begin
         with mHa5[j] do begin
            in_id := nil;
         end;
      end;
      mHa5N := 0; mHa5 := nil;
      for j:=0 to mHa6N-1 do begin
         with mHa6[j] do begin
            in_id := nil;
         end;
      end;
      mHa6N := 0; mHa6 := nil;
      for j:=0 to mHa7N-1 do begin
         with mHa7[j] do begin
            in_id := nil;
         end;
      end;
      mHa7N := 0; mHa7 := nil;
   end;
end;

//   nb`Ö}`f[^
procedure TDataClass.DataClearHAr ;
var
   i : integer ;
begin
   for i:=0 to zHArN-1 do begin
      zHAr[i].a := nil ;
      zHAr[i].an:= 0 ;
   end;
   zHAr := nil;
   zHArN:= 0;
end;

//   nb`Of[^
procedure TDataClass.DataClearHLn ;
begin
   zHLn  := nil ;
   zHLnN := 0 ;
end;

// @Xg
procedure TDataClass.DataClearAttribute ;
var
   i : integer ;
begin
   for i:=0 to zAttN-1 do begin
      zAtt[i].att := nil;
      zAtt[i].Number := 0;
   end;
   zAtt  := nil;
   zAttN := 0;
end;

// lZbg
procedure TDataClass.DataInit;
begin
   BackColor := $00FFFFFF ;   // wiF
   PwakColor := $00FF0000 ;   // pgFF
   HojoColor :=-$00800000 ;   // ⏕FZF

   // 񒷂0偁(NULL)͋Ȃ̂Ŕp󔒂܂
   with zt do begin
      P_Name   := ' ';
      C_Name   := ' ';
      C_type   := ' ';
      D_title  := ' ';
      D_number := ' ';
      D_type   := ' ';
      D_Scale  := '1/1';
      D_Year   := 2011;
      D_Month  := 1;
      D_Day    := 1;
      C_Contractor := ' ';
      C_Owner  := ' ';
   end;
   with zp do begin
      name  := ' ';
      typ   := 0;
      orient:= 1;
      x     := 1189;
      y     := 841;
   end;
   zLay  := nil;
   zLayN := 0;    zLayMax := 0;
   AddLayer(1, 'C1',1,1,1,1,1, 0,0);

   zCol  := nil;
   zColN := 0;    zColMax := 0;
   AddColor( 1,  0,  0,  0, 0,0);
   AddColor( 2,255,  0,  0, 0,0);
   AddColor( 3,  0,255,  0, 0,0);
   AddColor( 4,  0,  0,255, 0,0);
   AddColor( 5,255,255,  0, 0,0);
   AddColor( 6,255,  0,255, 0,0);
   AddColor( 7,  0,255,255, 0,0);
   AddColor( 8,255,255,255, 0,0);
   AddColor( 9,192,  0,128, 0,0);
   AddColor(10,192,128, 64, 0,0);
   AddColor(11,255,128,  0, 0,0);
   AddColor(12,128,192,128, 0,0);
   AddColor(13,  0,128,255, 0,0);
   AddColor(14,128, 64,255, 0,0);
   AddColor(15,192,192,192, 0,0);
   AddColor(16,128,128,128, 0,0);

   zLtp  := nil;
   zLtpN := 0;    zLtpMax := 0;
   AddLtype( 1,'continuous'                       ,0,[ 0.0,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0], 0,0);
   AddLtype( 2,'dashed'                           ,2,[ 6.0,1.5,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0], 0,0);
   AddLtype( 3,'dashed spaced'                    ,2,[ 6.0,6.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0], 0,0);
   AddLtype( 4,'long dashed dotted'               ,4,[12.0,1.5,0.25,1.5,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0], 0,0);
   AddLtype( 5,'long dashed double-dotted'        ,6,[12.0,1.5,0.25,1.5,0.25,1.5,0.0 ,0.0,0.0 ,0.0], 0,0);
   AddLtype( 6,'long dashed triplicate-dotted'    ,8,[12.0,1.5,0.25,1.5,0.25,1.5,0.25,1.5,0.0 ,0.0], 0,0);
   AddLtype( 7,'dotted'                           ,2,[0.25,1.5,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0], 0,0);
   AddLtype( 8,'chain'                            ,4,[12.0,1.5,3.5 ,1.5,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0], 0,0);
   AddLtype( 9,'chain double dash'                ,6,[12.0,1.5,3.5 ,1.5,3.5 ,1.5,0.0 ,0.0,0.0 ,0.0], 0,0);
   AddLtype(10,'dashed dotted'                    ,4,[6.0 ,1.5,0.25,1.5,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0], 0,0);
   AddLtype(11,'Double-dashed dotted'             ,6,[6.0 ,1.5,6.0 ,1.5,0.25,1.5,0.0 ,0.0,0.0 ,0.0], 0,0);
   AddLtype(12,'dashed double-dotted'             ,6,[6.0 ,1.5,0.25,1.5,0.25,1.5,0.0 ,0.0,0.0 ,0.0], 0,0);
   AddLtype(13,'double-dashed double-dotted'      ,8,[6.0 ,1.5,6.0 ,1.5,0.25,1.5,0.25,1.5,0.0 ,0.0], 0,0);
   AddLtype(14,'dashed triplicate-dotted'         ,8,[6.0 ,1.5,0.25,1.5,0.25,1.5,0.25,1.5,0.0 ,0.0], 0,0);
   AddLtype(15,'double-dashed triplicate-dotted' ,10,[6.0 ,1.5,6.0 ,1.5,0.25,1.5,0.25,1.5,0.25,1.5], 0,0);
   AddLtype(16,'gp'                           ,0,[0.0 ,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0,0.0 ,0.0], 0,0);

   zWid  := nil;
   zWidN := 0;    zWidMax := 0;
   AddWidth( 1,0.13, 0,0);
   AddWidth( 2,0.18, 0,0);
   AddWidth( 3,0.25, 0,0);
   AddWidth( 4,0.35, 0,0);
   AddWidth( 5,0.5 , 0,0);
   AddWidth( 6,0.7 , 0,0);
   AddWidth( 7,1.0 , 0,0);
   AddWidth( 8,1.4 , 0,0);
   AddWidth( 9,2.0 , 0,0);
   AddWidth(10,0.01, 0,0); // gp

   zFnt  := nil;
   zFntN := 0;    zFntMax := 0;
   AddFont(1,'lr SVbN', 0,0);

   hOrd  := nil;
   hOrdN := 0;
   hTen  := nil;
   hTenN := 0;
   hLin  := nil;
   hLinN := 0;
   hLns  := nil;
   hLnsN := 0;
   hCir  := nil;
   hCirN := 0;
   hArc  := nil;
   hArcN := 0;
   hEll  := nil;
   hEllN := 0;
   hEAr  := nil;
   hEArN := 0;
   hTxt  := nil;
   hTxtN := 0;

   OpeHistory  := nil ;
   OpeHistoryN := 0 ;
   OpeNumber   := 0 ;
   OpeUndoN    := 0 ;

   dOrd  := nil;
   dOrdN := 0;
   dTen  := nil;
   dTenN := 0;
   dLin  := nil;
   dLinN := 0;
   dLns  := nil;
   dLnsN := 0;
   dCir  := nil;
   dCirN := 0;
   dArc  := nil;
   dArcN := 0;
   dEll  := nil;
   dEllN := 0;
   dEAr  := nil;
   dEArN := 0;
   dTxt  := nil;
   dTxtN := 0;
   dBez  := nil;
   dBezN := 0;
   dBsp  := nil;
   dBspN := 0;
   dSpl  := nil;
   dSplN := 0;
   dClo  := nil;
   dCloN := 0;
   dArw  := nil;
   dArwN := 0;
   dImg  := nil;
   dImgN := 0;
   dDoc  := nil;
   dDocN := 0;
   dTbl  := nil;
   dTblN := 0;
   dDLn  := nil;
   dDLnN := 0;
   dDAr  := nil;
   dDArN := 0;
   dDAn  := nil;
   dDAnN := 0;
   dDRa  := nil;
   dDRaN := 0;
   dDDi  := nil;
   dDDiN := 0;
   dDLe  := nil;
   dDLeN := 0;
   dDBa  := nil;
   dDBaN := 0;
   dHa1  := nil;
   dHa1N := 0;
   dHa2  := nil;
   dHa2N := 0;
   dHa3  := nil;
   dHa3N := 0;
   dHa4  := nil;
   dHa4N := 0;
   dHa5  := nil;
   dHa5N := 0;
   dHa6  := nil;
   dHa6N := 0;
   dHa7  := nil;
   dHa7N := 0;
   dSzk  := nil;
   dSzkN := 0;
   dFzk  := nil;
   dFzkN := 0;

   cDefD := nil;
   cDefDN:= 0;
   cDef  := nil;
   cDefN := 0;
   fDefD := nil;
   fDefDN:= 0;
   fDef  := nil;
   fDefN := 0;
   zFzt  := nil;
   zFztN := 0;
   zAtt  := nil;
   zAttN := 0;
   zHAr  := nil;
   zHArN := 0 ;
   zHCp  := nil;
   zHCpN := 0 ;
   zHLn  := nil;
   zHLnN := 0 ;
end;

// V{`f[^@lZbg
procedure TDataClass.DataInitSymbol ;
var
   a : double ;
begin
   sDefD := nil;
   sDefDN:= 0;
   sDef  := nil;
   sDefN := 0;
   AddSymbolDef('sxf_hatch_style_7_symbol');
   AddDataLine( 'sxf_hatch_style_7_symbol', 1,0,0,0,   0.0,  0.0,  200.0,  0.0);
   AddDataLine( 'sxf_hatch_style_7_symbol', 1,0,0,0, 200.0,  0.0,  200.0,100.0);
   AddDataLine( 'sxf_hatch_style_7_symbol', 1,0,0,0, 200.0,100.0,    0.0,100.0);
   AddDataLine( 'sxf_hatch_style_7_symbol', 1,0,0,0, 100.0,100.0,  100.0,200.0);
   a := 100.0*Cos(45.0/180.0*Pi);
   AddSymbolDef('sxf_hatch_style_8_symbol');
   AddDataLine( 'sxf_hatch_style_8_symbol', 1,0,0,0, 0.0  ,0.0  ,      a,    a);
   AddDataLine( 'sxf_hatch_style_8_symbol', 1,0,0,0, 2.0*a,0.0  ,  0.0  ,2.0*a);
   AddDataLine( 'sxf_hatch_style_8_symbol', 1,0,0,0, 0.0  ,2.0*a,  2.0*a,4.0*a);
   AddDataLine( 'sxf_hatch_style_8_symbol', 1,0,0,0, 2.0*a,4.0*a,  3.0*a,3.0*a);
   AddDataLine( 'sxf_hatch_style_8_symbol', 1,0,0,0, 3.0*a,3.0*a,  4.0*a,4.0*a);
   AddDataLine( 'sxf_hatch_style_8_symbol', 1,0,0,0, 4.0*a,0.0  ,  1.0*a,3.0*a);
   AddDataLine( 'sxf_hatch_style_8_symbol', 1,0,0,0, 3.0*a,1.0*a,  4.0*a,2.0*a);
end;

// `nb`O`f[^@lZbg
procedure TDataClass.DataInitHatchName ;
begin
   hDef  := nil;
   hDefN := 0;
   AddHatchNameDef('sxf_hatch_style_1', 1,[-1],[1],[2],[2.0],[45.0]);   // Eオΐ
   AddHatchNameDef('sxf_hatch_style_2', 1,[-1],[2],[2],[2.0],[45.0]);   // Eオΐijj
   AddHatchNameDef('sxf_hatch_style_3', 1,[-1],[1],[2],[2.0],[0.0]);    // 
   AddHatchNameDef('sxf_hatch_style_4', 1,[-1],[2],[2],[2.0],[0.0]);    // ijj
   AddHatchNameDef('sxf_hatch_style_5', 2,[-1,-1],[1,1],[2,2],[2.0,2.0],[45.0,135.0]); // ΐiq
   AddHatchNameDef('sxf_hatch_style_6', 2,[-1,-1],[2,2],[2,2],[2.0,2.0],[45.0,135.0]); // ΐiqȁijj
   AddHatchNameDef('Area_control',      0,[],[],[],[],[]);
end;

// 񒷂擾
//    (ret) 񒷂ioCgj
function TDataClass.StrBytes(s:string) : integer;
var
   t : AnsiString ;
begin
   t := AnsiString(s) ;
   Result := Length(t) ;
end;

// `FbN
//    (ret) OK : True  NG : False
//     0񒷁256 ǂ`FbN
function TDataClass.StrCheck(s:string) : Boolean;
var
   t : AnsiString ;
   l : integer ;
begin
   t := AnsiString(s) ;
   l := Length(t) ;
   if (l > 0) and (l <= 256) then
      Result := True
   else
      Result := False ;
end;

// pTCYZbg
//    t : (0:A0, 1:A1, 2:A2, 3:A3, 4:A4, 9:FREE)
//          {(10:A0~2 11:A0~3 12:A1~3 13:A1~4 14:A2~3 15:A2~4 16:A2~5
//             17:A3~3 18:A3~4 19:A3~5 20:A3~6 21:A3~7 22:A4~3 23:A4~4
//             24:A4~5 25:A4~6 26:A4~7 27:A4~8 28:A4~9)
//          {(30:B0 31:B1 32:B2 33:B3 34:B4 35:B5 36:B6)
//    o : c^敪(0:c,1:)
//    x : Rp(Pmm) t=9̎Ɏw
//    y : Rpc(Pmm) t=9̎Ɏw
procedure TDataClass.PaperSet(t,o,x,y:integer);
begin
   case(t)of
   0: begin
         x := 1189;
         y :=  841;
      end;
   1: begin
         x := 841;
         y := 594;
      end;
   2: begin
         x := 594;
         y := 420;
      end;
   3: begin
         x := 420;
         y := 297;
      end;
   4: begin
         x := 297;
         y := 210;
      end;
   10:begin // A0~2
         x := 1682;
         y := 1189;
      end;
   11:begin // A0~3
         x := 2523;
         y := 1189;
      end;
   12:begin // A1~3
         x := 1783;
         y :=  841;
      end;
   13:begin // A1~4
         x := 2378;
         y :=  841;
      end;
   14:begin // A2~3
         x := 1261;
         y :=  594;
      end;
   15:begin // A2~4
         x := 1682;
         y :=  594;
      end;
   16:begin // A2~5
         x := 2102;
         y :=  594;
      end;
   17:begin // A3~3
         x :=  891;
         y :=  420;
      end;
   18:begin // A3~4
         x := 1189;
         y :=  420;
      end;
   19:begin // A3~5
         x := 1486;
         y :=  420;
      end;
   20:begin // A3~6
         x := 1783;
         y :=  420;
      end;
   21:begin // A3~7
         x := 2080;
         y :=  420;
      end;
   22:begin // A4~3
         x :=  630;
         y :=  297;
      end;
   23:begin // A4~4
         x :=  841;
         y :=  297;
      end;
   24:begin // A4~5
         x := 1051;
         y :=  297;
      end;
   25:begin // A4~6
         x := 1261;
         y :=  297;
      end;
   26:begin // A4~7
         x := 1471;
         y :=  297;
      end;
   27:begin // A4~8
         x := 1682;
         y :=  297;
      end;
   28:begin // A4~9
         x := 1892;
         y :=  297;
      end;
   30:begin // B0
			x := 1456;
			y := 1028;
      end;
   31:begin // B1
			x := 1028;
			y :=  728;
      end;
   32:begin // B2
			x := 728;
			y := 514;
      end;
   33:begin // B3
			x := 514;
			y := 364;
      end;
   34:begin // B4
         x := 364;
			y := 257;
      end;
   35:begin // B5
         x := 257;
			y := 182;
      end;
   36:begin // B6
			x := 182;
			y := 128;
      end;
   end;
   if (t >= 0)and(t <= 4) then begin
      if (o = 0) then
         swapI(x,y)
      else
         o := 1;  // CM[lłꍇɔ
   end
   else if (t >= 10)and(t <= 28)
         or(t >= 30)and(t <= 36) then begin
      t := 9 ;
      if (o = 0) then
         swapI(x,y)
      else
         o := 1;
   end
   else begin
      t := 9 ;
      if (x < 100) then x := 100 ;   // RTCY̏ꍇ̒l`FbN
      if (y < 100) then y := 100 ;   //    100mm`10000mmƂĂ
      if (x > 10000) then x := 10000 ;
      if (y > 10000) then y := 10000 ;
      // p̌
      if (x >= y) then
         o := 1
      else
         o := 0 ;
   end;

   zp.typ      := t ;
   zp.orient   := o ;
   zp.x        := x ;
   zp.y        := y ;
end;

// ----- 엚֘A -----

// 엚ǉ܂
//    tp : ^Cv 1:ݒǉ 2:ݒ폜 3:`ǉ 4:`폜 5:vfǉ 6:vf폜 7:Ȑvfǉ 8:Ȑvf폜
//    et : ݒ) 1:C 2:F 3: 4: 5:tHg
//         `) 1:Ȑ 2:V{}` 3:}`
//         vf) 0:\Lvf +:􉽗vf -:V{
//         ) Ȑvfindex 0-
//    en : } xOrdւ̔ԍ
//    OpeNumber ... ԍ(1-)
function TDataClass.OpAdd(tp,et,en:integer) : Boolean ;
begin
   try
      Inc(OpeHistoryN);
      if ((OpeHistoryN mod 200) = 1) then
         SetLength(OpeHistory, OpeHistoryN+199);
      with OpeHistory[OpeHistoryN-1] do begin
         opt := tp ;
         opn := OpeNumber ;
         ope := et ;
         ord := en ;
      end;
      Result := True ;
   except
      Dec(OpeHistoryN);
      Result := False ;
   end;
   OpeUndoN := OpeHistoryN ;
end;

// AhD\ǂ̃`FbN
function TDataClass.CheckOpUndo : Boolean ;
begin
   Result := True ;
   if (OpeNumber = 0) then Result := False ;
end;

// hD\ǂ̃`FbN
function TDataClass.CheckOpRedo : Boolean ;
begin
   Result := True ;
   if (OpeUndoN = OpeHistoryN) then Result := False ;
end;

// AhDEhD̃Tu
//    ݃tO𔽓]遁ǉ폜A폜ǉ̑s
//
// (ret) True : }`@False : }`Ȃ
//       }`zũAhDEhDꍇɂ͌ŃubNc[Đs
function TDataClass.OpUndoRedoSub : Boolean ;
var
   tp,et,en,o0,o1,o2 : integer ;
begin
   Result := False ;
   with OpeHistory[OpeHistoryN-1] do begin
      tp := opt ;
      et := ope ;
      en := ord ;
   end;
   case(tp)of
   1,2: begin  // ݒ
         case(et)of
         1: begin   // C
               with zLay[en] do
                  exf := not(exf);
            end;
         2: begin   // F
               with zCol[en] do
                  exf := not(exf);
            end;
         3: begin   // 
               with zLtp[en] do
                  exf := not(exf);
            end;
         4: begin   // 
               with zWid[en] do
                  exf := not(exf);
            end;
         5: begin   // tHg
               with zFnt[en] do
                  exf := not(exf);
            end;
         end;
      end;
   3,4: begin  // `
         case(et)of
         1: begin   // Ȑ
               with cDef[en] do
                  exf := not(exf);
            end;
         2: begin   // V{}`
               with sDef[en] do
                  exf := not(exf);
            end;
         3: begin   // }`
               with fDef[en] do
                  exf := not(exf);
               Result := True ;
            end;
         end;
      end;
   5,6: begin  // vf
         if (et = 0) then begin
            o1 := dOrd[en].DataType ;
            o2 := dOrd[en].DataNo ;
            case (o1) of
            1: begin
                  // _}[J
                  if (o2 < dTenN) then begin
                     with dTen[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            2: begin
                  // 
                  if (o2 < dLinN) then begin
                     with dLin[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            3: begin
                  // ܐ
                  if (o2 < dLnsN) then begin
                     with dLns[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            4: begin
                  // ~
                  if (o2 < dCirN) then begin
                     with dCir[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            5: begin
                  // ~
                  if (o2 < dArcN) then begin
                     with dArc[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            6: begin
                  // ȉ~
                  if (o2 < dEllN) then begin
                     with dEll[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            7: begin
                  // ȉ~
                  if (o2 < dEArN) then begin
                     with dEAr[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            8: begin
                  // 
                  if (o2 < dTxtN) then begin
                     with dTxt[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            9: begin
                  // xWFȐ
                  if (o2 < dBezN) then begin
                     with dBez[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            10:begin
                  // aXvCȐ
                  if (o2 < dBspN) then begin
                     with dBsp[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            11:begin
                  // XvCȐ
                  if (o2 < dSplN) then begin
                     with dSpl[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            12:begin
                  // N\ChȐ
                  if (o2 < dCloN) then begin
                     with dClo[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            13:begin
                  // 
                  if (o2 < dArwN) then begin
                     with dArw[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            14:begin
                  // 摜
                  if (o2 < dImgN) then begin
                     with dImg[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            15:begin
                  // 
                  if (o2 < dDocN) then begin
                     with dDoc[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            16:begin
                  // \
                  if (o2 < dTblN) then begin
                     with dTbl[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            99:begin
                  // }`
                  if (o2 < dFzkN) then begin
                     with dFzk[o2] do begin
                        exf := not(exf);
                     end;
                     Result := True ;
                  end;
               end;
            100:begin
                  // V{}`
                  if (o2 < dSzkN) then begin
                     with dSzk[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            101:begin
                  // @
                  if (o2 < dDLnN) then begin
                     with dDLn[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            102:begin
                  // ʒ@
                  if (o2 < dDArN) then begin
                     with dDAr[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            103:begin
                  // px@
                  if (o2 < dDAnN) then begin
                     with dDAn[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            104:begin
                  // a@
                  if (o2 < dDRaN) then begin
                     with dDRa[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            105:begin
                  // a@
                  if (o2 < dDDiN) then begin
                     with dDDi[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            106:begin
                  // o
                  if (o2 < dDLeN) then begin
                     with dDLe[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            107:begin
                  // o[
                  if (o2 < dDBaN) then begin
                     with dDBa[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            108:begin
                  // nb`Oi`j
                  if (o2 < dHa1N) then begin
                     with dHa1[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            109:begin
                  // nb`Oihj
                  if (o2 < dHa2N) then begin
                     with dHa2[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            110:begin
                  // nb`Oi[U`j
                  if (o2 < dHa3N) then begin
                     with dHa3[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            111:begin
                  // nb`Oip^[j
                  if (o2 < dHa4N) then begin
                     with dHa4[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            112:begin
                  // nb`Oiߓhj
                  if (o2 < dHa5N) then begin
                     with dHa5[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            113:begin
                  // nb`OiOf[Vhj
                  if (o2 < dHa6N) then begin
                     with dHa6[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            114:begin
                  // nb`Oi摜hj
                  if (o2 < dHa7N) then begin
                     with dHa7[o2] do begin
                        exf := not(exf);
                     end;
                  end;
               end;
            end;
         end
         else if (et > 0)and(et <= fDefN) then begin
            with fDef[et-1] do begin
               o0 := datn ;
            end;
            with fDefD[o0] do begin
               o1 := mOrd[en].DataType ;
               o2 := mOrd[en].DataNo ;
               case (o1) of
               1: begin
                     // _}[J
                     if (o2 < mTenN) then begin
                        with mTen[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               2: begin
                     // 
                     if (o2 < mLinN) then begin
                        with mLin[o2] do begin
                           exf := not(exf);
                        end;
                    end;
                  end;
               3: begin
                     // ܐ
                     if (o2 < mLnsN) then begin
                        with mLns[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               4: begin
                     // ~
                     if (o2 < mCirN) then begin
                        with mCir[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               5: begin
                     // ~
                     if (o2 < mArcN) then begin
                        with mArc[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               6: begin
                     // ȉ~
                     if (o2 < mEllN) then begin
                        with mEll[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               7: begin
                     // ȉ~
                     if (o2 < mEArN) then begin
                        with mEAr[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               8: begin
                     // 
                     if (o2 < mTxtN) then begin
                        with mTxt[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               9: begin
                     // xWFȐ
                     if (o2 < mBezN) then begin
                        with mBez[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               10:begin
                     // aXvCȐ
                     if (o2 < mBspN) then begin
                        with mBsp[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               11:begin
                     // XvCȐ
                     if (o2 < mSplN) then begin
                        with mSpl[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               12:begin
                     // N\ChȐ
                     if (o2 < mCloN) then begin
                        with mClo[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               13:begin
                     // 
                     if (o2 < mArwN) then begin
                        with mArw[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               15:begin
                     // 
                     if (o2 < mDocN) then begin
                        with mDoc[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               16:begin
                     // \
                     if (o2 < mTblN) then begin
                        with mTbl[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               99:begin
                     // }`
                     if (o2 < mFzkN) then begin
                        with mFzk[o2] do begin
                           exf := not(exf);
                        end;
                        Result := True ;
                     end;
                  end;
               100:begin
                     // V{}`
                     if (o2 < mSzkN) then begin
                        with mSzk[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               101:begin
                     // @
                     if (o2 < mDLnN) then begin
                        with mDLn[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               102:begin
                     // ʒ@
                     if (o2 < mDArN) then begin
                        with mDAr[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               103:begin
                     // px@
                     if (o2 < mDAnN) then begin
                        with mDAn[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               104:begin
                     // a@
                     if (o2 < mDRaN) then begin
                        with mDRa[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               105:begin
                     // a@
                     if (o2 < mDDiN) then begin
                        with mDDi[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               106:begin
                     // o
                     if (o2 < mDLeN) then begin
                        with mDLe[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               107:begin
                     // o[
                     if (o2 < mDBaN) then begin
                        with mDBa[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               108:begin
                     // nb`Oi`j
                     if (o2 < mHa1N) then begin
                        with mHa1[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               109:begin
                     // nb`Oihj
                     if (o2 < mHa2N) then begin
                        with mHa2[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               110:begin
                     // nb`Oi[U`j
                     if (o2 < mHa3N) then begin
                        with mHa3[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               111:begin
                     // nb`Oip^[j
                     if (o2 < mHa4N) then begin
                        with mHa4[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               112:begin
                     // nb`Oiߓhj
                     if (o2 < mHa5N) then begin
                        with mHa5[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               113:begin
                     // nb`OiOf[Vhj
                     if (o2 < mHa6N) then begin
                        with mHa6[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               114:begin
                     // nb`Oi摜hj
                     if (o2 < mHa7N) then begin
                        with mHa7[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               end;
            end;
         end
         else if (et < 0)and(et >= -sDefN) then begin
            with sDef[-et-1] do begin
               o0 := datn ;
            end;
            with sDefD[o0] do begin
               o1 := mOrd[en].DataType ;
               o2 := mOrd[en].DataNo ;
               case (o1) of
               1: begin
                     // _}[J
                     if (o2 < mTenN) then begin
                        with mTen[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               2: begin
                     // 
                     if (o2 < mLinN) then begin
                        with mLin[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               3: begin
                     // ܐ
                     if (o2 < mLnsN) then begin
                        with mLns[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               4: begin
                     // ~
                     if (o2 < mCirN) then begin
                        with mCir[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               5: begin
                     // ~
                     if (o2 < mArcN) then begin
                        with mArc[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               6: begin
                     // ȉ~
                     if (o2 < mEllN) then begin
                        with mEll[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               7: begin
                     // ȉ~
                     if (o2 < mEArN) then begin
                        with mEAr[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               8: begin
                     // 
                     if (o2 < mTxtN) then begin
                        with mTxt[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               9: begin
                     // xWFȐ
                     if (o2 < mBezN) then begin
                        with mBez[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               10:begin
                     // aXvCȐ
                     if (o2 < mBspN) then begin
                        with mBsp[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               11:begin
                     // XvCȐ
                     if (o2 < mSplN) then begin
                        with mSpl[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               12:begin
                     // N\ChȐ
                     if (o2 < mCloN) then begin
                        with mClo[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               13:begin
                     // 
                     if (o2 < mArwN) then begin
                        with mArw[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               15:begin
                     // 
                     if (o2 < mDocN) then begin
                        with mDoc[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               16:begin
                     // \
                     if (o2 < mTblN) then begin
                        with mTbl[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               101:begin
                     // @
                     if (o2 < mDLnN) then begin
                        with mDLn[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               102:begin
                     // ʒ@
                     if (o2 < mDArN) then begin
                        with mDAr[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               103:begin
                     // px@
                     if (o2 < mDAnN) then begin
                        with mDAn[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               104:begin
                     // a@
                     if (o2 < mDRaN) then begin
                        with mDRa[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               105:begin
                     // a@
                     if (o2 < mDDiN) then begin
                        with mDDi[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               106:begin
                     // o
                     if (o2 < mDLeN) then begin
                        with mDLe[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               107:begin
                     // o[
                     if (o2 < mDBaN) then begin
                        with mDBa[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               108:begin
                     // nb`Oi`j
                     if (o2 < mHa1N) then begin
                        with mHa1[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               109:begin
                     // nb`Oihj
                     if (o2 < mHa2N) then begin
                        with mHa2[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               110:begin
                     // nb`Oi[U`j
                     if (o2 < mHa3N) then begin
                        with mHa3[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               111:begin
                     // nb`Oip^[j
                     if (o2 < mHa4N) then begin
                        with mHa4[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               112:begin
                     // nb`Oiߓhj
                     if (o2 < mHa5N) then begin
                        with mHa5[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               113:begin
                     // nb`OiOf[Vhj
                     if (o2 < mHa6N) then begin
                        with mHa6[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               114:begin
                     // nb`Oi摜hj
                     if (o2 < mHa7N) then begin
                        with mHa7[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               end;
            end;
         end;
      end;
   else begin  // Ȑvf
         if (et >= 0)and(et <= (cDefN-1)) then begin
            with cDef[et] do begin
               o0 := datn ;
            end;
            with cDefD[o0] do begin
               o1 := mOrd[en].DataType ;
               o2 := mOrd[en].DataNo ;
               case (o1) of
               3: begin
                     // ܐ
                     if (o2 < mLnsN) then begin
                        with mLns[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               5: begin
                     // ~
                     if (o2 < mArcN) then begin
                        with mArc[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               7: begin
                     // ȉ~
                     if (o2 < mEArN) then begin
                        with mEAr[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               9: begin
                     // xWFȐ
                     if (o2 < mBezN) then begin
                        with mBez[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               10:begin
                     // aXvCȐ
                     if (o2 < mBspN) then begin
                        with mBsp[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               11:begin
                     // XvCȐ
                     if (o2 < mSplN) then begin
                        with mSpl[o2] do begin
                           exf := not(exf);
                        end;
                     end;
                  end;
               end;
            end;
         end
      end;
   end
end;

// AhD
procedure TDataClass.OpUndo ;
var
   i : integer ;
begin
   if not(CheckOpUndo) then exit ;
   i := 0 ;
   while (OpeHistoryN > 0) do begin
      if (OpeHistory[OpeHistoryN-1].opn = OpeNumber) then begin
         if (OpUndoRedoSub) then Inc(i);
      end
      else
         break ;
      Dec(OpeHistoryN);
   end;
   Dec(OpeNumber);
   if (i > 0) then
      MakeFZukeiTree ;
end;

// hD
procedure TDataClass.OpRedo ;
var
   i : integer ;
begin
   if not(CheckOpRedo) then exit ;
   i := 0 ;
   Inc(OpeNumber);
   while (OpeHistoryN <= OpeUndoN) do begin
      Inc(OpeHistoryN);
      if (OpeHistory[OpeHistoryN-1].opn = OpeNumber) then begin
         if (OpUndoRedoSub) then Inc(i);
      end
      else begin
         Dec(OpeHistoryN);
         break ;
      end;
   end;
   if (i > 0) then
      MakeFZukeiTree ;
end;

// ̃Iy[V
procedure TDataClass.OpNext ;
var
   i,tp,et,en,o0,o1,o2 : integer ;
begin
   for i:=OpeUndoN-1 downto OpeHistoryN do begin
      with OpeHistory[i] do begin
         tp := opt ;
         et := ope ;
         en := ord ;
      end;
      case(tp)of
      1: begin  // ݒ
            case(et)of
            1: begin   // C
                  if (en = (zLayN-1)) then
                     if not(zLay[en].exf) then
                        Dec(zLayN);
               end;
            2: begin   // F
                  if (en = (zColN-1)) then
                     if not(zCol[en].exf) then
                        Dec(zColN);
               end;
            3: begin   // 
                  if (en = (zLtpN-1)) then
                     if not(zLtp[en].exf) then
                        Dec(zLtpN);
               end;
            4: begin   // 
                  if (en = (zWidN-1)) then
                     if not(zWid[en].exf) then
                        Dec(zWidN);
               end;
            5: begin   // tHg
                  if (en = (zFntN-1)) then
                     if not(zFnt[en].exf) then
                        Dec(zFntN);
               end;
            end;
         end;
      3: begin  // `
            case(et)of
            1: begin   // Ȑ
                  if (en = (cDefN-1)) then
                     if not(cDef[en].exf) then
                        Dec(cDefN);
               end;
            2: begin   // V{}`
                  if (en = (sDefN-1)) then
                     if not(sDef[en].exf) then
                        Dec(sDefN);
               end;
            3: begin   // }`
                  if (en = (fDefN-1)) then
                     if not(fDef[en].exf) then
                        Dec(fDefN);
               end;
            end;
         end;
      5: begin  // vf
            if (et = 0) then begin
               o1 := dOrd[en].DataType ;
               o2 := dOrd[en].DataNo ;
               case (o1) of
               1: begin
                     // _}[J
                     if (o2 = (dTenN-1)) then
                        if not(dTen[o2].exf) then
                           Dec(dTenN);
                  end;
               2: begin
                     // 
                     if (o2 = (dLinN-1)) then
                        if not(dLin[o2].exf) then
                           Dec(dLinN);
                  end;
               3: begin
                     // ܐ
                     if (o2 = (dLnsN-1)) then
                        if not(dLns[o2].exf) then begin
                           dLns[o2].X := nil;
                           dLns[o2].Y := nil;
                           Dec(dLnsN);
                        end;
                  end;
               4: begin
                     // ~
                     if (o2 = (dCirN-1)) then
                        if not(dCir[o2].exf) then
                           Dec(dCirN);
                  end;
               5: begin
                     // ~
                     if (o2 = (dArcN-1)) then
                        if not(dArc[o2].exf) then
                           Dec(dArcN);
                  end;
               6: begin
                     // ȉ~
                     if (o2 = (dEllN-1)) then
                        if not(dEll[o2].exf) then
                           Dec(dEllN);
                  end;
               7: begin
                     // ȉ~
                     if (o2 = (dEArN-1)) then
                        if not(dEAr[o2].exf) then
                           Dec(dEArN);
                  end;
               8: begin
                     // 
                     if (o2 = (dTxtN-1)) then
                        if not(dTxt[o2].exf) then
                           Dec(dTxtN);
                  end;
               9: begin
                     // xWFȐ
                     if (o2 = (dBezN-1)) then
                        if not(dBez[o2].exf) then begin
                           dBez[o2].X := nil;
                           dBez[o2].Y := nil;
                           Dec(dBezN);
                        end;
                  end;
               10:begin
                     // aXvCȐ
                     if (o2 = (dBspN-1)) then
                        if not(dBsp[o2].exf) then begin
                           dBsp[o2].X := nil;
                           dBsp[o2].Y := nil;
                           Dec(dBspN);
                        end;
                  end;
               11:begin
                     // XvCȐ
                     if (o2 = (dSplN-1)) then
                        if not(dSpl[o2].exf) then begin
                           dSpl[o2].X := nil;
                           dSpl[o2].Y := nil;
                           Dec(dSplN);
                        end;
                  end;
               12:begin
                     // N\ChȐ
                     if (o2 = (dCloN-1)) then
                        if not(dClo[o2].exf) then
                           Dec(dCloN);
                  end;
               13:begin
                     // 
                     if (o2 = (dArwN-1)) then
                        if not(dArw[o2].exf) then
                           Dec(dArwN);
                  end;
               14:begin
                     // 摜
                     if (o2 = (dImgN-1)) then
                        if not(dImg[o2].exf) then
                           Dec(dImgN);
                  end;
               15:begin
                     // 
                     if (o2 = (dDocN-1)) then
                        if not(dDoc[o2].exf) then
                           Dec(dDocN);
                  end;
               16:begin
                     // \
                     if (o2 = (dTblN-1)) then
                        if not(dTbl[o2].exf) then begin
                           with dTbl[o2] do begin
                              ColWidth := nil;
                              RowHeight:= nil;
                              align    := nil;
                              str      := nil;
                              calc     := nil;
                           end;
                           Dec(dTblN);
                        end;
                  end;
               99:begin
                     // }`
                     if (o2 = (dFzkN-1)) then
                        if not(dFzk[o2].exf) then
                           Dec(dFzkN);
                  end;
               100:begin
                     // V{}`
                     if (o2 = (dSzkN-1)) then
                        if not(dSzk[o2].exf) then
                           Dec(dSzkN);
                  end;
               101:begin
                     // @
                     if (o2 = (dDLnN-1)) then
                        if not(dDLn[o2].exf) then
                           Dec(dDLnN);
                  end;
               102:begin
                     // ʒ@
                     if (o2 = (dDArN-1)) then
                        if not(dDAr[o2].exf) then
                           Dec(dDArN);
                  end;
               103:begin
                     // px@
                     if (o2 = (dDAnN-1)) then
                        if not(dDAn[o2].exf) then
                           Dec(dDAnN);
                  end;
               104:begin
                     // a@
                     if (o2 = (dDRaN-1)) then
                        if not(dDRa[o2].exf) then
                           Dec(dDRaN);
                  end;
               105:begin
                     // a@
                     if (o2 = (dDDiN-1)) then
                        if not(dDDi[o2].exf) then
                           Dec(dDDiN);
                  end;
               106:begin
                     // o
                     if (o2 = (dDLeN-1)) then
                        if not(dDLe[o2].exf) then begin
                           dDLe[o2].vertex_x := nil;
                           dDLe[o2].vertex_y := nil;
                           Dec(dDLeN);
                        end;
                  end;
               107:begin
                     // o[
                     if (o2 = (dDBaN-1)) then
                        if not(dDBa[o2].exf) then begin
                           dDBa[o2].vertex_x := nil;
                           dDBa[o2].vertex_y := nil;
                           Dec(dDBaN);
                        end;
                  end;
               108:begin
                     // nb`Oi`j
                     if (o2 = (dHa1N-1)) then
                        if not(dHa1[o2].exf) then begin
                           dHa1[o2].in_id := nil;
                           dHa1[o2].hl    := nil;
                           Dec(dHa1N);
                        end;
                  end;
               109:begin
                     // nb`Oihj
                     if (o2 = (dHa2N-1)) then
                        if not(dHa2[o2].exf) then begin
                           dHa2[o2].in_id := nil;
                           Dec(dHa2N);
                        end;
                  end;
               110:begin
                     // nb`Oi[U`j
                     if (o2 = (dHa3N-1)) then
                        if not(dHa3[o2].exf) then begin
                           dHa3[o2].in_id := nil;
                           dHa3[o2].hl    := nil;
                           Dec(dHa3N);
                        end;
                  end;
               111:begin
                     // nb`Oip^[j
                     if (o2 = (dHa4N-1)) then
                        if not(dHa4[o2].exf) then begin
                           dHa4[o2].in_id := nil;
                           dHa4[o2].hl    := nil;
                           Dec(dHa4N);
                        end;
                  end;
               112:begin
                     // nb`Oiߓhj
                     if (o2 = (dHa5N-1)) then
                        if not(dHa5[o2].exf) then begin
                           dHa5[o2].in_id := nil;
                           Dec(dHa5N);
                        end;
                  end;
               113:begin
                     // nb`OiOf[Vhj
                     if (o2 = (dHa6N-1)) then
                        if not(dHa6[o2].exf) then begin
                           dHa6[o2].in_id := nil;
                           Dec(dHa6N);
                        end;
                  end;
               114:begin
                     // nb`Oi摜hj
                     if (o2 = (dHa7N-1)) then
                        if not(dHa7[o2].exf) then begin
                           dHa7[o2].in_id := nil;
                           Dec(dHa7N);
                        end;
                  end;
               end;
            end
            else if (et > 0)and(et <= fDefN) then begin
               with fDef[et-1] do begin
                  o0 := datn ;
               end;
               with fDefD[o0] do begin
                  o1 := mOrd[en].DataType ;
                  o2 := mOrd[en].DataNo ;
                  case (o1) of
                  1: begin
                        // _}[J
                        if (o2 = (mTenN-1)) then
                           if not(mTen[o2].exf) then
                              Dec(mTenN);
                     end;
                  2: begin
                        // 
                        if (o2 = (mLinN-1)) then
                           if not(mLin[o2].exf) then
                              Dec(mLinN);
                     end;
                  3: begin
                        // ܐ
                        if (o2 = (mLnsN-1)) then
                           if not(mLns[o2].exf) then begin
                              mLns[o2].X := nil;
                              mLns[o2].Y := nil;
                              Dec(mLnsN);
                           end;
                     end;
                  4: begin
                        // ~
                        if (o2 = (mCirN-1)) then
                           if not(mCir[o2].exf) then
                              Dec(mCirN);
                     end;
                  5: begin
                        // ~
                        if (o2 = (mArcN-1)) then
                           if not(mArc[o2].exf) then
                              Dec(mArcN);
                     end;
                  6: begin
                        // ȉ~
                        if (o2 = (mEllN-1)) then
                           if not(mEll[o2].exf) then
                              Dec(mEllN);
                     end;
                  7: begin
                        // ȉ~
                        if (o2 = (mEArN-1)) then
                           if not(mEAr[o2].exf) then
                              Dec(mEArN);
                     end;
                  8: begin
                        // 
                        if (o2 = (mTxtN-1)) then
                           if not(mTxt[o2].exf) then
                              Dec(mTxtN);
                     end;
                  9: begin
                        // xWFȐ
                        if (o2 = (mBezN-1)) then
                           if not(mBez[o2].exf) then begin
                              mBez[o2].X := nil;
                              mBez[o2].Y := nil;
                              Dec(mBezN);
                           end;
                     end;
                  10:begin
                        // aXvCȐ
                        if (o2 = (mBspN-1)) then
                           if not(mBsp[o2].exf) then begin
                              mBsp[o2].X := nil;
                              mBsp[o2].Y := nil;
                              Dec(mBspN);
                           end;
                     end;
                  11:begin
                        // XvCȐ
                        if (o2 = (mSplN-1)) then
                           if not(mSpl[o2].exf) then begin
                              mSpl[o2].X := nil;
                              mSpl[o2].Y := nil;
                              Dec(mSplN);
                           end;
                     end;
                  12:begin
                        // N\ChȐ
                        if (o2 = (mCloN-1)) then
                           if not(mClo[o2].exf) then
                              Dec(mCloN);
                     end;
                  13:begin
                        // 
                        if (o2 = (mArwN-1)) then
                           if not(mArw[o2].exf) then
                              Dec(mArwN);
                     end;
                  15:begin
                        // 
                        if (o2 = (mDocN-1)) then
                           if not(mDoc[o2].exf) then
                              Dec(mDocN);
                     end;
                  16:begin
                        // \
                        if (o2 = (mTblN-1)) then
                           if not(mTbl[o2].exf) then begin
                              with mTbl[o2] do begin
                                 ColWidth := nil;
                                 RowHeight:= nil;
                                 align    := nil;
                                 str      := nil;
                                 calc     := nil;
                              end;
                              Dec(mTblN);
                           end;
                     end;
                  99:begin
                        // }`
                        if (o2 = (mFzkN-1)) then
                           if not(mFzk[o2].exf) then
                              Dec(mFzkN);
                     end;
                  100:begin
                        // V{}`
                        if (o2 = (mSzkN-1)) then
                           if not(mSzk[o2].exf) then
                              Dec(mSzkN);
                     end;
                  101:begin
                        // @
                        if (o2 = (mDLnN-1)) then
                           if not(mDLn[o2].exf) then
                              Dec(mDLnN);
                     end;
                  102:begin
                        // ʒ@
                        if (o2 = (mDArN-1)) then
                           if not(mDAr[o2].exf) then
                              Dec(mDArN);
                     end;
                  103:begin
                        // px@
                        if (o2 = (mDAnN-1)) then
                           if not(mDAn[o2].exf) then
                              Dec(mDAnN);
                     end;
                  104:begin
                        // a@
                        if (o2 = (mDRaN-1)) then
                           if not(mDRa[o2].exf) then
                              Dec(mDRaN);
                     end;
                  105:begin
                        // a@
                        if (o2 = (mDDiN-1)) then
                           if not(mDDi[o2].exf) then
                              Dec(mDDiN);
                     end;
                  106:begin
                        // o
                        if (o2 = (mDLeN-1)) then
                           if not(mDLe[o2].exf) then begin
                              mDLe[o2].vertex_x := nil;
                              mDLe[o2].vertex_y := nil;
                              Dec(mDLeN);
                           end;
                     end;
                  107:begin
                        // o[
                        if (o2 = (mDBaN-1)) then
                           if not(mDBa[o2].exf) then begin
                              mDBa[o2].vertex_x := nil;
                              mDBa[o2].vertex_y := nil;
                              Dec(mDBaN);
                           end;
                     end;
                  108:begin
                        // nb`Oi`j
                        if (o2 = (mHa1N-1)) then
                           if not(mHa1[o2].exf) then begin
                              mHa1[o2].in_id := nil;
                              mHa1[o2].hl    := nil;
                              Dec(mHa1N);
                           end;
                     end;
                  109:begin
                        // nb`Oihj
                        if (o2 = (mHa2N-1)) then
                           if not(mHa2[o2].exf) then begin
                              mHa2[o2].in_id := nil;
                              Dec(mHa2N);
                           end;
                     end;
                  110:begin
                        // nb`Oi[U`j
                        if (o2 = (mHa3N-1)) then
                           if not(mHa3[o2].exf) then begin
                              mHa3[o2].in_id := nil;
                              mHa3[o2].hl    := nil;
                              Dec(mHa3N);
                           end;
                     end;
                  111:begin
                        // nb`Oip^[j
                        if (o2 = (mHa4N-1)) then
                           if not(mHa4[o2].exf) then begin
                              mHa4[o2].in_id := nil;
                              mHa4[o2].hl    := nil;
                              Dec(mHa4N);
                           end;
                     end;
                  112:begin
                        // nb`Oiߓhj
                        if (o2 = (mHa5N-1)) then
                           if not(mHa5[o2].exf) then begin
                              mHa5[o2].in_id := nil;
                              Dec(mHa5N);
                           end;
                     end;
                  113:begin
                        // nb`OiOf[Vhj
                        if (o2 = (mHa6N-1)) then
                           if not(mHa6[o2].exf) then begin
                              mHa6[o2].in_id := nil;
                              Dec(mHa6N);
                           end;
                     end;
                  114:begin
                        // nb`Oi摜hj
                        if (o2 = (mHa7N-1)) then
                           if not(mHa7[o2].exf) then begin
                              mHa7[o2].in_id := nil;
                              Dec(mHa7N);
                           end;
                     end;
                  end;
               end;
            end
            else if (et < 0)and(et >= -sDefN) then begin
               with sDef[-et-1] do begin
                  o0 := datn ;
               end;
               with sDefD[o0] do begin
                  o1 := mOrd[en].DataType ;
                  o2 := mOrd[en].DataNo ;
                  case (o1) of
                  1: begin
                        // _}[J
                        if (o2 = (mTenN-1)) then
                           if not(mTen[o2].exf) then
                              Dec(mTenN);
                     end;
                  2: begin
                        // 
                        if (o2 = (mLinN-1)) then
                           if not(mLin[o2].exf) then
                              Dec(mLinN);
                     end;
                  3: begin
                        // ܐ
                        if (o2 = (mLnsN-1)) then
                           if not(mLns[o2].exf) then begin
                              mLns[o2].X := nil;
                              mLns[o2].Y := nil;
                              Dec(mLnsN);
                           end;
                     end;
                  4: begin
                        // ~
                        if (o2 = (mCirN-1)) then
                           if not(mCir[o2].exf) then
                              Dec(mCirN);
                     end;
                  5: begin
                        // ~
                        if (o2 = (mArcN-1)) then
                           if not(mArc[o2].exf) then
                              Dec(mArcN);
                     end;
                  6: begin
                        // ȉ~
                        if (o2 = (mEllN-1)) then
                           if not(mEll[o2].exf) then
                              Dec(mEllN);
                     end;
                  7: begin
                        // ȉ~
                        if (o2 = (mEArN-1)) then
                           if not(mEAr[o2].exf) then
                              Dec(mEArN);
                     end;
                  8: begin
                        // 
                        if (o2 = (mTxtN-1)) then
                           if not(mTxt[o2].exf) then
                              Dec(mTxtN);
                     end;
                  9: begin
                        // xWFȐ
                        if (o2 = (mBezN-1)) then
                           if not(mBez[o2].exf) then begin
                              mBez[o2].X := nil;
                              mBez[o2].Y := nil;
                              Dec(mBezN);
                           end;
                     end;
                  10:begin
                        // aXvCȐ
                        if (o2 = (mBspN-1)) then
                           if not(mBsp[o2].exf) then begin
                              mBsp[o2].X := nil;
                              mBsp[o2].Y := nil;
                              Dec(mBspN);
                           end;
                     end;
                  11:begin
                        // XvCȐ
                        if (o2 = (mSplN-1)) then
                           if not(mSpl[o2].exf) then begin
                              mSpl[o2].X := nil;
                              mSpl[o2].Y := nil;
                              Dec(mSplN);
                           end;
                     end;
                  12:begin
                        // N\ChȐ
                        if (o2 = (mCloN-1)) then
                           if not(mClo[o2].exf) then
                              Dec(mCloN);
                     end;
                  13:begin
                        // 
                        if (o2 = (mArwN-1)) then
                           if not(mArw[o2].exf) then
                              Dec(mArwN);
                     end;
                  15:begin
                        // 
                        if (o2 = (mDocN-1)) then
                           if not(mDoc[o2].exf) then
                              Dec(mDocN);
                     end;
                  16:begin
                        // \
                        if (o2 = (mTblN-1)) then
                           if not(mTbl[o2].exf) then begin
                              with mTbl[o2] do begin
                                 ColWidth := nil;
                                 RowHeight:= nil;
                                 align    := nil;
                                 str      := nil;
                                 calc     := nil;
                              end;
                              Dec(mTblN);
                           end;
                     end;
                  101:begin
                        // @
                        if (o2 = (mDLnN-1)) then
                           if not(mDLn[o2].exf) then
                              Dec(mDLnN);
                     end;
                  102:begin
                        // ʒ@
                        if (o2 = (mDArN-1)) then
                           if not(mDAr[o2].exf) then
                              Dec(mDArN);
                     end;
                  103:begin
                        // px@
                        if (o2 = (mDAnN-1)) then
                           if not(mDAn[o2].exf) then
                              Dec(mDAnN);
                     end;
                  104:begin
                        // a@
                        if (o2 = (mDRaN-1)) then
                           if not(mDRa[o2].exf) then
                              Dec(mDRaN);
                     end;
                  105:begin
                        // a@
                        if (o2 = (mDDiN-1)) then
                           if not(mDDi[o2].exf) then
                              Dec(mDDiN);
                     end;
                  106:begin
                        // o
                        if (o2 = (mDLeN-1)) then
                           if not(mDLe[o2].exf) then begin
                              mDLe[o2].vertex_x := nil;
                              mDLe[o2].vertex_y := nil;
                              Dec(mDLeN);
                           end;
                     end;
                  107:begin
                        // o[
                        if (o2 = (mDBaN-1)) then
                           if not(mDBa[o2].exf) then begin
                              mDBa[o2].vertex_x := nil;
                              mDBa[o2].vertex_y := nil;
                              Dec(mDBaN);
                           end;
                     end;
                  108:begin
                        // nb`Oi`j
                        if (o2 = (mHa1N-1)) then
                           if not(mHa1[o2].exf) then begin
                              mHa1[o2].in_id := nil;
                              mHa1[o2].hl    := nil;
                              Dec(mHa1N);
                           end;
                     end;
                  109:begin
                        // nb`Oihj
                        if (o2 = (mHa2N-1)) then
                           if not(mHa2[o2].exf) then begin
                              mHa2[o2].in_id := nil;
                              Dec(mHa2N);
                           end;
                     end;
                  110:begin
                        // nb`Oi[U`j
                        if (o2 = (mHa3N-1)) then
                           if not(mHa3[o2].exf) then begin
                              mHa3[o2].in_id := nil;
                              mHa3[o2].hl    := nil;
                              Dec(mHa3N);
                           end;
                     end;
                  111:begin
                        // nb`Oip^[j
                        if (o2 = (mHa4N-1)) then
                           if not(mHa4[o2].exf) then begin
                              mHa4[o2].in_id := nil;
                              mHa4[o2].hl    := nil;
                              Dec(mHa4N);
                           end;
                     end;
                  112:begin
                        // nb`Oiߓhj
                        if (o2 = (mHa5N-1)) then
                           if not(mHa5[o2].exf) then begin
                              mHa5[o2].in_id := nil;
                              Dec(mHa5N);
                           end;
                     end;
                  113:begin
                        // nb`OiOf[Vhj
                        if (o2 = (mHa6N-1)) then
                           if not(mHa6[o2].exf) then begin
                              mHa6[o2].in_id := nil;
                              Dec(mHa6N);
                           end;
                     end;
                  114:begin
                        // nb`Oi摜hj
                        if (o2 = (mHa7N-1)) then
                           if not(mHa7[o2].exf) then begin
                              mHa7[o2].in_id := nil;
                              Dec(mHa7N);
                           end;
                     end;
                  end;
               end;
            end;
         end;
      7: begin  // Ȑvf
            if (et >= 0)and(et <= (cDefN-1)) then begin
               with cDef[et] do begin
                  o0 := datn ;
               end;
               with cDefD[o0] do begin
                  o1 := mOrd[en].DataType ;
                  o2 := mOrd[en].DataNo ;
                  case (o1) of
                  3: begin
                        // ܐ
                        if (o2 = (mLnsN-1)) then
                           if not(mLns[o2].exf) then begin
                              mLns[o2].X := nil;
                              mLns[o2].Y := nil;
                              Dec(mLnsN);
                           end;
                     end;
                  5: begin
                        // ~
                        if (o2 = (mArcN-1)) then
                           if not(mArc[o2].exf) then
                              Dec(mArcN);
                     end;
                  7: begin
                        // ȉ~
                        if (o2 = (mEArN-1)) then
                           if not(mEAr[o2].exf) then
                              Dec(mEArN);
                     end;
                  9: begin
                        // xWFȐ
                        if (o2 = (mBezN-1)) then
                           if not(mBez[o2].exf) then begin
                              mBez[o2].X := nil;
                              mBez[o2].Y := nil;
                              Dec(mBezN);
                           end;
                     end;
                  10:begin
                        // aXvCȐ
                        if (o2 = (mBspN-1)) then
                           if not(mBsp[o2].exf) then begin
                              mBsp[o2].X := nil;
                              mBsp[o2].Y := nil;
                              Dec(mBspN);
                           end;
                     end;
                  11:begin
                        // XvCȐ
                        if (o2 = (mSplN-1)) then
                           if not(mSpl[o2].exf) then begin
                              mSpl[o2].X := nil;
                              mSpl[o2].Y := nil;
                              Dec(mSplN);
                           end;
                     end;
                  end;
               end;
            end
         end;
      end
   end;

   Inc(OpeNumber);
end;


// ----- ----- -----

// ݂̃C擾
//
// (ret)C
// zLayMax : ő僌Cԍ
function TDataClass.GetLayerNum : Integer;
var
   m,r,i : integer ;
begin
   m := 0 ;
   r := 0 ;
   for i:=0 to zLayN-1 do begin
      if not(zLay[i].exf) then continue ;
      if (m < zLay[i].no) then m := zLay[i].no ;
      Inc(r);
   end;

   zLayMax := m ;
   Result := r ;
end;

// Cԍ̗vfindex擾
//
//    n : Cԍ 1-256
// (ret) -1:݂Ȃ 0`:vfindex
function TDataClass.GetLayerIdx(n:integer) : Integer;
var
   i : integer ;
begin
   Result := -1 ;
   if (n < 1)or(n > LAYER_MAX_NUM) then exit;
   for i:=0 to zLayN-1 do begin
      if not(zLay[i].exf) then continue ;
      if (n = zLay[i].no) then begin
         Result := i ;
         break ;
      end;
   end;
end;

// w肵C̃Cԍ擾
//    n  : `FbNO郌Cԍ(0,1-256)
//    s  : C
// (ret) 1`256FCԍ@0:o^
//    xPlA擪32oCgŃ`FbN
//    C̏d`FbNɂp
function TDataClass.LayerNameCheck(n:integer;s:string) : Integer;
var
   i,j : integer;
   s1,s2 : AnsiString ;
begin
   Result := 0 ;
   s1 := AnsiString(s) ;
   s1 := MidStr2(s1,1,32,j);
   for i:=0 to zLayN-1 do begin
      if not(zLay[i].exf) then continue ;
      if (zLay[i].no = n) then continue;    // w背Cԍ̓`FbNX[
      s2 := AnsiString(zLay[i].name) ;
      s2 := MidStr2(s2,1,32,j);
      if (s1 = s2) then begin
         Result := zLay[i].no ;
         break ;
      end;
   end;
end;

// w肵C̗vfindex擾
//    n  : `FbNO郌Cԍ(0,1-256)
//    s  : C
// (ret) 0`FCindex@-1:o^
//    xPlA擪32oCgŃ`FbN
//    C̏d`FbNɂp
function TDataClass.LayerNameIdx(n:integer;s:string) : Integer;
var
   i,j : integer;
   s1,s2 : AnsiString ;
begin
   Result := -1 ;
   s1 := AnsiString(s) ;
   s1 := MidStr2(s1,1,32,j);
   for i:=0 to zLayN-1 do begin
      if not(zLay[i].exf) then continue ;
      if (zLay[i].no = (n-1)) then continue;    // w背Cԍ̓`FbNX[
      s2 := AnsiString(zLay[i].name) ;
      s2 := MidStr2(s2,1,32,j);
      if (s1 = s2) then begin
         Result := i ;
         break ;
      end;
   end;
end;

// C@f[^ڂ̒ǉo^
//    n  : Cԍ(1-256)
//    s  : C
//    fla: \tO(0,1)
//    col: CF  (1-256)
//    ltp: C(1-32)
//    wid: C(1-16)
//    fnt: CtHg(1-1024)
// (ret) True:o^OK@False:NG
function TDataClass.AddLayer(n:integer;s:string;fla,col,ltp,wid,fnt,cn1,cn2:integer) : Boolean;
var
   idx : integer ;
begin
   Result := False;
   if (n < 1)or(n > LAYER_MAX_NUM) then exit;   // Cԍ`FbN
   idx := GetLayerIdx(n);
   if (idx > -1) then exit ;                    // CԍɎgp
   if not(StrCheck(s)) then exit;               // 񐔃`FbN
   if (LayerNameCheck(0,s) > 0) then exit;      // ɃC͎gp

   if (fla <> 0) then fla := 1;
   if (col < 1)or(col > zColMax) then col := 1;
   if (ltp < 1)or(ltp > zLtpMax)or(ltp = 16) then ltp := 1;
   if (wid < 1)or(wid > zWidMax) then wid := 1;
   if (fnt < 1)or(fnt > zFntMax) then fnt := 1;

   try
      Inc(zLayN);
      SetLength(zLay, zLayN);
      with zLay[zLayN-1] do begin
         exf   := True ;
         no    := n ;
         name  := s ;
         Lflag := fla ;
         Color := col ;
         Ltype := ltp ;
         Width := wid ;
         Mfont := fnt ;
         cnt   := cn1 ;
         Fcnt  := cn2 ;
      end;
      if (OpAdd(1,1,zLayN-1)) then begin
         Result := True ;
         if (zLayMax < n) then zLayMax := n ;
      end
      else
         Dec(zLayN);
   except
      Dec(zLayN);
   end;
end;

// C@f[^ڂ̍폜
//    n : Cԍ
// (ret) True:OK@False:NG
function TDataClass.DelLayer(n:integer) : Boolean;
var
   i : integer ;
begin
   Result := False ;
   i := GetLayerIdx(n); // vfindex
   if (i > -1) then begin
      if (OpAdd(2,1,i)) then begin
         zLay[i].exf := False ;
         if (n = zLayMax) then GetLayerNum;  // ő僌CԍXV
         Result := True ;
      end;
   end;
end;

// C@f[^ڂ̎擾
//    n  : Cԍ(1-256)
//    s  : C
//    fla: \tO(0,1)
//    col: CF  (1-256)
//    ltp: C(1-32)
//    wid: C(1-16)
//    fnt: CtHg(1-1024)
//    cn1: Cvf
//    cn2: }``̃Cvf
// (ret) True:OK@False:NG
function TDataClass.GetLayer(n:integer;var s:string;var fla,col,ltp,wid,fnt,cn1,cn2:integer) : Boolean;
var
   idx : integer ;
begin
   Result := False;
   if (n < 1)or(n > LAYER_MAX_NUM) then exit;   // Cԍ`FbN
   idx := GetLayerIdx(n);
   if (idx = -1) then exit ;                    // gpCԍ

   with zLay[idx] do begin
      s   := name ;
      fla := Lflag ;
      col := Color ;
      ltp := Ltype ;
      wid := Width ;
      fnt := Mfont ;
      cn1 := cnt ;
      cn2 := Fcnt ;
   end;

   Result := True ;
end;

// C@f[^ڂ̕ҏWo^
//    n  : Cԍ(1-256)
//    s  : C                    '':ύXȂ
//    fla: \tO(0,1)             -1:ύXȂ
//    col: CF  (1-256)           -1:ύXȂ
//    ltp: C(1-32)            -1:ύXȂ
//    wid: C(1-16)            -1:ύXȂ
//    fnt: CtHg(1-1024)  -1:ύXȂ
// (ret) True:OK@False:NG
function TDataClass.EditLayer(n:integer;s:string;fla,col,ltp,wid,fnt:integer) : Boolean;
var
   idx,cn1,cn2 : integer ;
begin
   Result := False;
   if (n < 1)or(n > LAYER_MAX_NUM) then exit;   // Cԍ`FbN
   idx := GetLayerIdx(n);
   if (idx = -1) then exit ;                    // gpCԍ

   with zLay[idx] do begin
      if (s = '')    then s   := name ;
      if (fla = -1)  then fla := Lflag ;
      if (col = -1)  then col := Color ;
      if (ltp = -1)  then ltp := Ltype ;
      if (wid = -1)  then wid := Width ;
      if (fnt = -1)  then fnt := Mfont ;
      cn1 := cnt ;
      cn2 := Fcnt ;
   end;

   if not(StrCheck(s)) then exit;               // 񐔃`FbN
   if (LayerNameCheck(n,s) > 0) then exit;      // ɃC͎gp

   if (fla <> 0) then fla := 1;
   if (col < 1)or(col > zColMax) then col := 1;
   if (ltp < 1)or(ltp > zLtpMax)or(ltp = 16) then ltp := 1;
   if (wid < 1)or(wid > zWidMax) then wid := 1;
   if (fnt < 1)or(fnt > zFntMax) then fnt := 1;

   if (DelLayer(n)) then begin
      if (AddLayer(n,s,fla,col,ltp,wid,fnt,cn1,cn2)) then
         Result := True ;
   end;
end;

// ݂̐F擾
//
// (ret)F
// zColMax : őFԍ
function TDataClass.GetColorNum : Integer;
var
   m,r,i : integer ;
begin
   m := 0 ;
   r := 0 ;
   for i:=0 to zColN-1 do begin
      if not(zCol[i].exf) then continue ;
      if (m < zCol[i].no) then m := zCol[i].no ;
      Inc(r);
   end;

   zColMax := m ;
   Result := r ;
end;

// Fԍ̗vfindex擾
//
//    n : Fԍ 1-256
// (ret) -1:݂Ȃ 0`:vfindex
function TDataClass.GetColorIdx(n:integer) : Integer;
var
   i : integer ;
begin
   Result := -1 ;
   if (n < 1)or(n > COLOR_MAX_NUM) then exit;
   for i:=0 to zColN-1 do begin
      if not(zCol[i].exf) then continue ;
      if (n = zCol[i].no) then begin
         Result := i ;
         break ;
      end;
   end;
end;

// F@f[^ڂ̒ǉo^
//    n : Fԍ(1-256)
//    r : ql(0-255)
//    g : fl(0-255)
//    b : al(0-255)
// (ret) True:o^OK@False:NG
function TDataClass.AddColor(n,r,g,b,cn1,cn2:integer) : Boolean;
var
   idx : integer ;
begin
   Result := False;
   if (n < 1)or(n > COLOR_MAX_NUM) then exit;   // Fԍ`FbN
   idx := GetColorIdx(n);
   if (idx > -1) then exit ;                    // ԍɎgp

   if (r < 0) then r := 0;
   if (g < 0) then g := 0;
   if (b < 0) then b := 0;
   if (r > 255) then r := 255;
   if (g > 255) then g := 255;
   if (b > 255) then b := 255;

   try
      Inc(zColN);
      SetLength(zCol, zColN);
      with zCol[zColN-1] do begin
         exf   := True ;
         no    := n ;
         Red   := r ;
         Green := g ;
         Blue  := b ;
         cnt   := cn1 ;
         Fcnt  := cn2 ;
      end;
      if (OpAdd(1,2,zColN-1)) then begin
         Result := True ;
         if (zColMax < n) then zColMax := n ;
      end
      else
         Dec(zColN);
   except
      Dec(zColN);
   end;
end;

// F@f[^ڂ̍폜
//    n : Fԍ
// (ret) True:OK@False:NG
function TDataClass.DelColor(n:integer) : Boolean;
var
   i : integer ;
begin
   Result := False ;
   i := GetColorIdx(n); // vfindex
   if (i > -1) then begin
      if (OpAdd(2,2,i)) then begin
         zCol[i].exf := False ;
         if (n = zColMax) then GetColorNum;  // őFԍXV
         Result := True ;
      end;
   end;
end;

// F@f[^ڂ̎擾
//    n : Fԍ(1-256)
//    r : ql(0-255)
//    g : fl(0-255)
//    b : al(0-255)
//    cn1: vf
//    cn2: }``̗vf
// (ret) True:OK@False:NG
function TDataClass.GetColor(n:integer;var r,g,b,cn1,cn2:integer) : Boolean;
var
   idx : integer ;
begin
   Result := False;
   if (n < 1)or(n > COLOR_MAX_NUM) then exit;   // ԍ`FbN
   idx := GetColorIdx(n);
   if (idx = -1) then exit ;                    // gpԍ

   with zCol[idx] do begin
      r   := Red ;
      g   := Green ;
      b   := Blue ;
      cn1 := cnt ;
      cn2 := Fcnt ;
   end;
   Result := True ;
end;

// F@f[^ڂ̕ҏWo^
//    n : Fԍ(1-256)
//    r : ql(0-255)      -1:ύXȂ
//    g : fl(0-255)      -1:ύXȂ
//    b : al(0-255)      -1:ύXȂ
// (ret) True:o^OK@False:NG
//    Fԍ 1-16̕ҏWo^\łASXFdlł͗pґɂҏW͕s
function TDataClass.EditColor(n:integer;r,g,b:integer) : Boolean;
var
   idx,cn1,cn2 : integer ;
begin
   Result := False;
   if (n < 1)or(n > COLOR_MAX_NUM) then exit;   // ԍ`FbN
   idx := GetColorIdx(n);
   if (idx = -1) then exit ;                    // gpԍ

   with zCol[idx] do begin
      if (r = -1)  then r := Red ;
      if (g = -1)  then g := Green ;
      if (b = -1)  then b := Blue ;
      cn1 := cnt ;
      cn2 := Fcnt ;
   end;

   if (r < 0) then r := 0;
   if (g < 0) then g := 0;
   if (b < 0) then b := 0;
   if (r > 255) then r := 255;
   if (g > 255) then g := 255;
   if (b > 255) then b := 255;

   if (DelColor(n)) then begin
      if (AddColor(n,r,g,b,cn1,cn2)) then
         Result := True ;
   end;
end;

// ݂̐퐔擾
//
// (ret)퐔
// zLtpMax : őԍ
function TDataClass.GetLtypeNum : Integer;
var
   m,r,i : integer ;
begin
   m := 0 ;
   r := 0 ;
   for i:=0 to zLtpN-1 do begin
      if not(zLtp[i].exf) then continue ;
      if (m < zLtp[i].no) then m := zLtp[i].no ;
      Inc(r);
   end;

   zLtpMax := m ;
   Result := r ;
end;

// ԍ̗vfindex擾
//
//    n : ԍ 1-32
// (ret) -1:݂Ȃ 0`:vfindex
function TDataClass.GetLtypeIdx(n:integer) : Integer;
var
   i : integer ;
begin
   Result := -1 ;
   if (n < 1)or(n > LTYPE_MAX_NUM) then exit;
   for i:=0 to zLtpN-1 do begin
      if not(zLtp[i].exf) then continue ;
      if (n = zLtp[i].no) then begin
         Result := i ;
         break ;
      end;
   end;
end;

// w肵햼̐ԍ擾
//    n  : `FbNOԍ(0,1-32)
//    s  : 햼
// (ret) 1`32Fԍ@0:o^
//   햼̏d`FbNɂp
function TDataClass.LtypeNameCheck(n:integer;s:string) : Integer;
var
   i : integer;
   s2 : String ;
begin
   Result := 0 ;
   for i:=0 to zLtpN-1 do begin
      if not(zLtp[i].exf) then continue ;
      if (zLtp[i].no = n) then continue;  // wԍ̓`FbNX[
      s2 := zLtp[i].name ;
      if (s = s2) then begin
         Result := zLtp[i].no;
         break ;
      end;
   end;
end;

// w肵햼̗vfindex擾
//    n  : `FbNOԍ(0,1-32)
//    s  : 햼
// (ret) 0`Findex@-1:o^
function TDataClass.LtypeNameIdx(n:integer;s:string) : Integer;
var
   i : integer;
   s2 : String ;
begin
   Result := 0 ;
   for i:=0 to zLtpN-1 do begin
      if not(zLtp[i].exf) then continue ;
      if (zLtp[i].no = n) then continue;  // wԍ̓`FbNX[
      s2 := zLtp[i].name ;
      if (s = s2) then begin
         Result := i ;
         break ;
      end;
   end;
end;

// @f[^ڂ̒ǉo^
//    s  : 햼
//    seg: ZOg(0-10)
//    pit: esb` (10vf)
// (ret) True:o^OK@False:NG
function TDataClass.AddLtype(n:integer;s:string;seg:integer;pit:array of double;cn1,cn2:integer) : Boolean;
var
   idx : integer ;
   i : integer;
begin
   Result := False;
   if (n < 1)or(n > LTYPE_MAX_NUM) then exit;   // ԍ`FbN
   idx := GetLtypeIdx(n);
   if (idx > -1) then exit ;                    // ԍɎgp
   if not(StrCheck(s)) then exit;            // 񐔃`FbN
   if (LtypeNameCheck(0,s) > 0) then exit;   // ɐ햼͎gp

   if (seg < 0)or(seg > 10) then seg := 0;
   for i:=0 to 9 do begin
      if (pit[i] <    0.0) then pit[i] :=    0.0;
      if (pit[i] > 1000.0) then pit[i] := 1000.0;
   end;

   try
      Inc(zLtpN);
      SetLength(zLtp, zLtpN);
      with zLtp[zLtpN-1] do begin
         exf   := True ;
         no    := n ;
         name     := s ;
         Segment  := seg ;
         for i:=0 to 9 do
            Pitch[i] := 0.0 ;
         for i:=0 to seg-1 do
            Pitch[i] := pit[i] ;
         SpaceMax := 0.0 ;
         for i:=0 to (seg div 2 - 1) do begin
            if (SpaceMax < Pitch[i*2+1]) then
               SpaceMax := Pitch[i*2+1] ;
         end;
         cnt   := cn1 ;
         Fcnt  := cn2 ;
      end;
      if (OpAdd(1,3,zLtpN-1)) then begin
         Result := True ;
         if (zLtpMax < n) then zLtpMax := n ;
      end
      else
         Dec(zLtpN);
   except
      Dec(zLtpN);
   end;
end;

// @f[^ڂ̍폜
//    n : ԍ
// (ret) True:OK@False:NG
function TDataClass.DelLtype(n:integer) : Boolean;
var
   i : integer ;
begin
   Result := False ;
   i := GetLtypeIdx(n); // vfindex
   if (i > -1) then begin
      if (OpAdd(2,3,i)) then begin
         zLtp[i].exf := False ;
         if (n = zLtpMax) then GetLtypeNum;  // őԍXV
         Result := True ;
      end;
   end;
end;

// @f[^ڂ̎擾
//    n  : ԍ(1-32)
//    s  : 햼
//    seg: ZOg(0-10)
//    pit: esb` (10vf)
//    cn1: vf
//    cn2: }``̗vf
// (ret) True:OK@False:NG
function TDataClass.GetLtype(n:integer;var s:string;var seg:integer;var pit:array of double;var cn1,cn2:integer) : Boolean;
var
   idx : integer ;
   i : integer;
begin
   Result := False;
   if (n < 1)or(n > LTYPE_MAX_NUM) then exit;   // ԍ`FbN
   idx := GetLtypeIdx(n);
   if (idx = -1) then exit ;                    // gpԍ

   with zLtp[idx] do begin
      s   := name ;
      seg := Segment ;
      for i:=0 to 9 do
         pit[i] := 0.0 ;
      for i:=0 to seg-1 do
         pit[i] := Pitch[i] ;
      cn1 := cnt ;
      cn2 := Fcnt ;
   end;
   Result := True ;
end;

// @f[^ڂ̕ҏWo^
//    n  : ԍ(1-32)
//    s  : 햼                '':ύXȂ
//    seg: ZOg(0-10)    -1:ύXȂ
//    pit: esb` (10vf)     -1:ύXȂ
// (ret) True:o^OK@False:NG
function TDataClass.EditLtype(n:integer;s:string;seg:integer;pit:array of double) : Boolean;
var
   idx,cn1,cn2 : integer ;
   i : integer;
begin
   Result := False;
   if (n < 1)or(n > LTYPE_MAX_NUM) then exit;   // ԍ`FbN
   idx := GetLtypeIdx(n);
   if (idx = -1) then exit ;                    // gpԍ

   with zLtp[idx] do begin
      if (s = '')    then s   := name ;
      if (seg = -1)  then seg := Segment ;
      for i:=0 to 9 do
         if (pit[i] >= (-1.0-LIMIT8))and(pit[i] <= (-1.0+LIMIT8)) then
            pit[i] := Pitch[i] ;
      cn1 := cnt ;
      cn2 := Fcnt ;
   end;

   if not(StrCheck(s)) then exit;            // 񐔃`FbN
   if (LtypeNameCheck(n,s) > 0) then exit;   // ɐ햼͎gp

   if (seg < 0)or(seg > 10) then seg := 0;
   for i:=0 to 9 do begin
      if (pit[i] <    0.0) then pit[i] :=    0.0;
      if (pit[i] > 1000.0) then pit[i] := 1000.0;
   end;

   if (DelLtype(n)) then begin
      if (AddLtype(n,s,seg,pit,cn1,cn2)) then
         Result := True ;
   end;
end;

// ݂̐擾
//
// (ret)
// zLtpMax : őԍ
function TDataClass.GetWidthNum : Integer;
var
   m,r,i : integer ;
begin
   m := 0 ;
   r := 0 ;
   for i:=0 to zWidN-1 do begin
      if not(zWid[i].exf) then continue ;
      if (m < zWid[i].no) then m := zWid[i].no ;
      Inc(r);
   end;

   zWidMax := m ;
   Result := r ;
end;

// ԍ̗vfindex擾
//
//    n : ԍ 1-16
// (ret) -1:݂Ȃ 0`:vfindex
function TDataClass.GetWidthIdx(n:integer) : Integer;
var
   i : integer ;
begin
   Result := -1 ;
   if (n < 1)or(n > WIDTH_MAX_NUM) then exit;
   for i:=0 to zWidN-1 do begin
      if not(zWid[i].exf) then continue ;
      if (n = zWid[i].no) then begin
         Result := i ;
         break ;
      end;
   end;
end;

// @f[^ڂ̒ǉo^
//    w : (0.01-1000)
// (ret) True:o^OK@False:NG
function TDataClass.AddWidth(n:integer;w:double;cn1,cn2:integer) : Boolean;
var
   idx : integer ;
begin
   Result := False;
   if (n < 1)or(n > WIDTH_MAX_NUM) then exit;   // ԍ`FbN
   idx := GetWidthIdx(n);
   if (idx > -1) then exit ;                    // ԍɎgp

   if (w <   0.01) then w :=   0.01;
   if (w > 1000.0) then w := 1000.0;   // SXFdlł 010^15Ƃ܂

   try
      Inc(zWidN);
      SetLength(zWid, zWidN);
      with zWid[zWidN-1] do begin
         exf   := True ;
         no    := n ;
         Width := w ;
         cnt   := cn1 ;
         Fcnt  := cn2 ;
      end;
      if (OpAdd(1,4,zWidN-1)) then begin
         Result := True ;
         if (zWidMax < n) then zWidMax := n ;
      end
      else
         Dec(zWidN);
   except
      Dec(zWidN);
   end;
end;

// @f[^ڂ̍폜
//    n : ԍ
// (ret) True:OK@False:NG
function TDataClass.DelWidth(n:integer) : Boolean;
var
   i : integer ;
begin
   Result := False ;
   i := GetWidthIdx(n); // vfindex
   if (i > -1) then begin
      if (OpAdd(2,4,i)) then begin
         zWid[i].exf := False ;
         if (n = zWidMax) then GetWidthNum;  // őԍXV
         Result := True ;
      end;
   end;
end;

// @f[^ڂ̎擾
//    n : ԍ(1-16)
//    w : (0.01-1000)
//    cn1: vf
//    cn2: }``̗vf
// (ret) True:OK@False:NG
function TDataClass.GetWidth(n:integer;var w:double;var cn1,cn2:integer) : Boolean;
var
   idx : integer ;
begin
   Result := False;
   if (n < 1)or(n > WIDTH_MAX_NUM) then exit;   // ԍ`FbN
   idx := GetWidthIdx(n);
   if (idx = -1) then exit ;                    // gpԍ

   with zWid[idx] do begin
      w   := Width ;
      cn1 := cnt ;
      cn2 := Fcnt ;
   end;
   Result := True ;
end;

// @f[^ڂ̕ҏWo^
//    n : ԍ(1-16)
//    w : (0.01-1000)     -1:ύXȂ
// (ret) True:o^OK@False:NG
function TDataClass.EditWidth(n:integer;w:double) : Boolean;
var
   idx,cn1,cn2 : integer ;
begin
   Result := False;
   if (n < 1)or(n > WIDTH_MAX_NUM) then exit;   // ԍ`FbN
   idx := GetWidthIdx(n);
   if (idx = -1) then exit ;                    // gpԍ

   with zWid[idx] do begin
      if (w >= (-1.0-LIMIT8))and(w <= (-1.0+LIMIT8)) then
         w := Width ;
      cn1 := cnt ;
      cn2 := Fcnt ;
   end;

   if (w <   0.01) then w :=   0.01;
   if (w > 1000.0) then w := 1000.0;   // SXFdlł 010^15Ƃ܂

   if (DelWidth(n)) then begin
      if (AddWidth(n,w,cn1,cn2)) then
         Result := True ;
   end;
end;

// ݂̕tHg擾
//
// (ret)tHg
// zLtpMax : ő啶tHgԍ
function TDataClass.GetFontNum : Integer;
var
   m,r,i : integer ;
begin
   m := 0 ;
   r := 0 ;
   for i:=0 to zFntN-1 do begin
      if not(zFnt[i].exf) then continue ;
      if (m < zFnt[i].no) then m := zFnt[i].no ;
      Inc(r);
   end;

   zFntMax := m ;
   Result := r ;
end;

// tHgԍ̗vfindex擾
//
//    n : tHgԍ 1-1024
// (ret) -1:݂Ȃ 0`:vfindex
function TDataClass.GetFontIdx(n:integer) : Integer;
var
   i : integer ;
begin
   Result := -1 ;
   if (n < 1)or(n > MFONT_MAX_NUM) then exit;
   for i:=0 to zFntN-1 do begin
      if not(zFnt[i].exf) then continue ;
      if (n = zFnt[i].no) then begin
         Result := i ;
         break ;
      end;
   end;
end;

// w肵tHg̕tHgԍ擾
//    n  : `FbNO镶tHgԍ(0,1-1024)
//    s  : tHg
// (ret) 1`1024Fԍ@0:o^
function TDataClass.FontNameCheck(n:integer;s:string) : Integer;
var
   i : integer;
   s2 : String ;
begin
   Result := 0 ;
   for i:=0 to zFntN-1 do begin
      if not(zFnt[i].exf) then continue ;
      if (zFnt[i].no = n) then continue;  // w蕶tHgԍ̓`FbNX[
      s2 := zFnt[i].name ;
      if (s = s2) then begin
         Result := zFnt[i].no;
         break ;
      end;
   end;
end;

// tHg@f[^ڂ̒ǉo^
//    s  : tHg
// (ret) True:o^OK@False:NG
function TDataClass.AddFont(n:integer;s:string;cn1,cn2:integer) : Boolean;
var
   idx : integer ;
begin
   Result := False;
   if (n < 1)or(n > MFONT_MAX_NUM) then exit;   // tHgԍ`FbN
   idx := GetFontIdx(n);
   if (idx > -1) then exit ;                    // ԍɎgp
   if not(StrCheck(s)) then exit;               // 񐔃`FbN
   // if (FontNameCheck(0,s) > 0) then exit;    // ***ɕtHg͎gp***d`FbN͂Ȃ

   try
      Inc(zFntN);
      SetLength(zFnt, zFntN);
      with zFnt[zFntN-1] do begin
         exf   := True ;
         no    := n ;
         name  := s ;
         cnt   := cn1 ;
         Fcnt  := cn2 ;
      end;
      if (OpAdd(1,5,zFntN-1)) then begin
         Result := True ;
         if (zFntMax < n) then zFntMax := n ;
      end
      else
         Dec(zFntN);
   except
      Dec(zFntN);
   end;
end;

// tHg@f[^ڂ̍폜
//    n : tHgԍ
// (ret) True:OK@False:NG
function TDataClass.DelFont(n:integer) : Boolean;
var
   i : integer ;
begin
   Result := False ;
   i := GetFontIdx(n);  // vfindex
   if (i > -1) then begin
      if (OpAdd(2,5,i)) then begin
         zFnt[i].exf := False ;
         if (n = zFntMax) then GetFontNum;  // ő啶tHgԍXV
         Result := True ;
      end;
   end;
end;

// tHg@f[^ڂ̎擾
//    n  : tHgԍ(1-1024)
//    s  : tHg
//    cn1: vf
//    cn2: }``̗vf
// (ret) True:OK@False:NG
function TDataClass.GetFont(n:integer;var s:string;var cn1,cn2:integer) : Boolean;
var
   idx : integer ;
begin
   Result := False;
   if (n < 1)or(n > MFONT_MAX_NUM) then exit;   // ԍ`FbN
   idx := GetFontIdx(n);
   if (idx = -1) then exit ;                    // gpԍ

   with zFnt[idx] do begin
      s   := name ;
      cn1 := cnt ;
      cn2 := Fcnt ;
   end;
   Result := True ;
end;

// tHg@f[^ڂ̕ҏWo^
//    n  : tHgԍ(1-1024)
//    s  : tHg     '':ύXȂ
// (ret) True:o^OK@False:NG
function TDataClass.EditFont(n:integer;s:string) : Boolean;
var
   idx,cn1,cn2 : integer ;
begin
   Result := False;
   if (n < 1)or(n > MFONT_MAX_NUM) then exit;   // ԍ`FbN
   idx := GetFontIdx(n);
   if (idx = -1) then exit ;                    // gpԍ

   with zFnt[idx] do begin
      if (s = '') then s := name ;
      cn1 := cnt ;
      cn2 := Fcnt ;
   end;

   if not(StrCheck(s)) then exit;               // 񐔃`FbN
   // if (FontNameCheck(n,s) > 0) then exit;    // ***ɕtHg͎gp***d`FbN͂Ȃ

   if (DelFont(n)) then begin
      if (AddFont(n,s,cn1,cn2)) then
         Result := True ;
   end;
end;



// w肵}`̔ԍ擾
//    n  : `FbNOԍ(0,1`,`-1)
//    s  : }`
// (ret) 1`F}`̔ԍ@0:o^@`-1:V{̔ԍ
function TDataClass.FZukeiNameCheck(n:integer;s:string) : Integer;
var
   i : integer;
   s2 : String ;
begin
   Result := 0 ;
   for i:=0 to fDefN-1 do begin
      if not(fDef[i].exf) then continue;        // ݂Ȃꍇ̓X[
      if (n > 0)and(i = (n-1)) then continue;   // wԍ̓`FbNX[
      s2 := fDef[i].name ;
      if (s = s2) then begin
         Result := i + 1;
         break ;
      end;
   end;
   // V{̃`FbN
   if (Result = 0) then begin
      for i:=0 to sDefN-1 do begin
         if not(sDef[i].exf) then continue;           // ݂Ȃꍇ̓X[
         if (n < 0)and(i = (Abs(n)-1)) then continue; // wԍ̓`FbNX[
         s2 := sDef[i].name ;
         if (s = s2) then begin
            Result := -(i + 1);
            break ;
         end;
      end;
   end;
end;

// }``@f[^ڂ̒ǉo^
//    ł́AOƃtÔݓo^@̊ef[^͕ʓro^
//    s  : }`
//    f  : tO(1-4)
// (ret) True:o^OK@False:NG
function TDataClass.AddFZukeiDef(s:string;f:integer) : Boolean;
var
   l : integer ;
begin
   Result := False;
   if (f < 1)or(f > 4) then exit;   // tOwG[
   l := StrBytes(s);
   if (f <= 2) then begin
      if (l < 1)or(l > (256-9)) then exit;   // }(XY)P21t@Cu$$SXF_FM_v擪ɕt
                                             // }(YX)P21t@Cu$$SXF_FG_v擪ɕt
   end
   else begin
      if (l < 1)or(l > (256-8)) then exit;   // }O[vP21t@Cu$$SXF_G_v擪ɕt
                                             // }í@@P21t@Cu$$SXF_P_v擪ɕt
   end;
   if (FZukeiNameCheck(0,s) <> 0) then exit; // ɕ}`͎gp

   try
      Inc(fDefDN);
      SetLength(fDefD, fDefDN);
      DataClearZukeiMember(fDefDN-1);
      try
         Inc(fDefN);
         SetLength(fDef, fDefN);
         with fDef[fDefN-1] do begin
            exf   := True ;
            name  := s ;
            Flag  := f ;
            cnt   := 0 ;
            datn  := fDefDN-1 ;
         end;
         if (OpAdd(3,3,fDefN-1)) then begin
            Result := True ;
         end
         else begin
            Dec(fDefN);
            Dec(fDefDN);
         end;
      except
         Dec(fDefN);
         Dec(fDefDN);
      end;
   except
      Dec(fDefDN);
   end;
end;

// }``@f[^ڂ̍폜
//    n  : }`` vfIndex (0-)
// (ret) True:OK@False:NG
function TDataClass.DelFZukeiDef(n:integer) : Boolean;
begin
   Result := False ;
   if (n < 0)or(n >= fDefN) then exit;    // vfIndex`FbN
   if not(fDef[n].exf) then exit;         // ɍ폜

   if (OpAdd(4,3,n)) then begin
      fDef[n].exf := False ;
      Result := True ;
   end;
end;

// }``@f[^ڂ̎擾
//    n  : }`` vfIndex (0-)
//    ex : ݃tO
//    s  : }`
//    fl : tO(1-4)
//    cn : vf
//    dn : f[^vfIndex
// (ret) True:OK@False:NG
function TDataClass.GetFZukeiDef(n:integer;var ex:Boolean;var s:string;var f,cn,dn:integer) : Boolean;
begin
   Result := False;
   if (n < 0)or(n >= fDefN) then exit;    // vfIndex`FbN

   with fDef[n] do begin
      ex := exf ;
      s  := name ;
      f  := Flag ;
      cn := cnt ;
      dn := datn ;
   end;

   Result := True ;
end;

// }``@f[^ڂ̕ҏWo^
//    n  : }`` vfIndex (0-)
//    s  : }`
//    fl : tO(1-4)
//    cn : vf
//    dn : f[^vfIndex
// (ret) True:o^OK@False:NG
function TDataClass.EditFZukeiDef(n:integer;s:string;f,cn,dn:integer) : Boolean;
var
   l : integer ;
begin
   Result := False;
   if (n < 0)or(n >= fDefN) then exit;    // vfIndex`FbN
   if not(fDef[n].exf) then exit;         // ɍ폜
   if (dn < 0)or(dn >= fDefDN) then exit; // f[^vfIndex`FbN
   if not(StrCheck(s)) then exit;         // 񐔃`FbN
   if (f < 1)or(f > 4) then exit;         // tOwG[
   l := StrBytes(s);
   if (f <= 2) then begin
      if (l < 1)or(l > (256-9)) then exit;   // }(XY)P21t@Cu$$SXF_FM_v擪ɕt
                                             // }(YX)P21t@Cu$$SXF_FG_v擪ɕt
   end
   else begin
      if (l < 1)or(l > (256-8)) then exit;   // }O[vP21t@Cu$$SXF_G_v擪ɕt
                                             // }í@@P21t@Cu$$SXF_P_v擪ɕt
   end;
   if (FZukeiNameCheck(n+1,s)<>0) then exit; // ɕ}`͎gp(n͗vfindexȂ̂+1)

   if (DelFZukeiDef(n)) then begin
      if (AddFZukeiDef(s,f)) then begin
         with fDef[fDefN-1] do begin
            cnt   := cn ;
            datn  := dn ;
         end;
         Dec(fDefDN);         // vff[^͒ǉȂ̂-1Ă
         Result := True ;
      end;
   end;
end;


// }`zu@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`  null:p֒ǉ
//    lay: C(0,1-256)
//    nam: }`
//    px : zu_X
//    py : zu_Y
//    an : ]p[]
//    sx : ړxX
//    sy : ړxY
// (ret) True:o^OK@False:NG
function TDataClass.AddDataFZukei(s:string;lay:integer;nam:string;px,py,an,sx,sy:double) : Boolean;
var
   m,n,f1,f2,dn : integer ;
begin
   Result := False;
   n := FZukeiNameCheck(0,nam);
   if (n <= 0) then exit ;    // zu镡}`͖̂ŃG[
   if (fDef[n-1].Flag = 3) then begin
      // zu悤ƂĂ镡}`}O[v̏ꍇ
      if (fDef[n-1].cnt <> 0) then exit ;   // ɔzuς݂Ȃ̂ŃG[
      px := 0.0 ;
      py := 0.0 ;
      an := 0.0 ;
      sx := 1.0 ;
      sy := 1.0 ;
   end;

   if (lay < 0) or (lay > zLayMax) then lay := 0 ;
   an := SetAngle(an);
   if (sx < LIMIT8) then sx := 1.0;
   if (sy < LIMIT8) then sy := 1.0;

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,99,dFzkN)) then begin
         try
            Inc(dFzkN);
            SetLength(dFzk, dFzkN);
            with dFzk[dFzkN-1] do begin
               exf   := True ;
               Layer := lay ;
               name  := nam ;
               X     := px ;
               Y     := py ;
               Angle := an ;
               ratio_x  := sx ;
               ratio_y  := sy ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
         except
            Dec(dFzkN);
            SetLength(dFzk, dFzkN);
            Dec(dOrdN);
         end;
         if (Result) then
            fDef[n-1].cnt := fDef[n-1].cnt + 1 ; // zuJEg
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m <= 0) then exit ;    // ǉ̕}`͖̂ŃG[
      if (m =  n) then exit ;    // ǉƔzu̕}`Ȃ̂ŃG[
      f1 := fDef[m-1].Flag ;
      f2 := fDef[n-1].Flag ;
      if (f1 = 1)or(f1 = 2) then begin
         // ǉ悪}̏ꍇ
         if (f2 = 1)or(f2 = 2) then exit ;   // }̒ɕ}͕̂s
      end
      else if (f1 = 3) then begin
         // ǉ悪}O[v̏ꍇ
         if (f2 = 1)or(f2 = 2) then exit ;   // }O[v̒ɕ}͕̂s
      end
      else begin
         // ǉ悪}ȉꍇ
         if (f2 = 1)or(f2 = 2)or(f2 = 3) then exit ;  // }i̒ɕ}E}O[v͕̂s
      end;
      // [vɂȂ悤ȔzuȂ悤ӂĉ
      with fDef[m-1] do begin
         dn := datn ;
      end;
      with fDefD[dn] do begin
         if (AddDataOrder(m,99,mFzkN)) then begin
            try
               Inc(mFzkN);
               SetLength(mFzk, mFzkN);
               with mFzk[mFzkN-1] do begin
                  exf   := True ;
                  Layer := lay ;
                  name  := nam ;
                  X     := px ;
                  Y     := py ;
                  Angle := an ;
                  ratio_x  := sx ;
                  ratio_y  := sy ;
               end;
               OpAdd(5,m,mOrdN-1);
               Result := True ;
            except
               Dec(mFzkN);
               SetLength(mFzk, mFzkN);
               Dec(mOrdN);
            end;
            if (Result) then
               fDef[n-1].cnt := fDef[n-1].cnt + 1 ; // zuJEg
         end;
      end;
   end;
end;

// }`zu@f[^ڂ̎擾
//    s  : f[^ǉ̕}`  null:p֒ǉ
//    n  : }`zu  vfIndex (0-)
//    ex : ݃tO
//    lay: C(0,1-256)
//    nam: }`
//    px : zu_X
//    py : zu_Y
//    an : ]p[]
//    sx : ړxX
//    sy : ړxY
// (ret) True:OK@False:NG
function TDataClass.GetDataFZukei(s:string;n:integer;var ex:Boolean;var lay:integer;var nam:string;var px,py,an,sx,sy:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dFzkN) then exit;    // vfIndex`FbN
      with dFzk[n] do begin
         ex := exf ;
         lay:= Layer ;
         nam:= name ;
         px := X ;
         py := Y ;
         an := Angle ;
         sx := ratio_x ;
         sy := ratio_y ;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mFzkN) then exit;    // vfIndex`FbN
            with mFzk[n] do begin
               ex := exf ;
               lay:= Layer ;
               nam:= name ;
               px := X ;
               py := Y ;
               an := Angle ;
               sx := ratio_x ;
               sy := ratio_y ;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// }`zu@f[^ڂ̕ҏWo^
//    s  : f[^ǉ̕}`  null:p֒ǉ
//    n  : }`zu  vfIndex (0-)
//    lay: C(0,1-256)
//    nam: }`
//    px : zu_X
//    py : zu_Y
//    an : ]p[]
//    sx : ړxX
//    sy : ړxY
// (ret) True:o^OK@False:NG
function TDataClass.EditDataFZukei(s:string;n:integer;lay:integer;nam:string;px,py,an,sx,sy:double) : Boolean;
var
   mm,m,dn,f1,f2 : integer ;
begin
   Result := False;
   mm := FZukeiNameCheck(0,nam);
   if (mm <= 0) then exit ;   // zu镡}`͖̂ŃG[
   if (fDef[mm-1].Flag = 3) then begin
      // zu悤ƂĂ镡}`}O[v̏ꍇ
      if (fDef[mm-1].cnt <> 0) then exit ;   // ɔzuς݂Ȃ̂ŃG[
      px := 0.0 ;
      py := 0.0 ;
      an := 0.0 ;
      sx := 1.0 ;
      sy := 1.0 ;
   end;
   if (lay < 0) or (lay > zLayMax) then lay := 0 ;
   an := SetAngle(an);
   if (sx < LIMIT8) then sx := 1.0;
   if (sy < LIMIT8) then sy := 1.0;
   //
   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dFzkN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m = mm) then exit ;    // ǉƔzu̕}`Ȃ̂ŃG[
      if (m > 0) then begin
         f1 := fDef[m -1].Flag ;
         f2 := fDef[mm-1].Flag ;
         if (f1 = 1)or(f1 = 2) then begin
            // ǉ悪}̏ꍇ
            if (f2 = 1)or(f2 = 2) then exit ;   // }̒ɕ}͕̂s
         end
         else if (f1 = 3) then begin
            // ǉ悪}O[v̏ꍇ
            if (f2 = 1)or(f2 = 2) then exit ;   // }O[v̒ɕ}͕̂s
         end
         else begin
            // ǉ悪}ȉꍇ
            if (f2 = 1)or(f2 = 2)or(f2 = 3) then exit ;  // }i̒ɕ}E}O[v͕̂s
         end;
         // [vɂȂ悤ȔzuȂ悤ӂĉ

         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mFzkN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,99,n);
   if (AddDataFZukei(s, lay, nam, px,py,an,sx,sy)) then Result := True ;
end;



// }`c[\@
//    }`̕}`擾ċApTu
//    no : e̕}`` ԍ(1`)
//    lv : Kwx(0:root(p) 1`)   [v̂ߍő100Kw܂łƂ
//    pa : ẽc[ԍ(0`)
procedure TDataClass.MakeFZukeiTreeSub(no,lv,pa:integer) ;
var
   i,j,dn : integer ;
   t,t1 : TMatrix ;
begin
   if (lv > 100) then exit ;
   dn := fDef[no-1].datn ;
   for i:=0 to fDefD[dn].mFzkN-1 do begin
      if not(fDefD[dn].mFzk[i].exf) then continue ;
      j := FZukeiNameCheck(0,fDefD[dn].mFzk[i].name) ;
      if (j <= 0) then continue;
      Inc(zFztN);
      if ((zFztN mod 200) = 1) then SetLength(zFzt,zFztN+199); // 200m
      with zFzt[zFztN-1] do begin
         name  := fDefD[dn].mFzk[i].name;
         level := lv;
         par   := pa;
         //
         MtxScale(t, fDefD[dn].mFzk[i].ratio_x,fDefD[dn].mFzk[i].ratio_y);
         MtxRotD(t1, fDefD[dn].mFzk[i].Angle);
         t := MtxMult(t, t1);
         MtxMove(t1, fDefD[dn].mFzk[i].X,fDefD[dn].mFzk[i].Y);
         t := MtxMult(t, t1);
         t1:= zFzt[pa].mtx ;  // e̕ϊs
         mtx   := MtxMult(t, t1);
      end;
      MakeFZukeiTreeSub(j,lv+1,zFztN-1);
   end;
end;

// }`c[\@
//    zFztNAzFzt
procedure TDataClass.MakeFZukeiTree ;
var
   i,j : integer ;
   t : TMatrix ;
begin
   zFzt  := nil;
   zFztN := 0;
   for i:=0 to dFzkN-1 do begin
      if not(dFzk[i].exf) then continue ;
      j := FZukeiNameCheck(0,dFzk[i].name) ;
      if (j <= 0) then continue;
      Inc(zFztN);
      if ((zFztN mod 200) = 1) then SetLength(zFzt,zFztN+199); // 200m
      with zFzt[zFztN-1] do begin
         name  := dFzk[i].name;
         level := 1 ;
         par   :=-1;
         //
         if (fDef[j-1].Flag = 2) then
            MtxSetYX(mtx)     // }YXWn
         else
            MtxSetE(mtx);
         MtxScale(t, dFzk[i].ratio_x,dFzk[i].ratio_y);
         mtx := MtxMult(mtx, t);
         MtxRotD(t, dFzk[i].Angle);
         mtx := MtxMult(mtx, t);
         MtxMove(t, dFzk[i].X,dFzk[i].Y);
         mtx := MtxMult(mtx, t);
      end;
      MakeFZukeiTreeSub(j,2,zFztN-1);
   end;
   SetLength(zFzt,zFztN);  // ]Ƀmۂ
end;

// V{}``@f[^ڂ̒ǉo^
//    ł́AÔݓo^@̊ef[^͕ʓro^
//    s  : V{
// (ret) True:o^OK@False:NG
function TDataClass.AddSymbolDef(s:string) : Boolean;
var
   l : integer ;
begin
   Result := False;
   l := StrBytes(s);
   if (l < 1)or(l > 256) then exit;
   if (FZukeiNameCheck(0,s) <> 0) then exit;  // Ɏgp

   try
      Inc(sDefDN);
      SetLength(sDefD, sDefDN);
      DataClearSymbolMember(sDefDN-1);
      try
         Inc(sDefN);
         SetLength(sDef, sDefN);
         with sDef[sDefN-1] do begin
            exf   := True ;
            name  := s ;
            cnt   := 0 ;
            datn  := sDefDN-1 ;
         end;
         if (OpAdd(3,2,sDefN-1)) then begin
            Result := True ;
         end
         else begin
            Dec(sDefN);
            Dec(sDefDN);
         end;
      except
         Dec(sDefN);
         Dec(sDefDN);
      end;
   except
      Dec(sDefDN);
   end;
end;

// V{}``@f[^ڂ̍폜
//    n  : V{}`` vfIndex (0-)
// (ret) True:OK@False:NG
function TDataClass.DelSymbolDef(n:integer) : Boolean;
begin
   Result := False ;
   if (n < 0)or(n >= sDefN) then exit;    // vfIndex`FbN
   if not(sDef[n].exf) then exit;         // ɍ폜

   if (OpAdd(4,2,n)) then begin
      sDef[n].exf := False ;
      Result := True ;
   end;
end;

// V{}``@f[^ڂ̎擾
//    n  : V{}`` vfIndex (0-)
//    ex : ݃tO
//    s  : V{}`
//    cn : vf
//    dn : f[^vfIndex
// (ret) True:OK@False:NG
function TDataClass.GetSymbolDef(n:integer;var ex:Boolean;var s:string;var cn,dn:integer) : Boolean;
begin
   Result := False;
   if (n < 0)or(n >= sDefN) then exit;    // vfIndex`FbN

   with sDef[n] do begin
      ex := exf ;
      s  := name ;
      cn := cnt ;
      dn := datn ;
   end;

   Result := True ;
end;

// V{}``@f[^ڂ̕ҏWo^
//    n  : V{}`` vfIndex (0-)
//    s  : V{}`
//    cn : vf
//    dn : f[^vfIndex
// (ret) True:o^OK@False:NG
function TDataClass.EditSymbolDef(n:integer;s:string;cn,dn:integer) : Boolean;
begin
   Result := False;
   if (n < 0)or(n >= sDefN) then exit;    // vfIndex`FbN
   if not(sDef[n].exf) then exit;         // ɍ폜
   if (dn < 0)or(dn >= sDefDN) then exit; // f[^vfIndex`FbN
   if not(StrCheck(s)) then exit;         // 񐔃`FbN
   if (FZukeiNameCheck(-n-1,s)<>0) then exit; // ɕ}`͎gp(n͗vfindexȂ̂-)

   if (DelSymbolDef(n)) then begin
      if (AddSymbolDef(s)) then begin
         with sDef[sDefN-1] do begin
            cnt   := cn ;
            datn  := dn ;
         end;
         Dec(sDefDN);         // vff[^͒ǉȂ̂-1Ă
         Result := True ;
      end;
   end;
end;

// V{}`zu@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`  null:p֒ǉ
//    lay: C(0,1-256)
//    cf : FR[htO(0: 1:L)
//    col: F (0:CF 1`256)
//    nam: V{}`
//    px : zu_X
//    py : zu_Y
//    an : ]p[]
//    sc : {
// (ret) True:o^OK@False:NG
//  f[^ԍ́AЂƂ\L^􉽗vfǉ邩Ȃ̂ŗ]T 100 ƂĂ܂
function TDataClass.AddDataSZukei(s:string;lay,cf,col:integer;nam:string;px,py,an,sc:double) : Boolean;
var
   m,n,dn : integer ;
begin
   Result := False;
   if (lay < 0) or (lay > zLayMax) then lay := 0 ;
   if (cf <> 1) then cf := 0 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (nam = '') then exit ;
   n  := FZukeiNameCheck(0,nam);  // V{}`Ăo^͍s
   an := SetAngle(an);
   if (sc < LIMIT8) then sc := 1.0;

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,100,dSzkN)) then begin
         try
            Inc(dSzkN);
            if ((dSzkN mod 200) = 1) then SetLength(dSzk, dSzkN+199);   // 200m
            with dSzk[dSzkN-1] do begin
               exf         := True ;
               Layer       := lay ;
               color_flag  := cf ;
               Color       := col ;
               name        := nam ;
               start_x     := px ;
               start_y     := py ;
               rotate_angle:= an ;
               Scale       := sc ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            if (cf = 0) then
               AddLayerCnt(lay,-1,-1,-1,-1)
            else
               AddLayerCnt(lay,col,-1,-1,-1);
         except
            Dec(dSzkN);
            Dec(dOrdN);
         end;
         if (Result)and(n < 0) then
            sDef[-n-1].cnt := sDef[-n-1].cnt + 1 ; // zuJEg
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,100,mSzkN)) then begin
               try
                  Inc(mSzkN);
                  if ((mSzkN mod 200) = 1) then SetLength(mSzk, mSzkN+199);   // 200m
                  with mSzk[mSzkN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     color_flag  := cf ;
                     Color       := col ;
                     name        := nam ;
                     start_x     := px ;
                     start_y     := py ;
                     rotate_angle:= an ;
                     Scale       := sc ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  if (cf = 0) then
                     AddLayerFCnt(lay,-1,-1,-1,-1)
                  else
                     AddLayerFCnt(lay,col,-1,-1,-1);
               except
                  Dec(mSzkN);
                  Dec(mOrdN);
               end;
            end;
         end;
         if (Result)and(n < 0) then
            sDef[-n-1].cnt := sDef[-n-1].cnt + 1 ; // zuJEg
      end
   end;
end;

// V{}`zu@f[^ڂ̎擾
//    s  : f[^ǉ̕}`  null:p֒ǉ
//    n  : V{}`zu  vfIndex (0-)
//    ex : ݃tO
//    lay: C(0,1-256)
//    cf : FR[htO(0: 1:L)
//    col: F (0:CF 1`256)
//    nam: V{}`
//    px : zu_X
//    py : zu_Y
//    an : ]p[]
//    sc : {
// (ret) True:OK@False:NG
function TDataClass.GetDataSZukei(s:string;n:integer;var ex:Boolean;var lay,cf,col:integer;var nam:string;var px,py,an,sc:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dSzkN) then exit;    // vfIndex`FbN
      with dSzk[n] do begin
         ex := exf ;
         lay:= Layer ;
         cf := color_flag ;
         col:= Color ;
         nam:= name ;
         px := start_x ;
         py := start_y ;
         an := rotate_angle ;
         sc := Scale ;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mSzkN) then exit;    // vfIndex`FbN
            with mSzk[n] do begin
               ex := exf ;
               lay:= Layer ;
               cf := color_flag ;
               col:= Color ;
               nam:= name ;
               px := start_x ;
               py := start_y ;
               an := rotate_angle ;
               sc := Scale ;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// V{}`zu@f[^ڂ̕ҏWo^
//    s  : f[^ǉ̕}`  null:p֒ǉ
//    n  : V{}`zu  vfIndex (0-)
//    lay: C(0,1-256)
//    cf : FR[htO(0: 1:L)
//    col: F (0:CF 1`256)
//    nam: V{}`
//    px : zu_X
//    py : zu_Y
//    an : ]p[]
//    sc : {
// (ret) True:o^OK@False:NG
function TDataClass.EditDataSZukei(s:string;n:integer;lay,cf,col:integer;nam:string;px,py,an,sc:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (lay < 0) or (lay > zLayMax) then lay := 0 ;
   if (cf <> 1) then cf := 0 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (nam = '') then exit ;
   an := SetAngle(an);
   if (sc < LIMIT8) then sc := 1.0;
   //
   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dSzkN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mSzkN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,100,n);
   if (AddDataSZukei(s, lay,cf,col, nam, px,py,an,sc)) then Result := True ;
end;



// w肵`nb`O̔ԍ擾
//    s  : nb`O
// (ret) 1`Fnb`Oԍ@0:o^
function TDataClass.HatchNameCheck(s:string) : Integer;
var
   i : integer;
begin
   Result := 0 ;
   for i:=0 to hDefN-1 do begin
      if (s = hDef[i].name) then begin
         Result := i + 1;
         break ;
      end;
   end;
end;

// `nb`O`@f[^ڂ̒ǉo^
//    s  : V{
// (ret) True:o^OK@False:NG
function TDataClass.AddHatchNameDef(s:string;num:integer;col,ltp,wid:array of integer;sp,an:array of double) : Boolean ;
var
   i : integer ;
begin
   Result := False;
   i := StrBytes(s);
   if (i < 1)or(i > 256) then exit;
   if (HatchNameCheck(s) <> 0) then exit;    // ɒ`

   try
      Inc(hDefN);
      SetLength(hDef, hDefN);
      with hDef[hDefN-1] do begin
         name  := s ;
         hatch1_number  := num ;
         for i:=0 to 3 do begin
            hatch1_color[i]      := 0 ;
            hatch_type[i]        := 0 ;
            hatch_line_width[i]  := 0 ;
            hatch_spacing[i]     := 0.0 ;
            hatch_angle[i]       := 0.0 ;
         end;
         for i:=0 to num-1 do begin
            hatch1_color[i]      := col[i] ;
            hatch_type[i]        := ltp[i] ;
            hatch_line_width[i]  := wid[i] ;
            hatch_spacing[i]     := sp[i] ;
            hatch_angle[i]       := an[i] ;
         end;
      end;
      Result := True ;
   except
      Dec(hDefN);
      SetLength(hDef, hDefN);
   end;
end;

// C̐{P
//    C̃R[h̓`FbNĂȂ̂ŒӁFOɃ`FbNςł鎖
//    lay: C(1-256)            -1:{PȂ(̏ꍇCF///̑ΉsȂ̂ŗv)
//    col: F(0,1-256)              -1:{PȂ
//    ltp: (0,1-32)             -1:{PȂ
//    wid: (0,1-16)             -1:{PȂ
//    fnt: tHg(0,1-1024)   -1:{PȂ
procedure TDataClass.AddLayerCnt(lay,col,ltp,wid,fnt:integer);
var
   i : integer ;
   c,l,w,f : integer ;
begin
   c := 1 ;
   l := 1 ;
   w := 1 ;
   f := 1 ;
   // C 
   if (lay > 0) then begin
      i := GetLayerIdx(lay);
      if (i > -1) then begin
         zLay[i].cnt := zLay[i].cnt + 1;
         c := zLay[i].Color ;
         l := zLay[i].Ltype ;
         w := zLay[i].Width ;
         f := zLay[i].Mfont ;
      end;
   end;
   // F 
   if (col > 0) then begin
      i := GetColorIdx(col);
      if (i > -1) then
         zCol[i].cnt := zCol[i].cnt + 1
   end
   else if (col = 0)and(lay > 0) then begin
      i := GetColorIdx(c);
      if (i > -1) then
         zCol[i].cnt := zCol[i].cnt + 1
   end;
   //  
   if (ltp > 0) then begin
      i := GetLtypeIdx(ltp);
      if (i > -1) then
         zLtp[i].cnt := zLtp[i].cnt + 1
   end
   else if (ltp = 0)and(lay > 0) then begin
      i := GetLtypeIdx(l);
      if (i > -1) then
         zLtp[i].cnt := zLtp[i].cnt + 1
   end;
   //  
   if (wid > 0) then begin
      i := GetWidthIdx(wid);
      if (i > -1) then
         zWid[i].cnt := zWid[i].cnt + 1
   end
   else if (wid = 0)and(lay > 0) then begin
      i := GetWidthIdx(w);
      if (i > -1) then
         zWid[i].cnt := zWid[i].cnt + 1
   end;
   // tHg 
   if (fnt > 0) then begin
      i := GetFontIdx(fnt);
      if (i > -1) then
         zFnt[i].cnt := zFnt[i].cnt + 1
   end
   else if (fnt = 0)and(lay > 0) then begin
      i := GetFontIdx(f);
      if (i > -1) then
         zFnt[i].cnt := zFnt[i].cnt + 1
   end;
end;

// }``@C̐{P
//    C̃R[h̓`FbNĂȂ̂ŒӁFOɃ`FbNςł鎖
//    lay: C(1-256)            -1:{PȂ(̏ꍇCF///̑ΉsȂ̂ŗv)
//    col: F(0,1-256)              -1:{PȂ
//    ltp: (0,1-32)             -1:{PȂ
//    wid: (0,1-16)             -1:{PȂ
//    fnt: tHg(0,1-1024)   -1:{PȂ
procedure TDataClass.AddLayerFCnt(lay,col,ltp,wid,fnt:integer);
var
   i : integer ;
   c,l,w,f : integer ;
begin
   c := 1 ;
   l := 1 ;
   w := 1 ;
   f := 1 ;
   // C 
   if (lay > 0) then begin
      i := GetLayerIdx(lay);
      if (i > -1) then begin
         zLay[i].Fcnt := zLay[i].Fcnt + 1;
         c := zLay[i].Color ;
         l := zLay[i].Ltype ;
         w := zLay[i].Width ;
         f := zLay[i].Mfont ;
      end;
   end;
   // F 
   if (col > 0) then begin
      i := GetColorIdx(col);
      if (i > -1) then
         zCol[i].Fcnt := zCol[i].Fcnt + 1
   end
   else if (col = 0)and(lay > 0) then begin
      i := GetColorIdx(c);
      if (i > -1) then
         zCol[i].Fcnt := zCol[i].Fcnt + 1
   end;
   //  
   if (ltp > 0) then begin
      i := GetLtypeIdx(ltp);
      if (i > -1) then
         zLtp[i].Fcnt := zLtp[i].Fcnt + 1
   end
   else if (ltp = 0)and(lay > 0) then begin
      i := GetLtypeIdx(l);
      if (i > -1) then
         zLtp[i].Fcnt := zLtp[i].Fcnt + 1
   end;
   //  
   if (wid > 0) then begin
      i := GetWidthIdx(wid);
      if (i > -1) then
         zWid[i].Fcnt := zWid[i].Fcnt + 1
   end
   else if (wid = 0)and(lay > 0) then begin
      i := GetWidthIdx(w);
      if (i > -1) then
         zWid[i].Fcnt := zWid[i].Fcnt + 1
   end;
   // tHg 
   if (fnt > 0) then begin
      i := GetFontIdx(fnt);
      if (i > -1) then
         zFnt[i].Fcnt := zFnt[i].Fcnt + 1
   end
   else if (fnt = 0)and(lay > 0) then begin
      i := GetFontIdx(f);
      if (i > -1) then
         zFnt[i].Fcnt := zFnt[i].Fcnt + 1
   end;
end;



// ⏕f[^}̓o^
//    m : }``No  0:p
//    tp: f[^^Cv (1-)
//    no: f[^ԍ   (0-)
function TDataClass.AddHojoOrder(m,tp,no:integer) : Boolean;
begin
   Result := False;
   if (m = 0) then begin
      try
         Inc(hOrdN);
         if ((hOrdN mod 200) = 1) then SetLength(hOrd, hOrdN+199);   // 200m
         with hOrd[hOrdN-1] do begin
            DataType := tp ;
            DataNo   := no ;
         end;
         Result := True ;
      except
         Dec(hOrdN);
      end;
   end
   else if (m > 0) then begin
      with fDef[m-1] do begin
         try
            Inc(hOrdN);
            if ((hOrdN mod 200) = 1) then SetLength(hOrd, hOrdN+199);   // 200m
            with hOrd[hOrdN-1] do begin
               DataType := tp ;
               DataNo   := no ;
            end;
            Result := True ;
         except
            Dec(hOrdN);
         end;
      end;
   end;
end;

// ⏕b_}[J@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    mc : }[JR[h(1: 2: 3:E 4:{ 5: 6: 7:~)
//    px : zu_X
//    py : zu_Y
//    an : ]p[]
//    sc : ړx
// (ret) True:o^OK@False:NG
function TDataClass.AddHojoTen(s:string;lay,mc:integer;px,py,an,sc:double) : Boolean;
var
   m : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (mc  < 1) or (mc  > 7)       then mc  := 3 ;   // dot
   an := SetAngle(an);
   if (sc < LIMIT8) then sc := 1.0;

   if (s = '') then begin
      // p֒ǉ
      if (AddHojoOrder(0,1,hTenN)) then begin
         try
            Inc(hTenN);
            if ((hTenN mod 200) = 1) then SetLength(hTen, hTenN+199);   // 200m
            with hTen[hTenN-1] do begin
               Layer       := lay ;
               start_x     := px ;
               start_y     := py ;
               marker_code := mc ;
               rotate_angle:= an ;
               Scale       := sc ;
            end;
            Result := True ;
         except
            Dec(hTenN);
            Dec(hOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddHojoOrder(m,1,hTenN)) then begin
               try
                  Inc(hTenN);
                  if ((hTenN mod 200) = 1) then SetLength(hTen, hTenN+199);   // 200m
                  with hTen[hTenN-1] do begin
                     Layer       := lay ;
                     start_x     := px ;
                     start_y     := py ;
                     marker_code := mc ;
                     rotate_angle:= an ;
                     Scale       := sc ;
                  end;
                  Result := True ;
               except
                  Dec(hTenN);
                  Dec(hOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// ⏕b@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    x1 : n_X
//    y1 : n_Y
//    x2 : I_X
//    y2 : I_Y
// (ret) True:o^OK@False:NG
function TDataClass.AddHojoLine(s:string;lay,ltp,wid:integer;x1,y1,x2,y2:double) : Boolean;
var
   m : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (SamePosCheck(x1,y1,x2,y2))  then exit ; // _

   if (s = '') then begin
      // p֒ǉ
      if (AddHojoOrder(0,2,hLinN)) then begin
         try
            Inc(hLinN);
            if ((hLinN mod 200) = 1) then SetLength(hLin, hLinN+199);   // 200m
            with hLin[hLinN-1] do begin
               Layer       := lay ;
               Ltype       := ltp ;
               line_width  := wid ;
               start_x     := x1 ;
               start_y     := y1 ;
               end_x       := x2 ;
               end_y       := y2 ;
            end;
            Result := True ;
         except
            Dec(hLinN);
            Dec(hOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddHojoOrder(m,2,hLinN)) then begin
               try
                  Inc(hLinN);
                  if ((hLinN mod 200) = 1) then SetLength(hLin, hLinN+199);   // 200m
                  with hLin[hLinN-1] do begin
                     Layer       := lay ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     start_x     := x1 ;
                     start_y     := y1 ;
                     end_x       := x2 ;
                     end_y       := y2 ;
                  end;
                  Result := True ;
               except
                  Dec(hLinN);
                  Dec(hOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// ⏕bܐ@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    num: _
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:o^OK@False:NG
function TDataClass.AddHojoLines(s:string;lay,ltp,wid,num:integer;vx,vy:array of double) : Boolean;
var
   m,i : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (num <=0) then exit ;
   try
      for i:=1 to num-1 do
         if (SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ; // _
   except
      exit ;   // IzG[
   end;
   if (s = '') then begin
      // p֒ǉ
      if (AddHojoOrder(0,3,hLnsN)) then begin
         try
            Inc(hLnsN);
            if ((hLnsN mod 100) = 1) then SetLength(hLns, hLnsN+99);    // 100m
            with hLns[hLnsN-1] do begin
               Layer       := lay ;
               Ltype       := ltp ;
               line_width  := wid ;
               Number      := num ;
               try
                  SetLength(X, Number);
                  SetLength(Y, Number);
               except
                  X := nil ;
                  Y := nil ;
                  Number := 0 ;
               end;
               for i:=0 to Number-1 do begin
                  X[i]     := vx[i];
                  Y[i]     := vy[i];
               end;
            end;
            Result := True ;
         except
            Dec(hLnsN);
            Dec(hOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddHojoOrder(m,3,hLnsN)) then begin
               try
                  Inc(hLnsN);
                  if ((hLnsN mod 100) = 1) then SetLength(hLns, hLnsN+99);    // 100m
                  with hLns[hLnsN-1] do begin
                     Layer       := lay ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     Number      := num ;
                     try
                        SetLength(X, Number);
                        SetLength(Y, Number);
                     except
                        X := nil ;
                        Y := nil ;
                        Number := 0 ;
                     end;
                     for i:=0 to Number-1 do begin
                        X[i]     := vx[i];
                        Y[i]     := vy[i];
                     end;
                  end;
                  Result := True ;
               except
                  Dec(hLnsN);
                  Dec(hOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// ⏕b~@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : (3`3600)
//    cx : S_X
//    cy : S_Y
//    cr : a
// (ret) True:o^OK@False:NG
function TDataClass.AddHojoCircle(s:string;lay,ltp,wid,sp:integer;cx,cy,cr:double) : Boolean;
var
   m : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp  < 3) or (sp  >  3600)   then sp  := 72;
   if (cr < LIMIT10) then exit ;    // a <= 0

   if (s = '') then begin
      // p֒ǉ
      if (AddHojoOrder(0,4,hCirN)) then begin
         try
            Inc(hCirN);
            if ((hCirN mod 200) = 1) then SetLength(hCir, hCirN+199);   // 200m
            with hCir[hCirN-1] do begin
               Layer       := lay ;
               Ltype       := ltp ;
               line_width  := wid ;
               sep         := sp ;
               Center_x    := cx ;
               Center_y    := cy ;
               Radius      := cr ;
            end;
            Result := True ;
         except
            Dec(hCirN);
            Dec(hOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddHojoOrder(m,4,hCirN)) then begin
               try
                  Inc(hCirN);
                  if ((hCirN mod 200) = 1) then SetLength(hCir, hCirN+199);   // 200m
                  with hCir[hCirN-1] do begin
                     Layer       := lay ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sep         := sp ;
                     Center_x    := cx ;
                     Center_y    := cy ;
                     Radius      := cr ;
                  end;
                  Result := True ;
               except
                  Dec(hCirN);
                  Dec(hOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// ⏕b~ʁ@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : (3`3600)
//    dir: (0,1)
//    cx : S_X
//    cy : S_Y
//    cr : a
//    sa : np
//    ea : Ip
// (ret) True:o^OK@False:NG
function TDataClass.AddHojoArc(s:string;lay,ltp,wid,sp,dir:integer;cx,cy,cr,sa,ea:double) : Boolean;
var
   m : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp  < 3) or (sp  >  3600)   then sp  := 72;
   if (cr < LIMIT10) then exit ;          // a <= 0
   if (dir <> 0) then dir := 1 ;
   sa := SetAngle(sa);
   ea := SetAngle(ea);
   if (Abs(ea-sa) < LIMIT10) then exit ;  // np = Ip

   if (s = '') then begin
      // p֒ǉ
      if (AddHojoOrder(0,5,hArcN)) then begin
         try
            Inc(hArcN);
            if ((hArcN mod 200) = 1) then SetLength(hArc, hArcN+199);   // 200m
            with hArc[hArcN-1] do begin
               Layer       := lay ;
               Ltype       := ltp ;
               line_width  := wid ;
               sep         := sp ;
               Center_x    := cx ;
               Center_y    := cy ;
               Radius      := cr ;
               Direction   := dir ;
               start_angle := sa ;
               end_angle   := ea ;
            end;
            Result := True ;
         except
            Dec(hArcN);
            Dec(hOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddHojoOrder(m,5,hArcN)) then begin
               try
                  Inc(hArcN);
                  if ((hArcN mod 200) = 1) then SetLength(hArc, hArcN+199);   // 200m
                  with hArc[hArcN-1] do begin
                     Layer       := lay ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sep         := sp ;
                     Center_x    := cx ;
                     Center_y    := cy ;
                     Radius      := cr ;
                     Direction   := dir ;
                     start_angle := sa ;
                     end_angle   := ea ;
                  end;
                  Result := True ;
               except
                  Dec(hArcN);
                  Dec(hOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// ⏕bȉ~@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : (3`3600)
//    cx : S_X
//    cy : S_Y
//    rx : wa
//    ry : xa
//    ra : ]p
// (ret) True:o^OK@False:NG
function TDataClass.AddHojoEllipse(s:string;lay,ltp,wid,sp:integer;cx,cy,rx,ry,ra:double) : Boolean;
var
   m : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp  < 3) or (sp  >  3600)   then sp  := 72;
   if (rx < LIMIT10)or(ry < LIMIT10) then exit ;   // a <= 0
   ra := SetAngle(ra);

   if (s = '') then begin
      // p֒ǉ
      if (AddHojoOrder(0,6,hEllN)) then begin
         try
            Inc(hEllN);
            if ((hEllN mod 200) = 1) then SetLength(hEll, hEllN+199);   // 200m
            with hEll[hEllN-1] do begin
               Layer       := lay ;
               Ltype       := ltp ;
               line_width  := wid ;
               sep         := sp ;
               Center_x    := cx ;
               Center_y    := cy ;
               Radius_x    := rx ;
               Radius_y    := ry ;
               rotation_angle := ra ;
            end;
            Result := True ;
         except
            Dec(hEllN);
            Dec(hOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddHojoOrder(m,6,hEllN)) then begin
               try
                  Inc(hEllN);
                  if ((hEllN mod 200) = 1) then SetLength(hEll, hEllN+199);   // 200m
                  with hEll[hEllN-1] do begin
                     Layer       := lay ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sep         := sp ;
                     Center_x    := cx ;
                     Center_y    := cy ;
                     Radius_x    := rx ;
                     Radius_y    := ry ;
                     rotation_angle := ra ;
                  end;
                  Result := True ;
               except
                  Dec(hEllN);
                  Dec(hOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// ⏕bȉ~ʁ@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : (3`3600)
//    dir: (0,1)
//    cx : S_X
//    cy : S_Y
//    rx : wa
//    ry : xa
//    ra : ]p
//    sa : np
//    ea : Ip
// (ret) True:o^OK@False:NG
function TDataClass.AddHojoEllipseArc(s:string;lay,ltp,wid,sp,dir:integer;cx,cy,rx,ry,ra,sa,ea:double) : Boolean;
var
   m : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp  < 3) or (sp  >  3600)   then sp  := 72;
   if (rx < LIMIT10)or(ry < LIMIT10) then exit ;   // a <= 0
   if (dir <> 0) then dir := 1 ;
   ra := SetAngle(ra);
   sa := SetAngle(sa);
   ea := SetAngle(ea);
   if (Abs(ea-sa) < LIMIT10) then exit ;  // np = Ip

   if (s = '') then begin
      // p֒ǉ
      if (AddHojoOrder(0,7,hEArN)) then begin
         try
            Inc(hEArN);
            if ((hEArN mod 200) = 1) then SetLength(hEAr, hEArN+199);   // 200m
            with hEAr[hEArN-1] do begin
               Layer       := lay ;
               Ltype       := ltp ;
               line_width  := wid ;
               sep         := sp ;
               Center_x    := cx ;
               Center_y    := cy ;
               Radius_x    := rx ;
               Radius_y    := ry ;
               Direction   := dir ;
               rotation_angle := ra ;
               start_angle := sa ;
               end_angle   := ea ;
            end;
            Result := True ;
         except
            Dec(hEArN);
            Dec(hOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddHojoOrder(m,7,hEArN)) then begin
               try
                  Inc(hEArN);
                  if ((hEArN mod 200) = 1) then SetLength(hEAr, hEArN+199);   // 200m
                  with hEAr[hEArN-1] do begin
                     Layer       := lay ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sep         := sp ;
                     Center_x    := cx ;
                     Center_y    := cy ;
                     Radius_x    := rx ;
                     Radius_y    := ry ;
                     Direction   := dir ;
                     rotation_angle := ra ;
                     start_angle := sa ;
                     end_angle   := ea ;
                  end;
                  Result := True ;
               except
                  Dec(hEArN);
                  Dec(hOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// ⏕b@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    str: 
//    lay: C(1-256)
//    fon: tHg(0,1-1024)
//    bp : _(1-9)
//    dir: (1,2)
//    px : zu_X
//    py : zu_Y
//    ph : ͈͍
//    pw : ͈͕
//    ps : Ԋu
//    an : ]p
//    sl : Xgp
// (ret) True:o^OK@False:NG
function TDataClass.AddHojoText(s,st:string;lay,fnt,bp,dir:integer;px,py,ph,pw,ps,an,sl:double) : Boolean;
var
   m : integer ;
begin
   Result := False;
   if not(StrCheck(st)) then exit;                 // 񐔃`FbN
   if (ph < LIMIT10)or(pw < LIMIT10) then exit ;   // ͈͂ <= 0
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (fnt < 0) or (fnt > zFntMax) then fnt := 0 ;
   if (bp  < 1) or (bp  >     9)   then bp  := 1 ;
   if (dir <> 1) then dir := 2 ;
   if (ps < 0.0) then ps := 0.0;
   an := SetAngle(an);
   if (sl < -85.0) or (sl > 85.0) then sl := 0.0;

   if (s = '') then begin
      // p֒ǉ
      if (AddHojoOrder(0,8,hTxtN)) then begin
         try
            Inc(hTxtN);
            if ((hTxtN mod 200) = 1) then SetLength(hTxt, hTxtN+199);   // 200m
            with hTxt[hTxtN-1] do begin
               Layer       := lay ;
               Font        := fnt ;
               str         := st ;
               text_x      := px ;
               text_y      := py ;
               Height      := ph ;
               Width       := pw ;
               Spc         := ps ;
               Angle       := an ;
               Slant       := sl ;
               b_pnt       := bp ;
               Direct      := dir ;
            end;
            Result := True ;
         except
            Dec(hTxtN);
            Dec(hOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            if (AddHojoOrder(m,8,hTxtN)) then begin
               try
                  Inc(hTxtN);
                  if ((hTxtN mod 200) = 1) then SetLength(hTxt, hTxtN+199);   // 200m
                  with hTxt[hTxtN-1] do begin
                     Layer       := lay ;
                     Font        := fnt ;
                     str         := st ;
                     text_x      := px ;
                     text_y      := py ;
                     Height      := ph ;
                     Width       := pw ;
                     Spc         := ps ;
                     Angle       := an ;
                     Slant       := sl ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  Result := True ;
               except
                  Dec(hTxtN);
                  Dec(hOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// ⏕@O폜
//    s  : }`i􉽗vfj  null:pi\Lvfj
procedure TDataClass.DelHojoPrev(s:string) ;
var
   m : integer ;
begin
   if (s = '') then
      DelHojoPrev(0)
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then
         DelHojoPrev(m) ;
   end;
end;

// ⏕@O폜
//    m : 0:ʏ@1`:}`vf
procedure TDataClass.DelHojoPrev(m:integer) ;
var
   tp : integer ;
begin
   tp := 0;
   if (m = 0) then begin
      if (hOrdN > 0) then begin
         with hOrd[hOrdN-1] do begin
            tp := DataType ;
         end;
         Dec(hOrdN);
      end;
      case (tp) of
      1: begin
            // _}[JEf[^\
            if (hTenN > 0) then Dec(hTenN);
            if (hTenN = 0) then hTen := nil;
         end;
      2: begin
            // f[^\
            if (hLinN > 0) then Dec(hLinN);
            if (hLinN = 0) then hLin := nil;
         end;
      3: begin
            // ܐf[^\
            if (hLnsN > 0) then begin
               with hLns[hLnsN-1] do begin
                  X := nil;
                  Y := nil;
               end;
               Dec(hLnsN);
            end;
            if (hLnsN = 0) then hLns := nil;
         end;
      4: begin
            // ~f[^\
            if (hCirN > 0) then Dec(hCirN);
            if (hCirN = 0) then hCir := nil;
         end;
      5: begin
            // ~ʃf[^\
            if (hArcN > 0) then Dec(hArcN);
            if (hArcN = 0) then hArc := nil;
         end;
      6: begin
            // ȉ~f[^\
            if (hEllN > 0) then Dec(hEllN);
            if (hEllN = 0) then hEll := nil;
         end;
      7: begin
            // ȉ~ʃf[^\
            if (hEArN > 0) then Dec(hEArN);
            if (hEArN = 0) then hEAr := nil;
         end;
      8: begin
            // f[^\
            if (hTxtN > 0) then Dec(hTxtN);
            if (hTxtN = 0) then hTxt := nil;
         end;
      end;
      if (hOrdN = 0) then DelHojoAll(0) ; // ꉞ
   end
   else if (m > 0)and(m <= fDefN) then begin
      with fDef[m-1] do begin
         if (hOrdN > 0) then begin
            with hOrd[hOrdN-1] do begin
               tp := DataType ;
            end;
            Dec(hOrdN);
         end;
         case (tp) of
         1: begin
               // _}[JEf[^\
               if (hTenN > 0) then Dec(hTenN);
               if (hTenN = 0) then hTen := nil;
            end;
         2: begin
               // f[^\
               if (hLinN > 0) then Dec(hLinN);
               if (hLinN = 0) then hLin := nil;
            end;
         3: begin
               // ܐf[^\
               if (hLnsN > 0) then begin
                  with hLns[hLnsN-1] do begin
                     X := nil;
                     Y := nil;
                  end;
                  Dec(hLnsN);
               end;
               if (hLnsN = 0) then hLns := nil;
            end;
         4: begin
               // ~f[^\
               if (hCirN > 0) then Dec(hCirN);
               if (hCirN = 0) then hCir := nil;
            end;
         5: begin
               // ~ʃf[^\
               if (hArcN > 0) then Dec(hArcN);
               if (hArcN = 0) then hArc := nil;
            end;
         6: begin
               // ȉ~f[^\
               if (hEllN > 0) then Dec(hEllN);
               if (hEllN = 0) then hEll := nil;
            end;
         7: begin
               // ȉ~ʃf[^\
               if (hEArN > 0) then Dec(hEArN);
               if (hEArN = 0) then hEAr := nil;
            end;
         8: begin
               // f[^\
               if (hTxtN > 0) then Dec(hTxtN);
               if (hTxtN = 0) then hTxt := nil;
            end;
         end;
         if (hOrdN = 0) then DelHojoAll(m) ; // ꉞ
      end;
   end;
end;

// ⏕@S폜
procedure TDataClass.DelHojoAll ;
var
   i : integer ;
begin
   for i:=0 to fDefN do
      DelHojoAll(i);
end;

// ⏕@S폜
//    s  : }`i􉽗vfj  null:pi\Lvfj
procedure TDataClass.DelHojoAll(s:string) ;
var
   m : integer ;
begin
   if (s = '') then
      DelHojoAll(0)
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then
         DelHojoAll(m) ;
   end;
end;

// ⏕@S폜
//    m : 0:ʏ@1`:}`vf
procedure TDataClass.DelHojoAll(m:integer) ;
var
   i : integer ;
begin
   if (m = 0) then begin
      hOrd  := nil;
      hOrdN := 0;
      hTen  := nil;
      hTenN := 0;
      hLin  := nil;
      hLinN := 0;
      for i:=0 to hLnsN-1 do begin
         with hLns[i] do begin
            X := nil;
            Y := nil;
         end;
      end;
      hLns  := nil;
      hLnsN := 0;
      hCir  := nil;
      hCirN := 0;
      hArc  := nil;
      hArcN := 0;
      hEll  := nil;
      hEllN := 0;
      hEAr  := nil;
      hEArN := 0;
      hTxt  := nil;
      hTxtN := 0;
   end
   else if (m > 0)and(m <= fDefN) then begin
      with fDef[m-1] do begin
         hOrdN := 0; hOrd := nil;
         hTenN := 0; hTen := nil;
         hLinN := 0; hLin := nil;
         for i:=0 to hLnsN-1 do begin
            with hLns[i] do begin
               X := nil;
               Y := nil;
            end;
         end;
         hLnsN := 0; hLns := nil;
         hCirN := 0; hCir := nil;
         hArcN := 0; hArc := nil;
         hEllN := 0; hEll := nil;
         hEArN := 0; hEAr := nil;
         hTxtN := 0; hTxt := nil;
      end;
   end;
end;



// f[^}̓o^
//    m : }``No  0:p  `-1:V{`
//    tp: f[^^Cv (1-)
//    no: f[^ԍ   (0-)
function TDataClass.AddDataOrder(m,tp,no:integer) : Boolean;
var
   dn : integer ;
begin
   Result := False;
   if (m = 0) then begin
      try
         Inc(dOrdN);
         if ((dOrdN mod 200) = 1) then SetLength(dOrd, dOrdN+199);   // 200m
         with dOrd[dOrdN-1] do begin
            DataType := tp ;
            DataNo   := no ;
         end;
         Result := True ;
      except
         Dec(dOrdN);
      end;
   end
   else if (m > 0) then begin
      with fDef[m-1] do begin
         dn := datn ;
      end;
      with fDefD[dn] do begin
         try
            Inc(mOrdN);
            if ((mOrdN mod 200) = 1) then SetLength(mOrd, mOrdN+199);   // 200m
            with mOrd[mOrdN-1] do begin
               DataType := tp ;
               DataNo   := no ;
            end;
            Result := True ;
         except
            Dec(mOrdN);
         end;
      end;
   end
   else begin
      with sDef[-m-1] do begin
         dn := datn ;
      end;
      with sDefD[dn] do begin
         try
            Inc(mOrdN);
            if ((mOrdN mod 200) = 1) then SetLength(mOrd, mOrdN+199);   // 200m
            with mOrd[mOrdN-1] do begin
               DataType := tp ;
               DataNo   := no ;
            end;
            Result := True ;
         except
            Dec(mOrdN);
         end;
      end;
   end;
end;

// _}[J@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F(0,1-256)
//    mc : }[JR[h(1: 2: 3:E 4:{ 5: 6: 7:~)
//    px : zu_X
//    py : zu_Y
//    an : ]p[]
//    sc : ړx
// (ret) True:o^OK@False:NG
function TDataClass.AddDataTen(s:string;lay,col,mc:integer;px,py,an,sc:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (mc  < 1) or (mc  > 7)       then mc  := 3 ;   // dot
   an := SetAngle(an);
   if (sc < LIMIT8) then sc := 1.0;

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,1,dTenN)) then begin
         try
            Inc(dTenN);
            if ((dTenN mod 200) = 1) then SetLength(dTen, dTenN+199);   // 200m
            with dTen[dTenN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               start_x     := px ;
               start_y     := py ;
               marker_code := mc ;
               rotate_angle:= an ;
               Scale       := sc ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,col,-1,-1,-1);
         except
            Dec(dTenN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,1,mTenN)) then begin
               try
                  Inc(mTenN);
                  if ((mTenN mod 200) = 1) then SetLength(mTen, mTenN+199);   // 200m
                  with mTen[mTenN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     start_x     := px ;
                     start_y     := py ;
                     marker_code := mc ;
                     rotate_angle:= an ;
                     Scale       := sc ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,col,-1,-1,-1);
               except
                  Dec(mTenN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,1,mTenN)) then begin
               try
                  Inc(mTenN);
                  if ((mTenN mod 200) = 1) then SetLength(mTen, mTenN+199);   // 200m
                  with mTen[mTenN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     start_x     := px ;
                     start_y     := py ;
                     marker_code := mc ;
                     rotate_angle:= an ;
                     Scale       := sc ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mTenN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// @f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    x1 : n_X
//    y1 : n_Y
//    x2 : I_X
//    y2 : I_Y
// (ret) True:o^OK@False:NG
function TDataClass.AddDataLine(s:string;lay,col,ltp,wid:integer;x1,y1,x2,y2:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (SamePosCheck(x1,y1,x2,y2))  then exit ; // _

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,2,dLinN)) then begin
         try
            Inc(dLinN);
            if ((dLinN mod 200) = 1) then SetLength(dLin, dLinN+199);   // 200m
            with dLin[dLinN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               start_x     := x1 ;
               start_y     := y1 ;
               end_x       := x2 ;
               end_y       := y2 ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,col,ltp,wid,-1);
         except
            Dec(dLinN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,2,mLinN)) then begin
               try
                  Inc(mLinN);
                  if ((mLinN mod 200) = 1) then SetLength(mLin, mLinN+199);   // 200m
                  with mLin[mLinN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     start_x     := x1 ;
                     start_y     := y1 ;
                     end_x       := x2 ;
                     end_y       := y2 ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,col,ltp,wid,-1);
               except
                  Dec(mLinN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,2,mLinN)) then begin
               try
                  Inc(mLinN);
                  if ((mLinN mod 200) = 1) then SetLength(mLin, mLinN+199);   // 200m
                  with mLin[mLinN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     start_x     := x1 ;
                     start_y     := y1 ;
                     end_x       := x2 ;
                     end_y       := y2 ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mLinN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// ܐ@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    num: _
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:o^OK@False:NG
function TDataClass.AddDataLines(s:string;lay,col,ltp,wid,num:integer;vx,vy:array of double) : Boolean;
var
   m,i,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (num <=0) then exit ;
   try
      for i:=1 to num-1 do
         if (SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ; // _
   except
      exit ;   // IzG[
   end;
   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,3,dLnsN)) then begin
         try
            Inc(dLnsN);
            if ((dLnsN mod 100) = 1) then SetLength(dLns, dLnsN+99);    // 100m
            with dLns[dLnsN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               Number      := num ;
               try
                  SetLength(X, Number);
                  SetLength(Y, Number);
               except
                  X := nil ;
                  Y := nil ;
                  Number := 0 ;
               end;
               for i:=0 to Number-1 do begin
                  X[i]     := vx[i];
                  Y[i]     := vy[i];
               end;
            end;
            Result := True ;
            OpAdd(5,0,dOrdN-1);
            AddLayerCnt(lay,col,ltp,wid,-1);
         except
            Dec(dLnsN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,3,mLnsN)) then begin
               try
                  Inc(mLnsN);
                  if ((mLnsN mod 100) = 1) then SetLength(mLns, mLnsN+99);    // 100m
                  with mLns[mLnsN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     Number      := num ;
                     try
                        SetLength(X, Number);
                        SetLength(Y, Number);
                     except
                        X := nil ;
                        Y := nil ;
                        Number := 0 ;
                     end;
                     for i:=0 to Number-1 do begin
                        X[i]     := vx[i];
                        Y[i]     := vy[i];
                     end;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,col,ltp,wid,-1);
               except
                  Dec(mLnsN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,3,mLnsN)) then begin
               try
                  Inc(mLnsN);
                  if ((mLnsN mod 100) = 1) then SetLength(mLns, mLnsN+99);    // 100m
                  with mLns[mLnsN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     Number      := num ;
                     try
                        SetLength(X, Number);
                        SetLength(Y, Number);
                     except
                        X := nil ;
                        Y := nil ;
                        Number := 0 ;
                     end;
                     for i:=0 to Number-1 do begin
                        X[i]     := vx[i];
                        Y[i]     := vy[i];
                     end;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mLnsN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// ~@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : (3`3600)
//    cx : S_X
//    cy : S_Y
//    cr : a
// (ret) True:o^OK@False:NG
function TDataClass.AddDataCircle(s:string;lay,col,ltp,wid,sp:integer;cx,cy,cr:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp  < 3) or (sp  >  3600)   then sp  := 72;
   if (cr < LIMIT10) then exit ;    // a <= 0

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,4,dCirN)) then begin
         try
            Inc(dCirN);
            if ((dCirN mod 200) = 1) then SetLength(dCir, dCirN+199);   // 200m
            with dCir[dCirN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               sep         := sp ;
               Center_x    := cx ;
               Center_y    := cy ;
               Radius      := cr ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,col,ltp,wid,-1);
         except
            Dec(dCirN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,4,mCirN)) then begin
               try
                  Inc(mCirN);
                  if ((mCirN mod 200) = 1) then SetLength(mCir, mCirN+199);   // 200m
                  with mCir[mCirN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sep         := sp ;
                     Center_x    := cx ;
                     Center_y    := cy ;
                     Radius      := cr ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,col,ltp,wid,-1);
               except
                  Dec(mCirN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,4,mCirN)) then begin
               try
                  Inc(mCirN);
                  if ((mCirN mod 200) = 1) then SetLength(mCir, mCirN+199);   // 200m
                  with mCir[mCirN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sep         := sp ;
                     Center_x    := cx ;
                     Center_y    := cy ;
                     Radius      := cr ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mCirN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// ~ʁ@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : (3`3600)
//    dir: (0,1)
//    cx : S_X
//    cy : S_Y
//    cr : a
//    sa : np
//    ea : Ip
// (ret) True:o^OK@False:NG
function TDataClass.AddDataArc(s:string;lay,col,ltp,wid,sp,dir:integer;cx,cy,cr,sa,ea:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp  < 3) or (sp  >  3600)   then sp  := 72;
   if (cr < LIMIT10) then exit ;          // a <= 0
   if (dir <> 0) then dir := 1 ;
   sa := SetAngle(sa);
   ea := SetAngle(ea);
   if (Abs(ea-sa) < LIMIT10) then exit ;  // np = Ip

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,5,dArcN)) then begin
         try
            Inc(dArcN);
            if ((dArcN mod 200) = 1) then SetLength(dArc, dArcN+199);   // 200m
            with dArc[dArcN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               sep         := sp ;
               Center_x    := cx ;
               Center_y    := cy ;
               Radius      := cr ;
               Direction   := dir ;
               start_angle := sa ;
               end_angle   := ea ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,col,ltp,wid,-1);
         except
            Dec(dArcN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,5,mArcN)) then begin
               try
                  Inc(mArcN);
                  if ((mArcN mod 200) = 1) then SetLength(mArc, mArcN+199);   // 200m
                  with mArc[mArcN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sep         := sp ;
                     Center_x    := cx ;
                     Center_y    := cy ;
                     Radius      := cr ;
                     Direction   := dir ;
                     start_angle := sa ;
                     end_angle   := ea ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,col,ltp,wid,-1);
               except
                  Dec(mArcN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,5,mArcN)) then begin
               try
                  Inc(mArcN);
                  if ((mArcN mod 200) = 1) then SetLength(mArc, mArcN+199);   // 200m
                  with mArc[mArcN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sep         := sp ;
                     Center_x    := cx ;
                     Center_y    := cy ;
                     Radius      := cr ;
                     Direction   := dir ;
                     start_angle := sa ;
                     end_angle   := ea ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mArcN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// ȉ~@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : (3`3600)
//    cx : S_X
//    cy : S_Y
//    rx : wa
//    ry : xa
//    ra : ]p
// (ret) True:o^OK@False:NG
function TDataClass.AddDataEllipse(s:string;lay,col,ltp,wid,sp:integer;cx,cy,rx,ry,ra:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp  < 3) or (sp  >  3600)   then sp  := 72;
   if (rx < LIMIT10)or(ry < LIMIT10) then exit ;   // a <= 0
   ra := SetAngle(ra);

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,6,dEllN)) then begin
         try
            Inc(dEllN);
            if ((dEllN mod 200) = 1) then SetLength(dEll, dEllN+199);   // 200m
            with dEll[dEllN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               sep         := sp ;
               Center_x    := cx ;
               Center_y    := cy ;
               Radius_x    := rx ;
               Radius_y    := ry ;
               rotation_angle := ra ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,col,ltp,wid,-1);
         except
            Dec(dEllN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,6,mEllN)) then begin
               try
                  Inc(mEllN);
                  if ((mEllN mod 200) = 1) then SetLength(mEll, mEllN+199);   // 200m
                  with mEll[mEllN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sep         := sp ;
                     Center_x    := cx ;
                     Center_y    := cy ;
                     Radius_x    := rx ;
                     Radius_y    := ry ;
                     rotation_angle := ra ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,col,ltp,wid,-1);
               except
                  Dec(mEllN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,6,mEllN)) then begin
               try
                  Inc(mEllN);
                  if ((mEllN mod 200) = 1) then SetLength(mEll, mEllN+199);   // 200m
                  with mEll[mEllN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sep         := sp ;
                     Center_x    := cx ;
                     Center_y    := cy ;
                     Radius_x    := rx ;
                     Radius_y    := ry ;
                     rotation_angle := ra ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mEllN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// ȉ~ʁ@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : (3`3600)
//    dir: (0,1)
//    cx : S_X
//    cy : S_Y
//    rx : wa
//    ry : xa
//    ra : ]p
//    sa : np
//    ea : Ip
// (ret) True:o^OK@False:NG
function TDataClass.AddDataEllipseArc(s:string;lay,col,ltp,wid,sp,dir:integer;cx,cy,rx,ry,ra,sa,ea:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp  < 3) or (sp  >  3600) then sp  := 72;
   if (rx < LIMIT10)or(ry < LIMIT10) then exit ;   // a <= 0
   if (dir <> 0) then dir := 1 ;
   ra := SetAngle(ra);
   sa := SetAngle(sa);
   ea := SetAngle(ea);
   if (Abs(ea-sa) < LIMIT10) then exit ;  // np = Ip

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,7,dEArN)) then begin
         try
            Inc(dEArN);
            if ((dEArN mod 200) = 1) then SetLength(dEAr, dEArN+199);   // 200m
            with dEAr[dEArN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               sep         := sp ;
               Center_x    := cx ;
               Center_y    := cy ;
               Radius_x    := rx ;
               Radius_y    := ry ;
               Direction   := dir ;
               rotation_angle := ra ;
               start_angle := sa ;
               end_angle   := ea ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,col,ltp,wid,-1);
         except
            Dec(dEArN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,7,mEArN)) then begin
               try
                  Inc(mEArN);
                  if ((mEArN mod 200) = 1) then SetLength(mEAr, mEArN+199);   // 200m
                  with mEAr[mEArN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sep         := sp ;
                     Center_x    := cx ;
                     Center_y    := cy ;
                     Radius_x    := rx ;
                     Radius_y    := ry ;
                     Direction   := dir ;
                     rotation_angle := ra ;
                     start_angle := sa ;
                     end_angle   := ea ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,col,ltp,wid,-1);
               except
                  Dec(mEArN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,7,mEArN)) then begin
               try
                  Inc(mEArN);
                  if ((mEArN mod 200) = 1) then SetLength(mEAr, mEArN+199);   // 200m
                  with mEAr[mEArN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sep         := sp ;
                     Center_x    := cx ;
                     Center_y    := cy ;
                     Radius_x    := rx ;
                     Radius_y    := ry ;
                     Direction   := dir ;
                     rotation_angle := ra ;
                     start_angle := sa ;
                     end_angle   := ea ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mEArN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// @f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    str: 
//    lay: C(1-256)
//    col: F@    (0,1-256)
//    fon: tHg(0,1-1024)
//    bp : _(1-9)
//    dir: (1,2)
//    px : zu_X
//    py : zu_Y
//    ph : ͈͍
//    pw : ͈͕
//    ps : Ԋu
//    an : ]p
//    sl : Xgp
// (ret) True:o^OK@False:NG
function TDataClass.AddDataText(s,st:string;lay,col,fnt,bp,dir:integer;px,py,ph,pw,ps,an,sl:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if not(StrCheck(st)) then exit;                 // 񐔃`FbN
   if (ph < LIMIT10)or(pw < LIMIT10) then exit ;   // ͈͂ <= 0
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (fnt < 0) or (fnt > zFntMax) then fnt := 0 ;
   if (bp  < 1) or (bp  >     9) then bp  := 1 ;
   if (dir <> 1) then dir := 2 ;
   if (ps < 0.0) then ps := 0.0;
   an := SetAngle(an);
   if (sl < -85.0) or (sl > 85.0) then sl := 0.0;

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,8,dTxtN)) then begin
         try
            Inc(dTxtN);
            if ((dTxtN mod 200) = 1) then SetLength(dTxt, dTxtN+199);   // 200m
            with dTxt[dTxtN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Font        := fnt ;
               str         := st ;
               text_x      := px ;
               text_y      := py ;
               Height      := ph ;
               Width       := pw ;
               Spc         := ps ;
               Angle       := an ;
               Slant       := sl ;
               b_pnt       := bp ;
               Direct      := dir ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,col,-1,-1,fnt);
         except
            Dec(dTxtN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,8,mTxtN)) then begin
               try
                  Inc(mTxtN);
                  if ((mTxtN mod 200) = 1) then SetLength(mTxt, mTxtN+199);   // 200m
                  with mTxt[mTxtN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Font        := fnt ;
                     str         := st ;
                     text_x      := px ;
                     text_y      := py ;
                     Height      := ph ;
                     Width       := pw ;
                     Spc         := ps ;
                     Angle       := an ;
                     Slant       := sl ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,col,-1,-1,fnt);
               except
                  Dec(mTxtN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,8,mTxtN)) then begin
               try
                  Inc(mTxtN);
                  if ((mTxtN mod 200) = 1) then SetLength(mTxt, mTxtN+199);   // 200m
                  with mTxt[mTxtN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Font        := fnt ;
                     str         := st ;
                     text_x      := px ;
                     text_y      := py ;
                     Height      := ph ;
                     Width       := pw ;
                     Spc         := ps ;
                     Angle       := an ;
                     Slant       := sl ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mTxtN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// xWFȐ@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : _ԕ
//    num: _(1-1000)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:o^OK@False:NG
function TDataClass.AddDataBezier(s:string;lay,col,ltp,wid,sp,num:integer;vx,vy:array of double) : Boolean;
var
   m,i,dn : integer ;
   oc : integer ; // J敪(0: 1:J)
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp <  1)   then sp := 1 ;
   if (sp > 1000) then sp := 1000 ;
   if ( ((num-1)mod 3) > 0) then num := ((num-1) div 3)*3+1;
   if (num <= 1) then exit ;
   try
      for i:=1 to num-1 do
         if (((i-2) mod 3) > 0)
          and(SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ;   // _i_1Ɛ_2͓ł\Ȃj
   except
      exit ;   // IzG[
   end;

   oc := 1;
   if (Abs(vx[0]-vx[num-1]) < LIMIT10)
   and(Abs(vy[0]-vy[num-1]) < LIMIT10) then oc := 0;  // 

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,9,dBezN)) then begin
         try
            Inc(dBezN);
            if ((dBezN mod 100) = 1) then SetLength(dBez, dBezN+99);    // 100m
            with dBez[dBezN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               open_close  := oc ;
               sep         := sp ;
               Number      := num ;
               try
                  SetLength(X, Number);
                  SetLength(Y, Number);
               except
                  X := nil ;
                  Y := nil ;
                  Number := 0 ;
               end;
               for i:=0 to Number-1 do begin
                  X[i]     := vx[i];
                  Y[i]     := vy[i];
               end;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,col,ltp,wid,-1);
         except
            Dec(dBezN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,9,mBezN)) then begin
               try
                  Inc(mBezN);
                  if ((mBezN mod 100) = 1) then SetLength(mBez, mBezN+99);    // 100m
                  with mBez[mBezN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     open_close  := oc ;
                     sep         := sp ;
                     Number      := num ;
                     try
                        SetLength(X, Number);
                        SetLength(Y, Number);
                     except
                        X := nil ;
                        Y := nil ;
                        Number := 0 ;
                     end;
                     for i:=0 to Number-1 do begin
                        X[i]     := vx[i];
                        Y[i]     := vy[i];
                     end;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,col,ltp,wid,-1);
               except
                  Dec(mBezN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,9,mBezN)) then begin
               try
                  Inc(mBezN);
                  if ((mBezN mod 100) = 1) then SetLength(mBez, mBezN+99);    // 100m
                  with mBez[mBezN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     open_close  := oc ;
                     sep         := sp ;
                     Number      := num ;
                     try
                        SetLength(X, Number);
                        SetLength(Y, Number);
                     except
                        X := nil ;
                        Y := nil ;
                        Number := 0 ;
                     end;
                     for i:=0 to Number-1 do begin
                        X[i]     := vx[i];
                        Y[i]     := vy[i];
                     end;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mBezN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// aXvCȐ@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : _ԕ
//    num: _(1-1000)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:o^OK@False:NG
function TDataClass.AddDataBspline(s:string;lay,col,ltp,wid,sp,num:integer;vx,vy:array of double) : Boolean;
var
   m,i,dn : integer ;
   oc : integer ; // J敪(0: 1:J)
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp <  1)   then sp := 1 ;
   if (sp > 1000) then sp := 1000 ;
   if (num <= 2) then exit ;
   try
      for i:=1 to num-1 do
         if (SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ; // _
   except
      exit ;   // IzG[
   end;

   oc := 1;
   if (Abs(vx[0]-vx[num-1]) < LIMIT10)
   and(Abs(vy[0]-vy[num-1]) < LIMIT10) then oc := 0;  // 

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,10,dBspN)) then begin
         try
            Inc(dBspN);
            if ((dBspN mod 100) = 1) then SetLength(dBsp, dBspN+99);    // 100m
            with dBsp[dBspN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               open_close  := oc ;
               sep         := sp ;
               Number      := num ;
               try
                  SetLength(X, Number);
                  SetLength(Y, Number);
               except
                  X := nil ;
                  Y := nil ;
                  Number := 0 ;
               end;
               for i:=0 to Number-1 do begin
                  X[i]     := vx[i];
                  Y[i]     := vy[i];
               end;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,col,ltp,wid,-1);
         except
            Dec(dBspN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,10,mBspN)) then begin
               try
                  Inc(mBspN);
                  if ((mBspN mod 100) = 1) then SetLength(mBsp, mBspN+99);    // 100m
                  with mBsp[mBspN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     open_close  := oc ;
                     sep         := sp ;
                     Number      := num ;
                     try
                        SetLength(X, Number);
                        SetLength(Y, Number);
                     except
                        X := nil ;
                        Y := nil ;
                        Number := 0 ;
                     end;
                     for i:=0 to Number-1 do begin
                        X[i]     := vx[i];
                        Y[i]     := vy[i];
                     end;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,col,ltp,wid,-1);
               except
                  Dec(mBspN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,10,mBspN)) then begin
               try
                  Inc(mBspN);
                  if ((mBspN mod 100) = 1) then SetLength(mBsp, mBspN+99);    // 100m
                  with mBsp[mBspN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     open_close  := oc ;
                     sep         := sp ;
                     Number      := num ;
                     try
                        SetLength(X, Number);
                        SetLength(Y, Number);
                     except
                        X := nil ;
                        Y := nil ;
                        Number := 0 ;
                     end;
                     for i:=0 to Number-1 do begin
                        X[i]     := vx[i];
                        Y[i]     := vy[i];
                     end;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mBspN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// XvCȐ@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    stp: Ȑ^Cv (1:CXvC 2:xWF 3:NUBS)
//@@sp : _ԕ
//    num: _(1-1000)
//    av : CXvĈ`l(0-1 ʏ0.5)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:o^OK@False:NG
function TDataClass.AddDataSpline(s:string;lay,col,ltp,wid,stp,sp,num:integer;av:double;vx,vy:array of double) : Boolean;
var
   m,i,dn : integer ;
   oc : integer ; // J敪(0: 1:J)
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (stp < 1) or (stp > 3)     then stp := 1 ;
   if (sp <  1)   then sp := 1 ;
   if (sp > 1000) then sp := 1000 ;
   if (num <= 2) then exit ;
   try
      for i:=1 to num-1 do
         if (SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ; // _
   except
      exit ;   // IzG[
   end;

   oc := 1;
   if (Abs(vx[0]-vx[num-1]) < LIMIT10)
   and(Abs(vy[0]-vy[num-1]) < LIMIT10) then oc := 0;  // 

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,11,dSplN)) then begin
         try
            Inc(dSplN);
            if ((dSplN mod 100) = 1) then SetLength(dSpl, dSplN+99);    // 100m
            with dSpl[dSplN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               Stype       := stp ;
               Aval        := av ;
               open_close  := oc ;
               sep         := sp ;
               Number      := num ;
               try
                  SetLength(X, Number);
                  SetLength(Y, Number);
               except
                  X := nil ;
                  Y := nil ;
                  Number := 0 ;
               end;
               for i:=0 to Number-1 do begin
                  X[i]     := vx[i];
                  Y[i]     := vy[i];
               end;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,col,ltp,wid,-1);
         except
            Dec(dSplN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,11,mSplN)) then begin
               try
                  Inc(mSplN);
                  if ((mSplN mod 100) = 1) then SetLength(mSpl, mSplN+99);    // 100m
                  with mSpl[mSplN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     Stype       := stp ;
                     Aval        := av ;
                     open_close  := oc ;
                     sep         := sp ;
                     Number      := num ;
                     try
                        SetLength(X, Number);
                        SetLength(Y, Number);
                     except
                        X := nil ;
                        Y := nil ;
                        Number := 0 ;
                     end;
                     for i:=0 to Number-1 do begin
                        X[i]     := vx[i];
                        Y[i]     := vy[i];
                     end;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,col,ltp,wid,-1);
               except
                  Dec(mSplN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,11,mSplN)) then begin
               try
                  Inc(mSplN);
                  if ((mSplN mod 100) = 1) then SetLength(mSpl, mSplN+99);    // 100m
                  with mSpl[mSplN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     Stype       := stp ;
                     Aval        := av ;
                     open_close  := oc ;
                     sep         := sp ;
                     Number      := num ;
                     try
                        SetLength(X, Number);
                        SetLength(Y, Number);
                     except
                        X := nil ;
                        Y := nil ;
                        Number := 0 ;
                     end;
                     for i:=0 to Number-1 do begin
                        X[i]     := vx[i];
                        Y[i]     := vy[i];
                     end;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mSplN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// N\ChȐ@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    dir: @(0:v,1:v)
//@@sp : 
//    bx : zu_wW
//    by : zu_xW
//    av : p[^@N\Cĥ`l(0)
//    an : ]p[]
//    l1 : JnȐ (0ȏ) ȐƂĂ̓}CiXl\łSXFdl0ȏƌ܂Ă̂Ő
//    l2 : IȐ (0ȏ)
// (ret) True:o^OK@False:NG
function TDataClass.AddDataClothoid(s:string;lay,col,ltp,wid,dir,sp:integer;bx,by,av,an,l1,l2:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (dir <> 0) then dir := 1 ;
   if (sp <     1) then sp := 1 ;
   if (sp > 10000) then sp := 10000 ;
   if (av <= 0.0) then exit ;             // p[^Al 0
   an := SetAngle(an);
   if (l1 < 0.0) then l1 := 0.0 ;
   if (l2 < 0.0) then l2 := 0.0 ;
   if (Abs(l1-l2) < LIMIT10) then exit ;  // Jn = I

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,12,dCloN)) then begin
         try
            Inc(dCloN);
            if ((dCloN mod 100) = 1) then SetLength(dClo, dCloN+99);    // 100m
            with dClo[dCloN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               base_x      := bx ;
               base_y      := by ;
               Aval        := av ;
               Direction   := dir ;
               Angle       := an ;
               start_length:= l1 ;
               end_length  := l2 ;
               sep         := sp ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,col,ltp,wid,-1);
         except
            Dec(dCloN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,12,mCloN)) then begin
               try
                  Inc(mCloN);
                  if ((mCloN mod 100) = 1) then SetLength(mClo, mCloN+99);    // 100m
                  with mClo[mCloN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     base_x      := bx ;
                     base_y      := by ;
                     Aval        := av ;
                     Direction   := dir ;
                     Angle       := an ;
                     start_length:= l1 ;
                     end_length  := l2 ;
                     sep         := sp ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,col,ltp,wid,-1);
               except
                  Dec(mCloN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,12,mCloN)) then begin
               try
                  Inc(mCloN);
                  if ((mCloN mod 100) = 1) then SetLength(mClo, mCloN+99);    // 100m
                  with mClo[mCloN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     base_x      := bx ;
                     base_y      := by ;
                     Aval        := av ;
                     Direction   := dir ;
                     Angle       := an ;
                     start_length:= l1 ;
                     end_length  := l2 ;
                     sep         := sp ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mCloN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// @f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    col: F(0,1-256)
//    ac : R[h(1:blanked arrow 2:blanked box 3:blanked dot
//                    4:dimension origin 5:filled box 6:filled arrow
//                    7:filled dot 8:integral symbol 9:open arrow
//                   10:slash 11:unfilled arrow)
//    px : zu_X
//    py : zu_Y
//    an : ]p[]
//    sc : ړx
// (ret) True:o^OK@False:NG
function TDataClass.AddDataArrow(s:string;lay,col,ac:integer;px,py,an,sc:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ac  < 1) or (ac  > 11)      then ac  := 9 ;   // open arrow
   an := SetAngle(an);
   if (sc < LIMIT8) then sc := 1.0;

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,13,dArwN)) then begin
         try
            Inc(dArwN);
            if ((dArwN mod 200) = 1) then SetLength(dArw, dArwN+199);   // 200m
            with dArw[dArwN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               start_x     := px ;
               start_y     := py ;
               arrow_code  := ac ;
               rotate_angle:= an ;
               Scale       := sc ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,col,-1,-1,-1);
         except
            Dec(dArwN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
             dn := datn ;
         end;
         with fDefD[dn] do begin
           if (AddDataOrder(m,13,mArwN)) then begin
               try
                  Inc(mArwN);
                  if ((mArwN mod 200) = 1) then SetLength(mArw, mArwN+199);   // 200m
                  with mArw[mArwN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     start_x     := px ;
                     start_y     := py ;
                     arrow_code  := ac ;
                     rotate_angle:= an ;
                     Scale       := sc ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,col,-1,-1,-1);
               except
                  Dec(mArwN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,13,mArwN)) then begin
               try
                  Inc(mArwN);
                  if ((mArwN mod 200) = 1) then SetLength(mArw, mArwN+199);   // 200m
                  with mArw[mArwN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     start_x     := px ;
                     start_y     := py ;
                     arrow_code  := ac ;
                     rotate_angle:= an ;
                     Scale       := sc ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mArwN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// 摜@f[^ڂ̒ǉo^
//    fn : 摜t@C
//    lay: C(1-256)
//    al : At@l(0`255)
//    px : zu_X
//    py : zu_Y
//    sx : wTCY
//    sy : xTCY
//    an : ]p[]
// (ret) True:o^OK@False:NG
function TDataClass.AddDataImage(fn:string;lay,al:integer;px,py,sx,sy,an:double) : Boolean;
begin
   Result := False;
   if (fn = '') then exit ;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (al <   0) then al :=   0;
   if (al > 255) then al := 255;
   if (sx < LIMIT10)or(sy < LIMIT10) then exit ;
   an := SetAngle(an);

   if (AddDataOrder(0,14,dImgN)) then begin
      try
         Inc(dImgN);
         if ((dImgN mod 100) = 1) then SetLength(dImg, dImgN+99); // 100m
         with dImg[dImgN-1] do begin
            exf         := True ;
            Layer       := lay ;
            Alpha       := al ;
            start_x     := px ;
            start_y     := py ;
            size_x      := sx ;
            size_y      := sy ;
            Angle       := an ;
            ImgFileName := fn ;
         end;
         OpAdd(5,0,dOrdN-1);
         Result := True ;
         AddLayerCnt(lay,-1,-1,-1,-1);
      except
         Dec(dImgN);
         Dec(dOrdN);
      end;
   end;
end;

// ́@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    st : 
//    lay: C(1-256)
//    bp : _(1:,2:,3:E,4:,5:,6:E,7:,8:,9:E)
//    dir: (1,2)
//    px : zu_X
//    py : zu_Y
//    pd : sNZmmϊ䗦(W72)
//    pw : ͔͈͕
//    ps : Ԋu
//    pl : sԊu
//    an : ]p
// (ret) True:o^OK@False:NG
function TDataClass.AddDataDocument(s,st:string;lay,bp,dir:integer;px,py,pd,pw,ps,pl,an:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (st = '') then exit;                         // `FbN
   if (KTrim(GetPlainText(st)) = '') then exit ;   // `FbN
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (bp  < 1) or (bp  >       9) then bp  := 1 ;
   if (dir <> 1) then dir := 2 ;
   if (pd < LIMIT10) then pd := 72.0 ;
   if (ps < 0.0) then ps := 0.0;
   if (pl < 0.0) then pl := 0.0;
   an := SetAngle(an);

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,15,dDocN)) then begin
         try
            Inc(dDocN);
            if ((dDocN mod 10) = 1) then SetLength(dDoc, dDocN+9);   // 10m
            with dDoc[dDocN-1] do begin
               exf         := True ;
               Layer       := lay ;
               str         := st ;
               text_x      := px ;
               text_y      := py ;
               Dpi         := pd ;
               Width       := pw ;
               Spc         := ps ;
               LSpc        := pl ;
               Angle       := an ;
               b_pnt       := bp ;
               Direct      := dir ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,-1,-1,-1,-1);
         except
            Dec(dDocN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,15,mDocN)) then begin
               try
                  Inc(mDocN);
                  if ((mDocN mod 10) = 1) then SetLength(mDoc, mDocN+9);   // 10m
                  with mDoc[mDocN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     str         := st ;
                     text_x      := px ;
                     text_y      := py ;
                     Dpi         := pd ;
                     Width       := pw ;
                     Spc         := ps ;
                     LSpc        := pl ;
                     Angle       := an ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,-1,-1,-1,-1);
               except
                  Dec(mDocN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,15,mDocN)) then begin
               try
                  Inc(mDocN);
                  if ((mDocN mod 10) = 1) then SetLength(mDoc, mDocN+9);   // 10m
                  with mDoc[mDocN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     str         := st ;
                     text_x      := px ;
                     text_y      := py ;
                     Dpi         := pd ;
                     Width       := pw ;
                     Spc         := ps ;
                     LSpc        := pl ;
                     Angle       := an ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mDocN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// \@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    lay: C(1-256)
//    bp : _(1:,2:,3:E,4:,5:,6:E,7:,8:,9:E)
//    co1: 
//    ro1: s
//    co2: Œ
//    ro2: Œs
//    lco: r̐F@(0:CF@ 1`256)
//    llt: r̐(0:C 1`32)
//    lwd: r̐(0:C 1`16)
//    cc1: ZhאF(0:CF@ 1`256)
//    fl1: Z̓hׂ̗L(0:A1:L)
//    cc2: ŒZhאF(0:CF@1`256)
//    fl2: ŒZ̓hׂ̗L(0:A1:L)
//    tco: ̐F (0:CF@ 1`256)
//    fnt: tHg (0:CtHg 1`1024)
//    px : zu_X
//    py : zu_Y
//    pg : rƕ̊Ԃ̊Ԋu
//    ps : Ԋu
//    cw : 
//    rh : s
//    al : ʒu(1: 2: 3:E)
//    st : 
//    ca : vZ
// (ret) True:o^OK@False:NG
function TDataClass.AddDataTable(s:string;lay,bp,co1,ro1,co2,ro2,lco,llt,lwd,cc1,fl1,cc2,fl2,tco,fnt:integer;
            px,py,pg,ps:double;cw,rh:array of double;al:array of Integer; st,ca:TStrGrid) : Boolean;
var
   i,j,m,dn : integer ;
   fl : Boolean ;
begin
   Result := False;
   if (co1 <= 0) then exit;
   if (ro1 <= 0) then exit;
   fl := False ;
   for j:=0 to ro1-1 do begin
      for i:=0 to co1-1 do begin
         if (st[i,j] <> '') then begin
            fl := True ;
            break ;
         end;
      end;
   end;
   if not(fl) then exit;   // `FbN

   fl := True ;
   for j:=0 to ro1-1 do begin
      for i:=0 to co1-1 do begin
         if (st[i,j] <> '') then begin
            if not(StrCheck(st[i,j])) then begin
               fl := False ;
               break ;
            end;
         end;
         if (ca[i,j] <> '') then begin
            if not(StrCheck(ca[i,j])) then begin
               fl := False ;
               break ;
            end;
         end;
      end;
   end;
   if not(fl) then exit;   // 񐔃`FbN

   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (bp  < 1) or (bp  >       9) then bp  := 1 ;
   if (co2 < 0) or (co2 > co1)     then co2 := 0 ;
   if (ro2 < 0) or (ro2 > ro1)     then ro2 := 0 ;
   if (lco < 0) or (lco > zColMax) then lco := 0 ;
   if (llt < 0) or (llt > zLtpMax) then llt := 0 ;
   if (lwd < 0) or (lwd > zWidMax) then lwd := 0 ;
   if (cc1 < 0) or (cc1 > zColMax) then cc1 := 0 ;
   if (cc2 < 0) or (cc2 > zColMax) then cc2 := 0 ;
   if (fl1 <> 0) then fl1 := 1 ;
   if (fl2 <> 0) then fl2 := 1 ;
   if (tco < 0) or (tco > zColMax) then tco := 0 ;
   if (fnt < 0) or (fnt > zFntMax) then fnt := 0 ;
   if (pg < 0.0) then pg := 0.0;
   if (ps < 0.0) then ps := 0.0;
   for i:=0 to co1-1 do begin
      if (cw[i] <= LIMIT6) then cw[i] := LIMIT6;
   end;
   for j:=0 to ro1-1 do begin
      if (rh[j] <= LIMIT6) then rh[j] := LIMIT6;
   end;
   for i:=0 to co1-1 do begin
      if (al[i] < 1)or(al[i] > 3) then al[i] := 1 ;
   end;

   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,16,dTblN)) then begin
         try
            Inc(dTblN);
            SetLength(dTbl, dTblN);
            with dTbl[dTblN-1] do begin
               exf         := True ;
               Layer       := lay ;
               start_x     := px ;
               start_y     := py ;
               b_pnt       := bp ;
               Cols        := co1 ;
               Rows        := ro1 ;
               FixCols     := co2 ;
               FixRows     := ro2 ;
               SetLength(ColWidth, co1);
               for i:=0 to co1-1 do
                  ColWidth[i] := cw[i] ;
               SetLength(RowHeight, ro1);
               for j:=0 to ro1-1 do
                  RowHeight[j] := rh[j] ;
               Gap         := pg ;
               line_color  := lco ;
               line_ltype  := llt ;
               line_width  := lwd ;
               cell_color1 := cc1 ;
               flg1        := fl1 ;
               cell_color2 := cc2 ;
               flg2        := fl2 ;
               text_color  := tco ;
               Font        := fnt ;
               Spc         := ps ;
               SetLength(align, co1);
               for i:=0 to co1-1 do
                  align[i] := al[i] ;
               SetLength(str , co1,ro1);
               SetLength(calc, co1,ro1);
               for j:=0 to ro1-1 do
                  for i:=0 to co1-1 do begin
                     str[i,j]  := st[i,j] ;
                     calc[i,j] := ca[i,j] ;
                  end;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,-1,-1,-1,-1);
         except
            with dTbl[dTblN-1] do begin
               ColWidth := nil ;
               RowHeight:= nil ;
               align    := nil ;
               str      := nil ;
               calc     := nil ;
            end;
            Dec(dTblN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,16,mTblN)) then begin
               try
                  Inc(mTblN);
                  SetLength(mTbl, mTblN);
                  with mTbl[mTblN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     start_x     := px ;
                     start_y     := py ;
                     b_pnt       := bp ;
                     Cols        := co1 ;
                     Rows        := ro1 ;
                     FixCols     := co2 ;
                     FixRows     := ro2 ;
                     SetLength(ColWidth, co1);
                     for i:=0 to co1-1 do
                        ColWidth[i] := cw[i] ;
                     SetLength(RowHeight, ro1);
                     for j:=0 to ro1-1 do
                        RowHeight[j] := rh[j] ;
                     Gap         := pg ;
                     line_color  := lco ;
                     line_ltype  := llt ;
                     line_width  := lwd ;
                     cell_color1 := cc1 ;
                     flg1        := fl1 ;
                     cell_color2 := cc2 ;
                     flg2        := fl2 ;
                     text_color  := tco ;
                     Font        := fnt ;
                     Spc         := ps ;
                     SetLength(align, co1);
                     for i:=0 to co1-1 do
                        align[i] := al[i] ;
                     SetLength(str , co1,ro1);
                     SetLength(calc, co1,ro1);
                     for j:=0 to ro1-1 do
                        for i:=0 to co1-1 do begin
                           str[i,j]  := st[i,j] ;
                           calc[i,j] := ca[i,j] ;
                        end;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,-1,-1,-1,-1);
               except
                  with mTbl[mTblN-1] do begin
                     ColWidth := nil ;
                     RowHeight:= nil ;
                     align    := nil ;
                     str      := nil ;
                     calc     := nil ;
                  end;
                  Dec(mTblN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,16,mTblN)) then begin
               try
                  Inc(mTblN);
                  SetLength(mTbl, mTblN);
                  with mTbl[mTblN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     start_x     := px ;
                     start_y     := py ;
                     b_pnt       := bp ;
                     Cols        := co1 ;
                     Rows        := ro1 ;
                     FixCols     := co2 ;
                     FixRows     := ro2 ;
                     SetLength(ColWidth, co1);
                     for i:=0 to co1-1 do
                        ColWidth[i] := cw[i] ;
                     SetLength(RowHeight, ro1);
                     for j:=0 to ro1-1 do
                        RowHeight[j] := rh[j] ;
                     Gap         := pg ;
                     line_color  := lco ;
                     line_ltype  := llt ;
                     line_width  := lwd ;
                     cell_color1 := cc1 ;
                     flg1        := fl1 ;
                     cell_color2 := cc2 ;
                     flg2        := fl2 ;
                     text_color  := tco ;
                     Font        := fnt ;
                     Spc         := ps ;
                     SetLength(align, co1);
                     for i:=0 to co1-1 do
                        align[i] := al[i] ;
                     SetLength(str , co1,ro1);
                     SetLength(calc, co1,ro1);
                     for j:=0 to ro1-1 do
                        for i:=0 to co1-1 do begin
                           str[i,j]  := st[i,j] ;
                           calc[i,j] := ca[i,j] ;
                        end;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  with mTbl[mTblN-1] do begin
                     ColWidth := nil ;
                     RowHeight:= nil ;
                     align    := nil ;
                     str      := nil ;
                     calc     := nil ;
                  end;
                  Dec(mTblN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// @@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`^V{  null:p֒ǉ
// (ret) True:o^OK@False:NG
function TDataClass.AddDataDimLine(s,st:string;lay,col,ltp,wid,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx1,sy1,sx2,sy2, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
var
   m,dn : integer ;
   a1,a2,w1,w2 : double ;
begin
   Result := False;
   if (st = '') then
      f4 := 0
   else
      if not(StrCheck(st)) then exit;        // 񐔃`FbN
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (f2 <> 0) then f2 := 1;
   if (f3 <> 0) then f3 := 1;
   if (f4 <> 0) then f4 := 1;
   if (ar11 < 1)or(ar11 > 11) then ar11 := 9;
   if (ar21 < 1)or(ar21 > 11) then ar21 := 9;
   if (ar12 < 0)or(ar12 > 2)  then ar12 := 2;
   if (ar22 < 0)or(ar22 > 2)  then ar22 := 2;
   if (ar1r < LIMIT8) then ar1r := 1.0;
   if (ar2r < LIMIT8) then ar2r := 1.0;
   if (f4 = 1)and( (th < LIMIT10)or(tw < LIMIT10) ) then exit ;   // ͈͂ <= 0
   if (fnt < 0) or (fnt > zFntN) then fnt := 0 ;
   if (bp  < 1) or (bp  >     9) then bp  := 2 ;   // 
   if (dir <> 1) then dir := 2 ;
   if (ts < 0.0) then ts := 0.0;
   an := SetAngle(an);
   if (sl < -85.0) or (sl > 85.0) then sl := 0.0;
   // W`FbN
   if (SamePosCheck(sx1,sy1, sx2,sy2)) then exit ;    // @̎n_EI__
   if (SamePosCheck(h1x1,h1y1, h1x2,h1y2)) then
      f2 := 0 ;                                       // ⏕P̎n_EI__
   if (SamePosCheck(h2x1,h2y1, h2x2,h2y2)) then
      f3 := 0 ;                                       // ⏕Q̎n_EI__
   // ⏕̂P`FbN
   if (f2 = 1) then begin
      a1 := dAngle((h1x1-h1x0),(h1y1-h1y0));
      a2 := dAngle((h1x2-h1x0),(h1y2-h1y0));
      a2 := SetAngle(a1-a2) ;
      if (Abs(a2) > LIMIT10) then begin
         // PłȂߏI_̕킹
         dRev(w1,w2, h1x2,h1y2, h1x0,h1y0, -a1);
         if (Abs(w1-h1x0) < LIMIT10) then
            f2 := 0
         else
            dRev(h1x2,h1y2, w1,h1y0, h1x0,h1y0, a1);
      end;
   end;
   if (f3 = 1) then begin
      a1 := dAngle((h2x1-h2x0),(h2y1-h2y0));
      a2 := dAngle((h2x2-h2x0),(h2y2-h2y0));
      a2 := SetAngle(a1-a2) ;
      if (Abs(a2) > LIMIT10) then begin
         // PłȂߏI_̕킹
         dRev(w1,w2, h2x2,h2y2, h2x0,h2y0, -a1);
         if (Abs(w1-h2x0) < LIMIT10) then
            f3 := 0
         else
            dRev(h2x2,h2y2, w1,h2y0, h2x0,h2y0, a1);
      end;
   end;
   //
   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,101,dDLnN)) then begin
         try
            Inc(dDLnN);
            if ((dDLnN mod 100) = 1) then SetLength(dDLn, dDLnN+99);   // 100m
            with dDLn[dDLnN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               sun_x1      := sx1 ;
               sun_y1      := sy1 ;
               sun_x2      := sx2 ;
               sun_y2      := sy2 ;
               flg2        := f2 ;
               ho1_x0      := h1x0 ;
               ho1_y0      := h1y0 ;
               ho1_x1      := h1x1 ;
               ho1_y1      := h1y1 ;
               ho1_x2      := h1x2 ;
               ho1_y2      := h1y2 ;
               flg3        := f3 ;
               ho2_x0      := h2x0 ;
               ho2_y0      := h2y0 ;
               ho2_x1      := h2x1 ;
               ho2_y1      := h2y1 ;
               ho2_x2      := h2x2 ;
               ho2_y2      := h2y2 ;
               arr1_code1  := ar11 ;
               arr1_code2  := ar12 ;
               arr1_x      := ar1x ;
               arr1_y      := ar1y ;
               arr1_r      := ar1r ;
               arr2_code1  := ar21 ;
               arr2_code2  := ar22 ;
               arr2_x      := ar2x ;
               arr2_y      := ar2y ;
               arr2_r      := ar2r ;
               flg4        := f4 ;
               Font        := fnt ;
               str         := st ;
               text_x      := tx ;
               text_y      := ty ;
               Height      := th ;
               Width       := tw ;
               Spc         := ts ;
               Angle       := an ;
               Slant       := sl ;
               b_pnt       := bp ;
               Direct      := dir ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            if (f4 = 0) then
               AddLayerCnt(lay,col,ltp,wid,-1)
            else
               AddLayerCnt(lay,col,ltp,wid,fnt);
         except
            Dec(dDLnN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,101,mDLnN)) then begin
               try
                  Inc(mDLnN);
                  if ((mDLnN mod 100) = 1) then SetLength(mDLn, mDLnN+99);   // 100m
                  with mDLn[mDLnN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sun_x1      := sx1 ;
                     sun_y1      := sy1 ;
                     sun_x2      := sx2 ;
                     sun_y2      := sy2 ;
                     flg2        := f2 ;
                     ho1_x0      := h1x0 ;
                     ho1_y0      := h1y0 ;
                     ho1_x1      := h1x1 ;
                     ho1_y1      := h1y1 ;
                     ho1_x2      := h1x2 ;
                     ho1_y2      := h1y2 ;
                     flg3        := f3 ;
                     ho2_x0      := h2x0 ;
                     ho2_y0      := h2y0 ;
                     ho2_x1      := h2x1 ;
                     ho2_y1      := h2y1 ;
                     ho2_x2      := h2x2 ;
                     ho2_y2      := h2y2 ;
                     arr1_code1  := ar11 ;
                     arr1_code2  := ar12 ;
                     arr1_x      := ar1x ;
                     arr1_y      := ar1y ;
                     arr1_r      := ar1r ;
                     arr2_code1  := ar21 ;
                     arr2_code2  := ar22 ;
                     arr2_x      := ar2x ;
                     arr2_y      := ar2y ;
                     arr2_r      := ar2r ;
                     flg4        := f4 ;
                     Font        := fnt ;
                     str         := st ;
                     text_x      := tx ;
                     text_y      := ty ;
                     Height      := th ;
                     Width       := tw ;
                     Spc         := ts ;
                     Angle       := an ;
                     Slant       := sl ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  if (f4 = 0) then
                     AddLayerFCnt(lay,col,ltp,wid,-1)
                  else
                     AddLayerFCnt(lay,col,ltp,wid,fnt);
               except
                  Dec(mDLnN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,101,mDLnN)) then begin
               try
                  Inc(mDLnN);
                  if ((mDLnN mod 100) = 1) then SetLength(mDLn, mDLnN+99);   // 100m
                  with mDLn[mDLnN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sun_x1      := sx1 ;
                     sun_y1      := sy1 ;
                     sun_x2      := sx2 ;
                     sun_y2      := sy2 ;
                     flg2        := f2 ;
                     ho1_x0      := h1x0 ;
                     ho1_y0      := h1y0 ;
                     ho1_x1      := h1x1 ;
                     ho1_y1      := h1y1 ;
                     ho1_x2      := h1x2 ;
                     ho1_y2      := h1y2 ;
                     flg3        := f3 ;
                     ho2_x0      := h2x0 ;
                     ho2_y0      := h2y0 ;
                     ho2_x1      := h2x1 ;
                     ho2_y1      := h2y1 ;
                     ho2_x2      := h2x2 ;
                     ho2_y2      := h2y2 ;
                     arr1_code1  := ar11 ;
                     arr1_code2  := ar12 ;
                     arr1_x      := ar1x ;
                     arr1_y      := ar1y ;
                     arr1_r      := ar1r ;
                     arr2_code1  := ar21 ;
                     arr2_code2  := ar22 ;
                     arr2_x      := ar2x ;
                     arr2_y      := ar2y ;
                     arr2_r      := ar2r ;
                     flg4        := f4 ;
                     Font        := fnt ;
                     str         := st ;
                     text_x      := tx ;
                     text_y      := ty ;
                     Height      := th ;
                     Width       := tw ;
                     Spc         := ts ;
                     Angle       := an ;
                     Slant       := sl ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mDLnN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// ʒ@@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`^V{  null:p֒ǉ
// (ret) True:o^OK@False:NG
function TDataClass.AddDataDimArc(s,st:string;lay,col,ltp,wid,sp,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx,sy,sr,sa0,sa1, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
var
   m,dn : integer ;
   a1,a2,w1,w2 : double ;
begin
   Result := False;
   if (st = '') then
      f4 := 0
   else
      if not(StrCheck(st)) then exit;        // 񐔃`FbN
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp  < 3) or (sp  >  3600)   then sp  := 72;
   if (f2 <> 0) then f2 := 1;
   if (f3 <> 0) then f3 := 1;
   if (f4 <> 0) then f4 := 1;
   if (ar11 < 1)or(ar11 > 11) then ar11 := 9;
   if (ar21 < 1)or(ar21 > 11) then ar21 := 9;
   if (ar12 < 0)or(ar12 > 2)  then ar12 := 2;
   if (ar22 < 0)or(ar22 > 2)  then ar22 := 2;
   if (ar1r < LIMIT8) then ar1r := 1.0;
   if (ar2r < LIMIT8) then ar2r := 1.0;
   if (sr < LIMIT8) then exit ;     // @a <= 0
   sa0 := SetAngle(sa0);
   sa1 := SetAngle(sa1);
   if (f4 = 1)and( (th < LIMIT10)or(tw < LIMIT10) ) then exit ;   // ͈͂ <= 0
   if (fnt < 0) or (fnt > zFntN) then fnt := 0 ;
   if (bp  < 1) or (bp  >     9) then bp  := 2 ;   // 
   if (dir <> 1) then dir := 2 ;
   if (ts < 0.0) then ts := 0.0;
   an := SetAngle(an);
   if (sl < -85.0) or (sl > 85.0) then sl := 0.0;
   // W`FbN
   if (SamePosCheck(h1x1,h1y1, h1x2,h1y2)) then
      f2 := 0 ;                                       // ⏕P̎n_EI__
   if (SamePosCheck(h2x1,h2y1, h2x2,h2y2)) then
      f3 := 0 ;                                       // ⏕Q̎n_EI__
   // ⏕̂P`FbN
   if (f2 = 1) then begin
      a1 := dAngle((h1x1-h1x0),(h1y1-h1y0));
      a2 := dAngle((h1x2-h1x0),(h1y2-h1y0));
      a2 := SetAngle(a1-a2) ;
      if (Abs(a2) > LIMIT10) then begin
         // PłȂߏI_̕킹
         dRev(w1,w2, h1x2,h1y2, h1x0,h1y0, -a1);
         if (Abs(w1-h1x0) < LIMIT10) then
            f2 := 0
         else
            dRev(h1x2,h1y2, w1,h1y0, h1x0,h1y0, a1);
      end;
   end;
   if (f3 = 1) then begin
      a1 := dAngle((h2x1-h2x0),(h2y1-h2y0));
      a2 := dAngle((h2x2-h2x0),(h2y2-h2y0));
      a2 := SetAngle(a1-a2) ;
      if (Abs(a2) > LIMIT10) then begin
         // PłȂߏI_̕킹
         dRev(w1,w2, h2x2,h2y2, h2x0,h2y0, -a1);
         if (Abs(w1-h2x0) < LIMIT10) then
            f3 := 0
         else
            dRev(h2x2,h2y2, w1,h2y0, h2x0,h2y0, a1);
      end;
   end;
   //
   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,102,dDArN)) then begin
         try
            Inc(dDArN);
            if ((dDArN mod 100) = 1) then SetLength(dDAr, dDArN+99);   // 100m
            with dDAr[dDArN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               sep         := sp ;
               sun_x       := sx ;
               sun_y       := sy ;
               sun_radius  := sr ;
               sun_angle0  := sa0 ;
               sun_angle1  := sa1 ;
               flg2        := f2 ;
               ho1_x0      := h1x0 ;
               ho1_y0      := h1y0 ;
               ho1_x1      := h1x1 ;
               ho1_y1      := h1y1 ;
               ho1_x2      := h1x2 ;
               ho1_y2      := h1y2 ;
               flg3        := f3 ;
               ho2_x0      := h2x0 ;
               ho2_y0      := h2y0 ;
               ho2_x1      := h2x1 ;
               ho2_y1      := h2y1 ;
               ho2_x2      := h2x2 ;
               ho2_y2      := h2y2 ;
               arr1_code1  := ar11 ;
               arr1_code2  := ar12 ;
               arr1_x      := ar1x ;
               arr1_y      := ar1y ;
               arr1_r      := ar1r ;
               arr2_code1  := ar21 ;
               arr2_code2  := ar22 ;
               arr2_x      := ar2x ;
               arr2_y      := ar2y ;
               arr2_r      := ar2r ;
               flg4        := f4 ;
               Font        := fnt ;
               str         := st ;
               text_x      := tx ;
               text_y      := ty ;
               Height      := th ;
               Width       := tw ;
               Spc         := ts ;
               Angle       := an ;
               Slant       := sl ;
               b_pnt       := bp ;
               Direct      := dir ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            if (f4 = 0) then
               AddLayerCnt(lay,col,ltp,wid,-1)
            else
               AddLayerCnt(lay,col,ltp,wid,fnt);
         except
            Dec(dDArN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,102,mDArN)) then begin
               try
                  Inc(mDArN);
                  if ((mDArN mod 100) = 1) then SetLength(mDAr, mDArN+99);   // 100m
                  with mDAr[mDArN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sep         := sp ;
                     sun_x       := sx ;
                     sun_y       := sy ;
                     sun_radius  := sr ;
                     sun_angle0  := sa0 ;
                     sun_angle1  := sa1 ;
                     flg2        := f2 ;
                     ho1_x0      := h1x0 ;
                     ho1_y0      := h1y0 ;
                     ho1_x1      := h1x1 ;
                     ho1_y1      := h1y1 ;
                     ho1_x2      := h1x2 ;
                     ho1_y2      := h1y2 ;
                     flg3        := f3 ;
                     ho2_x0      := h2x0 ;
                     ho2_y0      := h2y0 ;
                     ho2_x1      := h2x1 ;
                     ho2_y1      := h2y1 ;
                     ho2_x2      := h2x2 ;
                     ho2_y2      := h2y2 ;
                     arr1_code1  := ar11 ;
                     arr1_code2  := ar12 ;
                     arr1_x      := ar1x ;
                     arr1_y      := ar1y ;
                     arr1_r      := ar1r ;
                     arr2_code1  := ar21 ;
                     arr2_code2  := ar22 ;
                     arr2_x      := ar2x ;
                     arr2_y      := ar2y ;
                     arr2_r      := ar2r ;
                     flg4        := f4 ;
                     Font        := fnt ;
                     str         := st ;
                     text_x      := tx ;
                     text_y      := ty ;
                     Height      := th ;
                     Width       := tw ;
                     Spc         := ts ;
                     Angle       := an ;
                     Slant       := sl ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  if (f4 = 0) then
                     AddLayerFCnt(lay,col,ltp,wid,-1)
                  else
                     AddLayerFCnt(lay,col,ltp,wid,fnt);
               except
                  Dec(mDArN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,102,mDArN)) then begin
               try
                  Inc(mDArN);
                  if ((mDArN mod 100) = 1) then SetLength(mDAr, mDArN+99);   // 100m
                  with mDAr[mDArN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sep         := sp ;
                     sun_x       := sx ;
                     sun_y       := sy ;
                     sun_radius  := sr ;
                     sun_angle0  := sa0 ;
                     sun_angle1  := sa1 ;
                     flg2        := f2 ;
                     ho1_x0      := h1x0 ;
                     ho1_y0      := h1y0 ;
                     ho1_x1      := h1x1 ;
                     ho1_y1      := h1y1 ;
                     ho1_x2      := h1x2 ;
                     ho1_y2      := h1y2 ;
                     flg3        := f3 ;
                     ho2_x0      := h2x0 ;
                     ho2_y0      := h2y0 ;
                     ho2_x1      := h2x1 ;
                     ho2_y1      := h2y1 ;
                     ho2_x2      := h2x2 ;
                     ho2_y2      := h2y2 ;
                     arr1_code1  := ar11 ;
                     arr1_code2  := ar12 ;
                     arr1_x      := ar1x ;
                     arr1_y      := ar1y ;
                     arr1_r      := ar1r ;
                     arr2_code1  := ar21 ;
                     arr2_code2  := ar22 ;
                     arr2_x      := ar2x ;
                     arr2_y      := ar2y ;
                     arr2_r      := ar2r ;
                     flg4        := f4 ;
                     Font        := fnt ;
                     str         := st ;
                     text_x      := tx ;
                     text_y      := ty ;
                     Height      := th ;
                     Width       := tw ;
                     Spc         := ts ;
                     Angle       := an ;
                     Slant       := sl ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mDArN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// px@@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`^V{  null:p֒ǉ
// (ret) True:o^OK@False:NG
function TDataClass.AddDataDimAngle(s,st:string;lay,col,ltp,wid,sp,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx,sy,sr,sa0,sa1, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
var
   m,dn : integer ;
   a1,a2,w1,w2 : double ;
begin
   Result := False;
   if (st = '') then
      f4 := 0
   else
      if not(StrCheck(st)) then exit;        // 񐔃`FbN
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp  < 3) or (sp  >  3600)   then sp  := 72;
   if (f2 <> 0) then f2 := 1;
   if (f3 <> 0) then f3 := 1;
   if (f4 <> 0) then f4 := 1;
   if (ar11 < 1)or(ar11 > 11) then ar11 := 9;
   if (ar21 < 1)or(ar21 > 11) then ar21 := 9;
   if (ar12 < 0)or(ar12 > 2)  then ar12 := 2;
   if (ar22 < 0)or(ar22 > 2)  then ar22 := 2;
   if (ar1r < LIMIT8) then ar1r := 1.0;
   if (ar2r < LIMIT8) then ar2r := 1.0;
   if (sr < LIMIT8) then exit ;     // @a <= 0
   sa0 := SetAngle(sa0);
   sa1 := SetAngle(sa1);
   a1  := Abs(sa0-sa1);
   if (a1 < LIMIT10)or(Abs(a1-360.0) < LIMIT10) then exit ;       // npIp
   if (f4 = 1)and( (th < LIMIT10)or(tw < LIMIT10) ) then exit ;   // ͈͂ <= 0
   if (fnt < 0) or (fnt > zFntN) then fnt := 0 ;
   if (bp  < 1) or (bp  >     9) then bp  := 2 ;   // 
   if (dir <> 1) then dir := 2 ;
   if (ts < 0.0) then ts := 0.0;
   an := SetAngle(an);
   if (sl < -85.0) or (sl > 85.0) then sl := 0.0;
   // W`FbN
   if (SamePosCheck(h1x1,h1y1, h1x2,h1y2)) then
      f2 := 0 ;                                       // ⏕P̎n_EI__
   if (SamePosCheck(h2x1,h2y1, h2x2,h2y2)) then
      f3 := 0 ;                                       // ⏕Q̎n_EI__
   // ⏕̂P`FbN
   if (f2 = 1) then begin
      a1 := dAngle((h1x1-h1x0),(h1y1-h1y0));
      a2 := dAngle((h1x2-h1x0),(h1y2-h1y0));
      a2 := SetAngle(a1-a2) ;
      if (Abs(a2) > LIMIT10) then begin
         // PłȂߏI_̕킹
         dRev(w1,w2, h1x2,h1y2, h1x0,h1y0, -a1);
         if (Abs(w1-h1x0) < LIMIT10) then
            f2 := 0
         else
            dRev(h1x2,h1y2, w1,h1y0, h1x0,h1y0, a1);
      end;
   end;
   if (f3 = 1) then begin
      a1 := dAngle((h2x1-h2x0),(h2y1-h2y0));
      a2 := dAngle((h2x2-h2x0),(h2y2-h2y0));
      a2 := SetAngle(a1-a2) ;
      if (Abs(a2) > LIMIT10) then begin
         // PłȂߏI_̕킹
         dRev(w1,w2, h2x2,h2y2, h2x0,h2y0, -a1);
         if (Abs(w1-h2x0) < LIMIT10) then
            f3 := 0
         else
            dRev(h2x2,h2y2, w1,h2y0, h2x0,h2y0, a1);
      end;
   end;
   //
   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,103,dDAnN)) then begin
         try
            Inc(dDAnN);
            if ((dDAnN mod 100) = 1) then SetLength(dDAn, dDAnN+99);   // 100m
            with dDAn[dDAnN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               sep         := sp ;
               sun_x       := sx ;
               sun_y       := sy ;
               sun_radius  := sr ;
               sun_angle0  := sa0 ;
               sun_angle1  := sa1 ;
               flg2        := f2 ;
               ho1_x0      := h1x0 ;
               ho1_y0      := h1y0 ;
               ho1_x1      := h1x1 ;
               ho1_y1      := h1y1 ;
               ho1_x2      := h1x2 ;
               ho1_y2      := h1y2 ;
               flg3        := f3 ;
               ho2_x0      := h2x0 ;
               ho2_y0      := h2y0 ;
               ho2_x1      := h2x1 ;
               ho2_y1      := h2y1 ;
               ho2_x2      := h2x2 ;
               ho2_y2      := h2y2 ;
               arr1_code1  := ar11 ;
               arr1_code2  := ar12 ;
               arr1_x      := ar1x ;
               arr1_y      := ar1y ;
               arr1_r      := ar1r ;
               arr2_code1  := ar21 ;
               arr2_code2  := ar22 ;
               arr2_x      := ar2x ;
               arr2_y      := ar2y ;
               arr2_r      := ar2r ;
               flg4        := f4 ;
               Font        := fnt ;
               str         := st ;
               text_x      := tx ;
               text_y      := ty ;
               Height      := th ;
               Width       := tw ;
               Spc         := ts ;
               Angle       := an ;
               Slant       := sl ;
               b_pnt       := bp ;
               Direct      := dir ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            if (f4 = 0) then
               AddLayerCnt(lay,col,ltp,wid,-1)
            else
               AddLayerCnt(lay,col,ltp,wid,fnt);
         except
            Dec(dDAnN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,103,mDAnN)) then begin
               try
                  Inc(mDAnN);
                  if ((mDAnN mod 100) = 1) then SetLength(mDAn, mDAnN+99);   // 100m
                  with mDAn[mDAnN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sep         := sp ;
                     sun_x       := sx ;
                     sun_y       := sy ;
                     sun_radius  := sr ;
                     sun_angle0  := sa0 ;
                     sun_angle1  := sa1 ;
                     flg2        := f2 ;
                     ho1_x0      := h1x0 ;
                     ho1_y0      := h1y0 ;
                     ho1_x1      := h1x1 ;
                     ho1_y1      := h1y1 ;
                     ho1_x2      := h1x2 ;
                     ho1_y2      := h1y2 ;
                     flg3        := f3 ;
                     ho2_x0      := h2x0 ;
                     ho2_y0      := h2y0 ;
                     ho2_x1      := h2x1 ;
                     ho2_y1      := h2y1 ;
                     ho2_x2      := h2x2 ;
                     ho2_y2      := h2y2 ;
                     arr1_code1  := ar11 ;
                     arr1_code2  := ar12 ;
                     arr1_x      := ar1x ;
                     arr1_y      := ar1y ;
                     arr1_r      := ar1r ;
                     arr2_code1  := ar21 ;
                     arr2_code2  := ar22 ;
                     arr2_x      := ar2x ;
                     arr2_y      := ar2y ;
                     arr2_r      := ar2r ;
                     flg4        := f4 ;
                     Font        := fnt ;
                     str         := st ;
                     text_x      := tx ;
                     text_y      := ty ;
                     Height      := th ;
                     Width       := tw ;
                     Spc         := ts ;
                     Angle       := an ;
                     Slant       := sl ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  if (f4 = 0) then
                     AddLayerFCnt(lay,col,ltp,wid,-1)
                  else
                     AddLayerFCnt(lay,col,ltp,wid,fnt);
               except
                  Dec(mDAnN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,103,mDAnN)) then begin
               try
                  Inc(mDAnN);
                  if ((mDAnN mod 100) = 1) then SetLength(mDAn, mDAnN+99);   // 100m
                  with mDAn[mDAnN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sep         := sp ;
                     sun_x       := sx ;
                     sun_y       := sy ;
                     sun_radius  := sr ;
                     sun_angle0  := sa0 ;
                     sun_angle1  := sa1 ;
                     flg2        := f2 ;
                     ho1_x0      := h1x0 ;
                     ho1_y0      := h1y0 ;
                     ho1_x1      := h1x1 ;
                     ho1_y1      := h1y1 ;
                     ho1_x2      := h1x2 ;
                     ho1_y2      := h1y2 ;
                     flg3        := f3 ;
                     ho2_x0      := h2x0 ;
                     ho2_y0      := h2y0 ;
                     ho2_x1      := h2x1 ;
                     ho2_y1      := h2y1 ;
                     ho2_x2      := h2x2 ;
                     ho2_y2      := h2y2 ;
                     arr1_code1  := ar11 ;
                     arr1_code2  := ar12 ;
                     arr1_x      := ar1x ;
                     arr1_y      := ar1y ;
                     arr1_r      := ar1r ;
                     arr2_code1  := ar21 ;
                     arr2_code2  := ar22 ;
                     arr2_x      := ar2x ;
                     arr2_y      := ar2y ;
                     arr2_r      := ar2r ;
                     flg4        := f4 ;
                     Font        := fnt ;
                     str         := st ;
                     text_x      := tx ;
                     text_y      := ty ;
                     Height      := th ;
                     Width       := tw ;
                     Spc         := ts ;
                     Angle       := an ;
                     Slant       := sl ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mDAnN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// a@@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`^V{  null:p֒ǉ
// (ret) True:o^OK@False:NG
function TDataClass.AddDataDimRadius(s,st:string;lay,col,ltp,wid,fl,ar1,ar2,fnt,bp,dir:integer;sx1,sy1,sx2,sy2, arx,ary,arr, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
var
   m,dn : integer ;
begin
   Result := False;
   if (st = '') then
      fl := 0
   else
      if not(StrCheck(st)) then exit;        // 񐔃`FbN
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (fl <> 0) then fl := 1;
   if (ar1 < 1)or(ar1 > 11) then ar1 := 9;
   if (ar2 < 0)or(ar2 > 2)  then ar2 := 2;
   if (arr < LIMIT8) then arr := 1.0;
   if (fl = 1)and( (th < LIMIT10)or(tw < LIMIT10) ) then exit ;   // ͈͂ <= 0
   if (fnt < 0) or (fnt > zFntN) then fnt := 0 ;
   if (bp  < 1) or (bp  >     9) then bp  := 2 ;   // 
   if (dir <> 1) then dir := 2 ;
   if (ts < 0.0) then ts := 0.0;
   an := SetAngle(an);
   if (sl < -85.0) or (sl > 85.0) then sl := 0.0;
   // W`FbN
   if (SamePosCheck(sx1,sy1, sx2,sy2)) then exit ;    // @̎n_EI__
   //
   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,104,dDRaN)) then begin
         try
            Inc(dDRaN);
            if ((dDRaN mod 100) = 1) then SetLength(dDRa, dDRaN+99);   // 100m
            with dDRa[dDRaN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               sun_x1      := sx1 ;
               sun_y1      := sy1 ;
               sun_x2      := sx2 ;
               sun_y2      := sy2 ;
               arr_code1   := ar1 ;
               arr_code2   := ar2 ;
               arr_x       := arx ;
               arr_y       := ary ;
               arr_r       := arr ;
               flg         := fl ;
               Font        := fnt ;
               str         := st ;
               text_x      := tx ;
               text_y      := ty ;
               Height      := th ;
               Width       := tw ;
               Spc         := ts ;
               Angle       := an ;
               Slant       := sl ;
               b_pnt       := bp ;
               Direct      := dir ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            if (fl = 0) then
               AddLayerCnt(lay,col,ltp,wid,-1)
            else
               AddLayerCnt(lay,col,ltp,wid,fnt);
         except
            Dec(dDRaN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,104,mDRaN)) then begin
               try
                  Inc(mDRaN);
                  if ((mDRaN mod 100) = 1) then SetLength(mDRa, mDRaN+99);   // 100m
                  with mDRa[mDRaN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sun_x1      := sx1 ;
                     sun_y1      := sy1 ;
                     sun_x2      := sx2 ;
                     sun_y2      := sy2 ;
                     arr_code1   := ar1 ;
                     arr_code2   := ar2 ;
                     arr_x       := arx ;
                     arr_y       := ary ;
                     arr_r       := arr ;
                     flg         := fl ;
                     Font        := fnt ;
                     str         := st ;
                     text_x      := tx ;
                     text_y      := ty ;
                     Height      := th ;
                     Width       := tw ;
                     Spc         := ts ;
                     Angle       := an ;
                     Slant       := sl ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  if (fl = 0) then
                     AddLayerFCnt(lay,col,ltp,wid,-1)
                  else
                     AddLayerFCnt(lay,col,ltp,wid,fnt);
               except
                  Dec(mDRaN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,104,mDRaN)) then begin
               try
                  Inc(mDRaN);
                  if ((mDRaN mod 100) = 1) then SetLength(mDRa, mDRaN+99);   // 100m
                  with mDRa[mDRaN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sun_x1      := sx1 ;
                     sun_y1      := sy1 ;
                     sun_x2      := sx2 ;
                     sun_y2      := sy2 ;
                     arr_code1   := ar1 ;
                     arr_code2   := ar2 ;
                     arr_x       := arx ;
                     arr_y       := ary ;
                     arr_r       := arr ;
                     flg         := fl ;
                     Font        := fnt ;
                     str         := st ;
                     text_x      := tx ;
                     text_y      := ty ;
                     Height      := th ;
                     Width       := tw ;
                     Spc         := ts ;
                     Angle       := an ;
                     Slant       := sl ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mDRaN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// a@@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`^V{  null:p֒ǉ
// (ret) True:o^OK@False:NG
function TDataClass.AddDataDimDiameter(s,st:string;lay,col,ltp,wid,fl,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx1,sy1,sx2,sy2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
var
   m,dn : integer ;
begin
   Result := False;
   if (st = '') then
      fl := 0
   else
      if not(StrCheck(st)) then exit;        // 񐔃`FbN
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (fl <> 0) then fl := 1;
   if (ar11 < 1)or(ar11 > 11) then ar11 := 9;
   if (ar21 < 1)or(ar21 > 11) then ar21 := 9;
   if (ar12 < 0)or(ar12 > 2)  then ar12 := 2;
   if (ar22 < 0)or(ar22 > 2)  then ar22 := 2;
   if (ar1r < LIMIT8) then ar1r := 1.0;
   if (ar2r < LIMIT8) then ar2r := 1.0;
   if (fl = 1)and( (th < LIMIT10)or(tw < LIMIT10) ) then exit ;   // ͈͂ <= 0
   if (fnt < 0) or (fnt > zFntN) then fnt := 0 ;
   if (bp  < 1) or (bp  >     9) then bp  := 2 ;   // 
   if (dir <> 1) then dir := 2 ;
   if (ts < 0.0) then ts := 0.0;
   an := SetAngle(an);
   if (sl < -85.0) or (sl > 85.0) then sl := 0.0;
   // W`FbN
   if (SamePosCheck(sx1,sy1, sx2,sy2)) then exit ;    // @̎n_EI__
   //
   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,105,dDDiN)) then begin
         try
            Inc(dDDiN);
            if ((dDDiN mod 100) = 1) then SetLength(dDDi, dDDiN+99);   // 100m
            with dDDi[dDDiN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               sun_x1      := sx1 ;
               sun_y1      := sy1 ;
               sun_x2      := sx2 ;
               sun_y2      := sy2 ;
               arr1_code1  := ar11 ;
               arr1_code2  := ar12 ;
               arr1_x      := ar1x ;
               arr1_y      := ar1y ;
               arr1_r      := ar1r ;
               arr2_code1  := ar21 ;
               arr2_code2  := ar22 ;
               arr2_x      := ar2x ;
               arr2_y      := ar2y ;
               arr2_r      := ar2r ;
               flg         := fl ;
               Font        := fnt ;
               str         := st ;
               text_x      := tx ;
               text_y      := ty ;
               Height      := th ;
               Width       := tw ;
               Spc         := ts ;
               Angle       := an ;
               Slant       := sl ;
               b_pnt       := bp ;
               Direct      := dir ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            if (fl = 0) then
               AddLayerCnt(lay,col,ltp,wid,-1)
            else
               AddLayerCnt(lay,col,ltp,wid,fnt);
         except
            Dec(dDDiN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,105,mDDiN)) then begin
               try
                  Inc(mDDIN);
                  if ((mDDiN mod 100) = 1) then SetLength(mDDi, mDDiN+99);   // 100m
                  with mDDi[mDDiN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sun_x1      := sx1 ;
                     sun_y1      := sy1 ;
                     sun_x2      := sx2 ;
                     sun_y2      := sy2 ;
                     arr1_code1  := ar11 ;
                     arr1_code2  := ar12 ;
                     arr1_x      := ar1x ;
                     arr1_y      := ar1y ;
                     arr1_r      := ar1r ;
                     arr2_code1  := ar21 ;
                     arr2_code2  := ar22 ;
                     arr2_x      := ar2x ;
                     arr2_y      := ar2y ;
                     arr2_r      := ar2r ;
                     flg         := fl ;
                     Font        := fnt ;
                     str         := st ;
                     text_x      := tx ;
                     text_y      := ty ;
                     Height      := th ;
                     Width       := tw ;
                     Spc         := ts ;
                     Angle       := an ;
                     Slant       := sl ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  if (fl = 0) then
                     AddLayerFCnt(lay,col,ltp,wid,-1)
                  else
                     AddLayerFCnt(lay,col,ltp,wid,fnt);
               except
                  Dec(mDDiN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,105,mDDiN)) then begin
               try
                  Inc(mDDiN);
                  if ((mDDiN mod 100) = 1) then SetLength(mDDi, mDDiN+99);   // 100m
                  with mDDi[mDDiN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sun_x1      := sx1 ;
                     sun_y1      := sy1 ;
                     sun_x2      := sx2 ;
                     sun_y2      := sy2 ;
                     arr1_code1  := ar11 ;
                     arr1_code2  := ar12 ;
                     arr1_x      := ar1x ;
                     arr1_y      := ar1y ;
                     arr1_r      := ar1r ;
                     arr2_code1  := ar21 ;
                     arr2_code2  := ar22 ;
                     arr2_x      := ar2x ;
                     arr2_y      := ar2y ;
                     arr2_r      := ar2r ;
                     flg         := fl ;
                     Font        := fnt ;
                     str         := st ;
                     text_x      := tx ;
                     text_y      := ty ;
                     Height      := th ;
                     Width       := tw ;
                     Spc         := ts ;
                     Angle       := an ;
                     Slant       := sl ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mDDiN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// o@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`^V{  null:p֒ǉ
// (ret) True:o^OK@False:NG
function TDataClass.AddDataDimLeader(s,st:string;lay,col,ltp,wid,fl,num,ar,fnt,bp,dir:integer;vx,vy:array of double;arr, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
var
   m,i,dn : integer ;
begin
   Result := False;
   if (st = '') then
      fl := 0
   else
      if not(StrCheck(st)) then exit;        // 񐔃`FbN
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (fl <> 0) then fl := 1;
   if (num < 2) then exit ;
   if (ar < 1)or(ar > 11) then ar := 9;
   if (arr < LIMIT8) then arr := 1.0;
   if (fl = 1)and( (th < LIMIT10)or(tw < LIMIT10) ) then exit ;   // ͈͂ <= 0
   if (fnt < 0) or (fnt > zFntN) then fnt := 0 ;
   if (bp  < 1) or (bp  >     9) then bp  := 2 ;   // 
   if (dir <> 1) then dir := 2 ;
   if (ts < 0.0) then ts := 0.0;
   an := SetAngle(an);
   if (sl < -85.0) or (sl > 85.0) then sl := 0.0;
   // W`FbN
   try
      for i:=1 to num-1 do
         if (SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ; // _
   except
      exit ;   // IzG[
   end;
   //
   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,106,dDLeN)) then begin
         try
            Inc(dDLeN);
            if ((dDLeN mod 100) = 1) then SetLength(dDLe, dDLeN+99);   // 100m
            with dDLe[dDLeN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               vertex_number  := num ;
               try
                  SetLength(vertex_x, vertex_number);
                  SetLength(vertex_y, vertex_number);
               except
                  vertex_x := nil ;
                  vertex_y := nil ;
                  vertex_number := 0 ;
               end;
               for i:=0 to vertex_number-1 do begin
                  vertex_x[i] := vx[i];
                  vertex_y[i] := vy[i];
               end;
               arr_code    := ar ;
               arr_r       := arr ;
               flg         := fl ;
               Font        := fnt ;
               str         := st ;
               text_x      := tx ;
               text_y      := ty ;
               Height      := th ;
               Width       := tw ;
               Spc         := ts ;
               Angle       := an ;
               Slant       := sl ;
               b_pnt       := bp ;
               Direct      := dir ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            if (fl = 0) then
               AddLayerCnt(lay,col,ltp,wid,-1)
            else
               AddLayerCnt(lay,col,ltp,wid,fnt);
         except
            Dec(dDLeN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,106,mDLeN)) then begin
               try
                  Inc(mDLeN);
                  if ((mDLeN mod 100) = 1) then SetLength(mDLe, mDLeN+99);   // 100m
                  with mDLe[mDLeN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     vertex_number    := num ;
                     try
                        SetLength(vertex_x, vertex_number);
                        SetLength(vertex_y, vertex_number);
                     except
                        vertex_x := nil ;
                        vertex_y := nil ;
                        vertex_number := 0 ;
                     end;
                     for i:=0 to vertex_number-1 do begin
                        vertex_x[i] := vx[i];
                        vertex_y[i] := vy[i];
                     end;
                     arr_code    := ar ;
                     arr_r       := arr ;
                     flg         := fl ;
                     Font        := fnt ;
                     str         := st ;
                     text_x      := tx ;
                     text_y      := ty ;
                     Height      := th ;
                     Width       := tw ;
                     Spc         := ts ;
                     Angle       := an ;
                     Slant       := sl ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  if (fl = 0) then
                     AddLayerFCnt(lay,col,ltp,wid,-1)
                  else
                     AddLayerFCnt(lay,col,ltp,wid,fnt);
               except
                  Dec(mDLeN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,106,mDLeN)) then begin
               try
                  Inc(mDLeN);
                  if ((mDLeN mod 100) = 1) then SetLength(mDLe, mDLeN+99);   // 100m
                  with mDLe[mDLeN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     vertex_number    := num ;
                     try
                        SetLength(vertex_x, vertex_number);
                        SetLength(vertex_y, vertex_number);
                     except
                        vertex_x := nil ;
                        vertex_y := nil ;
                        vertex_number := 0 ;
                     end;
                     for i:=0 to vertex_number-1 do begin
                        vertex_x[i] := vx[i];
                        vertex_y[i] := vy[i];
                     end;
                     arr_code    := ar ;
                     arr_r       := arr ;
                     flg         := fl ;
                     Font        := fnt ;
                     str         := st ;
                     text_x      := tx ;
                     text_y      := ty ;
                     Height      := th ;
                     Width       := tw ;
                     Spc         := ts ;
                     Angle       := an ;
                     Slant       := sl ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mDLeN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// o[@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`^V{  null:p֒ǉ
// (ret) True:o^OK@False:NG
function TDataClass.AddDataDimBalloon(s,st:string;lay,col,ltp,wid,sp,fl,num,ar,fnt,bp,dir:integer;vx,vy:array of double;cx,cy,cr,arr, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
var
   m,i,dn : integer ;
   a1,a2,w1,w2 : double ;
begin
   Result := False;
   if (st = '') then
      fl := 0
   else
      if not(StrCheck(st)) then exit;        // 񐔃`FbN
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp  < 3) or (sp  >  3600)   then sp  := 72;
   if (fl <> 0) then fl := 1;
   if (num < 2) then exit ;
   if (cr < LIMIT8) then exit;
   if (ar < 1)or(ar > 11) then ar := 9;
   if (arr < LIMIT8) then arr := 1.0;
   if (fl = 1)and( (th < LIMIT10)or(tw < LIMIT10) ) then exit ;   // ͈͂ <= 0
   if (fnt < 0) or (fnt > zFntN) then fnt := 0 ;
   if (bp  < 1) or (bp  >     9) then bp  := 2 ;   // 
   if (dir <> 1) then dir := 2 ;
   if (ts < 0.0) then ts := 0.0;
   an := SetAngle(an);
   if (sl < -85.0) or (sl > 85.0) then sl := 0.0;
   // W`FbN
   try
      for i:=1 to num-1 do
         if (SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ; // _
   except
      exit ;   // IzG[
   end;
   // oƒS_̂P`FbN
   a1 := dAngle((cx       -vx[num-2]),(cy       -vy[num-2]));
   a2 := dAngle((vx[num-1]-vx[num-2]),(vy[num-1]-vy[num-2]));
   a2 := SetAngle(a1-a2) ;
   if (Abs(a2) > LIMIT10) then begin
      // PłȂ߈oŏI_̕킹
      dRev(w1,w2, vx[num-1],vy[num-1], vx[num-2],vy[num-2], -a1);
      if (Abs(w1-vx[num-2]) < LIMIT10) then
         exit  // sl
      else
         dRev(vx[num-1],vy[num-1], w1,vy[num-2], vx[num-2],vy[num-2], a1);
   end;
   // o[~aƈoڑĂ邩ǂ̃`FbN͍sȂ
   // o[@o[~aɂ邩ǂ̃`FbN͍sȂ
   //
   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,107,dDBaN)) then begin
         try
            Inc(dDBaN);
            if ((dDBaN mod 100) = 1) then SetLength(dDBa, dDBaN+99);   // 100m
            with dDBa[dDBaN-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Ltype       := ltp ;
               line_width  := wid ;
               sep         := sp ;
               vertex_number  := num ;
               try
                  SetLength(vertex_x, vertex_number);
                  SetLength(vertex_y, vertex_number);
               except
                  vertex_x := nil ;
                  vertex_y := nil ;
                  vertex_number := 0 ;
               end;
               for i:=0 to vertex_number-1 do begin
                  vertex_x[i] := vx[i];
                  vertex_y[i] := vy[i];
               end;
               center_x    := cx ;
               center_y    := cy ;
               Radius      := cr ;
               arr_code    := ar ;
               arr_r       := arr ;
               flg         := fl ;
               Font        := fnt ;
               str         := st ;
               text_x      := tx ;
               text_y      := ty ;
               Height      := th ;
               Width       := tw ;
               Spc         := ts ;
               Angle       := an ;
               Slant       := sl ;
               b_pnt       := bp ;
               Direct      := dir ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            if (fl = 0) then
               AddLayerCnt(lay,col,ltp,wid,-1)
            else
               AddLayerCnt(lay,col,ltp,wid,fnt);
         except
            Dec(dDBaN);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,107,mDBaN)) then begin
               try
                  Inc(mDBaN);
                  if ((mDBaN mod 100) = 1) then SetLength(mDBa, mDBaN+99);   // 100m
                  with mDBa[mDBaN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sep         := sp ;
                     vertex_number    := num ;
                     try
                        SetLength(vertex_x, vertex_number);
                        SetLength(vertex_y, vertex_number);
                     except
                        vertex_x := nil ;
                        vertex_y := nil ;
                        vertex_number := 0 ;
                     end;
                     for i:=0 to vertex_number-1 do begin
                        vertex_x[i] := vx[i];
                        vertex_y[i] := vy[i];
                     end;
                     center_x    := cx ;
                     center_y    := cy ;
                     Radius      := cr ;
                     arr_code    := ar ;
                     arr_r       := arr ;
                     flg         := fl ;
                     Font        := fnt ;
                     str         := st ;
                     text_x      := tx ;
                     text_y      := ty ;
                     Height      := th ;
                     Width       := tw ;
                     Spc         := ts ;
                     Angle       := an ;
                     Slant       := sl ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  if (fl = 0) then
                     AddLayerFCnt(lay,col,ltp,wid,-1)
                  else
                     AddLayerFCnt(lay,col,ltp,wid,fnt);
               except
                  Dec(mDBaN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,107,mDBaN)) then begin
               try
                  Inc(mDBaN);
                  if ((mDBaN mod 100) = 1) then SetLength(mDBa, mDBaN+99);   // 100m
                  with mDBa[mDBaN-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Ltype       := ltp ;
                     line_width  := wid ;
                     sep         := sp ;
                     vertex_number    := num ;
                     try
                        SetLength(vertex_x, vertex_number);
                        SetLength(vertex_y, vertex_number);
                     except
                        vertex_x := nil ;
                        vertex_y := nil ;
                        vertex_number := 0 ;
                     end;
                     for i:=0 to vertex_number-1 do begin
                        vertex_x[i] := vx[i];
                        vertex_y[i] := vy[i];
                     end;
                     center_x    := cx ;
                     center_y    := cy ;
                     Radius      := cr ;
                     arr_code    := ar ;
                     arr_r       := arr ;
                     flg         := fl ;
                     Font        := fnt ;
                     str         := st ;
                     text_x      := tx ;
                     text_y      := ty ;
                     Height      := th ;
                     Width       := tw ;
                     Spc         := ts ;
                     Angle       := an ;
                     Slant       := sl ;
                     b_pnt       := bp ;
                     Direct      := dir ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mDBaN);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
end;

// nb`OiTujȐ`FbNnb`Ö`FbN}`Zbg
function TDataClass.CheckHatchSub_CCrv_HAr(oid,num:integer;iid:array of integer) : Boolean ;
var
   m,i : integer ;
begin
   Result := False ;

   m := CCrvIDCheck(oid);        // IDԍLǂ`FbN
   if (m = -1) then exit ;       // IDԍ
   for i:=0 to num-1 do begin
      m := CCrvIDCheck(iid[i]);  // IDԍLǂ`FbN
      if (m = -1) then exit ;    // IDԍ
   end;
   // Ȑ`f[^̐ڑ`FbN
   if not(CCrvDataCheck(oid)) then exit ;          // ڑG[
   for i:=0 to num-1 do begin
      if not(CCrvDataCheck(iid[i])) then exit ;    // ڑG[
   end;
   // nb`Ö}`̃Zbg
   zHArN := 1 + num ;
   SetLength(zHAr,zHArN);
   CCrvDataToHAr(oid,1);         // Ȑ` oid  Os
   m := 2 ;
   for i:=0 to num-1 do begin
      CCrvDataToHAr(iid[i],m);   // Ȑ` iid  
      Inc(m);
   end;
   for i:=1 to zHArN do begin
      if not(HArDataSelfIntersectCheck(i)) then begin
         // ȌG[
         DataClearHAr ;
         exit ;
      end;
   end;
   if not(HArDataOverlapCheck1) then begin
      // O`ƒdȂ/ڂĂ܂
      DataClearHAr ;
      exit ;
   end;
   if not(HArDataOverlapCheck2) then begin
      // ƒdȂĂ܂
      DataClearHAr ;
      exit ;
   end;
   Result := True ;
end;

// nb`O(`)@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`^V{  null:p֒ǉ
// (ret) True:o^OK@False:NG
function TDataClass.AddDataHatch1(s,st:string;lay,col,oid,num:integer;iid:array of integer) : Boolean ;
var
   m,i,dn : integer ;
begin
   Result := False;
   if not(StrCheck(st)) then exit;  // 񐔃`FbN
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (num < 0) then num := 0;
   // Ȑ`f[^̐ڑ`FbNEnb`Ö}`̃ZbgE`FbN
   if not(CheckHatchSub_CCrv_HAr(oid,num,iid)) then exit;
   //
   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,108,dHa1N)) then begin
         try
            Inc(dHa1N);
            if ((dHa1N mod 100) = 1) then SetLength(dHa1, dHa1N+99);   // 100m
            with dHa1[dHa1N-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               name        := st ;
               out_id      := oid ;
               Number      := num ;
               try
                  SetLength(in_id, Number);
               except
                  in_id    := nil ;
                  Number   := 0 ;
               end;
               for i:=0 to Number-1 do
                  in_id[i] := iid[i];
               //
               MakeHatch1(st);   // nb`O
               try
                  hln   := zHLnN ;
                  SetLength(hl, hln);
               except
                  hln   := 0;
                  hl    := nil;
               end;
               for i:=0 to hln-1 do begin
                  hl[i] := zHLn[i] ;
                  if (hl[i].Color = -1) then
                     hl[i].Color := col ;
               end;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,-1,-1,-1,-1);
         except
            Dec(dHa1N);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,108,mHa1N)) then begin
               try
                  Inc(mHa1N);
                  if ((mHa1N mod 100) = 1) then SetLength(mHa1, mHa1N+99);   // 100m
                  with mHa1[mHa1N-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     name        := st ;
                     out_id      := oid ;
                     Number      := num ;
                     try
                        SetLength(in_id, Number);
                     except
                        in_id    := nil ;
                        Number   := 0 ;
                     end;
                     for i:=0 to Number-1 do
                        in_id[i] := iid[i];
                     //
                     MakeHatch1(st);   // nb`O
                     try
                        hln   := zHLnN ;
                        SetLength(hl, hln);
                     except
                        hln   := 0;
                        hl    := nil;
                     end;
                     for i:=0 to hln-1 do begin
                        hl[i] := zHLn[i] ;
                        if (hl[i].Color = -1) then
                           hl[i].Color := col ;
                     end;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,-1,-1,-1,-1)
               except
                  Dec(mHa1N);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,108,mHa1N)) then begin
               try
                  Inc(mHa1N);
                  if ((mHa1N mod 100) = 1) then SetLength(mHa1, mHa1N+99);   // 100m
                  with mHa1[mHa1N-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     name        := st ;
                     out_id      := oid ;
                     Number      := num ;
                     try
                        SetLength(in_id, Number);
                     except
                        in_id    := nil ;
                        Number   := 0 ;
                     end;
                     for i:=0 to Number-1 do
                        in_id[i] := iid[i];
                     //
                     MakeHatch1(st);   // nb`O
                     try
                        hln   := zHLnN ;
                        SetLength(hl, hln);
                     except
                        hln   := 0;
                        hl    := nil;
                     end;
                     for i:=0 to hln-1 do begin
                        hl[i] := zHLn[i] ;
                        if (hl[i].Color = -1) then
                           hl[i].Color := col ;
                     end;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mHa1N);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
   //
   DataClearHLn ;
   DataClearHAr ;
   if (Result) then begin
      // Ȑ`̎QƐJEg
      m := CCrvIDCheck(oid);
      cDef[m].cnt := cDef[m].cnt + 1;
      for i:=0 to num-1 do begin
         m := CCrvIDCheck(iid[i]);
         cDef[m].cnt := cDef[m].cnt + 1;
      end;
   end;
end;

// nb`O(h)@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`^V{  null:p֒ǉ
// (ret) True:o^OK@False:NG
function TDataClass.AddDataHatch2(s:string;lay,col,oid,num:integer;iid:array of integer) : Boolean ;
var
   m,i,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (num < 0) then num := 0;
   // Ȑ`f[^̐ڑ`FbNEnb`Ö}`̃ZbgE`FbN
   if not(CheckHatchSub_CCrv_HAr(oid,num,iid)) then exit;
   //
   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,109,dHa2N)) then begin
         try
            Inc(dHa2N);
            if ((dHa2N mod 100) = 1) then SetLength(dHa2, dHa2N+99);   // 100m
            with dHa2[dHa2N-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               out_id      := oid ;
               Number      := num ;
               try
                  SetLength(in_id, Number);
               except
                  in_id    := nil ;
                  Number   := 0 ;
               end;
               for i:=0 to Number-1 do
                  in_id[i] := iid[i];
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,-1,-1,-1,-1);
         except
            Dec(dHa2N);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,109,mHa2N)) then begin
               try
                  Inc(mHa2N);
                  if ((mHa2N mod 100) = 1) then SetLength(mHa2, mHa2N+99);   // 100m
                  with mHa2[mHa2N-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     out_id      := oid ;
                     Number      := num ;
                     try
                        SetLength(in_id, Number);
                     except
                        in_id    := nil ;
                        Number   := 0 ;
                     end;
                     for i:=0 to Number-1 do
                        in_id[i] := iid[i];
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,-1,-1,-1,-1)
               except
                  Dec(mHa2N);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,109,mHa2N)) then begin
               try
                  Inc(mHa2N);
                  if ((mHa2N mod 100) = 1) then SetLength(mHa2, mHa2N+99);   // 100m
                  with mHa2[mHa2N-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     out_id      := oid ;
                     Number      := num ;
                     try
                        SetLength(in_id, Number);
                     except
                        in_id    := nil ;
                        Number   := 0 ;
                     end;
                     for i:=0 to Number-1 do
                        in_id[i] := iid[i];
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mHa2N);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
   //
   DataClearHAr ;
   if (Result) then begin
      // Ȑ`̎QƐJEg
      m := CCrvIDCheck(oid);
      cDef[m].cnt := cDef[m].cnt + 1;
      for i:=0 to num-1 do begin
         m := CCrvIDCheck(iid[i]);
         cDef[m].cnt := cDef[m].cnt + 1;
      end;
   end;
end;

// nb`O([U`)@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`^V{  null:p֒ǉ
// (ret) True:o^OK@False:NG
function TDataClass.AddDataHatch3(s:string;lay,hnum:integer;hcol,hltp,hwid:array of integer;hx,hy,hs,ha:array of double;oid,num:integer;iid:array of integer) : Boolean ;
var
   m,i,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (hnum< 1) then exit ;      // p^[̖wG[
   if (hnum> 4) then hnum := 4;
   for i:=0 to hnum-1 do begin
      if (hcol[i] < 0) or (hcol[i] > zColMax) then hcol[i] := 0 ;
      if (hltp[i] < 0) or (hltp[i] > zLtpMax) then hltp[i] := 0 ;
      if (hwid[i] < 0) or (hwid[i] > zWidMax) then hwid[i] := 0 ;
      if (hs[i] <= LIMIT8) then hs[i] := 1.0 ;
      ha[i] := SetAngle(ha[i]);
   end;
   if (num < 0) then num := 0;
   // Ȑ`f[^̐ڑ`FbNEnb`Ö}`̃ZbgE`FbN
   if not(CheckHatchSub_CCrv_HAr(oid,num,iid)) then exit;
   //
   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,110,dHa3N)) then begin
         try
            Inc(dHa3N);
            if ((dHa3N mod 100) = 1) then SetLength(dHa3, dHa3N+99);   // 100m
            with dHa3[dHa3N-1] do begin
               exf            := True ;
               Layer          := lay ;
               hatch1_number  := hnum ;
               for i:=0 to 3 do begin
                  hatch1_color[i]      := 0 ;
                  hatch_type[i]        := 0 ;
                  hatch_line_width[i]  := 0 ;
                  hatch_start_x[i]     := 0.0 ;
                  hatch_start_y[i]     := 0.0 ;
                  hatch_spacing[i]     := 0.0 ;
                  hatch_angle[i]       := 0.0 ;
               end;
               for i:=0 to hnum-1 do begin
                  hatch1_color[i]      := hcol[i] ;
                  hatch_type[i]        := hltp[i] ;
                  hatch_line_width[i]  := hwid[i] ;
                  hatch_start_x[i]     := hx[i] ;
                  hatch_start_y[i]     := hy[i] ;
                  hatch_spacing[i]     := hs[i] ;
                  hatch_angle[i]       := ha[i] ;
               end;
               out_id   := oid ;
               Number   := num ;
               try
                  SetLength(in_id, Number);
               except
                  in_id := nil ;
                  Number:= 0 ;
               end;
               for i:=0 to Number-1 do
                  in_id[i] := iid[i];
               //
               MakeHatch3(hnum,hcol,hltp,hwid,hx,hy,hs,ha) ;   // nb`O
               try
                  hln   := zHLnN ;
                  SetLength(hl, hln);
               except
                  hln   := 0;
                  hl    := nil;
               end;
               for i:=0 to hln-1 do
                  hl[i] := zHLn[i] ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,-1,-1,-1,-1);
         except
            Dec(dHa3N);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,110,mHa3N)) then begin
               try
                  Inc(mHa3N);
                  if ((mHa3N mod 100) = 1) then SetLength(mHa3, mHa3N+99);   // 100m
                  with mHa3[mHa3N-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     hatch1_number  := hnum ;
                     for i:=0 to 3 do begin
                        hatch1_color[i]      := 0 ;
                        hatch_type[i]        := 0 ;
                        hatch_line_width[i]  := 0 ;
                        hatch_start_x[i]     := 0.0 ;
                        hatch_start_y[i]     := 0.0 ;
                        hatch_spacing[i]     := 0.0 ;
                        hatch_angle[i]       := 0.0 ;
                     end;
                     for i:=0 to hnum-1 do begin
                        hatch1_color[i]      := hcol[i] ;
                        hatch_type[i]        := hltp[i] ;
                        hatch_line_width[i]  := hwid[i] ;
                        hatch_start_x[i]     := hx[i] ;
                        hatch_start_y[i]     := hy[i] ;
                        hatch_spacing[i]     := hs[i] ;
                        hatch_angle[i]       := ha[i] ;
                     end;
                     out_id   := oid ;
                     Number   := num ;
                     try
                        SetLength(in_id, Number);
                     except
                        in_id := nil ;
                        Number:= 0 ;
                     end;
                     for i:=0 to Number-1 do
                        in_id[i] := iid[i];
                     //
                     MakeHatch3(hnum,hcol,hltp,hwid,hx,hy,hs,ha) ;   // nb`O
                     try
                        hln   := zHLnN ;
                        SetLength(hl, hln);
                     except
                        hln   := 0;
                        hl    := nil;
                     end;
                     for i:=0 to hln-1 do
                        hl[i] := zHLn[i] ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,-1,-1,-1,-1)
               except
                  Dec(mHa3N);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,110,mHa3N)) then begin
               try
                  Inc(mHa3N);
                  if ((mHa3N mod 100) = 1) then SetLength(mHa3, mHa3N+99);   // 100m
                  with mHa3[mHa3N-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     hatch1_number  := hnum ;
                     for i:=0 to 3 do begin
                        hatch1_color[i]      := 0 ;
                        hatch_type[i]        := 0 ;
                        hatch_line_width[i]  := 0 ;
                        hatch_start_x[i]     := 0.0 ;
                        hatch_start_y[i]     := 0.0 ;
                        hatch_spacing[i]     := 0.0 ;
                        hatch_angle[i]       := 0.0 ;
                     end;
                     for i:=0 to hnum-1 do begin
                        hatch1_color[i]      := hcol[i] ;
                        hatch_type[i]        := hltp[i] ;
                        hatch_line_width[i]  := hwid[i] ;
                        hatch_start_x[i]     := hx[i] ;
                        hatch_start_y[i]     := hy[i] ;
                        hatch_spacing[i]     := hs[i] ;
                        hatch_angle[i]       := ha[i] ;
                     end;
                     out_id   := oid ;
                     Number   := num ;
                     try
                        SetLength(in_id, Number);
                     except
                        in_id := nil ;
                        Number:= 0 ;
                     end;
                     for i:=0 to Number-1 do
                        in_id[i] := iid[i];
                     //
                     MakeHatch3(hnum,hcol,hltp,hwid,hx,hy,hs,ha) ;   // nb`O
                     try
                        hln   := zHLnN ;
                        SetLength(hl, hln);
                     except
                        hln   := 0;
                        hl    := nil;
                     end;
                     for i:=0 to hln-1 do
                        hl[i] := zHLn[i] ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mHa3N);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
   //
   DataClearHLn ;
   DataClearHAr ;
   if (Result) then begin
      // Ȑ`̎QƐJEg
      m := CCrvIDCheck(oid);
      cDef[m].cnt := cDef[m].cnt + 1;
      for i:=0 to num-1 do begin
         m := CCrvIDCheck(iid[i]);
         cDef[m].cnt := cDef[m].cnt + 1;
      end;
   end;
end;

// nb`O(p^[)@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`^V{  null:p֒ǉ
// (ret) True:o^OK@False:NG
function TDataClass.AddDataHatch4(s,st:string;lay,col:integer;px,py,pv1,pv1a,pv2,pv2a,psx,psy,pa:double; oid,num:integer; iid:array of integer) : Boolean ;
var
   m,mm,i,dn : integer ;
begin
   Result := False;
   if (st = '') then exit ;
   mm := FZukeiNameCheck(0,st);
   if (mm >= 0) then exit ;    // p^[V{}`w肵ĂȂ̂ŃG[
   m := FZukeiNameCheck(0,s);
   if (mm = m) then exit ;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (pv1 < 0.0) then begin
      pv1 := -pv1 ;
      pv1a := pv1a + 180.0 ;
   end;
   if (pv2 < 0.0) then begin
      pv2 := -pv2 ;
      pv2a := pv2a + 180.0 ;
   end;
   if (pv1 < LIMIT8)or(pv2 < LIMIT8) then exit ;
   if (psx < LIMIT8) then psx := 1.0 ;
   if (psy < LIMIT8) then psy := 1.0 ;
   pv1a := SetAngle(pv1a);
   pv2a := SetAngle(pv2a);
   pa   := SetAngle(pa);
   if (num < 0) then num := 0;
   // Ȑ`f[^̐ڑ`FbNEnb`Ö}`̃ZbgE`FbN
   if not(CheckHatchSub_CCrv_HAr(oid,num,iid)) then exit;
   //
   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,111,dHa4N)) then begin
         try
            Inc(dHa4N);
            if ((dHa4N mod 100) = 1) then SetLength(dHa4, dHa4N+99);   // 100m
            with dHa4[dHa4N-1] do begin
               exf            := True ;
               Layer          := lay ;
               name           := st ;
               hatch_color    := col ;
               hatch_pattern_x            := px ;
               hatch_pattern_y            := py ;
               hatch_pattern_vector1      := pv1 ;
               hatch_pattern_vector1_angle:= pv1a ;
               hatch_pattern_vector2      := pv2 ;
               hatch_pattern_vector2_angle:= pv2a ;
               hatch_pattern_scale_x      := psx ;
               hatch_pattern_scale_y      := psy ;
               hatch_pattern_angle        := pa ;
               out_id   := oid ;
               Number   := num ;
               try
                  SetLength(in_id, Number);
               except
                  in_id := nil ;
                  Number:= 0 ;
               end;
               for i:=0 to Number-1 do
                  in_id[i] := iid[i];
               //
               MakeHatch4(mm,col,px,py,pv1,pv1a,pv2,pv2a,psx,psy,pa) ;   // nb`O
               try
                  hln   := zHLnN ;
                  SetLength(hl, hln);
               except
                  hln   := 0;
                  hl    := nil;
               end;
               for i:=0 to hln-1 do
                  hl[i] := zHLn[i] ;
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,-1,-1,-1,-1);
         except
            Dec(dHa4N);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,111,mHa4N)) then begin
               try
                  Inc(mHa4N);
                  if ((mHa4N mod 100) = 1) then SetLength(mHa4, mHa4N+99);   // 100m
                  with mHa4[mHa4N-1] do begin
                     exf            := True ;
                     Layer          := lay ;
                     name           := st ;
                     hatch_color    := col ;
                     hatch_pattern_x            := px ;
                     hatch_pattern_y            := py ;
                     hatch_pattern_vector1      := pv1 ;
                     hatch_pattern_vector1_angle:= pv1a ;
                     hatch_pattern_vector2      := pv2 ;
                     hatch_pattern_vector2_angle:= pv2a ;
                     hatch_pattern_scale_x      := psx ;
                     hatch_pattern_scale_y      := psy ;
                     hatch_pattern_angle        := pa ;
                     out_id   := oid ;
                     Number   := num ;
                     try
                        SetLength(in_id, Number);
                     except
                        in_id := nil ;
                        Number:= 0 ;
                     end;
                     for i:=0 to Number-1 do
                        in_id[i] := iid[i];
                     //
                     MakeHatch4(mm,col,px,py,pv1,pv1a,pv2,pv2a,psx,psy,pa) ;   // nb`O
                     try
                        hln   := zHLnN ;
                        SetLength(hl, hln);
                     except
                        hln   := 0;
                        hl    := nil;
                     end;
                     for i:=0 to hln-1 do
                        hl[i] := zHLn[i] ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,-1,-1,-1,-1)
               except
                  Dec(mHa4N);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,111,mHa4N)) then begin
               try
                  Inc(mHa4N);
                  if ((mHa4N mod 100) = 1) then SetLength(mHa4, mHa4N+99);   // 100m
                  with mHa4[mHa4N-1] do begin
                     exf            := True ;
                     Layer          := lay ;
                     name           := st ;
                     hatch_color    := col ;
                     hatch_pattern_x            := px ;
                     hatch_pattern_y            := py ;
                     hatch_pattern_vector1      := pv1 ;
                     hatch_pattern_vector1_angle:= pv1a ;
                     hatch_pattern_vector2      := pv2 ;
                     hatch_pattern_vector2_angle:= pv2a ;
                     hatch_pattern_scale_x      := psx ;
                     hatch_pattern_scale_y      := psy ;
                     hatch_pattern_angle        := pa ;
                     out_id   := oid ;
                     Number   := num ;
                     try
                        SetLength(in_id, Number);
                     except
                        in_id := nil ;
                        Number:= 0 ;
                     end;
                     for i:=0 to Number-1 do
                        in_id[i] := iid[i];
                     //
                     MakeHatch4(mm,col,px,py,pv1,pv1a,pv2,pv2a,psx,psy,pa) ;   // nb`O
                     try
                        hln   := zHLnN ;
                        SetLength(hl, hln);
                     except
                        hln   := 0;
                        hl    := nil;
                     end;
                     for i:=0 to hln-1 do
                        hl[i] := zHLn[i] ;
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mHa4N);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
   //
   DataClearHLn ;
   DataClearHAr ;
   if (Result) then begin
      // Ȑ`̎QƐJEg
      m := CCrvIDCheck(oid);
      cDef[m].cnt := cDef[m].cnt + 1;
      for i:=0 to num-1 do begin
         m := CCrvIDCheck(iid[i]);
         cDef[m].cnt := cDef[m].cnt + 1;
      end;
   end;
end;

// nb`O(ߓh)@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`^V{  null:p֒ǉ
// (ret) True:o^OK@False:NG
function TDataClass.AddDataHatch5(s:string;lay,col,al,oid,num:integer;iid:array of integer) : Boolean ;
var
   m,i,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (al  <   0) then al := 0;
   if (al  > 255) then al := 255;
   if (num < 0) then num := 0;
   // Ȑ`f[^̐ڑ`FbNEnb`Ö}`̃ZbgE`FbN
   if not(CheckHatchSub_CCrv_HAr(oid,num,iid)) then exit;
   //
   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,112,dHa5N)) then begin
         try
            Inc(dHa5N);
            if ((dHa5N mod 100) = 1) then SetLength(dHa5, dHa5N+99);   // 100m
            with dHa5[dHa5N-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               Alpha       := al  ;
               out_id      := oid ;
               Number      := num ;
               try
                  SetLength(in_id, Number);
               except
                  in_id    := nil ;
                  Number   := 0 ;
               end;
               for i:=0 to Number-1 do
                  in_id[i] := iid[i];
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,-1,-1,-1,-1);
         except
            Dec(dHa5N);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,112,mHa5N)) then begin
               try
                  Inc(mHa5N);
                  if ((mHa5N mod 100) = 1) then SetLength(mHa5, mHa5N+99);   // 100m
                  with mHa5[mHa5N-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Alpha       := al  ;
                     out_id      := oid ;
                     Number      := num ;
                     try
                        SetLength(in_id, Number);
                     except
                        in_id    := nil ;
                        Number   := 0 ;
                     end;
                     for i:=0 to Number-1 do
                        in_id[i] := iid[i];
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,-1,-1,-1,-1)
               except
                  Dec(mHa5N);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,112,mHa5N)) then begin
               try
                  Inc(mHa5N);
                  if ((mHa5N mod 100) = 1) then SetLength(mHa5, mHa5N+99);   // 100m
                  with mHa5[mHa5N-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     Alpha       := al  ;
                     out_id      := oid ;
                     Number      := num ;
                     try
                        SetLength(in_id, Number);
                     except
                        in_id    := nil ;
                        Number   := 0 ;
                     end;
                     for i:=0 to Number-1 do
                        in_id[i] := iid[i];
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mHa5N);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
   //
   DataClearHAr ;
   if (Result) then begin
      // Ȑ`̎QƐJEg
      m := CCrvIDCheck(oid);
      cDef[m].cnt := cDef[m].cnt + 1;
      for i:=0 to num-1 do begin
         m := CCrvIDCheck(iid[i]);
         cDef[m].cnt := cDef[m].cnt + 1;
      end;
   end;
end;

// nb`O(Of[Vh)@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`^V{  null:p֒ǉ
// (ret) True:o^OK@False:NG
function TDataClass.AddDataHatch6(s:string;lay,col1,col2,al,gtp:integer;an,hx,hy:double;oid,num:integer;iid:array of integer) : Boolean ;
var
   m,i,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col1< 0) or (col1> zColMax) then col1:= 0 ;
   if (col2< 0) or (col2> zColMax) then col2:= 0 ;
   if (al  <   0) then al := 0;
   if (al  > 255) then al := 255;
   if (gtp < 0) or (gtp > 2) then begin
      gtp := 0 ;
      an  := 0.0 ;
   end;
   if (num < 0) then num := 0;
   an := SetAngle(an);
   // Ȑ`f[^̐ڑ`FbNEnb`Ö}`̃ZbgE`FbN
   if not(CheckHatchSub_CCrv_HAr(oid,num,iid)) then exit;
   //
   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,113,dHa6N)) then begin
         try
            Inc(dHa6N);
            if ((dHa6N mod 100) = 1) then SetLength(dHa6, dHa6N+99);   // 100m
            with dHa6[dHa6N-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color1      := col1 ;
               Color2      := col2 ;
               Alpha       := al  ;
               Gtype       := gtp ;
               Angle       := an ;
               housya_x    := hx ;
               housya_y    := hy ;
               out_id      := oid ;
               Number      := num ;
               try
                  SetLength(in_id, Number);
               except
                  in_id    := nil ;
                  Number   := 0 ;
               end;
               for i:=0 to Number-1 do
                  in_id[i] := iid[i];
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,-1,-1,-1,-1);
         except
            Dec(dHa6N);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,113,mHa6N)) then begin
               try
                  Inc(mHa6N);
                  if ((mHa6N mod 100) = 1) then SetLength(mHa6, mHa6N+99);   // 100m
                  with mHa6[mHa6N-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color1      := col1 ;
                     Color2      := col2 ;
                     Alpha       := al  ;
                     Gtype       := gtp ;
                     Angle       := an ;
                     housya_x    := hx ;
                     housya_y    := hy ;
                     out_id      := oid ;
                     Number      := num ;
                     try
                        SetLength(in_id, Number);
                     except
                        in_id    := nil ;
                        Number   := 0 ;
                     end;
                     for i:=0 to Number-1 do
                        in_id[i] := iid[i];
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,-1,-1,-1,-1)
               except
                  Dec(mHa6N);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,113,mHa6N)) then begin
               try
                  Inc(mHa6N);
                  if ((mHa6N mod 100) = 1) then SetLength(mHa6, mHa6N+99);   // 100m
                  with mHa6[mHa6N-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color1      := col1 ;
                     Color2      := col2 ;
                     Alpha       := al  ;
                     Gtype       := gtp ;
                     Angle       := an ;
                     housya_x    := hx ;
                     housya_y    := hy ;
                     out_id      := oid ;
                     Number      := num ;
                     try
                        SetLength(in_id, Number);
                     except
                        in_id    := nil ;
                        Number   := 0 ;
                     end;
                     for i:=0 to Number-1 do
                        in_id[i] := iid[i];
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mHa6N);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
   //
   DataClearHAr ;
   if (Result) then begin
      // Ȑ`̎QƐJEg
      m := CCrvIDCheck(oid);
      cDef[m].cnt := cDef[m].cnt + 1;
      for i:=0 to num-1 do begin
         m := CCrvIDCheck(iid[i]);
         cDef[m].cnt := cDef[m].cnt + 1;
      end;
   end;
end;

// nb`O(摜h)@f[^ڂ̒ǉo^
//    s  : f[^ǉ̕}`^V{  null:p֒ǉ
// (ret) True:o^OK@False:NG
function TDataClass.AddDataHatch7(s,fn:string;lay,col,oid,num:integer;iid:array of integer) : Boolean ;
var
   m,i,dn : integer ;
begin
   Result := False;
   if (fn = '') then exit ;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (num < 0) then num := 0;
   // Ȑ`f[^̐ڑ`FbNEnb`Ö}`̃ZbgE`FbN
   if not(CheckHatchSub_CCrv_HAr(oid,num,iid)) then exit;
   //
   if (s = '') then begin
      // p֒ǉ
      if (AddDataOrder(0,114,dHa7N)) then begin
         try
            Inc(dHa7N);
            if ((dHa7N mod 100) = 1) then SetLength(dHa7, dHa7N+99);   // 100m
            with dHa7[dHa7N-1] do begin
               exf         := True ;
               Layer       := lay ;
               Color       := col ;
               ImgFileName := fn ;
               out_id      := oid ;
               Number      := num ;
               try
                  SetLength(in_id, Number);
               except
                  in_id    := nil ;
                  Number   := 0 ;
               end;
               for i:=0 to Number-1 do
                  in_id[i] := iid[i];
            end;
            OpAdd(5,0,dOrdN-1);
            Result := True ;
            AddLayerCnt(lay,-1,-1,-1,-1);
         except
            Dec(dHa7N);
            Dec(dOrdN);
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (AddDataOrder(m,114,mHa7N)) then begin
               try
                  Inc(mHa7N);
                  if ((mHa7N mod 100) = 1) then SetLength(mHa7, mHa7N+99);   // 100m
                  with mHa7[mHa7N-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     ImgFileName := fn ;
                     out_id      := oid ;
                     Number      := num ;
                     try
                        SetLength(in_id, Number);
                     except
                        in_id    := nil ;
                        Number   := 0 ;
                     end;
                     for i:=0 to Number-1 do
                        in_id[i] := iid[i];
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
                  AddLayerFCnt(lay,-1,-1,-1,-1)
               except
                  Dec(mHa7N);
                  Dec(mOrdN);
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (AddDataOrder(m,114,mHa7N)) then begin
               try
                  Inc(mHa7N);
                  if ((mHa7N mod 100) = 1) then SetLength(mHa7, mHa7N+99);   // 100m
                  with mHa7[mHa7N-1] do begin
                     exf         := True ;
                     Layer       := lay ;
                     Color       := col ;
                     ImgFileName := fn ;
                     out_id      := oid ;
                     Number      := num ;
                     try
                        SetLength(in_id, Number);
                     except
                        in_id    := nil ;
                        Number   := 0 ;
                     end;
                     for i:=0 to Number-1 do
                        in_id[i] := iid[i];
                  end;
                  OpAdd(5,m,mOrdN-1);
                  Result := True ;
               except
                  Dec(mHa7N);
                  Dec(mOrdN);
               end;
            end;
         end;
      end;
   end;
   //
   DataClearHAr ;
   if (Result) then begin
      // Ȑ`̎QƐJEg
      m := CCrvIDCheck(oid);
      cDef[m].cnt := cDef[m].cnt + 1;
      for i:=0 to num-1 do begin
         m := CCrvIDCheck(iid[i]);
         cDef[m].cnt := cDef[m].cnt + 1;
      end;
   end;
end;

// vff[^@폜
//    s  : }`^V{  null:pi\Lvfj
//    o1: vff[^ԍ
//    o2: ef[^̓o^Index 0`
procedure TDataClass.DelDataNo(s:string;o1,o2:integer) ;
var
   m : integer ;
begin
   if (s = '') then
      DelDataNo(0,o1,o2)
   else begin
      m := FZukeiNameCheck(0,s);
      if (m <> 0) then
         DelDataNo(m,o1,o2) ;
   end;
end;

// vff[^@폜
//    m : 0:ʏ@1`:}`vf `-1:V{
//    o1: vff[^ԍ
//    o2: ef[^̓o^Index 0`
procedure TDataClass.DelDataNo(m,o1,o2:integer) ;
var
   i,dn : integer ;
begin
   if (o1 <= 0)or(o2 < 0) then exit ;

   if (m = 0) then begin
      for i:=dOrdN-1 downto 0 do begin
         if (o1 = dOrd[i].DataType)
         and(o2 = dOrd[i].DataNo) then begin
            OpAdd(6,0,i);
            break ;
         end;
      end;
      case (o1) of
      1: begin
            // _}[J
            if (o2 < dTenN) then begin
               with dTen[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      2: begin
            // 
            if (o2 < dLinN) then begin
               with dLin[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      3: begin
            // ܐ
            if (o2 < dLnsN) then begin
               with dLns[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      4: begin
            // ~
            if (o2 < dCirN) then begin
               with dCir[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      5: begin
            // ~
            if (o2 < dArcN) then begin
               with dArc[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      6: begin
            // ȉ~
            if (o2 < dEllN) then begin
               with dEll[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      7: begin
            // ȉ~
            if (o2 < dEArN) then begin
               with dEAr[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      8: begin
            // 
            if (o2 < dTxtN) then begin
               with dTxt[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      9: begin
            // xWFȐ
            if (o2 < dBezN) then begin
               with dBez[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      10:begin
            // aXvCȐ
            if (o2 < dBspN) then begin
               with dBsp[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      11:begin
            // XvCȐ
            if (o2 < dSplN) then begin
               with dSpl[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      12:begin
            // N\ChȐ
            if (o2 < dCloN) then begin
               with dClo[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      13:begin
            // 
            if (o2 < dArwN) then begin
               with dArw[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      14:begin
            // 摜
            if (o2 < dImgN) then begin
               with dImg[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      15:begin
            // 
            if (o2 < dDocN) then begin
               with dDoc[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      16:begin
            // \
            if (o2 < dTblN) then begin
               with dTbl[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      99:begin
            // }`
            if (o2 < dFzkN) then begin
               with dFzk[o2] do begin
                  exf := False ;
               end;
               MakeFZukeiTree ;
            end;
         end;
      100:begin
            // V{}`
            if (o2 < dSzkN) then begin
               with dSzk[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      101:begin
            // @
            if (o2 < dDLnN) then begin
               with dDLn[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      102:begin
            // ʒ@
            if (o2 < dDArN) then begin
               with dDAr[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      103:begin
            // px@
            if (o2 < dDAnN) then begin
               with dDAn[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      104:begin
            // a@
            if (o2 < dDRaN) then begin
               with dDRa[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      105:begin
            // a@
            if (o2 < dDDiN) then begin
               with dDDi[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      106:begin
            // o
            if (o2 < dDLeN) then begin
               with dDLe[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      107:begin
            // o[
            if (o2 < dDBaN) then begin
               with dDBa[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      108:begin
            // nb`Oi`j
            if (o2 < dHa1N) then begin
               with dHa1[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      109:begin
            // nb`Oihj
            if (o2 < dHa2N) then begin
               with dHa2[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      110:begin
            // nb`Oi[U`j
            if (o2 < dHa3N) then begin
               with dHa3[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      111:begin
            // nb`Oip^[j
            if (o2 < dHa4N) then begin
               with dHa4[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      112:begin
            // nb`Oiߓhj
            if (o2 < dHa5N) then begin
               with dHa5[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      113:begin
            // nb`OiOf[Vhj
            if (o2 < dHa6N) then begin
               with dHa6[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      114:begin
            // nb`Oi摜hj
            if (o2 < dHa7N) then begin
               with dHa7[o2] do begin
                  exf := False ;
               end;
            end;
         end;
      end;
   end
   else if (m > 0)and(m <= fDefN) then begin
      with fDef[m-1] do begin
         dn := datn ;
      end;
      with fDefD[dn] do begin
         for i:=mOrdN-1 downto 0 do begin
            if (o1 = mOrd[i].DataType)
            and(o2 = mOrd[i].DataNo) then begin
               OpAdd(6,m,i);
               break ;
            end;
         end;
         case (o1) of
         1: begin
               // _}[J
               if (o2 < mTenN) then begin
                  with mTen[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         2: begin
               // 
               if (o2 < mLinN) then begin
                  with mLin[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         3: begin
               // ܐ
               if (o2 < mLnsN) then begin
                  with mLns[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         4: begin
               // ~
               if (o2 < mCirN) then begin
                  with mCir[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         5: begin
               // ~
               if (o2 < mArcN) then begin
                  with mArc[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         6: begin
               // ȉ~
               if (o2 < mEllN) then begin
                  with mEll[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         7: begin
               // ȉ~
               if (o2 < mEArN) then begin
                  with mEAr[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         8: begin
               // 
               if (o2 < mTxtN) then begin
                  with mTxt[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         9: begin
               // xWFȐ
               if (o2 < mBezN) then begin
                  with mBez[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         10:begin
               // aXvCȐ
               if (o2 < mBspN) then begin
                  with mBsp[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         11:begin
               // XvCȐ
               if (o2 < mSplN) then begin
                  with mSpl[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         12:begin
               // N\ChȐ
               if (o2 < mCloN) then begin
                  with mClo[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         13:begin
               // 
               if (o2 < mArwN) then begin
                  with mArw[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         15:begin
               // 
               if (o2 < mDocN) then begin
                  with mDoc[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         16:begin
               // \
               if (o2 < mTblN) then begin
                  with mTbl[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         99:begin
               // }`
               if (o2 < mFzkN) then begin
                  with mFzk[o2] do begin
                     exf := False ;
                  end;
                  MakeFZukeiTree ;
               end;
            end;
         100:begin
               // V{}`
               if (o2 < mSzkN) then begin
                  with mSzk[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         101:begin
               // @
               if (o2 < mDLnN) then begin
                  with mDLn[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         102:begin
               // ʒ@
               if (o2 < mDArN) then begin
                  with mDAr[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         103:begin
               // px@
               if (o2 < mDAnN) then begin
                  with mDAn[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         104:begin
               // a@
               if (o2 < mDRaN) then begin
                  with mDRa[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         105:begin
               // a@
               if (o2 < mDDiN) then begin
                  with mDDi[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         106:begin
               // o
               if (o2 < mDLeN) then begin
                  with mDLe[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         107:begin
               // o[
               if (o2 < mDBaN) then begin
                  with mDBa[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         108:begin
               // nb`Oi`j
               if (o2 < mHa1N) then begin
                  with mHa1[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         109:begin
               // nb`Oihj
               if (o2 < mHa2N) then begin
                  with mHa2[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         110:begin
               // nb`Oi[U`j
               if (o2 < mHa3N) then begin
                  with mHa3[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         111:begin
               // nb`Oip^[j
               if (o2 < mHa4N) then begin
                  with mHa4[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         112:begin
               // nb`Oiߓhj
               if (o2 < mHa5N) then begin
                  with mHa5[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         113:begin
               // nb`OiOf[Vhj
               if (o2 < mHa6N) then begin
                  with mHa6[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         114:begin
               // nb`Oi摜hj
               if (o2 < mHa7N) then begin
                  with mHa7[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         end;
      end;
   end
   else if (m < 0)and(m >= -sDefN) then begin
      with sDef[-m-1] do begin
         dn := datn ;
      end;
      with sDefD[dn] do begin
         for i:=mOrdN-1 downto 0 do begin
            if (o1 = mOrd[i].DataType)
            and(o2 = mOrd[i].DataNo) then begin
               OpAdd(6,m,i);
               break ;
            end;
         end;
         case (o1) of
         1: begin
               // _}[J
               if (o2 < mTenN) then begin
                  with mTen[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         2: begin
               // 
               if (o2 < mLinN) then begin
                  with mLin[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         3: begin
               // ܐ
               if (o2 < mLnsN) then begin
                  with mLns[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         4: begin
               // ~
               if (o2 < mCirN) then begin
                  with mCir[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         5: begin
               // ~
               if (o2 < mArcN) then begin
                  with mArc[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         6: begin
               // ȉ~
               if (o2 < mEllN) then begin
                  with mEll[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         7: begin
               // ȉ~
               if (o2 < mEArN) then begin
                  with mEAr[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         8: begin
               // 
               if (o2 < mTxtN) then begin
                  with mTxt[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         9: begin
               // xWFȐ
               if (o2 < mBezN) then begin
                  with mBez[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         10:begin
               // aXvCȐ
               if (o2 < mBspN) then begin
                  with mBsp[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         11:begin
               // XvCȐ
               if (o2 < mSplN) then begin
                  with mSpl[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         12:begin
               // N\ChȐ
               if (o2 < mCloN) then begin
                  with mClo[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         13:begin
               // 
               if (o2 < mArwN) then begin
                  with mArw[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         15:begin
               // 
               if (o2 < mDocN) then begin
                  with mDoc[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         16:begin
               // \
               if (o2 < mTblN) then begin
                  with mTbl[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         101:begin
               // @
               if (o2 < mDLnN) then begin
                  with mDLn[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         102:begin
               // ʒ@
               if (o2 < mDArN) then begin
                  with mDAr[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         103:begin
               // px@
               if (o2 < mDAnN) then begin
                  with mDAn[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         104:begin
               // a@
               if (o2 < mDRaN) then begin
                  with mDRa[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         105:begin
               // a@
               if (o2 < mDDiN) then begin
                  with mDDi[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         106:begin
               // o
               if (o2 < mDLeN) then begin
                  with mDLe[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         107:begin
               // o[
               if (o2 < mDBaN) then begin
                  with mDBa[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         108:begin
               // nb`Oi`j
               if (o2 < mHa1N) then begin
                  with mHa1[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         109:begin
               // nb`Oihj
               if (o2 < mHa2N) then begin
                  with mHa2[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         110:begin
               // nb`Oi[U`j
               if (o2 < mHa3N) then begin
                  with mHa3[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         111:begin
               // nb`Oip^[j
               if (o2 < mHa4N) then begin
                  with mHa4[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         112:begin
               // nb`Oiߓhj
               if (o2 < mHa5N) then begin
                  with mHa5[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         113:begin
               // nb`OiOf[Vhj
               if (o2 < mHa6N) then begin
                  with mHa6[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         114:begin
               // nb`Oi摜hj
               if (o2 < mHa7N) then begin
                  with mHa7[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         end;
      end;
   end;
end;

// vff[^@O폜
//    s  : }`^V{  null:pi\Lvfj
procedure TDataClass.DelDataPrev(s:string) ;
var
   m : integer ;
begin
   if (s = '') then
      DelDataPrev(0)
   else begin
      m := FZukeiNameCheck(0,s);
      if (m <> 0) then
         DelDataPrev(m) ;
   end;
end;

// vff[^@O폜
//    m : 0:ʏ@1`:}`vf `-1:V{
procedure TDataClass.DelDataPrev(m:integer) ;
var
   i,o1,o2,dn : integer ;
begin
   if (m = 0) then begin
      for i:=dOrdN-1 downto 0 do begin
         with dOrd[i] do begin
            o1 := DataType ;
            o2 := DataNo ;
         end;
         case (o1) of
         1: begin
               // _}[J
               if (o2 < dTenN) then begin
                  with dTen[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         2: begin
               // 
               if (o2 < dLinN) then begin
                  with dLin[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         3: begin
               // ܐ
               if (o2 < dLnsN) then begin
                  with dLns[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         4: begin
               // ~
               if (o2 < dCirN) then begin
                  with dCir[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         5: begin
            // ~
               if (o2 < dArcN) then begin
                  with dArc[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         6: begin
               // ȉ~
               if (o2 < dEllN) then begin
                  with dEll[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         7: begin
               // ȉ~
               if (o2 < dEArN) then begin
                  with dEAr[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         8: begin
               // 
               if (o2 < dTxtN) then begin
                  with dTxt[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         9: begin
               // xWFȐ
               if (o2 < dBezN) then begin
                  with dBez[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         10:begin
               // aXvCȐ
               if (o2 < dBspN) then begin
                  with dBsp[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         11:begin
               // XvCȐ
               if (o2 < dSplN) then begin
                  with dSpl[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         12:begin
               // N\ChȐ
               if (o2 < dCloN) then begin
                  with dClo[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         13:begin
               // 
               if (o2 < dArwN) then begin
                  with dArw[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         14:begin
               // 摜
               if (o2 < dImgN) then begin
                  with dImg[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         15:begin
               // 
               if (o2 < dDocN) then begin
                  with dDoc[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         16:begin
               // \
               if (o2 < dTblN) then begin
                  with dTbl[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         99:begin
               // }`
               if (o2 < dFzkN) then begin
                  with dFzk[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         100:begin
               // V{}`
               if (o2 < dSzkN) then begin
                  with dSzk[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         101:begin
               // @
               if (o2 < dDLnN) then begin
                  with dDLn[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         102:begin
               // ʒ@
               if (o2 < dDArN) then begin
                  with dDAr[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         103:begin
               // px@
               if (o2 < dDAnN) then begin
                  with dDAn[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         104:begin
               // a@
               if (o2 < dDRaN) then begin
                  with dDRa[o2] do begin
                     if not(exf) then continue ;
                  end;
              end;
            end;
         105:begin
               // a@
               if (o2 < dDDiN) then begin
                  with dDDi[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         106:begin
               // o
               if (o2 < dDLeN) then begin
                  with dDLe[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         107:begin
               // o[
               if (o2 < dDBaN) then begin
                  with dDBa[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         108:begin
               // nb`Oi`j
               if (o2 < dHa1N) then begin
                  with dHa1[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         109:begin
               // nb`Oihj
               if (o2 < dHa2N) then begin
                  with dHa2[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         110:begin
               // nb`Oi[U`j
               if (o2 < dHa3N) then begin
                  with dHa3[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         111:begin
               // nb`Oip^[j
               if (o2 < dHa4N) then begin
                  with dHa4[o2] do begin
                     if not(exf) then continue ;
               end;
               end;
            end;
         112:begin
               // nb`Oiߓhj
               if (o2 < dHa5N) then begin
                  with dHa5[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         113:begin
               // nb`OiOf[Vhj
               if (o2 < dHa6N) then begin
                  with dHa6[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         114:begin
               // nb`Oi摜hj
               if (o2 < dHa7N) then begin
                  with dHa7[o2] do begin
                     if not(exf) then continue ;
                  end;
               end;
            end;
         else begin
               continue ;
            end;
         end;
         DelDataNo(m,o1,o2);
         break ;
      end;
   end
   else if (m > 0)and(m <= fDefN) then begin
      with fDef[m-1] do begin
         dn := datn ;
      end;
      with fDefD[dn] do begin
         for i:=mOrdN-1 downto 0 do begin
            with mOrd[i] do begin
               o1 := DataType ;
               o2 := DataNo ;
            end;
            case (o1) of
            1: begin
                  // _}[J
                  if (o2 < mTenN) then begin
                     with mTen[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            2: begin
                  // 
                  if (o2 < mLinN) then begin
                     with mLin[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            3: begin
                  // ܐ
                  if (o2 < mLnsN) then begin
                     with mLns[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            4: begin
                  // ~
                  if (o2 < mCirN) then begin
                     with mCir[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            5: begin
                  // ~
                  if (o2 < mArcN) then begin
                     with mArc[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            6: begin
                  // ȉ~
                  if (o2 < mEllN) then begin
                     with mEll[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            7: begin
                  // ȉ~
                  if (o2 < mEArN) then begin
                     with mEAr[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            8: begin
                  // 
                  if (o2 < mTxtN) then begin
                     with mTxt[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            9: begin
                  // xWFȐ
                  if (o2 < mBezN) then begin
                     with mBez[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            10:begin
                  // aXvCȐ
                  if (o2 < mBspN) then begin
                     with mBsp[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            11:begin
                  // XvCȐ
                  if (o2 < mSplN) then begin
                     with mSpl[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            12:begin
                  // N\ChȐ
                  if (o2 < mCloN) then begin
                     with mClo[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            13:begin
                  // 
                  if (o2 < mArwN) then begin
                     with mArw[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            15:begin
                  // 
                  if (o2 < mDocN) then begin
                     with mDoc[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            16:begin
                  // \
                  if (o2 < mTblN) then begin
                     with mTbl[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            99:begin
                  // }`
                  if (o2 < mFzkN) then begin
                     with mFzk[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            100:begin
                  // V{}`
                  if (o2 < mSzkN) then begin
                     with mSzk[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            101:begin
                  // @
                  if (o2 < mDLnN) then begin
                     with mDLn[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            102:begin
                  // ʒ@
                  if (o2 < mDArN) then begin
                     with mDAr[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            103:begin
                  // px@
                  if (o2 < mDAnN) then begin
                     with mDAn[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            104:begin
                  // a@
                  if (o2 < mDRaN) then begin
                     with mDRa[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            105:begin
                  // a@
                  if (o2 < mDDiN) then begin
                     with mDDi[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            106:begin
                  // o
                  if (o2 < mDLeN) then begin
                     with mDLe[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            107:begin
                  // o[
                  if (o2 < mDBaN) then begin
                     with mDBa[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            108:begin
                  // nb`Oi`j
                  if (o2 < mHa1N) then begin
                     with mHa1[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            109:begin
                  // nb`Oihj
                  if (o2 < mHa2N) then begin
                     with mHa2[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            110:begin
                  // nb`Oi[U`j
                  if (o2 < mHa3N) then begin
                     with mHa3[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            111:begin
                  // nb`Oip^[j
                  if (o2 < mHa4N) then begin
                     with mHa4[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            112:begin
                  // nb`Oiߓhj
                  if (o2 < mHa5N) then begin
                     with mHa5[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            113:begin
                  // nb`OiOf[Vhj
                  if (o2 < mHa6N) then begin
                     with mHa6[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            114:begin
                  // nb`Oi摜hj
                  if (o2 < mHa7N) then begin
                     with mHa7[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            else begin
                  continue ;
               end;
            end;
            DelDataNo(m,o1,o2);
            break ;
         end;
      end;
   end
   else if (m < 0)and(m >= -sDefN) then begin
      with sDef[-m-1] do begin
         dn := datn ;
      end;
      with sDefD[dn] do begin
         for i:=mOrdN-1 downto 0 do begin
            with mOrd[i] do begin
               o1 := DataType ;
               o2 := DataNo ;
            end;
            case (o1) of
            1: begin
                  // _}[J
                  if (o2 < mTenN) then begin
                     with mTen[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            2: begin
                  // 
                  if (o2 < mLinN) then begin
                     with mLin[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            3: begin
                  // ܐ
                  if (o2 < mLnsN) then begin
                     with mLns[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            4: begin
                  // ~
                  if (o2 < mCirN) then begin
                     with mCir[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            5: begin
                  // ~
                  if (o2 < mArcN) then begin
                     with mArc[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            6: begin
                  // ȉ~
                  if (o2 < mEllN) then begin
                     with mEll[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            7: begin
                  // ȉ~
                  if (o2 < mEArN) then begin
                     with mEAr[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            8: begin
                  // 
                  if (o2 < mTxtN) then begin
                     with mTxt[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            9: begin
                  // xWFȐ
                  if (o2 < mBezN) then begin
                     with mBez[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            10:begin
                  // aXvCȐ
                  if (o2 < mBspN) then begin
                     with mBsp[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            11:begin
                  // XvCȐ
                  if (o2 < mSplN) then begin
                     with mSpl[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            12:begin
                  // N\ChȐ
                  if (o2 < mCloN) then begin
                     with mClo[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            13:begin
                  // 
                  if (o2 < mArwN) then begin
                     with mArw[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            15:begin
                  // 
                  if (o2 < mDocN) then begin
                     with mDoc[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            16:begin
                  // \
                  if (o2 < mTblN) then begin
                     with mTbl[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            101:begin
                  // @
                  if (o2 < mDLnN) then begin
                     with mDLn[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            102:begin
                  // ʒ@
                  if (o2 < mDArN) then begin
                     with mDAr[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            103:begin
                  // px@
                  if (o2 < mDAnN) then begin
                     with mDAn[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            104:begin
                  // a@
                  if (o2 < mDRaN) then begin
                     with mDRa[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            105:begin
                  // a@
                  if (o2 < mDDiN) then begin
                     with mDDi[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            106:begin
                  // o
                  if (o2 < mDLeN) then begin
                     with mDLe[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            107:begin
                  // o[
                  if (o2 < mDBaN) then begin
                     with mDBa[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            108:begin
                  // nb`Oi`j
                  if (o2 < mHa1N) then begin
                     with mHa1[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            109:begin
                  // nb`Oihj
                  if (o2 < mHa2N) then begin
                     with mHa2[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            110:begin
                  // nb`Oi[U`j
                  if (o2 < mHa3N) then begin
                     with mHa3[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            111:begin
                  // nb`Oip^[j
                  if (o2 < mHa4N) then begin
                     with mHa4[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            112:begin
                  // nb`Oiߓhj
                  if (o2 < mHa5N) then begin
                     with mHa5[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            113:begin
                  // nb`OiOf[Vhj
                  if (o2 < mHa6N) then begin
                     with mHa6[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            114:begin
                  // nb`Oi摜hj
                  if (o2 < mHa7N) then begin
                     with mHa7[o2] do begin
                        if not(exf) then continue ;
                     end;
                  end;
               end;
            else begin
                  continue ;
               end;
            end;
            DelDataNo(m,o1,o2);
            break ;
         end;
      end;
   end;
end;

// vff[^@S폜
procedure TDataClass.DelDataAll ;
var
   i : integer ;
begin
   DelDataAll(0);
   for i:=1 to fDefN do
      DelDataAll(i);
   for i:=1 to sDefN do
      DelDataAll(-i);
end;

// vff[^@S폜
//    s  : }`^V{  null:pi\Lvfj
procedure TDataClass.DelDataAll(s:string) ;
var
   m : integer ;
begin
   if (s = '') then
      DelDataAll(0)
   else begin
      m := FZukeiNameCheck(0,s);
      if (m <> 0) then
         DelDataAll(m) ;
   end;
end;

// vff[^@S폜
//    m : 0:ʏ@1`:}`vf `-1:V{
procedure TDataClass.DelDataAll(m:integer) ;
var
   i,o1,o2,dn : integer ;
begin
   if (m = 0) then begin
      for i:=0 to dOrdN-1 do begin
         with dOrd[i] do begin
            o1 := DataType ;
            o2 := DataNo ;
         end;
         DelDataNo(m,o1,o2);
      end;
   end
   else if (m > 0)and(m <= fDefN) then begin
      with fDef[m-1] do begin
         dn := datn ;
      end;
      with fDefD[dn] do begin
         for i:=0 to mOrdN-1 do begin
            with mOrd[i] do begin
               o1 := DataType ;
               o2 := DataNo ;
            end;
            DelDataNo(m,o1,o2);
         end;
      end;
   end
   else if (m < 0)and(m >= -sDefN) then begin
      with sDef[-m-1] do begin
         dn := datn ;
      end;
      with sDefD[dn] do begin
         for i:=0 to mOrdN-1 do begin
            with mOrd[i] do begin
               o1 := DataType ;
               o2 := DataNo ;
            end;
            DelDataNo(m,o1,o2);
         end;
      end;
   end;
end;

// _}[J@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : _}[J        vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    col: F(0,1-256)
//    mc : }[JR[h(1: 2: 3:E 4:{ 5: 6: 7:~)
//    px : zu_X
//    py : zu_Y
//    an : ]p[]
//    sc : ړx
// (ret) True:OK@False:NG
function TDataClass.GetDataTen(s:string;n:integer;var ex:Boolean;var lay,col,mc:integer;var px,py,an,sc:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dTenN) then exit;    // vfIndex`FbN
      with dTen[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         px := start_x ;
         py := start_y ;
         mc := marker_code ;
         an := rotate_angle ;
         sc := Scale ;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mTenN) then exit;    // vfIndex`FbN
            with mTen[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               px := start_x ;
               py := start_y ;
               mc := marker_code ;
               an := rotate_angle ;
               sc := Scale ;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mTenN) then exit;    // vfIndex`FbN
            with mTen[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               px := start_x ;
               py := start_y ;
               mc := marker_code ;
               an := rotate_angle ;
               sc := Scale ;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// @f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  :             vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    x1 : n_X
//    y1 : n_Y
//    x2 : I_X
//    y2 : I_Y
// (ret) True:OK@False:NG
function TDataClass.GetDataLine(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid:integer;var x1,y1,x2,y2:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dLinN) then exit;    // vfIndex`FbN
      with dLin[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         ltp:= Ltype ;
         wid:= line_width ;
         x1 := start_x ;
         y1 := start_y ;
         x2 := end_x ;
         y2 := end_y ;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mLinN) then exit;    // vfIndex`FbN
            with mLin[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               x1 := start_x ;
               y1 := start_y ;
               x2 := end_x ;
               y2 := end_y ;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mLinN) then exit;    // vfIndex`FbN
            with mLin[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               x1 := start_x ;
               y1 := start_y ;
               x2 := end_x ;
               y2 := end_y ;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// ܐ@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : ܐ            vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    num: _
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y       nil ̏ꍇ͎擾Ȃ
// (ret) True:OK@False:NG
function TDataClass.GetDataLines(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,num:integer;var vx,vy:array of double) : Boolean;
var
   m,dn,lx,ly,nn,i : integer ;
begin
   Result := False;
   lx := Length(vx) ;
   ly := Length(vy) ;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dLnsN) then exit;    // vfIndex`FbN
      with dLns[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         ltp:= Ltype ;
         wid:= line_width ;
         num:= Number ;
         if (lx > 0)and(ly > 0) then begin
            nn := num ;
            if (nn > lx) then nn := lx ;  // G[̒
            if (nn > ly) then nn := ly ;
            try
               for i:=0 to nn-1 do begin
                  vx[i] := X[i];
                  vy[i] := Y[i];
               end;
            except
               ;
            end;
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mLnsN) then exit;    // vfIndex`FbN
            with mLns[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               num:= Number ;
               if (lx > 0)and(ly > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  if (nn > ly) then nn := ly ;
                  try
                     for i:=0 to nn-1 do begin
                        vx[i] := X[i];
                        vy[i] := Y[i];
                     end;
                  except
                     ;
                  end;
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mLnsN) then exit;    // vfIndex`FbN
            with mLns[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               num:= Number ;
               if (lx > 0)and(ly > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  if (nn > ly) then nn := ly ;
                  try
                     for i:=0 to nn-1 do begin
                        vx[i] := X[i];
                        vy[i] := Y[i];
                     end;
                  except
                     ;
                  end;
               end;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// ~@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : ~@            vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : (3`3600)
//    cx : S_X
//    cy : S_Y
//    cr : a
// (ret) True:OK@False:NG
function TDataClass.GetDataCircle(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,sp:integer;var cx,cy,cr:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dCirN) then exit;    // vfIndex`FbN
      with dCir[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         ltp:= Ltype ;
         wid:= line_width ;
         sp := sep ;
         cx := Center_x ;
         cy := Center_y ;
         cr := Radius ;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mCirN) then exit;    // vfIndex`FbN
            with mCir[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               sp := sep ;
               cx := Center_x ;
               cy := Center_y ;
               cr := Radius ;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mCirN) then exit;    // vfIndex`FbN
            with mCir[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               sp := sep ;
               cx := Center_x ;
               cy := Center_y ;
               cr := Radius ;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// ~ʁ@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : ~            vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : (3`3600)
//    dir: (0,1)
//    cx : S_X
//    cy : S_Y
//    cr : a
//    sa : np
//    ea : Ip
// (ret) True:OK@False:NG
function TDataClass.GetDataArc(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,sp,dir:integer;var cx,cy,cr,sa,ea:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dArcN) then exit;    // vfIndex`FbN
      with dArc[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         ltp:= Ltype ;
         wid:= line_width ;
         sp := sep ;
         cx := Center_x ;
         cy := Center_y ;
         cr := Radius ;
         dir:= Direction ;
         sa := start_angle ;
         ea := end_angle ;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mArcN) then exit;    // vfIndex`FbN
            with mArc[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               sp := sep ;
               cx := Center_x ;
               cy := Center_y ;
               cr := Radius ;
               dir:= Direction ;
               sa := start_angle ;
               ea := end_angle ;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mArcN) then exit;    // vfIndex`FbN
            with mArc[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               sp := sep ;
               cx := Center_x ;
               cy := Center_y ;
               cr := Radius ;
               dir:= Direction ;
               sa := start_angle ;
               ea := end_angle ;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// ȉ~@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : ȉ~            vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : (3`3600)
//    cx : S_X
//    cy : S_Y
//    rx : wa
//    ry : xa
//    ra : ]p
// (ret) True:OK@False:NG
function TDataClass.GetDataEllipse(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,sp:integer;var cx,cy,rx,ry,ra:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dEllN) then exit;    // vfIndex`FbN
      with dEll[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         ltp:= Ltype ;
         wid:= line_width ;
         sp := sep ;
         cx := Center_x ;
         cy := Center_y ;
         rx := Radius_x ;
         ry := Radius_y ;
         ra := rotation_angle ;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mEllN) then exit;    // vfIndex`FbN
            with mEll[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               sp := sep ;
               cx := Center_x ;
               cy := Center_y ;
               rx := Radius_x ;
               ry := Radius_y ;
               ra := rotation_angle ;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mEllN) then exit;    // vfIndex`FbN
            with mEll[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               sp := sep ;
               cx := Center_x ;
               cy := Center_y ;
               rx := Radius_x ;
               ry := Radius_y ;
               ra := rotation_angle ;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// ȉ~ʁ@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : ȉ~          vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : (3`3600)
//    dir: (0,1)
//    cx : S_X
//    cy : S_Y
//    rx : wa
//    ry : xa
//    ra : ]p
//    sa : np
//    ea : Ip
// (ret) True:OK@False:NG
function TDataClass.GetDataEllipseArc(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,sp,dir:integer;var cx,cy,rx,ry,ra,sa,ea:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dEArN) then exit;    // vfIndex`FbN
      with dEAr[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         ltp:= Ltype ;
         wid:= line_width ;
         sp := sep ;
         cx := Center_x ;
         cy := Center_y ;
         rx := Radius_x ;
         ry := Radius_y ;
         dir:= Direction ;
         ra := rotation_angle ;
         sa := start_angle ;
         ea := end_angle ;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mEArN) then exit;    // vfIndex`FbN
            with mEAr[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               sp := sep ;
               cx := Center_x ;
               cy := Center_y ;
               rx := Radius_x ;
               ry := Radius_y ;
               dir:= Direction ;
               ra := rotation_angle ;
               sa := start_angle ;
               ea := end_angle ;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mEArN) then exit;    // vfIndex`FbN
            with mEAr[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               sp := sep ;
               cx := Center_x ;
               cy := Center_y ;
               rx := Radius_x ;
               ry := Radius_y ;
               dir:= Direction ;
               ra := rotation_angle ;
               sa := start_angle ;
               ea := end_angle ;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// @f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : @          vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    col: F@    (0,1-256)
//    fon: tHg(0,1-1024)
//    bp : _(1-9)
//    dir: (1,2)
//    px : zu_X
//    py : zu_Y
//    ph : ͈͍
//    pw : ͈͕
//    ps : Ԋu
//    an : ]p
//    sl : Xgp
//    str: 
// (ret) True:OK@False:NG
function TDataClass.GetDataText(s:string;n:integer;var ex:Boolean;var lay,col,fnt,bp,dir:integer;var px,py,ph,pw,ps,an,sl:double;var st:string) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dTxtN) then exit;    // vfIndex`FbN
      with dTxt[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         fnt:= Font ;
         st := str ;
         px := text_x ;
         py := text_y ;
         ph := Height ;
         pw := Width ;
         ps := Spc ;
         an := Angle ;
         sl := Slant ;
         bp := b_pnt ;
         dir:= Direct ;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mTxtN) then exit;    // vfIndex`FbN
            with mTxt[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               fnt:= Font ;
               st := str ;
               px := text_x ;
               py := text_y ;
               ph := Height ;
               pw := Width ;
               ps := Spc ;
               an := Angle ;
               sl := Slant ;
               bp := b_pnt ;
               dir:= Direct ;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mTxtN) then exit;    // vfIndex`FbN
            with mTxt[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               fnt:= Font ;
               st := str ;
               px := text_x ;
               py := text_y ;
               ph := Height ;
               pw := Width ;
               ps := Spc ;
               an := Angle ;
               sl := Slant ;
               bp := b_pnt ;
               dir:= Direct ;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// xWFȐ@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : xWFȐ      vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : _ԕ
//    num: _(1-1000)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y       nil ̏ꍇ͎擾Ȃ
// (ret) True:OK@False:NG
function TDataClass.GetDataBezier(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,oc,sp,num:integer;var vx,vy:array of double) : Boolean;
var
   m,dn,lx,ly,nn,i : integer ;
begin
   Result := False;
   lx := Length(vx) ;
   ly := Length(vy) ;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dBezN) then exit;    // vfIndex`FbN
      with dBez[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         ltp:= Ltype ;
         wid:= line_width ;
         oc := open_close ;
         sp := sep ;
         num:= Number ;
         if (lx > 0)and(ly > 0) then begin
            nn := num ;
            if (nn > lx) then nn := lx ;  // G[̒
            if (nn > ly) then nn := ly ;
            try
               for i:=0 to nn-1 do begin
                  vx[i] := X[i];
                  vy[i] := Y[i];
               end;
            except
               ;
            end;
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mBezN) then exit;    // vfIndex`FbN
            with mBez[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               oc := open_close ;
               sp := sep ;
               num:= Number ;
               if (lx > 0)and(ly > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  if (nn > ly) then nn := ly ;
                  try
                     for i:=0 to nn-1 do begin
                        vx[i] := X[i];
                        vy[i] := Y[i];
                     end;
                  except
                     ;
                  end;
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mBezN) then exit;    // vfIndex`FbN
            with mBez[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               oc := open_close ;
               sp := sep ;
               num:= Number ;
               if (lx > 0)and(ly > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  if (nn > ly) then nn := ly ;
                  try
                     for i:=0 to nn-1 do begin
                        vx[i] := X[i];
                        vy[i] := Y[i];
                     end;
                  except
                     ;
                  end;
               end;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// aXvCȐ@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : aXvC    vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : _ԕ
//    num: _(1-1000)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y       nil ̏ꍇ͎擾Ȃ
// (ret) True:OK@False:NG
function TDataClass.GetDataBspline(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,oc,sp,num:integer;var vx,vy:array of double) : Boolean;
var
   m,dn,lx,ly,nn,i : integer ;
begin
   Result := False;
   lx := Length(vx) ;
   ly := Length(vy) ;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dBspN) then exit;    // vfIndex`FbN
      with dBsp[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         ltp:= Ltype ;
         wid:= line_width ;
         oc := open_close ;
         sp := sep ;
         num:= Number ;
         if (lx > 0)and(ly > 0) then begin
            nn := num ;
            if (nn > lx) then nn := lx ;  // G[̒
            if (nn > ly) then nn := ly ;
            try
               for i:=0 to nn-1 do begin
                  vx[i] := X[i];
                  vy[i] := Y[i];
               end;
            except
               ;
            end;
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mBspN) then exit;    // vfIndex`FbN
            with mBsp[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               oc := open_close ;
               sp := sep ;
               num:= Number ;
               if (lx > 0)and(ly > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  if (nn > ly) then nn := ly ;
                  try
                     for i:=0 to nn-1 do begin
                        vx[i] := X[i];
                        vy[i] := Y[i];
                     end;
                  except
                     ;
                  end;
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mBspN) then exit;    // vfIndex`FbN
            with mBsp[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               oc := open_close ;
               sp := sep ;
               num:= Number ;
               if (lx > 0)and(ly > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  if (nn > ly) then nn := ly ;
                  try
                     for i:=0 to nn-1 do begin
                        vx[i] := X[i];
                        vy[i] := Y[i];
                     end;
                  except
                     ;
                  end;
               end;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// XvCȐ@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : XvCȐ  vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    stp: Ȑ^Cv (1:CXvC 2:xWF 3:NUBS)
//@@sp : _ԕ
//    num: _(1-1000)
//    av : CXvĈ`l(0-1 ʏ0.5)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y       nil ̏ꍇ͎擾Ȃ
// (ret) True:OK@False:NG
function TDataClass.GetDataSpline(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,stp,oc,sp,num:integer;var av:double;var vx,vy:array of double) : Boolean;
var
   m,dn,lx,ly,nn,i : integer ;
begin
   Result := False;
   lx := Length(vx) ;
   ly := Length(vy) ;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dSplN) then exit;    // vfIndex`FbN
      with dSpl[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         ltp:= Ltype ;
         wid:= line_width ;
         stp:= Stype ;
         av := Aval ;
         oc := open_close ;
         sp := sep ;
         num:= Number ;
         if (lx > 0)and(ly > 0) then begin
            nn := num ;
            if (nn > lx) then nn := lx ;  // G[̒
            if (nn > ly) then nn := ly ;
            try
               for i:=0 to nn-1 do begin
                  vx[i] := X[i];
                  vy[i] := Y[i];
               end;
            except
               ;
            end;
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mSplN) then exit;    // vfIndex`FbN
            with mSpl[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               stp:= Stype ;
               av := Aval ;
               oc := open_close ;
               sp := sep ;
               num:= Number ;
               if (lx > 0)and(ly > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  if (nn > ly) then nn := ly ;
                  try
                     for i:=0 to nn-1 do begin
                        vx[i] := X[i];
                        vy[i] := Y[i];
                     end;
                  except
                     ;
                  end;
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mSplN) then exit;    // vfIndex`FbN
            with mSpl[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               stp:= Stype ;
               av := Aval ;
               oc := open_close ;
               sp := sep ;
               num:= Number ;
               if (lx > 0)and(ly > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  if (nn > ly) then nn := ly ;
                  try
                     for i:=0 to nn-1 do begin
                        vx[i] := X[i];
                        vy[i] := Y[i];
                     end;
                  except
                     ;
                  end;
               end;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// N\ChȐ@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : N\ChȐ  vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    dir: @(0:v,1:v)
//@@sp : 
//    bx : zu_wW
//    by : zu_xW
//    av : p[^@N\Cĥ`l(0)
//    an : ]p[]
//    l1 : JnȐ (0ȏ) ȐƂĂ̓}CiXl\łSXFdl0ȏƌ܂Ă̂Ő
//    l2 : IȐ (0ȏ)
// (ret) True:OK@False:NG
function TDataClass.GetDataClothoid(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,dir,sp:integer;var bx,by,av,an,l1,l2:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dCloN) then exit;    // vfIndex`FbN
      with dClo[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         ltp:= Ltype ;
         wid:= line_width ;
         bx := base_x ;
         by := base_y ;
         av := Aval ;
         dir:= Direction ;
         an := Angle ;
         l1 := start_length ;
         l2 := end_length ;
         sp := sep ;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mCloN) then exit;    // vfIndex`FbN
            with mClo[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               bx := base_x ;
               by := base_y ;
               av := Aval ;
               dir:= Direction ;
               an := Angle ;
               l1 := start_length ;
               l2 := end_length ;
               sp := sep ;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mCloN) then exit;    // vfIndex`FbN
            with mClo[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               bx := base_x ;
               by := base_y ;
               av := Aval ;
               dir:= Direction ;
               an := Angle ;
               l1 := start_length ;
               l2 := end_length ;
               sp := sep ;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// @f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  :             vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    col: F(0,1-256)
//    ac : R[h(1:blanked arrow 2:blanked box 3:blanked dot
//                    4:dimension origin 5:filled box 6:filled arrow
//                    7:filled dot 8:integral symbol 9:open arrow
//                   10:slash 11:unfilled arrow)
//    px : zu_X
//    py : zu_Y
//    an : ]p[]
//    sc : ړx
// (ret) True:OK@False:NG
function TDataClass.GetDataArrow(s:string;n:integer;var ex:Boolean;var lay,col,ac:integer;var px,py,an,sc:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dArwN) then exit;    // vfIndex`FbN
      with dArw[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         px := start_x ;
         py := start_y ;
         ac := arrow_code ;
         an := rotate_angle ;
         sc := Scale ;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mArwN) then exit;    // vfIndex`FbN
            with mArw[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               px := start_x ;
               py := start_y ;
               ac := arrow_code ;
               an := rotate_angle ;
               sc := Scale ;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mArwN) then exit;    // vfIndex`FbN
            with mArw[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               px := start_x ;
               py := start_y ;
               ac := arrow_code ;
               an := rotate_angle ;
               sc := Scale ;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// 摜@f[^ڂ̎擾
//    (s : p֒ǉi\Lvf)j
//    n  : 摜            vfIndex (0-)
//    ex : ݃tO
//    fn : 摜t@C
//    lay: C(1-256)
//    al : At@l(0`255)
//    px : zu_X
//    py : zu_Y
//    sx : wTCY
//    sy : xTCY
//    an : ]p[]
// (ret) True:OK@False:NG
function TDataClass.GetDataImage(n:integer;fn:string;var ex:Boolean;var lay,al:integer;var px,py,sx,sy,an:double) : Boolean;
begin
   Result := False;

   if (n < 0)or(n >= dImgN) then exit;    // vfIndex`FbN
   with dImg[n] do begin
      ex := exf ;
      lay:= Layer ;
      al := Alpha ;
      px := start_x ;
      py := start_y ;
      sx := size_x ;
      sy := size_y ;
      an := Angle ;
      fn := ImgFileName ;
   end;
   Result := True ;
end;

// ́@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  :             vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    bp : _(1:,2:,3:E,4:,5:,6:E,7:,8:,9:E)
//    dir: (1,2)
//    px : zu_X
//    py : zu_Y
//    pd : sNZmmϊ䗦(W72)
//    pw : ͔͈͕
//    ps : Ԋu
//    pl : sԊu
//    an : ]p
//    st : 
// (ret) True:OK@False:NG
function TDataClass.GetDataDocument(s:string;n:integer;var ex:Boolean;var lay,bp,dir:integer;var px,py,pd,pw,ps,pl,an:double;var st:string) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dDocN) then exit;    // vfIndex`FbN
      with dDoc[n] do begin
         ex := exf ;
         lay:= Layer ;
         st := str ;
         px := text_x ;
         py := text_y ;
         pd := Dpi ;
         pw := Width ;
         ps := Spc ;
         pl := LSpc ;
         an := Angle ;
         bp := b_pnt ;
         dir:= Direct ;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mDocN) then exit;    // vfIndex`FbN
            with mDoc[n] do begin
               ex := exf ;
               lay:= Layer ;
               st := str ;
               px := text_x ;
               py := text_y ;
               pd := Dpi ;
               pw := Width ;
               ps := Spc ;
               pl := LSpc ;
               an := Angle ;
               bp := b_pnt ;
               dir:= Direct ;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mDocN) then exit;    // vfIndex`FbN
            with mDoc[n] do begin
               ex := exf ;
               lay:= Layer ;
               st := str ;
               px := text_x ;
               py := text_y ;
               pd := Dpi ;
               pw := Width ;
               ps := Spc ;
               pl := LSpc ;
               an := Angle ;
               bp := b_pnt ;
               dir:= Direct ;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// \@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : \              vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    bp : _(1:,2:,3:E,4:,5:,6:E,7:,8:,9:E)
//    co1: 
//    ro1: s
//    co2: Œ
//    ro2: Œs
//    lco: r̐F@(0:CF@ 1`256)
//    llt: r̐(0:C 1`32)
//    lwd: r̐(0:C 1`16)
//    cc1: ZhאF(0:CF@ 1`256)
//    fl1: Z̓hׂ̗L(0:A1:L)
//    cc2: ŒZhאF(0:CF@1`256)
//    fl2: ŒZ̓hׂ̗L(0:A1:L)
//    tco: ̐F (0:CF@ 1`256)
//    fnt: tHg (0:CtHg 1`1024)
//    px : zu_X
//    py : zu_Y
//    pg : rƕ̊Ԃ̊Ԋu
//    ps : Ԋu
//    cw :                      ĂяoœIzmۂsĂ鎖  nil ̏ꍇ͎擾Ȃ
//    rh : s                   ĂяoœIzmۂsĂ鎖  nil ̏ꍇ͎擾Ȃ
//    al : ʒu(1: 2: 3:E) ĂяoœIzmۂsĂ鎖  nil ̏ꍇ͎擾Ȃ
//    st :                    ĂяoœIzmۂsĂ鎖  nil ̏ꍇ͎擾Ȃ
//    ca : vZ                   ĂяoœIzmۂsĂ鎖  nil ̏ꍇ͎擾Ȃ
// (ret) True:OK@False:NG
function TDataClass.GetDataTable(s:string;n:integer;var ex:Boolean;var lay,bp,co1,ro1,co2,ro2,lco,llt,lwd,cc1,fl1,cc2,fl2,tco,fnt:integer;var px,py,pg,ps:double;var cw,rh:array of double;var al:array of Integer;var st,ca:TStrGrid) : Boolean;
var
   m,dn,a1,a2,a3,a4,a5,i,j : integer ;
begin
   Result := False;
   a1 := Length(cw) ;
   a2 := Length(rh) ;
   a3 := Length(al) ;
   a4 := Length(st) ;
   a5 := Length(ca) ;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dTblN) then exit;    // vfIndex`FbN
      with dTbl[n] do begin
         ex := exf ;
         lay:= Layer ;
         px := start_x ;
         py := start_y ;
         bp := b_pnt ;
         co1:= Cols ;
         ro1:= Rows ;
         co2:= FixCols ;
         ro2:= FixRows ;
         pg := Gap ;
         lco:= line_color ;
         llt:= line_ltype ;
         lwd:= line_width ;
         cc1:= cell_color1 ;
         fl1:= flg1 ;
         cc2:= cell_color2 ;
         fl2:= flg2 ;
         tco:= text_color ;
         fnt:= Font ;
         ps := Spc ;
         if (a1 > 0)and(a2 > 0)and(a3 > 0)and(a4 > 0)and(a5 > 0) then begin
            try
               for i:=0 to co1-1 do
                  cw[i] := ColWidth[i] ;
               for j:=0 to ro1-1 do
                  rh[j] := RowHeight[j] ;
               for i:=0 to co1-1 do
                  al[i] := align[i] ;
               for j:=0 to ro1-1 do
                  for i:=0 to co1-1 do begin
                     st[i,j] := str[i,j] ;
                     ca[i,j] := calc[i,j] ;
                  end;
            except
               ;
            end;
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mTblN) then exit;    // vfIndex`FbN
            with mTbl[n] do begin
               ex := exf ;
               lay:= Layer ;
               px := start_x ;
               py := start_y ;
               bp := b_pnt ;
               co1:= Cols ;
               ro1:= Rows ;
               co2:= FixCols ;
               ro2:= FixRows ;
               pg := Gap ;
               lco:= line_color ;
               llt:= line_ltype ;
               lwd:= line_width ;
               cc1:= cell_color1 ;
               fl1:= flg1 ;
               cc2:= cell_color2 ;
               fl2:= flg2 ;
               tco:= text_color ;
               fnt:= Font ;
               ps := Spc ;
               if (a1 > 0)and(a2 > 0)and(a3 > 0)and(a4 > 0)and(a5 > 0) then begin
                  try
                     for i:=0 to co1-1 do
                        cw[i] := ColWidth[i] ;
                     for j:=0 to ro1-1 do
                        rh[j] := RowHeight[j] ;
                     for i:=0 to co1-1 do
                        al[i] := align[i] ;
                     for j:=0 to ro1-1 do
                        for i:=0 to co1-1 do begin
                           st[i,j] := str[i,j] ;
                           ca[i,j] := calc[i,j] ;
                        end;
                  except
                     ;
                  end;
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mTblN) then exit;    // vfIndex`FbN
            with mTbl[n] do begin
               ex := exf ;
               lay:= Layer ;
               px := start_x ;
               py := start_y ;
               bp := b_pnt ;
               co1:= Cols ;
               ro1:= Rows ;
               co2:= FixCols ;
               ro2:= FixRows ;
               pg := Gap ;
               lco:= line_color ;
               llt:= line_ltype ;
               lwd:= line_width ;
               cc1:= cell_color1 ;
               fl1:= flg1 ;
               cc2:= cell_color2 ;
               fl2:= flg2 ;
               tco:= text_color ;
               fnt:= Font ;
               ps := Spc ;
               if (a1 > 0)and(a2 > 0)and(a3 > 0)and(a4 > 0)and(a5 > 0) then begin
                  try
                     for i:=0 to co1-1 do
                        cw[i] := ColWidth[i] ;
                     for j:=0 to ro1-1 do
                        rh[j] := RowHeight[j] ;
                     for i:=0 to co1-1 do
                        al[i] := align[i] ;
                     for j:=0 to ro1-1 do
                        for i:=0 to co1-1 do begin
                           st[i,j] := str[i,j] ;
                           ca[i,j] := calc[i,j] ;
                        end;
                  except
                     ;
                  end;
               end;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// @@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : @        vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.GetDataDimLine(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;var sx1,sy1,sx2,sy2, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double;var st:string) : Boolean ;
var
   m,dn : integer ;
begin
   Result := False;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dDLnN) then exit;    // vfIndex`FbN
      with dDLn[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         ltp:= Ltype ;
         wid:= line_width ;
         sx1:= sun_x1 ;
         sy1:= sun_y1 ;
         sx2:= sun_x2 ;
         sy2:= sun_y2 ;
         f2    := flg2 ;
         h1x0  := ho1_x0 ;
         h1y0  := ho1_y0 ;
         h1x1  := ho1_x1 ;
         h1y1  := ho1_y1 ;
         h1x2  := ho1_x2 ;
         h1y2  := ho1_y2 ;
         f3    := flg3 ;
         h2x0  := ho2_x0 ;
         h2y0  := ho2_y0 ;
         h2x1  := ho2_x1 ;
         h2y1  := ho2_y1 ;
         h2x2  := ho2_x2 ;
         h2y2  := ho2_y2 ;
         ar11  := arr1_code1 ;
         ar12  := arr1_code2 ;
         ar1x  := arr1_x ;
         ar1y  := arr1_y ;
         ar1r  := arr1_r ;
         ar21  := arr2_code1 ;
         ar22  := arr2_code2 ;
         ar2x  := arr2_x ;
         ar2y  := arr2_y ;
         ar2r  := arr2_r ;
         f4    := flg4 ;
         fnt:= Font ;
         st := str ;
         tx := text_x ;
         ty := text_y ;
         th := Height ;
         tw := Width ;
         ts := Spc ;
         an := Angle ;
         sl := Slant ;
         bp := b_pnt ;
         dir:= Direct ;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mDLnN) then exit;    // vfIndex`FbN
            with mDLn[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               sx1:= sun_x1 ;
               sy1:= sun_y1 ;
               sx2:= sun_x2 ;
               sy2:= sun_y2 ;
               f2    := flg2 ;
               h1x0  := ho1_x0 ;
               h1y0  := ho1_y0 ;
               h1x1  := ho1_x1 ;
               h1y1  := ho1_y1 ;
               h1x2  := ho1_x2 ;
               h1y2  := ho1_y2 ;
               f3    := flg3 ;
               h2x0  := ho2_x0 ;
               h2y0  := ho2_y0 ;
               h2x1  := ho2_x1 ;
               h2y1  := ho2_y1 ;
               h2x2  := ho2_x2 ;
               h2y2  := ho2_y2 ;
               ar11  := arr1_code1 ;
               ar12  := arr1_code2 ;
               ar1x  := arr1_x ;
               ar1y  := arr1_y ;
               ar1r  := arr1_r ;
               ar21  := arr2_code1 ;
               ar22  := arr2_code2 ;
               ar2x  := arr2_x ;
               ar2y  := arr2_y ;
               ar2r  := arr2_r ;
               f4    := flg4 ;
               fnt:= Font ;
               st := str ;
               tx := text_x ;
               ty := text_y ;
               th := Height ;
               tw := Width ;
               ts := Spc ;
               an := Angle ;
               sl := Slant ;
               bp := b_pnt ;
               dir:= Direct ;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mDLnN) then exit;    // vfIndex`FbN
            with mDLn[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               sx1:= sun_x1 ;
               sy1:= sun_y1 ;
               sx2:= sun_x2 ;
               sy2:= sun_y2 ;
               f2    := flg2 ;
               h1x0  := ho1_x0 ;
               h1y0  := ho1_y0 ;
               h1x1  := ho1_x1 ;
               h1y1  := ho1_y1 ;
               h1x2  := ho1_x2 ;
               h1y2  := ho1_y2 ;
               f3    := flg3 ;
               h2x0  := ho2_x0 ;
               h2y0  := ho2_y0 ;
               h2x1  := ho2_x1 ;
               h2y1  := ho2_y1 ;
               h2x2  := ho2_x2 ;
               h2y2  := ho2_y2 ;
               ar11  := arr1_code1 ;
               ar12  := arr1_code2 ;
               ar1x  := arr1_x ;
               ar1y  := arr1_y ;
               ar1r  := arr1_r ;
               ar21  := arr2_code1 ;
               ar22  := arr2_code2 ;
               ar2x  := arr2_x ;
               ar2y  := arr2_y ;
               ar2r  := arr2_r ;
               f4    := flg4 ;
               fnt:= Font ;
               st := str ;
               tx := text_x ;
               ty := text_y ;
               th := Height ;
               tw := Width ;
               ts := Spc ;
               an := Angle ;
               sl := Slant ;
               bp := b_pnt ;
               dir:= Direct ;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// ʒ@@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : ʒ@        vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.GetDataDimArc(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,sp,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;var sx,sy,sr,sa0,sa1, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double;var st:string) : Boolean ;
var
   m,dn : integer ;
begin
   Result := False;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dDArN) then exit;    // vfIndex`FbN
      with dDAr[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         ltp:= Ltype ;
         wid:= line_width ;
         sp := sep ;
         sx := sun_x ;
         sy := sun_y ;
         sr := sun_radius ;
         sa0:= sun_angle0 ;
         sa1:= sun_angle1 ;
         f2    := flg2 ;
         h1x0  := ho1_x0 ;
         h1y0  := ho1_y0 ;
         h1x1  := ho1_x1 ;
         h1y1  := ho1_y1 ;
         h1x2  := ho1_x2 ;
         h1y2  := ho1_y2 ;
         f3    := flg3 ;
         h2x0  := ho2_x0 ;
         h2y0  := ho2_y0 ;
         h2x1  := ho2_x1 ;
         h2y1  := ho2_y1 ;
         h2x2  := ho2_x2 ;
         h2y2  := ho2_y2 ;
         ar11  := arr1_code1 ;
         ar12  := arr1_code2 ;
         ar1x  := arr1_x ;
         ar1y  := arr1_y ;
         ar1r  := arr1_r ;
         ar21  := arr2_code1 ;
         ar22  := arr2_code2 ;
         ar2x  := arr2_x ;
         ar2y  := arr2_y ;
         ar2r  := arr2_r ;
         f4    := flg4 ;
         fnt:= Font ;
         st := str ;
         tx := text_x ;
         ty := text_y ;
         th := Height ;
         tw := Width ;
         ts := Spc ;
         an := Angle ;
         sl := Slant ;
         bp := b_pnt ;
         dir:= Direct ;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mDArN) then exit;    // vfIndex`FbN
            with mDAr[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               sp := sep ;
               sx := sun_x ;
               sy := sun_y ;
               sr := sun_radius ;
               sa0:= sun_angle0 ;
               sa1:= sun_angle1 ;
               f2    := flg2 ;
               h1x0  := ho1_x0 ;
               h1y0  := ho1_y0 ;
               h1x1  := ho1_x1 ;
               h1y1  := ho1_y1 ;
               h1x2  := ho1_x2 ;
               h1y2  := ho1_y2 ;
               f3    := flg3 ;
               h2x0  := ho2_x0 ;
               h2y0  := ho2_y0 ;
               h2x1  := ho2_x1 ;
               h2y1  := ho2_y1 ;
               h2x2  := ho2_x2 ;
               h2y2  := ho2_y2 ;
               ar11  := arr1_code1 ;
               ar12  := arr1_code2 ;
               ar1x  := arr1_x ;
               ar1y  := arr1_y ;
               ar1r  := arr1_r ;
               ar21  := arr2_code1 ;
               ar22  := arr2_code2 ;
               ar2x  := arr2_x ;
               ar2y  := arr2_y ;
               ar2r  := arr2_r ;
               f4    := flg4 ;
               fnt:= Font ;
               st := str ;
               tx := text_x ;
               ty := text_y ;
               th := Height ;
               tw := Width ;
               ts := Spc ;
               an := Angle ;
               sl := Slant ;
               bp := b_pnt ;
               dir:= Direct ;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mDArN) then exit;    // vfIndex`FbN
            with mDAr[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               sp := sep ;
               sx := sun_x ;
               sy := sun_y ;
               sr := sun_radius ;
               sa0:= sun_angle0 ;
               sa1:= sun_angle1 ;
               f2    := flg2 ;
               h1x0  := ho1_x0 ;
               h1y0  := ho1_y0 ;
               h1x1  := ho1_x1 ;
               h1y1  := ho1_y1 ;
               h1x2  := ho1_x2 ;
               h1y2  := ho1_y2 ;
               f3    := flg3 ;
               h2x0  := ho2_x0 ;
               h2y0  := ho2_y0 ;
               h2x1  := ho2_x1 ;
               h2y1  := ho2_y1 ;
               h2x2  := ho2_x2 ;
               h2y2  := ho2_y2 ;
               ar11  := arr1_code1 ;
               ar12  := arr1_code2 ;
               ar1x  := arr1_x ;
               ar1y  := arr1_y ;
               ar1r  := arr1_r ;
               ar21  := arr2_code1 ;
               ar22  := arr2_code2 ;
               ar2x  := arr2_x ;
               ar2y  := arr2_y ;
               ar2r  := arr2_r ;
               f4    := flg4 ;
               fnt:= Font ;
               st := str ;
               tx := text_x ;
               ty := text_y ;
               th := Height ;
               tw := Width ;
               ts := Spc ;
               an := Angle ;
               sl := Slant ;
               bp := b_pnt ;
               dir:= Direct ;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// px@@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : px@        vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.GetDataDimAngle(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,sp,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;var sx,sy,sr,sa0,sa1, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double;var st:string) : Boolean ;
var
   m,dn : integer ;
begin
   Result := False;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dDAnN) then exit;    // vfIndex`FbN
      with dDAn[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         ltp:= Ltype ;
         wid:= line_width ;
         sp := sep ;
         sx := sun_x ;
         sy := sun_y ;
         sr := sun_radius ;
         sa0:= sun_angle0 ;
         sa1:= sun_angle1 ;
         f2    := flg2 ;
         h1x0  := ho1_x0 ;
         h1y0  := ho1_y0 ;
         h1x1  := ho1_x1 ;
         h1y1  := ho1_y1 ;
         h1x2  := ho1_x2 ;
         h1y2  := ho1_y2 ;
         f3    := flg3 ;
         h2x0  := ho2_x0 ;
         h2y0  := ho2_y0 ;
         h2x1  := ho2_x1 ;
         h2y1  := ho2_y1 ;
         h2x2  := ho2_x2 ;
         h2y2  := ho2_y2 ;
         ar11  := arr1_code1 ;
         ar12  := arr1_code2 ;
         ar1x  := arr1_x ;
         ar1y  := arr1_y ;
         ar1r  := arr1_r ;
         ar21  := arr2_code1 ;
         ar22  := arr2_code2 ;
         ar2x  := arr2_x ;
         ar2y  := arr2_y ;
         ar2r  := arr2_r ;
         f4    := flg4 ;
         fnt:= Font ;
         st := str ;
         tx := text_x ;
         ty := text_y ;
         th := Height ;
         tw := Width ;
         ts := Spc ;
         an := Angle ;
         sl := Slant ;
         bp := b_pnt ;
         dir:= Direct ;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mDAnN) then exit;    // vfIndex`FbN
            with mDAn[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               sp := sep ;
               sx := sun_x ;
               sy := sun_y ;
               sr := sun_radius ;
               sa0:= sun_angle0 ;
               sa1:= sun_angle1 ;
               f2    := flg2 ;
               h1x0  := ho1_x0 ;
               h1y0  := ho1_y0 ;
               h1x1  := ho1_x1 ;
               h1y1  := ho1_y1 ;
               h1x2  := ho1_x2 ;
               h1y2  := ho1_y2 ;
               f3    := flg3 ;
               h2x0  := ho2_x0 ;
               h2y0  := ho2_y0 ;
               h2x1  := ho2_x1 ;
               h2y1  := ho2_y1 ;
               h2x2  := ho2_x2 ;
               h2y2  := ho2_y2 ;
               ar11  := arr1_code1 ;
               ar12  := arr1_code2 ;
               ar1x  := arr1_x ;
               ar1y  := arr1_y ;
               ar1r  := arr1_r ;
               ar21  := arr2_code1 ;
               ar22  := arr2_code2 ;
               ar2x  := arr2_x ;
               ar2y  := arr2_y ;
               ar2r  := arr2_r ;
               f4    := flg4 ;
               fnt:= Font ;
               st := str ;
               tx := text_x ;
               ty := text_y ;
               th := Height ;
               tw := Width ;
               ts := Spc ;
               an := Angle ;
               sl := Slant ;
               bp := b_pnt ;
               dir:= Direct ;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mDAnN) then exit;    // vfIndex`FbN
            with mDAn[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               sp := sep ;
               sx := sun_x ;
               sy := sun_y ;
               sr := sun_radius ;
               sa0:= sun_angle0 ;
               sa1:= sun_angle1 ;
               f2    := flg2 ;
               h1x0  := ho1_x0 ;
               h1y0  := ho1_y0 ;
               h1x1  := ho1_x1 ;
               h1y1  := ho1_y1 ;
               h1x2  := ho1_x2 ;
               h1y2  := ho1_y2 ;
               f3    := flg3 ;
               h2x0  := ho2_x0 ;
               h2y0  := ho2_y0 ;
               h2x1  := ho2_x1 ;
               h2y1  := ho2_y1 ;
               h2x2  := ho2_x2 ;
               h2y2  := ho2_y2 ;
               ar11  := arr1_code1 ;
               ar12  := arr1_code2 ;
               ar1x  := arr1_x ;
               ar1y  := arr1_y ;
               ar1r  := arr1_r ;
               ar21  := arr2_code1 ;
               ar22  := arr2_code2 ;
               ar2x  := arr2_x ;
               ar2y  := arr2_y ;
               ar2r  := arr2_r ;
               f4    := flg4 ;
               fnt:= Font ;
               st := str ;
               tx := text_x ;
               ty := text_y ;
               th := Height ;
               tw := Width ;
               ts := Spc ;
               an := Angle ;
               sl := Slant ;
               bp := b_pnt ;
               dir:= Direct ;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// a@@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : a@        vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.GetDataDimRadius(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,fl,ar1,ar2,fnt,bp,dir:integer;var sx1,sy1,sx2,sy2, arx,ary,arr, tx,ty,th,tw,ts,an,sl:double;var st:string) : Boolean ;
var
   m,dn : integer ;
begin
   Result := False;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dDRaN) then exit;    // vfIndex`FbN
      with dDRa[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         ltp:= Ltype ;
         wid:= line_width ;
         sx1:= sun_x1 ;
         sy1:= sun_y1 ;
         sx2:= sun_x2 ;
         sy2:= sun_y2 ;
         ar1:= arr_code1 ;
         ar2:= arr_code2 ;
         arx:= arr_x ;
         ary:= arr_y ;
         arr:= arr_r ;
         fl := flg ;
         fnt:= Font ;
         st := str ;
         tx := text_x ;
         ty := text_y ;
         th := Height ;
         tw := Width ;
         ts := Spc ;
         an := Angle ;
         sl := Slant ;
         bp := b_pnt ;
         dir:= Direct ;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mDRaN) then exit;    // vfIndex`FbN
            with mDRa[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               sx1:= sun_x1 ;
               sy1:= sun_y1 ;
               sx2:= sun_x2 ;
               sy2:= sun_y2 ;
               ar1:= arr_code1 ;
               ar2:= arr_code2 ;
               arx:= arr_x ;
               ary:= arr_y ;
               arr:= arr_r ;
               fl := flg ;
               fnt:= Font ;
               st := str ;
               tx := text_x ;
               ty := text_y ;
               th := Height ;
               tw := Width ;
               ts := Spc ;
               an := Angle ;
               sl := Slant ;
               bp := b_pnt ;
               dir:= Direct ;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mDRaN) then exit;    // vfIndex`FbN
            with mDRa[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               sx1:= sun_x1 ;
               sy1:= sun_y1 ;
               sx2:= sun_x2 ;
               sy2:= sun_y2 ;
               ar1:= arr_code1 ;
               ar2:= arr_code2 ;
               arx:= arr_x ;
               ary:= arr_y ;
               arr:= arr_r ;
               fl := flg ;
               fnt:= Font ;
               st := str ;
               tx := text_x ;
               ty := text_y ;
               th := Height ;
               tw := Width ;
               ts := Spc ;
               an := Angle ;
               sl := Slant ;
               bp := b_pnt ;
               dir:= Direct ;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// a@@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : a@        vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.GetDataDimDiameter(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,fl,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;var sx1,sy1,sx2,sy2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double;var st:string) : Boolean ;
var
   m,dn : integer ;
begin
   Result := False;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dDDiN) then exit;    // vfIndex`FbN
      with dDDi[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         ltp:= Ltype ;
         wid:= line_width ;
         sx1:= sun_x1 ;
         sy1:= sun_y1 ;
         sx2:= sun_x2 ;
         sy2:= sun_y2 ;
         ar11  := arr1_code1 ;
         ar12  := arr1_code2 ;
         ar1x  := arr1_x ;
         ar1y  := arr1_y ;
         ar1r  := arr1_r ;
         ar21  := arr2_code1 ;
         ar22  := arr2_code2 ;
         ar2x  := arr2_x ;
         ar2y  := arr2_y ;
         ar2r  := arr2_r ;
         fl := flg ;
         fnt:= Font ;
         st := str ;
         tx := text_x ;
         ty := text_y ;
         th := Height ;
         tw := Width ;
         ts := Spc ;
         an := Angle ;
         sl := Slant ;
         bp := b_pnt ;
         dir:= Direct ;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mDDiN) then exit;    // vfIndex`FbN
            with mDDi[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               sx1:= sun_x1 ;
               sy1:= sun_y1 ;
               sx2:= sun_x2 ;
               sy2:= sun_y2 ;
               ar11  := arr1_code1 ;
               ar12  := arr1_code2 ;
               ar1x  := arr1_x ;
               ar1y  := arr1_y ;
               ar1r  := arr1_r ;
               ar21  := arr2_code1 ;
               ar22  := arr2_code2 ;
               ar2x  := arr2_x ;
               ar2y  := arr2_y ;
               ar2r  := arr2_r ;
               fl := flg ;
               fnt:= Font ;
               st := str ;
               tx := text_x ;
               ty := text_y ;
               th := Height ;
               tw := Width ;
               ts := Spc ;
               an := Angle ;
               sl := Slant ;
               bp := b_pnt ;
               dir:= Direct ;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mDDiN) then exit;    // vfIndex`FbN
            with mDDi[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               sx1:= sun_x1 ;
               sy1:= sun_y1 ;
               sx2:= sun_x2 ;
               sy2:= sun_y2 ;
               ar11  := arr1_code1 ;
               ar12  := arr1_code2 ;
               ar1x  := arr1_x ;
               ar1y  := arr1_y ;
               ar1r  := arr1_r ;
               ar21  := arr2_code1 ;
               ar22  := arr2_code2 ;
               ar2x  := arr2_x ;
               ar2y  := arr2_y ;
               ar2r  := arr2_r ;
               fl := flg ;
               fnt:= Font ;
               st := str ;
               tx := text_x ;
               ty := text_y ;
               th := Height ;
               tw := Width ;
               ts := Spc ;
               an := Angle ;
               sl := Slant ;
               bp := b_pnt ;
               dir:= Direct ;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// o@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : o        vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.GetDataDimLeader(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,fl,num,ar,fnt,bp,dir:integer;var vx,vy:array of double;var arr, tx,ty,th,tw,ts,an,sl:double;var st:string) : Boolean ;
var
   m,dn,lx,ly,nn,i : integer ;
begin
   Result := False;
   lx := Length(vx) ;
   ly := Length(vy) ;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dDLeN) then exit;    // vfIndex`FbN
      with dDLe[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         ltp:= Ltype ;
         wid:= line_width ;
         num:= vertex_number ;
         if (lx > 0)and(ly > 0) then begin
            nn := num ;
            if (nn > lx) then nn := lx ;  // G[̒
            if (nn > ly) then nn := ly ;
            try
               for i:=0 to nn-1 do begin
                  vx[i] := vertex_x[i];
                  vy[i] := vertex_y[i];
               end;
            except
               ;
            end;
         end;
         ar := arr_code ;
         arr:= arr_r ;
         fl := flg ;
         fnt:= Font ;
         st := str ;
         tx := text_x ;
         ty := text_y ;
         th := Height ;
         tw := Width ;
         ts := Spc ;
         an := Angle ;
         sl := Slant ;
         bp := b_pnt ;
         dir:= Direct ;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mDLeN) then exit;    // vfIndex`FbN
            with mDLe[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               num:= vertex_number ;
               if (lx > 0)and(ly > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  if (nn > ly) then nn := ly ;
                  try
                     for i:=0 to nn-1 do begin
                        vx[i] := vertex_x[i];
                        vy[i] := vertex_y[i];
                     end;
                  except
                     ;
                  end;
               end;
               ar := arr_code ;
               arr:= arr_r ;
               fl := flg ;
               fnt:= Font ;
               st := str ;
               tx := text_x ;
               ty := text_y ;
               th := Height ;
               tw := Width ;
               ts := Spc ;
               an := Angle ;
               sl := Slant ;
               bp := b_pnt ;
               dir:= Direct ;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mDLeN) then exit;    // vfIndex`FbN
            with mDLe[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               num:= vertex_number ;
               if (lx > 0)and(ly > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  if (nn > ly) then nn := ly ;
                  try
                     for i:=0 to nn-1 do begin
                        vx[i] := vertex_x[i];
                        vy[i] := vertex_y[i];
                     end;
                  except
                     ;
                  end;
               end;
               ar := arr_code ;
               arr:= arr_r ;
               fl := flg ;
               fnt:= Font ;
               st := str ;
               tx := text_x ;
               ty := text_y ;
               th := Height ;
               tw := Width ;
               ts := Spc ;
               an := Angle ;
               sl := Slant ;
               bp := b_pnt ;
               dir:= Direct ;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// o[@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : o[        vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.GetDataDimBalloon(s:string;n:integer;var ex:Boolean;var lay,col,ltp,wid,sp,fl,num,ar,fnt,bp,dir:integer;var vx,vy:array of double;var cx,cy,cr,arr, tx,ty,th,tw,ts,an,sl:double;var st:string) : Boolean ;
var
   m,dn,lx,ly,nn,i : integer ;
begin
   Result := False;
   lx := Length(vx) ;
   ly := Length(vy) ;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dDBaN) then exit;    // vfIndex`FbN
      with dDBa[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         ltp:= Ltype ;
         wid:= line_width ;
         sp := sep ;
         num:= vertex_number ;
         if (lx > 0)and(ly > 0) then begin
            nn := num ;
            if (nn > lx) then nn := lx ;  // G[̒
            if (nn > ly) then nn := ly ;
            try
               for i:=0 to nn-1 do begin
                  vx[i] := vertex_x[i];
                  vy[i] := vertex_y[i];
               end;
            except
               ;
            end;
         end;
         cx := center_x ;
         cy := center_y ;
         cr := Radius ;
         ar := arr_code ;
         arr:= arr_r ;
         fl := flg ;
         fnt:= Font ;
         st := str ;
         tx := text_x ;
         ty := text_y ;
         th := Height ;
         tw := Width ;
         ts := Spc ;
         an := Angle ;
         sl := Slant ;
         bp := b_pnt ;
         dir:= Direct ;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mDBaN) then exit;    // vfIndex`FbN
            with mDBa[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               sp := sep ;
               num:= vertex_number ;
               if (lx > 0)and(ly > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  if (nn > ly) then nn := ly ;
                  try
                     for i:=0 to nn-1 do begin
                        vx[i] := vertex_x[i];
                        vy[i] := vertex_y[i];
                     end;
                  except
                     ;
                  end;
               end;
               cx := center_x ;
               cy := center_y ;
               cr := Radius ;
               ar := arr_code ;
               arr:= arr_r ;
               fl := flg ;
               fnt:= Font ;
               st := str ;
               tx := text_x ;
               ty := text_y ;
               th := Height ;
               tw := Width ;
               ts := Spc ;
               an := Angle ;
               sl := Slant ;
               bp := b_pnt ;
               dir:= Direct ;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mDBaN) then exit;    // vfIndex`FbN
            with mDBa[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               ltp:= Ltype ;
               wid:= line_width ;
               sp := sep ;
               num:= vertex_number ;
               if (lx > 0)and(ly > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  if (nn > ly) then nn := ly ;
                  try
                     for i:=0 to nn-1 do begin
                        vx[i] := vertex_x[i];
                        vy[i] := vertex_y[i];
                     end;
                  except
                     ;
                  end;
               end;
               cx := center_x ;
               cy := center_y ;
               cr := Radius ;
               ar := arr_code ;
               arr:= arr_r ;
               fl := flg ;
               fnt:= Font ;
               st := str ;
               tx := text_x ;
               ty := text_y ;
               th := Height ;
               tw := Width ;
               ts := Spc ;
               an := Angle ;
               sl := Slant ;
               bp := b_pnt ;
               dir:= Direct ;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// nb`O(`)@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : nb`O(`)      vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.GetDataHatch1(s:string;n:integer;var ex:Boolean;var lay,col,oid,num:integer;var iid:array of integer;var st:string) : Boolean ;
var
   m,dn,lx,nn,i : integer ;
begin
   Result := False;
   DataClearHLn ;
   lx := Length(iid) ;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dHa1N) then exit;    // vfIndex`FbN
      with dHa1[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         st := name ;
         oid:= out_id ;
         num:= Number ;
         if (lx > 0) then begin
            nn := num ;
            if (nn > lx) then nn := lx ;  // G[̒
            try
               for i:=0 to nn-1 do begin
                  iid[i] := in_id[i];
               end;
            except
               ;
            end;
         end;
         // nb`OzHLn,zHLnN
         try
            zHLnN := hln ;
            SetLength(zHLn, hln);
            for i:=0 to hln-1 do begin
               zHLn[i].Color := hl[i].Color ;
               zHLn[i].Ltype := hl[i].Ltype ;
               zHLn[i].line_width := hl[i].line_width ;
               zHLn[i].x1 := hl[i].x1 ;
               zHLn[i].y1 := hl[i].y1 ;
               zHLn[i].x2 := hl[i].x2 ;
               zHLn[i].y2 := hl[i].y2 ;
            end;
         except
            DataClearHLn ;
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mHa1N) then exit;    // vfIndex`FbN
            with mHa1[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               st := name ;
               oid:= out_id ;
               num:= Number ;
               if (lx > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  try
                     for i:=0 to nn-1 do begin
                        iid[i] := in_id[i];
                     end;
                  except
                     ;
                  end;
               end;
               // nb`OzHLn,zHLnN
               try
                  zHLnN := hln ;
                  SetLength(zHLn, hln);
                  for i:=0 to hln-1 do begin
                     zHLn[i].Color := hl[i].Color ;
                     zHLn[i].Ltype := hl[i].Ltype ;
                     zHLn[i].line_width := hl[i].line_width ;
                     zHLn[i].x1 := hl[i].x1 ;
                     zHLn[i].y1 := hl[i].y1 ;
                     zHLn[i].x2 := hl[i].x2 ;
                     zHLn[i].y2 := hl[i].y2 ;
                  end;
               except
                  DataClearHLn ;
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mHa1N) then exit;    // vfIndex`FbN
            with mHa1[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               st := name ;
               oid:= out_id ;
               num:= Number ;
               if (lx > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  try
                     for i:=0 to nn-1 do begin
                        iid[i] := in_id[i];
                     end;
                  except
                     ;
                  end;
               end;
               // nb`OzHLn,zHLnN
               try
                  zHLnN := hln ;
                  SetLength(zHLn, hln);
                  for i:=0 to hln-1 do begin
                     zHLn[i].Color := hl[i].Color ;
                     zHLn[i].Ltype := hl[i].Ltype ;
                     zHLn[i].line_width := hl[i].line_width ;
                     zHLn[i].x1 := hl[i].x1 ;
                     zHLn[i].y1 := hl[i].y1 ;
                     zHLn[i].x2 := hl[i].x2 ;
                     zHLn[i].y2 := hl[i].y2 ;
                  end;
               except
                  DataClearHLn ;
               end;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// nb`O(h)@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : nb`O(h)        vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.GetDataHatch2(s:string;n:integer;var ex:Boolean;var lay,col,oid,num:integer;var iid:array of integer) : Boolean ;
var
   m,dn,lx,nn,i : integer ;
begin
   Result := False;
   lx := Length(iid) ;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dHa2N) then exit;    // vfIndex`FbN
      with dHa2[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         oid:= out_id ;
         num:= Number ;
         if (lx > 0) then begin
            nn := num ;
            if (nn > lx) then nn := lx ;  // G[̒
            try
               for i:=0 to nn-1 do begin
                  iid[i] := in_id[i];
               end;
            except
               ;
            end;
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mHa2N) then exit;    // vfIndex`FbN
            with mHa2[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               oid:= out_id ;
               num:= Number ;
               if (lx > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  try
                     for i:=0 to nn-1 do begin
                        iid[i] := in_id[i];
                     end;
                  except
                     ;
                  end;
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mHa2N) then exit;    // vfIndex`FbN
            with mHa2[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               oid:= out_id ;
               num:= Number ;
               if (lx > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  try
                     for i:=0 to nn-1 do begin
                        iid[i] := in_id[i];
                     end;
                  except
                     ;
                  end;
               end;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// nb`O([U`)@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : nb`O([U`)  vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.GetDataHatch3(s:string;n:integer;var ex:Boolean;var lay,hnum:integer;var hcol,hltp,hwid:array of integer;var hx,hy,hs,ha:array of double;var oid,num:integer;var iid:array of integer) : Boolean ;
var
   m,dn,lx,l1,l2,l3,l4,l5,l6,l7,nn,i : integer ;
begin
   Result := False;
   DataClearHLn ;
   lx := Length(iid) ;
   l1 := Length(hcol) ;
   l2 := Length(hltp) ;
   l3 := Length(hwid) ;
   l4 := Length(hx) ;
   l5 := Length(hy) ;
   l6 := Length(hs) ;
   l7 := Length(ha) ;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dHa3N) then exit;    // vfIndex`FbN
      with dHa3[n] do begin
         ex := exf ;
         lay:= Layer ;
         hnum := hatch1_number ;
         if (l1 > 0)and(l2 > 0)and(l3 > 0)and(l4 > 0)
         and(l5 > 0)and(l6 > 0)and(l7 > 0) then begin
            nn := hnum ;
            if (nn > l1) then nn := l1 ;  // G[̒
            if (nn > l2) then nn := l2 ;
            if (nn > l3) then nn := l3 ;
            if (nn > l4) then nn := l4 ;
            if (nn > l5) then nn := l5 ;
            if (nn > l6) then nn := l6 ;
            if (nn > l7) then nn := l7 ;
            try
               for i:=0 to nn-1 do begin
                  hcol[i] := hatch1_color[i] ;
                  hltp[i] := hatch_type[i] ;
                  hwid[i] := hatch_line_width[i] ;
                  hx[i] := hatch_start_x[i] ;
                  hy[i] := hatch_start_y[i] ;
                  hs[i] := hatch_spacing[i] ;
                  ha[i] := hatch_angle[i] ;
               end;
            except
               ;
            end;
         end;
         oid:= out_id ;
         num:= Number ;
         if (lx > 0) then begin
            nn := num ;
            if (nn > lx) then nn := lx ;  // G[̒
            try
               for i:=0 to nn-1 do begin
                  iid[i] := in_id[i];
               end;
            except
               ;
            end;
         end;
         // nb`OzHLn,zHLnN
         try
            zHLnN := hln ;
            SetLength(zHLn, hln);
            for i:=0 to hln-1 do begin
               zHLn[i].Color := hl[i].Color ;
               zHLn[i].Ltype := hl[i].Ltype ;
               zHLn[i].line_width := hl[i].line_width ;
               zHLn[i].x1 := hl[i].x1 ;
               zHLn[i].y1 := hl[i].y1 ;
               zHLn[i].x2 := hl[i].x2 ;
               zHLn[i].y2 := hl[i].y2 ;
            end;
         except
            DataClearHLn ;
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mHa3N) then exit;    // vfIndex`FbN
            with mHa3[n] do begin
               ex := exf ;
               lay:= Layer ;
               hnum := hatch1_number ;
               if (l1 > 0)and(l2 > 0)and(l3 > 0)and(l4 > 0)
               and(l5 > 0)and(l6 > 0)and(l7 > 0) then begin
                  nn := hnum ;
                  if (nn > l1) then nn := l1 ;  // G[̒
                  if (nn > l2) then nn := l2 ;
                  if (nn > l3) then nn := l3 ;
                  if (nn > l4) then nn := l4 ;
                  if (nn > l5) then nn := l5 ;
                  if (nn > l6) then nn := l6 ;
                  if (nn > l7) then nn := l7 ;
                  try
                     for i:=0 to nn-1 do begin
                        hcol[i] := hatch1_color[i] ;
                        hltp[i] := hatch_type[i] ;
                        hwid[i] := hatch_line_width[i] ;
                        hx[i] := hatch_start_x[i] ;
                        hy[i] := hatch_start_y[i] ;
                        hs[i] := hatch_spacing[i] ;
                        ha[i] := hatch_angle[i] ;
                     end;
                  except
                     ;
                  end;
               end;
               oid:= out_id ;
               num:= Number ;
               if (lx > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  try
                     for i:=0 to nn-1 do begin
                        iid[i] := in_id[i];
                     end;
                  except
                     ;
                  end;
               end;
               // nb`OzHLn,zHLnN
               try
                  zHLnN := hln ;
                  SetLength(zHLn, hln);
                  for i:=0 to hln-1 do begin
                     zHLn[i].Color := hl[i].Color ;
                     zHLn[i].Ltype := hl[i].Ltype ;
                     zHLn[i].line_width := hl[i].line_width ;
                     zHLn[i].x1 := hl[i].x1 ;
                     zHLn[i].y1 := hl[i].y1 ;
                     zHLn[i].x2 := hl[i].x2 ;
                     zHLn[i].y2 := hl[i].y2 ;
                  end;
               except
                  DataClearHLn ;
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mHa3N) then exit;    // vfIndex`FbN
            with mHa3[n] do begin
               ex := exf ;
               lay:= Layer ;
               hnum := hatch1_number ;
               if (l1 > 0)and(l2 > 0)and(l3 > 0)and(l4 > 0)
               and(l5 > 0)and(l6 > 0)and(l7 > 0) then begin
                  nn := hnum ;
                  if (nn > l1) then nn := l1 ;  // G[̒
                  if (nn > l2) then nn := l2 ;
                  if (nn > l3) then nn := l3 ;
                  if (nn > l4) then nn := l4 ;
                  if (nn > l5) then nn := l5 ;
                  if (nn > l6) then nn := l6 ;
                  if (nn > l7) then nn := l7 ;
                  try
                     for i:=0 to nn-1 do begin
                        hcol[i] := hatch1_color[i] ;
                        hltp[i] := hatch_type[i] ;
                        hwid[i] := hatch_line_width[i] ;
                        hx[i] := hatch_start_x[i] ;
                        hy[i] := hatch_start_y[i] ;
                        hs[i] := hatch_spacing[i] ;
                        ha[i] := hatch_angle[i] ;
                     end;
                  except
                     ;
                  end;
               end;
               oid:= out_id ;
               num:= Number ;
               if (lx > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  try
                     for i:=0 to nn-1 do begin
                        iid[i] := in_id[i];
                     end;
                  except
                     ;
                  end;
               end;
               // nb`OzHLn,zHLnN
               try
                  zHLnN := hln ;
                  SetLength(zHLn, hln);
                  for i:=0 to hln-1 do begin
                     zHLn[i].Color := hl[i].Color ;
                     zHLn[i].Ltype := hl[i].Ltype ;
                     zHLn[i].line_width := hl[i].line_width ;
                     zHLn[i].x1 := hl[i].x1 ;
                     zHLn[i].y1 := hl[i].y1 ;
                     zHLn[i].x2 := hl[i].x2 ;
                     zHLn[i].y2 := hl[i].y2 ;
                  end;
               except
                  DataClearHLn ;
               end;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// nb`O(p^[)@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : nb`O(p^[)    vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.GetDataHatch4(s:string;n:integer;var ex:Boolean;var lay,col:integer;var px,py,pv1,pv1a,pv2,pv2a,psx,psy,pa:double;var oid,num:integer;var iid:array of integer;var st:string) : Boolean ;
var
   m,dn,lx,nn,i : integer ;
begin
   Result := False;
   DataClearHLn ;
   lx := Length(iid) ;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dHa4N) then exit;    // vfIndex`FbN
      with dHa4[n] do begin
         ex := exf ;
         lay:= Layer ;
         st := name ;
         col   := hatch_color ;
         px    := hatch_pattern_x ;
         py    := hatch_pattern_y ;
         pv1   := hatch_pattern_vector1 ;
         pv1a  := hatch_pattern_vector1_angle ;
         pv2   := hatch_pattern_vector2 ;
         pv2a  := hatch_pattern_vector2_angle ;
         psx   := hatch_pattern_scale_x ;
         psy   := hatch_pattern_scale_y ;
         pa    := hatch_pattern_angle ;
         oid:= out_id ;
         num:= Number ;
         if (lx > 0) then begin
            nn := num ;
            if (nn > lx) then nn := lx ;  // G[̒
            try
               for i:=0 to nn-1 do begin
                  iid[i] := in_id[i];
               end;
            except
               ;
            end;
         end;
         // nb`OzHLn,zHLnN
         try
            zHLnN := hln ;
            SetLength(zHLn, hln);
            for i:=0 to hln-1 do begin
               zHLn[i].Color := hl[i].Color ;
               zHLn[i].Ltype := hl[i].Ltype ;
               zHLn[i].line_width := hl[i].line_width ;
               zHLn[i].x1 := hl[i].x1 ;
               zHLn[i].y1 := hl[i].y1 ;
               zHLn[i].x2 := hl[i].x2 ;
               zHLn[i].y2 := hl[i].y2 ;
            end;
         except
            DataClearHLn ;
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mHa4N) then exit;    // vfIndex`FbN
            with mHa4[n] do begin
               ex := exf ;
               lay:= Layer ;
               st := name ;
               col   := hatch_color ;
               px    := hatch_pattern_x ;
               py    := hatch_pattern_y ;
               pv1   := hatch_pattern_vector1 ;
               pv1a  := hatch_pattern_vector1_angle ;
               pv2   := hatch_pattern_vector2 ;
               pv2a  := hatch_pattern_vector2_angle ;
               psx   := hatch_pattern_scale_x ;
               psy   := hatch_pattern_scale_y ;
               pa    := hatch_pattern_angle ;
               oid:= out_id ;
               num:= Number ;
               if (lx > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  try
                     for i:=0 to nn-1 do begin
                        iid[i] := in_id[i];
                     end;
                  except
                     ;
                  end;
               end;
               // nb`OzHLn,zHLnN
               try
                  zHLnN := hln ;
                  SetLength(zHLn, hln);
                  for i:=0 to hln-1 do begin
                     zHLn[i].Color := hl[i].Color ;
                     zHLn[i].Ltype := hl[i].Ltype ;
                     zHLn[i].line_width := hl[i].line_width ;
                     zHLn[i].x1 := hl[i].x1 ;
                     zHLn[i].y1 := hl[i].y1 ;
                     zHLn[i].x2 := hl[i].x2 ;
                     zHLn[i].y2 := hl[i].y2 ;
                  end;
               except
                  DataClearHLn ;
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mHa4N) then exit;    // vfIndex`FbN
            with mHa4[n] do begin
               ex := exf ;
               lay:= Layer ;
               st := name ;
               col   := hatch_color ;
               px    := hatch_pattern_x ;
               py    := hatch_pattern_y ;
               pv1   := hatch_pattern_vector1 ;
               pv1a  := hatch_pattern_vector1_angle ;
               pv2   := hatch_pattern_vector2 ;
               pv2a  := hatch_pattern_vector2_angle ;
               psx   := hatch_pattern_scale_x ;
               psy   := hatch_pattern_scale_y ;
               pa    := hatch_pattern_angle ;
               oid:= out_id ;
               num:= Number ;
               if (lx > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  try
                     for i:=0 to nn-1 do begin
                        iid[i] := in_id[i];
                     end;
                  except
                     ;
                  end;
               end;
               // nb`OzHLn,zHLnN
               try
                  zHLnN := hln ;
                  SetLength(zHLn, hln);
                  for i:=0 to hln-1 do begin
                     zHLn[i].Color := hl[i].Color ;
                     zHLn[i].Ltype := hl[i].Ltype ;
                     zHLn[i].line_width := hl[i].line_width ;
                     zHLn[i].x1 := hl[i].x1 ;
                     zHLn[i].y1 := hl[i].y1 ;
                     zHLn[i].x2 := hl[i].x2 ;
                     zHLn[i].y2 := hl[i].y2 ;
                  end;
               except
                  DataClearHLn ;
               end;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// nb`O(ߓh)@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : nb`O(ߓh)    vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.GetDataHatch5(s:string;n:integer;var ex:Boolean;var lay,col,al,oid,num:integer;var iid:array of integer) : Boolean ;
var
   m,dn,lx,nn,i : integer ;
begin
   Result := False;
   lx := Length(iid) ;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dHa5N) then exit;    // vfIndex`FbN
      with dHa5[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         al := Alpha ;
         oid:= out_id ;
         num:= Number ;
         if (lx > 0) then begin
            nn := num ;
            if (nn > lx) then nn := lx ;  // G[̒
            try
               for i:=0 to nn-1 do begin
                  iid[i] := in_id[i];
               end;
            except
               ;
            end;
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mHa5N) then exit;    // vfIndex`FbN
            with mHa5[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               al := Alpha ;
               oid:= out_id ;
               num:= Number ;
               if (lx > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  try
                     for i:=0 to nn-1 do begin
                        iid[i] := in_id[i];
                     end;
                  except
                     ;
                  end;
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mHa5N) then exit;    // vfIndex`FbN
            with mHa5[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               al := Alpha ;
               oid:= out_id ;
               num:= Number ;
               if (lx > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  try
                     for i:=0 to nn-1 do begin
                        iid[i] := in_id[i];
                     end;
                  except
                     ;
                  end;
               end;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// nb`O(Of[Vh)@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : nb`O(Of[Vh)  vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.GetDataHatch6(s:string;n:integer;var ex:Boolean;var lay,col1,col2,al,gtp:integer;var an,hx,hy:double;var oid,num:integer;var iid:array of integer) : Boolean ;
var
   m,dn,lx,nn,i : integer ;
begin
   Result := False;
   lx := Length(iid) ;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dHa6N) then exit;    // vfIndex`FbN
      with dHa6[n] do begin
         ex := exf ;
         lay:= Layer ;
         col1  := Color1 ;
         col2  := Color2 ;
         al    := Alpha ;
         gtp   := Gtype ;
         an    := Angle ;
         hx    := housya_x ;
         hy    := housya_y ;
         oid:= out_id ;
         num:= Number ;
         if (lx > 0) then begin
            nn := num ;
            if (nn > lx) then nn := lx ;  // G[̒
            try
               for i:=0 to nn-1 do begin
                  iid[i] := in_id[i];
               end;
            except
               ;
            end;
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mHa6N) then exit;    // vfIndex`FbN
            with mHa6[n] do begin
               ex := exf ;
               lay:= Layer ;
               col1  := Color1 ;
               col2  := Color2 ;
               al    := Alpha ;
               gtp   := Gtype ;
               an    := Angle ;
               hx    := housya_x ;
               hy    := housya_y ;
               oid:= out_id ;
               num:= Number ;
               if (lx > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  try
                     for i:=0 to nn-1 do begin
                        iid[i] := in_id[i];
                     end;
                  except
                     ;
                  end;
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mHa6N) then exit;    // vfIndex`FbN
            with mHa6[n] do begin
               ex := exf ;
               lay:= Layer ;
               col1  := Color1 ;
               col2  := Color2 ;
               al    := Alpha ;
               gtp   := Gtype ;
               an    := Angle ;
               hx    := housya_x ;
               hy    := housya_y ;
               oid:= out_id ;
               num:= Number ;
               if (lx > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  try
                     for i:=0 to nn-1 do begin
                        iid[i] := in_id[i];
                     end;
                  except
                     ;
                  end;
               end;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;

// nb`O(摜h)@f[^ڂ̎擾
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : nb`O(摜h)    vfIndex (0-)
//    ex : ݃tO
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.GetDataHatch7(s:string;n:integer;var ex:Boolean;var lay,col,oid,num:integer;var iid:array of integer;var fn:string) : Boolean ;
var
   m,dn,lx,nn,i : integer ;
begin
   Result := False;
   lx := Length(iid) ;
   if (s = '') then begin
      // p
      if (n < 0)or(n >= dHa7N) then exit;    // vfIndex`FbN
      with dHa7[n] do begin
         ex := exf ;
         lay:= Layer ;
         col:= Color ;
         fn := ImgFileName ;
         oid:= out_id ;
         num:= Number ;
         if (lx > 0) then begin
            nn := num ;
            if (nn > lx) then nn := lx ;  // G[̒
            try
               for i:=0 to nn-1 do begin
                  iid[i] := in_id[i];
               end;
            except
               ;
            end;
         end;
      end;
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         with fDef[m-1] do begin
            dn := datn ;
         end;
         with fDefD[dn] do begin
            if (n < 0)or(n >= mHa7N) then exit;    // vfIndex`FbN
            with mHa7[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               fn := ImgFileName ;
               oid:= out_id ;
               num:= Number ;
               if (lx > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  try
                     for i:=0 to nn-1 do begin
                        iid[i] := in_id[i];
                     end;
                  except
                     ;
                  end;
               end;
            end;
         end;
      end
      else if (m < 0) then begin
         with sDef[-m-1] do begin
            dn := datn ;
         end;
         with sDefD[dn] do begin
            if (n < 0)or(n >= mHa7N) then exit;    // vfIndex`FbN
            with mHa7[n] do begin
               ex := exf ;
               lay:= Layer ;
               col:= Color ;
               fn := ImgFileName ;
               oid:= out_id ;
               num:= Number ;
               if (lx > 0) then begin
                  nn := num ;
                  if (nn > lx) then nn := lx ;  // G[̒
                  try
                     for i:=0 to nn-1 do begin
                        iid[i] := in_id[i];
                     end;
                  except
                     ;
                  end;
               end;
            end;
         end;
      end
      else
         exit ;   // }`s
   end;
   Result := True ;
end;



// _}[J@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : _}[J        vfIndex (0-)
//    lay: C(1-256)
//    col: F(0,1-256)
//    mc : }[JR[h(1: 2: 3:E 4:{ 5: 6: 7:~)
//    px : zu_X
//    py : zu_Y
//    an : ]p[]
//    sc : ړx
// (ret) True:OK@False:NG
function TDataClass.EditDataTen(s:string;n:integer;lay,col,mc:integer;px,py,an,sc:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (mc  < 1) or (mc  > 7)       then mc  := 3 ;   // dot
   an := SetAngle(an);
   if (sc < LIMIT8) then sc := 1.0;

   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dTenN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mTenN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mTenN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,1,n);
   if (AddDataTen(s,lay,col,mc, px,py,an,sc)) then Result := True ;
end;

// @f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  :             vfIndex (0-)
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    x1 : n_X
//    y1 : n_Y
//    x2 : I_X
//    y2 : I_Y
// (ret) True:OK@False:NG
function TDataClass.EditDataLine(s:string;n:integer;lay,col,ltp,wid:integer;x1,y1,x2,y2:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (SamePosCheck(x1,y1,x2,y2))  then exit ; // _

   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dLinN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mLinN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mLinN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,2,n);
   if (AddDataLine(s,lay,col,ltp,wid, x1,y1,x2,y2)) then Result := True ;
end;

// ܐ@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : ܐ            vfIndex (0-)
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    num: _
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:OK@False:NG
function TDataClass.EditDataLines(s:string;n:integer;lay,col,ltp,wid,num:integer;vx,vy:array of double) : Boolean;
var
   m,i,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (num <=0) then exit ;
   try
      for i:=1 to num-1 do
         if (SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ; // _
   except
      exit ;   // IzG[
   end;

   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dLnsN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mLnsN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mLnsN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,3,n);
   if (AddDataLines(s,lay,col,ltp,wid,num, vx,vy)) then Result := True ;
end;

// ~@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : ~@            vfIndex (0-)
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : (3`3600)
//    cx : S_X
//    cy : S_Y
//    cr : a
// (ret) True:OK@False:NG
function TDataClass.EditDataCircle(s:string;n:integer;lay,col,ltp,wid,sp:integer;cx,cy,cr:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp  < 3) or (sp  >  3600)   then sp  := 72;
   if (cr < LIMIT10) then exit ;    // a <= 0

   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dCirN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mCirN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mCirN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,4,n);
   if (AddDataCircle(s,lay,col,ltp,wid,sp, cx,cy,cr)) then Result := True ;
end;

// ~ʁ@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : ~            vfIndex (0-)
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : (3`3600)
//    dir: (0,1)
//    cx : S_X
//    cy : S_Y
//    cr : a
//    sa : np
//    ea : Ip
// (ret) True:OK@False:NG
function TDataClass.EditDataArc(s:string;n:integer;lay,col,ltp,wid,sp,dir:integer;cx,cy,cr,sa,ea:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp  < 3) or (sp  >  3600)   then sp  := 72;
   if (cr < LIMIT10) then exit ;          // a <= 0
   if (dir <> 0) then dir := 1 ;
   sa := SetAngle(sa);
   ea := SetAngle(ea);
   if (Abs(ea-sa) < LIMIT10) then exit ;  // np = Ip

   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dArcN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mArcN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mArcN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,5,n);
   if (AddDataArc(s,lay,col,ltp,wid,sp,dir, cx,cy,cr,sa,ea)) then Result := True ;
end;

// ȉ~@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : ȉ~            vfIndex (0-)
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : (3`3600)
//    cx : S_X
//    cy : S_Y
//    rx : wa
//    ry : xa
//    ra : ]p
// (ret) True:OK@False:NG
function TDataClass.EditDataEllipse(s:string;n:integer;lay,col,ltp,wid,sp:integer;cx,cy,rx,ry,ra:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp  < 3) or (sp  >  3600)   then sp  := 72;
   if (rx < LIMIT10)or(ry < LIMIT10) then exit ;   // a <= 0
   ra := SetAngle(ra);

   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dEllN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mEllN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mEllN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,6,n);
   if (AddDataEllipse(s,lay,col,ltp,wid,sp, cx,cy,rx,ry,ra)) then Result := True ;
end;

// ȉ~ʁ@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : ȉ~          vfIndex (0-)
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : (3`3600)
//    dir: (0,1)
//    cx : S_X
//    cy : S_Y
//    rx : wa
//    ry : xa
//    ra : ]p
//    sa : np
//    ea : Ip
// (ret) True:OK@False:NG
function TDataClass.EditDataEllipseArc(s:string;n:integer;lay,col,ltp,wid,sp,dir:integer;cx,cy,rx,ry,ra,sa,ea:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp  < 3) or (sp  >  3600) then sp  := 72;
   if (rx < LIMIT10)or(ry < LIMIT10) then exit ;   // a <= 0
   if (dir <> 0) then dir := 1 ;
   ra := SetAngle(ra);
   sa := SetAngle(sa);
   ea := SetAngle(ea);
   if (Abs(ea-sa) < LIMIT10) then exit ;  // np = Ip

   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dEArN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mEArN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mEArN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,7,n);
   if (AddDataEllipseArc(s,lay,col,ltp,wid,sp,dir, cx,cy,rx,ry,ra,sa,ea)) then Result := True ;
end;

// @f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    str: 
//    n  :             vfIndex (0-)
//    lay: C(1-256)
//    col: F@    (0,1-256)
//    fon: tHg(0,1-1024)
//    bp : _(1-9)
//    dir: (1,2)
//    px : zu_X
//    py : zu_Y
//    ph : ͈͍
//    pw : ͈͕
//    ps : Ԋu
//    an : ]p
//    sl : Xgp
// (ret) True:OK@False:NG
function TDataClass.EditDataText(s,st:string;n:integer;lay,col,fnt,bp,dir:integer;px,py,ph,pw,ps,an,sl:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if not(StrCheck(st)) then exit;                 // 񐔃`FbN
   if (ph < LIMIT10)or(pw < LIMIT10) then exit ;   // ͈͂ <= 0
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (fnt < 0) or (fnt > zFntMax) then fnt := 0 ;
   if (bp  < 1) or (bp  >     9) then bp  := 1 ;
   if (dir <> 1) then dir := 2 ;
   if (ps < 0.0) then ps := 0.0;
   an := SetAngle(an);
   if (sl < -85.0) or (sl > 85.0) then sl := 0.0;

   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dTxtN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mTxtN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mTxtN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,8,n);
   if (AddDataText(s,st,lay,col,fnt,bp,dir, px,py,ph,pw,ps,an,sl)) then Result := True ;
end;

// xWFȐ@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : xWFȐ      vfIndex (0-)
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : _ԕ
//    num: _(1-1000)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:OK@False:NG
function TDataClass.EditDataBezier(s:string;n:integer;lay,col,ltp,wid,sp,num:integer;vx,vy:array of double) : Boolean;
var
   m,dn,i : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp <  1)   then sp := 1 ;
   if (sp > 1000) then sp := 1000 ;
   if ( ((num-1)mod 3) > 0) then num := ((num-1) div 3)*3+1;
   if (num <= 1) then exit ;
   try
      for i:=1 to num-1 do
         if (((i-2) mod 3) > 0)
          and(SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ;   // _i_1Ɛ_2͓ł\Ȃj
   except
      exit ;   // IzG[
   end;

   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dBezN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mBezN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mBezN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,9,n);
   if (AddDataBezier(s,lay,col,ltp,wid,sp,num, vx,vy)) then Result := True ;
end;

// aXvCȐ@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : aXvC    vfIndex (0-)
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//@@sp : _ԕ
//    num: _(1-1000)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:OK@False:NG
function TDataClass.EditDataBspline(s:string;n:integer;lay,col,ltp,wid,sp,num:integer;vx,vy:array of double) : Boolean;
var
   m,dn,i : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp <  1)   then sp := 1 ;
   if (sp > 1000) then sp := 1000 ;
   if (num <= 2) then exit ;
   try
      for i:=1 to num-1 do
         if (SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ; // _
   except
      exit ;   // IzG[
   end;

   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dBspN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mBspN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mBspN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,10,n);
   if (AddDataBspline(s,lay,col,ltp,wid,sp,num, vx,vy)) then Result := True ;
end;

// XvCȐ@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : XvCȐ  vfIndex (0-)
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    stp: Ȑ^Cv (1:CXvC 2:xWF 3:NUBS)
//@@sp : _ԕ
//    num: _(1-1000)
//    av : CXvĈ`l(0-1 ʏ0.5)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:OK@False:NG
function TDataClass.EditDataSpline(s:string;n:integer;lay,col,ltp,wid,stp,sp,num:integer;av:double;vx,vy:array of double) : Boolean;
var
   m,dn,i : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (stp < 1) or (stp > 3)     then stp := 1 ;
   if (sp <  1)   then sp := 1 ;
   if (sp > 1000) then sp := 1000 ;
   if (num <= 2) then exit ;
   try
      for i:=1 to num-1 do
         if (SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ; // _
   except
      exit ;   // IzG[
   end;

   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dSplN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mSplN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mSplN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,11,n);
   if (AddDataSpline(s,lay,col,ltp,wid,stp,sp,num, av,vx,vy)) then Result := True ;
end;

// N\ChȐ@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : N\ChȐ  vfIndex (0-)
//    lay: C(1-256)
//    col: F@(0,1-256)
//    ltp: (0,1-32)
//    wid: (0,1-16)
//    dir: @(0:v,1:v)
//@@sp : 
//    bx : zu_wW
//    by : zu_xW
//    av : p[^@N\Cĥ`l(0)
//    an : ]p[]
//    l1 : JnȐ (0ȏ) ȐƂĂ̓}CiXl\łSXFdl0ȏƌ܂Ă̂Ő
//    l2 : IȐ (0ȏ)
// (ret) True:OK@False:NG
function TDataClass.EditDataClothoid(s:string;n:integer;lay,col,ltp,wid,dir,sp:integer;bx,by,av,an,l1,l2:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (dir <> 0) then dir := 1 ;
   if (sp <     1) then sp := 1 ;
   if (sp > 10000) then sp := 10000 ;
   if (av <= 0.0) then exit ;             // p[^Al 0
   an := SetAngle(an);
   if (l1 < 0.0) then l1 := 0.0 ;
   if (l2 < 0.0) then l2 := 0.0 ;
   if (Abs(l1-l2) < LIMIT10) then exit ;  // Jn = I

   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dCloN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mCloN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mCloN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,12,n);
   if (AddDataClothoid(s,lay,col,ltp,wid,dir,sp, bx,by,av,an,l1,l2)) then Result := True ;
end;

// @f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  :             vfIndex (0-)
//    lay: C(1-256)
//    col: F(0,1-256)
//    ac : R[h(1:blanked arrow 2:blanked box 3:blanked dot
//                    4:dimension origin 5:filled box 6:filled arrow
//                    7:filled dot 8:integral symbol 9:open arrow
//                   10:slash 11:unfilled arrow)
//    px : zu_X
//    py : zu_Y
//    an : ]p[]
//    sc : ړx
// (ret) True:OK@False:NG
function TDataClass.EditDataArrow(s:string;n:integer;lay,col,ac:integer;px,py,an,sc:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ac  < 1) or (ac  > 11)      then ac  := 9 ;   // open arrow
   an := SetAngle(an);
   if (sc < LIMIT8) then sc := 1.0;

   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dArwN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mArwN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mArwN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,13,n);
   if (AddDataArrow(s,lay,col,ac, px,py,an,sc)) then Result := True ;
end;

// 摜@f[^ڂ̕ҏWo^
//    (s : null:p֒ǉi\Lvf)j
//    n  : 摜            vfIndex (0-)
//    f  : 摜t@C
//    lay: C(1-256)
//    al : At@l(0`255)
//    px : zu_X
//    py : zu_Y
//    sx : wTCY
//    sy : xTCY
//    an : ]p[]
// (ret) True:OK@False:NG
function TDataClass.EditDataImage(n:integer;fn:string;lay,al:integer;px,py,sx,sy,an:double) : Boolean;
var
   m : integer ;
begin
   Result := False;
   if (fn = '') then exit ;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (al <   0) then al :=   0;
   if (al > 255) then al := 255;
   if (sx < LIMIT10)or(sy < LIMIT10) then exit ;
   an := SetAngle(an);

   m := 0 ;
   if (n < 0)or(n >= dImgN) then exit;    // vfIndex`FbN

   DelDataNo(m,14,n);
   if (AddDataImage(fn,lay,al, px,py,sx,sy,an)) then Result := True ;
end;

// ́@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  :             vfIndex (0-)
//    st : 
//    lay: C(1-256)
//    bp : _(1:,2:,3:E,4:,5:,6:E,7:,8:,9:E)
//    dir: (1,2)
//    px : zu_X
//    py : zu_Y
//    pd : sNZmmϊ䗦(W72)
//    pw : ͔͈͕
//    ps : Ԋu
//    pl : sԊu
//    an : ]p
// (ret) True:OK@False:NG
function TDataClass.EditDataDocument(s,st:string;n:integer;lay,bp,dir:integer;px,py,pd,pw,ps,pl,an:double) : Boolean;
var
   m,dn : integer ;
begin
   Result := False;
   if (st = '') then exit;                         // `FbN
   if (KTrim(GetPlainText(st)) = '') then exit ;   // `FbN
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (bp  < 1) or (bp  >       9) then bp  := 1 ;
   if (dir <> 1) then dir := 2 ;
   if (pd < LIMIT10) then pd := 72.0 ;
   if (ps < 0.0) then ps := 0.0;
   if (pl < 0.0) then pl := 0.0;
   an := SetAngle(an);

   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dDocN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mDocN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mDocN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,15,n);
   if (AddDataDocument(s,st,lay,bp,dir, px,py,pd,pw,ps,pl,an)) then Result := True ;
end;

// \@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : \              vfIndex (0-)
//    lay: C(1-256)
//    bp : _(1:,2:,3:E,4:,5:,6:E,7:,8:,9:E)
//    co1: 
//    ro1: s
//    co2: Œ
//    ro2: Œs
//    lco: r̐F@(0:CF@ 1`256)
//    llt: r̐(0:C 1`32)
//    lwd: r̐(0:C 1`16)
//    cc1: ZhאF(0:CF@ 1`256)
//    fl1: Z̓hׂ̗L(0:A1:L)
//    cc2: ŒZhאF(0:CF@1`256)
//    fl2: ŒZ̓hׂ̗L(0:A1:L)
//    tco: ̐F (0:CF@ 1`256)
//    fnt: tHg (0:CtHg 1`1024)
//    px : zu_X
//    py : zu_Y
//    pg : rƕ̊Ԃ̊Ԋu
//    ps : Ԋu
//    cw : 
//    rh : s
//    al : ʒu(1: 2: 3:E)
//    st : 
//    ca : vZ
// (ret) True:OK@False:NG
function TDataClass.EditDataTable(s:string;n:integer;lay,bp,co1,ro1,co2,ro2,lco,llt,lwd,cc1,fl1,cc2,fl2,tco,fnt:integer; px,py,pg,ps:double;cw,rh:array of double;al:array of Integer; st,ca:TStrGrid) : Boolean;
var
   i,j,m,dn : integer ;
   fl : Boolean ;
begin
   Result := False;
   if (co1 <= 0) then exit;
   if (ro1 <= 0) then exit;
   fl := False ;
   for j:=0 to ro1-1 do begin
      for i:=0 to co1-1 do begin
         if (st[i,j] <> '') then begin
            fl := True ;
            break ;
         end;
      end;
   end;
   if not(fl) then exit;   // `FbN

   fl := True ;
   for j:=0 to ro1-1 do begin
      for i:=0 to co1-1 do begin
         if (st[i,j] <> '') then begin
            if not(StrCheck(st[i,j])) then begin
               fl := False ;
               break ;
            end;
         end;
         if (ca[i,j] <> '') then begin
            if not(StrCheck(ca[i,j])) then begin
               fl := False ;
               break ;
            end;
         end;
      end;
   end;
   if not(fl) then exit;   // 񐔃`FbN

   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (bp  < 1) or (bp  >       9) then bp  := 1 ;
   if (co2 < 0) or (co2 > co1)     then co2 := 0 ;
   if (ro2 < 0) or (ro2 > ro1)     then ro2 := 0 ;
   if (lco < 0) or (lco > zColMax) then lco := 0 ;
   if (llt < 0) or (llt > zLtpMax) then llt := 0 ;
   if (lwd < 0) or (lwd > zWidMax) then lwd := 0 ;
   if (cc1 < 0) or (cc1 > zColMax) then cc1 := 0 ;
   if (cc2 < 0) or (cc2 > zColMax) then cc2 := 0 ;
   if (fl1 <> 0) then fl1 := 1 ;
   if (fl2 <> 0) then fl2 := 1 ;
   if (tco < 0) or (tco > zColMax) then tco := 0 ;
   if (fnt < 0) or (fnt > zFntMax) then fnt := 0 ;
   if (pg < 0.0) then pg := 0.0;
   if (ps < 0.0) then ps := 0.0;
   for i:=0 to co1-1 do begin
      if (cw[i] <= LIMIT6) then cw[i] := LIMIT6;
   end;
   for j:=0 to ro1-1 do begin
      if (rh[j] <= LIMIT6) then rh[j] := LIMIT6;
   end;
   for i:=0 to co1-1 do begin
      if (al[i] < 1)or(al[i] > 3) then al[i] := 1 ;
   end;

   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dTblN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mTblN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mTblN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,16,n);
   if (AddDataTable(s,lay,bp,co1,ro1,co2,ro2,lco,llt,lwd,cc1,fl1,cc2,fl2,tco,fnt,
                  px,py,pg,ps, cw,rh,al, st,ca)) then Result := True ;
end;

// @@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : @        vfIndex (0-)
//    st : 
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.EditDataDimLine(s,st:string;n:integer;lay,col,ltp,wid,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx1,sy1,sx2,sy2, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
var
   m,dn : integer ;
   a1,a2,w1,w2 : double ;
begin
   Result := False ;
   if (st = '') then
      f4 := 0
   else
      if not(StrCheck(st)) then exit;        // 񐔃`FbN
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (f2 <> 0) then f2 := 1;
   if (f3 <> 0) then f3 := 1;
   if (f4 <> 0) then f4 := 1;
   if (ar11 < 1)or(ar11 > 11) then ar11 := 9;
   if (ar21 < 1)or(ar21 > 11) then ar21 := 9;
   if (ar12 < 0)or(ar12 > 2)  then ar12 := 2;
   if (ar22 < 0)or(ar22 > 2)  then ar22 := 2;
   if (ar1r < LIMIT8) then ar1r := 1.0;
   if (ar2r < LIMIT8) then ar2r := 1.0;
   if (f4 = 1)and( (th < LIMIT10)or(tw < LIMIT10) ) then exit ;   // ͈͂ <= 0
   if (fnt < 0) or (fnt > zFntN) then fnt := 0 ;
   if (bp  < 1) or (bp  >     9) then bp  := 2 ;   // 
   if (dir <> 1) then dir := 2 ;
   if (ts < 0.0) then ts := 0.0;
   an := SetAngle(an);
   if (sl < -85.0) or (sl > 85.0) then sl := 0.0;
   // W`FbN
   if (SamePosCheck(sx1,sy1, sx2,sy2)) then exit ;    // @̎n_EI__
   if (SamePosCheck(h1x1,h1y1, h1x2,h1y2)) then
      f2 := 0 ;                                       // ⏕P̎n_EI__
   if (SamePosCheck(h2x1,h2y1, h2x2,h2y2)) then
      f3 := 0 ;                                       // ⏕Q̎n_EI__
   // ⏕̂P`FbN
   if (f2 = 1) then begin
      a1 := dAngle((h1x1-h1x0),(h1y1-h1y0));
      a2 := dAngle((h1x2-h1x0),(h1y2-h1y0));
      a2 := SetAngle(a1-a2) ;
      if (Abs(a2) > LIMIT10) then begin
         // PłȂߏI_̕킹
         dRev(w1,w2, h1x2,h1y2, h1x0,h1y0, -a1);
         if (Abs(w1-h1x0) < LIMIT10) then
            f2 := 0
         else
            dRev(h1x2,h1y2, w1,h1y0, h1x0,h1y0, a1);
      end;
   end;
   if (f3 = 1) then begin
      a1 := dAngle((h2x1-h2x0),(h2y1-h2y0));
      a2 := dAngle((h2x2-h2x0),(h2y2-h2y0));
      a2 := SetAngle(a1-a2) ;
      if (Abs(a2) > LIMIT10) then begin
         // PłȂߏI_̕킹
         dRev(w1,w2, h2x2,h2y2, h2x0,h2y0, -a1);
         if (Abs(w1-h2x0) < LIMIT10) then
            f3 := 0
         else
            dRev(h2x2,h2y2, w1,h2y0, h2x0,h2y0, a1);
      end;
   end;
   //
   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dDLnN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mDLnN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mDLnN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,101,n);
   if (AddDataDimLine(s,st, lay,col,ltp,wid,f2,f3,f4,
         ar11,ar12,ar21,ar22,fnt,bp,dir, sx1,sy1,sx2,sy2,
         h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2,
         ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl)) then Result := True ;
end;

// ʒ@@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : ʒ@        vfIndex (0-)
//    st : 
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.EditDataDimArc(s,st:string;n:integer;lay,col,ltp,wid,sp,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx,sy,sr,sa0,sa1, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
var
   m,dn : integer ;
   a1,a2,w1,w2 : double ;
begin
   Result := False;
   if (st = '') then
      f4 := 0
   else
      if not(StrCheck(st)) then exit;        // 񐔃`FbN
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp  < 3) or (sp  >  3600)   then sp  := 72;
   if (f2 <> 0) then f2 := 1;
   if (f3 <> 0) then f3 := 1;
   if (f4 <> 0) then f4 := 1;
   if (ar11 < 1)or(ar11 > 11) then ar11 := 9;
   if (ar21 < 1)or(ar21 > 11) then ar21 := 9;
   if (ar12 < 0)or(ar12 > 2)  then ar12 := 2;
   if (ar22 < 0)or(ar22 > 2)  then ar22 := 2;
   if (ar1r < LIMIT8) then ar1r := 1.0;
   if (ar2r < LIMIT8) then ar2r := 1.0;
   if (sr < LIMIT8) then exit ;     // @a <= 0
   sa0 := SetAngle(sa0);
   sa1 := SetAngle(sa1);
   if (f4 = 1)and( (th < LIMIT10)or(tw < LIMIT10) ) then exit ;   // ͈͂ <= 0
   if (fnt < 0) or (fnt > zFntN) then fnt := 0 ;
   if (bp  < 1) or (bp  >     9) then bp  := 2 ;   // 
   if (dir <> 1) then dir := 2 ;
   if (ts < 0.0) then ts := 0.0;
   an := SetAngle(an);
   if (sl < -85.0) or (sl > 85.0) then sl := 0.0;
   // W`FbN
   if (SamePosCheck(h1x1,h1y1, h1x2,h1y2)) then
      f2 := 0 ;                                       // ⏕P̎n_EI__
   if (SamePosCheck(h2x1,h2y1, h2x2,h2y2)) then
      f3 := 0 ;                                       // ⏕Q̎n_EI__
   // ⏕̂P`FbN
   if (f2 = 1) then begin
      a1 := dAngle((h1x1-h1x0),(h1y1-h1y0));
      a2 := dAngle((h1x2-h1x0),(h1y2-h1y0));
      a2 := SetAngle(a1-a2) ;
      if (Abs(a2) > LIMIT10) then begin
         // PłȂߏI_̕킹
         dRev(w1,w2, h1x2,h1y2, h1x0,h1y0, -a1);
         if (Abs(w1-h1x0) < LIMIT10) then
            f2 := 0
         else
            dRev(h1x2,h1y2, w1,h1y0, h1x0,h1y0, a1);
      end;
   end;
   if (f3 = 1) then begin
      a1 := dAngle((h2x1-h2x0),(h2y1-h2y0));
      a2 := dAngle((h2x2-h2x0),(h2y2-h2y0));
      a2 := SetAngle(a1-a2) ;
      if (Abs(a2) > LIMIT10) then begin
         // PłȂߏI_̕킹
         dRev(w1,w2, h2x2,h2y2, h2x0,h2y0, -a1);
         if (Abs(w1-h2x0) < LIMIT10) then
            f3 := 0
         else
            dRev(h2x2,h2y2, w1,h2y0, h2x0,h2y0, a1);
      end;
   end;
   //
   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dDArN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mDArN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mDArN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,102,n);
   if (AddDataDimArc(s,st, lay,col,ltp,wid,sp,f2,f3,f4,
         ar11,ar12,ar21,ar22,fnt,bp,dir, sx,sy,sr,sa0,sa1,
         h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2,
         ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl)) then Result := True ;
end;

// px@@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : px@        vfIndex (0-)
//    st : 
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.EditDataDimAngle(s,st:string;n:integer;lay,col,ltp,wid,sp,f2,f3,f4,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx,sy,sr,sa0,sa1, h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
var
   m,dn : integer ;
   a1,a2,w1,w2 : double ;
begin
   Result := False;
   if (st = '') then
      f4 := 0
   else
      if not(StrCheck(st)) then exit;        // 񐔃`FbN
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp  < 3) or (sp  >  3600)   then sp  := 72;
   if (f2 <> 0) then f2 := 1;
   if (f3 <> 0) then f3 := 1;
   if (f4 <> 0) then f4 := 1;
   if (ar11 < 1)or(ar11 > 11) then ar11 := 9;
   if (ar21 < 1)or(ar21 > 11) then ar21 := 9;
   if (ar12 < 0)or(ar12 > 2)  then ar12 := 2;
   if (ar22 < 0)or(ar22 > 2)  then ar22 := 2;
   if (ar1r < LIMIT8) then ar1r := 1.0;
   if (ar2r < LIMIT8) then ar2r := 1.0;
   if (sr < LIMIT8) then exit ;     // @a <= 0
   sa0 := SetAngle(sa0);
   sa1 := SetAngle(sa1);
   a1  := Abs(sa0-sa1);
   if (a1 < LIMIT10)or(Abs(a1-360.0) < LIMIT10) then exit ;       // npIp
   if (f4 = 1)and( (th < LIMIT10)or(tw < LIMIT10) ) then exit ;   // ͈͂ <= 0
   if (fnt < 0) or (fnt > zFntN) then fnt := 0 ;
   if (bp  < 1) or (bp  >     9) then bp  := 2 ;   // 
   if (dir <> 1) then dir := 2 ;
   if (ts < 0.0) then ts := 0.0;
   an := SetAngle(an);
   if (sl < -85.0) or (sl > 85.0) then sl := 0.0;
   // W`FbN
   if (SamePosCheck(h1x1,h1y1, h1x2,h1y2)) then
      f2 := 0 ;                                       // ⏕P̎n_EI__
   if (SamePosCheck(h2x1,h2y1, h2x2,h2y2)) then
      f3 := 0 ;                                       // ⏕Q̎n_EI__
   // ⏕̂P`FbN
   if (f2 = 1) then begin
      a1 := dAngle((h1x1-h1x0),(h1y1-h1y0));
      a2 := dAngle((h1x2-h1x0),(h1y2-h1y0));
      a2 := SetAngle(a1-a2) ;
      if (Abs(a2) > LIMIT10) then begin
         // PłȂߏI_̕킹
         dRev(w1,w2, h1x2,h1y2, h1x0,h1y0, -a1);
         if (Abs(w1-h1x0) < LIMIT10) then
            f2 := 0
         else
            dRev(h1x2,h1y2, w1,h1y0, h1x0,h1y0, a1);
      end;
   end;
   if (f3 = 1) then begin
      a1 := dAngle((h2x1-h2x0),(h2y1-h2y0));
      a2 := dAngle((h2x2-h2x0),(h2y2-h2y0));
      a2 := SetAngle(a1-a2) ;
      if (Abs(a2) > LIMIT10) then begin
         // PłȂߏI_̕킹
         dRev(w1,w2, h2x2,h2y2, h2x0,h2y0, -a1);
         if (Abs(w1-h2x0) < LIMIT10) then
            f3 := 0
         else
            dRev(h2x2,h2y2, w1,h2y0, h2x0,h2y0, a1);
      end;
   end;
   //
   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dDAnN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mDAnN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mDAnN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,103,n);
   if (AddDataDimAngle(s,st, lay,col,ltp,wid,sp,f2,f3,f4,
         ar11,ar12,ar21,ar22,fnt,bp,dir, sx,sy,sr,sa0,sa1,
         h1x0,h1y0,h1x1,h1y1,h1x2,h1y2, h2x0,h2y0,h2x1,h2y1,h2x2,h2y2,
         ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl)) then Result := True ;
end;

// a@@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : a@        vfIndex (0-)
//    st : 
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.EditDataDimRadius(s,st:string;n:integer;lay,col,ltp,wid,fl,ar1,ar2,fnt,bp,dir:integer;sx1,sy1,sx2,sy2, arx,ary,arr, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
var
   m,dn : integer ;
begin
   Result := False;
   if (st = '') then
      fl := 0
   else
      if not(StrCheck(st)) then exit;        // 񐔃`FbN
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (fl <> 0) then fl := 1;
   if (ar1 < 1)or(ar1 > 11) then ar1 := 9;
   if (ar2 < 0)or(ar2 > 2)  then ar2 := 2;
   if (arr < LIMIT8) then arr := 1.0;
   if (fl = 1)and( (th < LIMIT10)or(tw < LIMIT10) ) then exit ;   // ͈͂ <= 0
   if (fnt < 0) or (fnt > zFntN) then fnt := 0 ;
   if (bp  < 1) or (bp  >     9) then bp  := 2 ;   // 
   if (dir <> 1) then dir := 2 ;
   if (ts < 0.0) then ts := 0.0;
   an := SetAngle(an);
   if (sl < -85.0) or (sl > 85.0) then sl := 0.0;
   // W`FbN
   if (SamePosCheck(sx1,sy1, sx2,sy2)) then exit ;    // @̎n_EI__
   //
   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dDRaN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mDRaN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mDRaN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,104,n);
   if (AddDataDimRadius(s,st, lay,col,ltp,wid,fl,ar1,ar2,fnt,bp,dir,
         sx1,sy1,sx2,sy2, arx,ary,arr,
         tx,ty,th,tw,ts,an,sl)) then Result := True ;
end;

// a@@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : a@        vfIndex (0-)
//    st : 
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.EditDataDimDiameter(s,st:string;n:integer;lay,col,ltp,wid,fl,ar11,ar12,ar21,ar22,fnt,bp,dir:integer;sx1,sy1,sx2,sy2, ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
var
   m,dn : integer ;
begin
   Result := False;
   if (st = '') then
      fl := 0
   else
      if not(StrCheck(st)) then exit;        // 񐔃`FbN
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (fl <> 0) then fl := 1;
   if (ar11 < 1)or(ar11 > 11) then ar11 := 9;
   if (ar21 < 1)or(ar21 > 11) then ar21 := 9;
   if (ar12 < 0)or(ar12 > 2)  then ar12 := 2;
   if (ar22 < 0)or(ar22 > 2)  then ar22 := 2;
   if (ar1r < LIMIT8) then ar1r := 1.0;
   if (ar2r < LIMIT8) then ar2r := 1.0;
   if (fl = 1)and( (th < LIMIT10)or(tw < LIMIT10) ) then exit ;   // ͈͂ <= 0
   if (fnt < 0) or (fnt > zFntN) then fnt := 0 ;
   if (bp  < 1) or (bp  >     9) then bp  := 2 ;   // 
   if (dir <> 1) then dir := 2 ;
   if (ts < 0.0) then ts := 0.0;
   an := SetAngle(an);
   if (sl < -85.0) or (sl > 85.0) then sl := 0.0;
   // W`FbN
   if (SamePosCheck(sx1,sy1, sx2,sy2)) then exit ;    // @̎n_EI__
   //
   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dDDiN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mDDiN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mDDiN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,105,n);
   if (AddDataDimDiameter(s,st, lay,col,ltp,wid,fl,
         ar11,ar12,ar21,ar22,fnt,bp,dir, sx1,sy1,sx2,sy2,
         ar1x,ar1y,ar1r, ar2x,ar2y,ar2r, tx,ty,th,tw,ts,an,sl)) then Result := True ;
end;

// o@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : o        vfIndex (0-)
//    st : 
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.EditDataDimLeader(s,st:string;n:integer;lay,col,ltp,wid,fl,num,ar,fnt,bp,dir:integer;vx,vy:array of double;arr, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
var
   m,dn,i : integer ;
begin
   Result := False;
   if (st = '') then
      fl := 0
   else
      if not(StrCheck(st)) then exit;        // 񐔃`FbN
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (fl <> 0) then fl := 1;
   if (num < 2) then exit ;
   if (ar < 1)or(ar > 11) then ar := 9;
   if (arr < LIMIT8) then arr := 1.0;
   if (fl = 1)and( (th < LIMIT10)or(tw < LIMIT10) ) then exit ;   // ͈͂ <= 0
   if (fnt < 0) or (fnt > zFntN) then fnt := 0 ;
   if (bp  < 1) or (bp  >     9) then bp  := 2 ;   // 
   if (dir <> 1) then dir := 2 ;
   if (ts < 0.0) then ts := 0.0;
   an := SetAngle(an);
   if (sl < -85.0) or (sl > 85.0) then sl := 0.0;
   // W`FbN
   try
      for i:=1 to num-1 do
         if (SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ; // _
   except
      exit ;   // IzG[
   end;
   //
   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dDLeN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mDLeN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mDLeN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,106,n);
   if (AddDataDimLeader(s,st, lay,col,ltp,wid,fl,num,ar,fnt,bp,dir,
         vx,vy, arr, tx,ty,th,tw,ts,an,sl)) then Result := True ;
end;

// o[@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : o[        vfIndex (0-)
//    st : 
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.EditDataDimBalloon(s,st:string;n:integer;lay,col,ltp,wid,sp,fl,num,ar,fnt,bp,dir:integer;vx,vy:array of double;cx,cy,cr,arr, tx,ty,th,tw,ts,an,sl:double) : Boolean ;
var
   m,dn,i : integer ;
   a1,a2,w1,w2 : double ;
begin
   Result := False;
   if (st = '') then
      fl := 0
   else
      if not(StrCheck(st)) then exit;        // 񐔃`FbN
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (sp  < 3) or (sp  >  3600)   then sp  := 72;
   if (fl <> 0) then fl := 1;
   if (num < 2) then exit ;
   if (cr < LIMIT8) then exit;
   if (ar < 1)or(ar > 11) then ar := 9;
   if (arr < LIMIT8) then arr := 1.0;
   if (fl = 1)and( (th < LIMIT10)or(tw < LIMIT10) ) then exit ;   // ͈͂ <= 0
   if (fnt < 0) or (fnt > zFntN) then fnt := 0 ;
   if (bp  < 1) or (bp  >     9) then bp  := 2 ;   // 
   if (dir <> 1) then dir := 2 ;
   if (ts < 0.0) then ts := 0.0;
   an := SetAngle(an);
   if (sl < -85.0) or (sl > 85.0) then sl := 0.0;
   // W`FbN
   try
      for i:=1 to num-1 do
         if (SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ; // _
   except
      exit ;   // IzG[
   end;
   // oƒS_̂P`FbN
   a1 := dAngle((cx       -vx[num-2]),(cy       -vy[num-2]));
   a2 := dAngle((vx[num-1]-vx[num-2]),(vy[num-1]-vy[num-2]));
   a2 := SetAngle(a1-a2) ;
   if (Abs(a2) > LIMIT10) then begin
      // PłȂ߈oŏI_̕킹
      dRev(w1,w2, vx[num-1],vy[num-1], vx[num-2],vy[num-2], -a1);
      if (Abs(w1-vx[num-2]) < LIMIT10) then
         exit  // sl
      else
         dRev(vx[num-1],vy[num-1], w1,vy[num-2], vx[num-2],vy[num-2], a1);
   end;
   // o[~aƈoڑĂ邩ǂ̃`FbN͍sȂ
   // o[@o[~aɂ邩ǂ̃`FbN͍sȂ
   //
   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dDBaN) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mDBaN) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mDBaN) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,107,n);
   if (AddDataDimBalloon(s,st, lay,col,ltp,wid,sp,fl,num,ar,fnt,bp,dir,
         vx,vy, cx,cy,cr,arr, tx,ty,th,tw,ts,an,sl)) then Result := True ;
end;

// nb`O(`)@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : nb`O(`)      vfIndex (0-)
//    st : nb`O
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.EditDataHatch1(s,st:string;n:integer;lay,col,oid,num:integer;iid:array of integer) : Boolean ;
var
   m,dn : integer ;
begin
   Result := False;
   if not(StrCheck(st)) then exit;  // 񐔃`FbN
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (num < 0) then num := 0;
   // Ȑ`f[^̐ڑ`FbNEnb`Ö}`̃ZbgE`FbN
   if not(CheckHatchSub_CCrv_HAr(oid,num,iid)) then exit;
   DataClearHAr ;
   //
   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dHa1N) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mHa1N) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mHa1N) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,108,n);
   if (AddDataHatch1(s,st, lay,col,oid,num, iid)) then Result := True ;
end;

// nb`O(h)@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : nb`O(h)        vfIndex (0-)
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.EditDataHatch2(s:string;n:integer;lay,col,oid,num:integer;iid:array of integer) : Boolean ;
var
   m,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (num < 0) then num := 0;
   // Ȑ`f[^̐ڑ`FbNEnb`Ö}`̃ZbgE`FbN
   if not(CheckHatchSub_CCrv_HAr(oid,num,iid)) then exit;
   DataClearHAr ;
   //
   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dHa2N) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mHa2N) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mHa2N) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,109,n);
   if (AddDataHatch2(s, lay,col,oid,num, iid)) then Result := True ;
end;

// nb`O([U`)@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : nb`O([U`)  vfIndex (0-)
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.EditDataHatch3(s:string;n:integer;lay,hnum:integer;hcol,hltp,hwid:array of integer;hx,hy,hs,ha:array of double;oid,num:integer;iid:array of integer) : Boolean ;
var
   m,dn,i : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (hnum< 1) then exit ;      // p^[̖wG[
   if (hnum> 4) then hnum := 4;
   for i:=0 to hnum-1 do begin
      if (hcol[i] < 0) or (hcol[i] > zColMax) then hcol[i] := 0 ;
      if (hltp[i] < 0) or (hltp[i] > zLtpMax) then hltp[i] := 0 ;
      if (hwid[i] < 0) or (hwid[i] > zWidMax) then hwid[i] := 0 ;
      if (hs[i] <= LIMIT8) then hs[i] := 1.0 ;
      ha[i] := SetAngle(ha[i]);
   end;
   if (num < 0) then num := 0;
   // Ȑ`f[^̐ڑ`FbNEnb`Ö}`̃ZbgE`FbN
   if not(CheckHatchSub_CCrv_HAr(oid,num,iid)) then exit;
   DataClearHAr ;
   //
   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dHa3N) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mHa3N) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mHa3N) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,110,n);
   if (AddDataHatch3(s, lay,hnum, hcol,hltp,hwid, hx,hy,hs,ha, oid,num, iid)) then Result := True ;
end;

// nb`O(p^[)@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : nb`O(p^[)    vfIndex (0-)
//    st : V{
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.EditDataHatch4(s,st:string;n:integer;lay,col:integer;px,py,pv1,pv1a,pv2,pv2a,psx,psy,pa:double; oid,num:integer;iid:array of integer) : Boolean ;
var
   m,mm,dn : integer ;
begin
   Result := False;
   if (st = '') then exit ;
   mm := FZukeiNameCheck(0,st);
   if (mm >= 0) then exit ;    // p^[V{}`w肵ĂȂ̂ŃG[
   m := FZukeiNameCheck(0,s);
   if (mm = m) then exit ;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (pv1 < 0.0) then begin
      pv1 := -pv1 ;
      pv1a := pv1a + 180.0 ;
   end;
   if (pv2 < 0.0) then begin
      pv2 := -pv2 ;
      pv2a := pv2a + 180.0 ;
   end;
   if (pv1 < LIMIT8)or(pv2 < LIMIT8) then exit ;
   if (psx < LIMIT8) then psx := 1.0 ;
   if (psy < LIMIT8) then psy := 1.0 ;
   pv1a := SetAngle(pv1a);
   pv2a := SetAngle(pv2a);
   pa   := SetAngle(pa);
   if (num < 0) then num := 0;
   // Ȑ`f[^̐ڑ`FbNEnb`Ö}`̃ZbgE`FbN
   if not(CheckHatchSub_CCrv_HAr(oid,num,iid)) then exit;
   DataClearHAr ;
   //
   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dHa4N) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mHa4N) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mHa4N) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,111,n);
   if (AddDataHatch4(s,st, lay,col, px,py,pv1,pv1a,pv2,pv2a,psx,psy,pa,
         oid,num, iid)) then Result := True ;
end;

// nb`O(ߓh)@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : nb`O(ߓh)    vfIndex (0-)
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.EditDataHatch5(s:string;n:integer;lay,col,al,oid,num:integer;iid:array of integer) : Boolean ;
var
   m,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (al  <   0) then al := 0;
   if (al  > 255) then al := 255;
   if (num < 0) then num := 0;
   // Ȑ`f[^̐ڑ`FbNEnb`Ö}`̃ZbgE`FbN
   if not(CheckHatchSub_CCrv_HAr(oid,num,iid)) then exit;
   DataClearHAr ;
   //
   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dHa5N) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mHa5N) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mHa5N) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,112,n);
   if (AddDataHatch5(s, lay,col,al,oid,num, iid)) then Result := True ;
end;

// nb`O(Of[Vh)@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : nb`O(Of[Vh)  vfIndex (0-)
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.EditDataHatch6(s:string;n:integer;lay,col1,col2,al,gtp:integer;an,hx,hy:double;oid,num:integer;iid:array of integer) : Boolean ;
var
   m,dn : integer ;
begin
   Result := False;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col1< 0) or (col1> zColMax) then col1:= 0 ;
   if (col2< 0) or (col2> zColMax) then col2:= 0 ;
   if (al  <   0) then al := 0;
   if (al  > 255) then al := 255;
   if (gtp < 0) or (gtp > 2) then begin
      gtp := 0 ;
      an  := 0.0 ;
   end;
   if (num < 0) then num := 0;
   an := SetAngle(an);
   // Ȑ`f[^̐ڑ`FbNEnb`Ö}`̃ZbgE`FbN
   if not(CheckHatchSub_CCrv_HAr(oid,num,iid)) then exit;
   DataClearHAr ;
   //
   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dHa6N) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mHa6N) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mHa6N) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,113,n);
   if (AddDataHatch6(s, lay,col1,col2,al,gtp, an,hx,hy, oid,num, iid)) then Result := True ;
end;

// nb`O(摜h)@f[^ڂ̕ҏWo^
//    s  : f[^̕}`i􉽗vfj  null:p֒ǉi\Lvfj
//    n  : nb`O(摜h)    vfIndex (0-)
//    fn : 摜t@C
//    lay: C(1-256)
//    EEE
// (ret) True:OK@False:NG
function TDataClass.EditDataHatch7(s,fn:string;n:integer;lay,col,oid,num:integer;iid:array of integer) : Boolean ;
var
   m,dn : integer ;
begin
   Result := False;
   if (fn = '') then exit ;
   if (lay < 1) or (lay > zLayMax) then lay := 1 ;
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (num < 0) then num := 0;
   // Ȑ`f[^̐ڑ`FbNEnb`Ö}`̃ZbgE`FbN
   if not(CheckHatchSub_CCrv_HAr(oid,num,iid)) then exit;
   DataClearHAr ;
   //
   m := 0 ;
   if (s = '') then begin
      if (n < 0)or(n >= dHa7N) then exit;    // vfIndex`FbN
   end
   else begin
      m := FZukeiNameCheck(0,s);
      if (m > 0) then begin
         dn := fDef[m-1].datn ;
         if (n < 0)or(n >= fDefD[dn].mHa7N) then exit;    // vfIndex`FbN
      end
      else if (m < 0) then begin
         dn := sDef[-m-1].datn ;
         if (n < 0)or(n >= sDefD[dn].mHa7N) then exit;    // vfIndex`FbN
      end
      else
         exit;    // }`s
   end;

   DelDataNo(m,114,n);
   if (AddDataHatch7(s,fn, lay,col,oid,num, iid)) then Result := True ;
end;



// Xgւ̑ǉo^  e`FbN͍s܂
//    id : }`ʔԍ
//    na : 
//    va : l
//    tp : ^Cv
//    un : P
// (ret) True:o^OK@False:NG
function TDataClass.AddDataAttribute(id:integer;na,va,tp,un:string) : Boolean ;
var
   i : integer ;
begin
   Result := False ;
   i := AttrZukeiIDcheck(id);
   if (i = -1) then begin
      try
         Inc(zAttN);
         if ((zAttN mod 10) = 1) then SetLength(zAtt, zAttN+9);   // 10m
         i := zAttN - 1;
         with zAtt[i] do begin
            zid   := id;      // }`ʔԍ
            Number:= 0;       // ̐
            att   := nil;     // 
         end;
      except
         Dec(zAttN);
         exit ;
      end;
   end ;

   with zAtt[i] do begin
      try
         Inc(Number);
         if ((Number mod 10) = 1) then SetLength(att, Number+9);  // 10m
         with att[Number-1] do begin
            name  := na ;
            value := va ;
            atype := tp ;
            aunit := un ;
         end;
         Result := True ;
      except
         Dec(Number);
         if (Number < 0) then Number := 0;
      end;
   end;
end;

// ̐}`ʔԍindex`FbN
//    id : }`ʔԍ
// (ret) 0`:zAttIndex@-1:NG
function TDataClass.AttrZukeiIDcheck(id:integer) : integer ;
var
   i : integer ;
begin
   Result := -1;
   for i:=0 to zAttN-1 do begin
      if (id = zAtt[i].zid) then begin
         Result := i ;
         break ;
      end;
   end;
end;

// Ȑ`@f[^ڂ̒ǉo^
//    ̊ef[^͕ʓro^
//    id : IDԍ(1-)
//    col: F@@(0:CF@ 1`256)
//    ltp: @(0:C 1`32)
//@@wid: @(0:C 1`16)
//    inv: \^\tO (0,1)
// (ret) True:o^OK@False:NG
function TDataClass.AddCCurveDef(id,col,ltp,wid,inv:integer) : Boolean;
var
   i : integer ;
begin
   Result := False;
   if (id < 1) then exit ;
   //
   i := CCrvIDCheck(id);    // IDԍgpςǂ`FbN
   if (i >= 0) then exit ;  // IDԍgp
   //
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (inv <> 0) then inv := 1 ;
   //
   try
      Inc(cDefDN);
      SetLength(cDefD, cDefDN);
      DataClearCCurveMember(cDefDN-1);
      try
         Inc(cDefN);
         SetLength(cDef, cDefN);
         with cDef[cDefN-1] do begin
            exf         := True ;
            number      := id ;        // IDԍ (1`)
            Color       := col ;       // F    (0:CF@ 1`256)
            Ltype       := ltp ;       // @(0:C 1`32)
            line_width  := wid ;       // @(0:C 1`16)
            invisibility:= inv ;       // \^\tO (0:\,1:\)
            cnt         := 0 ;
            datn        := cDefDN-1 ;
         end;
         if (OpAdd(3,1,cDefN-1)) then begin
            Result := True ;
         end
         else begin
            Dec(cDefN);
            Dec(cDefDN);
         end;
      except
         Dec(cDefN);
         Dec(cDefDN);
      end;
   except
      Dec(cDefDN);
   end;
end;

// Ȑ`@f[^ڂ̍폜
//    n  : Ȑ` vfIndex (0-)
// (ret) True:OK@False:NG
function TDataClass.DelCCurveDef(n:integer) : Boolean;
begin
   Result := False ;
   if (n < 0)or(n >= cDefN) then exit;    // vfIndex`FbN
   if not(cDef[n].exf) then exit;         // ɍ폜

   if (OpAdd(4,1,n)) then begin
      cDef[n].exf := False ;
      Result := True ;
   end;
end;

// Ȑ`@f[^ڂ̎擾
//    n  : Ȑ` vfIndex (0-)
//    ex : ݃tO
//    id : IDԍ(1-)
//    col: F@@(0:CF@ 1`256)
//    ltp: @(0:C 1`32)
//@@wid: @(0:C 1`16)
//    inv: \^\tO (0,1)
//    cn : vf
//    dn : f[^vfIndex
// (ret) True:OK@False:NG
function TDataClass.GetCCurveDef(n:integer;var ex:Boolean;var id,col,ltp,wid,inv,cn,dn:integer) : Boolean;
begin
   Result := False;
   if (n < 0)or(n >= cDefN) then exit;    // vfIndex`FbN

   with cDef[n] do begin
      ex := exf ;
      id := number ;       // IDԍ (1`)
      col:= Color ;        // F    (0:CF@ 1`256)
      ltp:= Ltype ;        // @(0:C 1`32)
      wid:= line_width ;   // @(0:C 1`16)
      inv:= invisibility ; // \^\tO (0:\,1:\)
      cn := cnt ;
      dn := datn ;
   end;

   Result := True ;
end;

// Ȑ`@f[^ڂ̕ҏWo^
//    n  : Ȑ` vfIndex (0-)
//    id : IDԍ(1-)
//    col: F@@(0:CF@ 1`256)
//    ltp: @(0:C 1`32)
//@@wid: @(0:C 1`16)
//    inv: \^\tO (0,1)
//    cn : vf
//    dn : f[^vfIndex
// (ret) True:OK@False:NG
function TDataClass.EditCCurveDef(n,id,col,ltp,wid,inv,cn,dn:integer) : Boolean;
var
   i : integer ;
begin
   Result := False;
   if (n < 0)or(n >= cDefN) then exit;    // vfIndex`FbN
   if not(cDef[n].exf) then exit;         // ɍ폜
   if (dn < 0)or(dn >= cDefDN) then exit; // f[^vfIndex`FbN
   if (id < 1) then exit ;
   i := CCrvIDCheck(n,id);    // IDԍgpςǂ`FbN
   if (i >= 0) then exit ;    // IDԍgp
   //
   if (col < 0) or (col > zColMax) then col := 0 ;
   if (ltp < 0) or (ltp > zLtpMax) then ltp := 0 ;
   if (wid < 0) or (wid > zWidMax) then wid := 0 ;
   if (inv <> 0) then inv := 1 ;

   if (DelCCurveDef(n)) then begin
      if (AddCCurveDef(id,col,ltp,wid,inv)) then begin
         with cDef[cDefN-1] do begin
            cnt   := cn ;
            datn  := dn ;
         end;
         Dec(cDefDN);         // vff[^͒ǉȂ̂-1Ă
         Result := True ;
      end;
   end;
end;

// Ȑ`@f[^}̓o^
//    idn: IDԍIndex(0-)
//    tp : f[^^Cv (1-)
//    no : f[^ԍ   (0-)
function TDataClass.AddCCrvDataOrder(idn,tp,no:integer) : Boolean;
var
   dn : integer ;
begin
   Result := False;
   with cDef[idn] do begin
      dn := datn ;
   end;
   with cDefD[dn] do begin
      try
         Inc(mOrdN);
         if ((mOrdN mod 100) = 1) then SetLength(mOrd, mOrdN+99);    // 100m
         with mOrd[mOrdN-1] do begin
            DataType := tp ;
            DataNo   := no ;
         end;
         Result := True ;
      except
         Dec(mOrdN);
      end;
   end;
end;

// Ȑ`@ܐ@f[^ڂ̒ǉo^
//    id : IDԍ(1-)
//    num: _
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:o^OK@False:NG
function TDataClass.AddCCrvDataLines(id,num:integer;vx,vy:array of double) : Boolean;
var
   i,idn,dn : integer ;
begin
   Result := False;
   idn := CCrvIDCheck(id);    // IDԍLǂ`FbN
   if (idn = -1) then exit ;  // IDԍ

   if (num <=0) then exit ;
   try
      for i:=1 to num-1 do
         if (SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ; // _
   except
      exit ;   // IzG[
   end;

   with cDef[idn] do begin
      dn := datn ;
   end;
   with cDefD[dn] do begin
      if (AddCCrvDataOrder(idn,3,mLnsN)) then begin
         try
            Inc(mLnsN);
            if ((mLnsN mod 100) = 1) then SetLength(mLns, mLnsN+99);    // 100m
            with mLns[mLnsN-1] do begin
               exf         := True ;
               Layer       := 0 ;
               Color       := 0 ;
               Ltype       := 0 ;
               line_width  := 0 ;
               Number      := num ;
               try
                  SetLength(X, Number);
                  SetLength(Y, Number);
               except
                  X := nil ;
                  Y := nil ;
                  Number := 0 ;
               end;
               for i:=0 to Number-1 do begin
                  X[i]     := vx[i];
                  Y[i]     := vy[i];
               end;
            end;
            OpAdd(7,idn,mOrdN-1);
            Result := True ;
         except
            Dec(mLnsN);
            Dec(mOrdN);
         end;
      end;
   end;
end;

// Ȑ`@~ʁ@f[^ڂ̒ǉo^
//    id : IDԍ(1-)
//@@sp : 
//    dir: (0,1)
//    cx : S_X
//    cy : S_Y
//    cr : a
//    sa : np
//    ea : Ip
// (ret) True:o^OK@False:NG
function TDataClass.AddCCrvDataArc(id,sp,dir:integer;cx,cy,cr,sa,ea:double) : Boolean;
var
   idn,dn : integer ;
begin
   Result := False;
   idn := CCrvIDCheck(id);    // IDԍLǂ`FbN
   if (idn = -1) then exit ;  // IDԍ

   if (sp < 3) or (sp > 3600) then sp := 72;
   if (cr < LIMIT10) then exit ;          // a <= 0
   if (dir <> 0) then dir := 1 ;
   sa := SetAngle(sa);
   ea := SetAngle(ea);
   if (Abs(ea-sa) < LIMIT10) then exit ;  // np = Ip

   with cDef[idn] do begin
      dn := datn ;
   end;
   with cDefD[dn] do begin
      if (AddCCrvDataOrder(idn,5,mArcN)) then begin
         try
            Inc(mArcN);
            if ((mArcN mod 100) = 1) then SetLength(mArc, mArcN+99);    // 100m
            with mArc[mArcN-1] do begin
               exf         := True ;
               Layer       := 0 ;
               Color       := 0 ;
               Ltype       := 0 ;
               line_width  := 0 ;
               sep         := sp ;
               Center_x    := cx ;
               Center_y    := cy ;
               Radius      := cr ;
               Direction   := dir ;
               start_angle := sa ;
               end_angle   := ea ;
            end;
            OpAdd(7,idn,mOrdN-1);
            Result := True ;
         except
            Dec(mArcN);
            Dec(mOrdN);
         end;
      end;
   end;
end;

// Ȑ`@ȉ~ʁ@f[^ڂ̒ǉo^
//    id : IDԍ(1-)
//@@sp : 
//    dir: (0,1)
//    cx : S_X
//    cy : S_Y
//    rx : wa
//    ry : xa
//    ra : ]p
//    sa : np
//    ea : Ip
// (ret) True:o^OK@False:NG
function TDataClass.AddCCrvDataEllipseArc(id,sp,dir:integer;cx,cy,rx,ry,ra,sa,ea:double) : Boolean;
var
   idn,dn : integer ;
begin
   Result := False;
   idn := CCrvIDCheck(id);    // IDԍLǂ`FbN
   if (idn = -1) then exit ;  // IDԍ

   if (sp < 3) or (sp > 3600) then sp := 72;
   if (rx < LIMIT10)or(ry < LIMIT10) then exit ;   // a <= 0
   if (dir <> 0) then dir := 1 ;
   ra := SetAngle(ra);
   sa := SetAngle(sa);
   ea := SetAngle(ea);
   if (Abs(ea-sa) < LIMIT10) then exit ;  // np = Ip

   with cDef[idn] do begin
      dn := datn ;
   end;
   with cDefD[dn] do begin
      if (AddCCrvDataOrder(idn,7,mEArN)) then begin
         try
            Inc(mEArN);
            if ((mEArN mod 100) = 1) then SetLength(mEAr, mEArN+99); // 100m
            with mEAr[mEArN-1] do begin
               exf         := True ;
               Layer       := 0 ;
               Color       := 0 ;
               Ltype       := 0 ;
               line_width  := 0 ;
               sep         := sp ;
               Center_x    := cx ;
               Center_y    := cy ;
               Radius_x    := rx ;
               Radius_y    := ry ;
               Direction   := dir ;
               rotation_angle := ra ;
               start_angle := sa ;
               end_angle   := ea ;
            end;
            OpAdd(7,idn,mOrdN-1);
            Result := True ;
         except
            Dec(mEArN);
            Dec(mOrdN);
         end;
      end;
   end;
end;

// Ȑ`@xWFȐ@f[^ڂ̒ǉo^
//    id : IDԍ(1-)
//@@sp : _ԕ
//    num: _(1-1000)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:o^OK@False:NG
function TDataClass.AddCCrvDataBezier(id,sp,num:integer;vx,vy:array of double) : Boolean;
var
   i,idn,dn : integer ;
   oc : integer ; // J敪(0: 1:J)
begin
   Result := False;
   idn := CCrvIDCheck(id);    // IDԍLǂ`FbN
   if (idn = -1) then exit ;  // IDԍ

   if (sp <  1)   then sp := 1 ;
   if (sp > 1000) then sp := 1000 ;
   if ( ((num-1)mod 3) > 0) then num := ((num-1) div 3)*3+1;
   if (num <= 1) then exit ;
   try
      for i:=1 to num-1 do
         if (((i-2) mod 3) > 0)
          and(SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ;   // _i_1Ɛ_2͓ł\Ȃj
   except
      exit ;   // IzG[
   end;

   oc := 1;
   if (Abs(vx[0]-vx[num-1]) < LIMIT10)
   and(Abs(vy[0]-vy[num-1]) < LIMIT10) then oc := 0;  // 

   with cDef[idn] do begin
      dn := datn ;
   end;
   with cDefD[dn] do begin
      if (AddCCrvDataOrder(idn,9,mBezN)) then begin
         try
            Inc(mBezN);
            if ((mBezN mod 100) = 1) then SetLength(mBez, mBezN+99);    // 100m
            with mBez[mBezN-1] do begin
               exf         := True ;
               Layer       := 0 ;
               Color       := 0 ;
               Ltype       := 0 ;
               line_width  := 0 ;
               open_close  := oc ;
               sep         := sp ;
               Number      := num ;
               try
                  SetLength(X, Number);
                  SetLength(Y, Number);
               except
                  X := nil ;
                  Y := nil ;
                  Number := 0 ;
               end;
               for i:=0 to Number-1 do begin
                  X[i]     := vx[i];
                  Y[i]     := vy[i];
               end;
            end;
            OpAdd(7,idn,mOrdN-1);
            Result := True ;
         except
            Dec(mBezN);
            Dec(mOrdN);
         end;
      end;
   end;
end;

// Ȑ`@aXvCȐ@f[^ڂ̒ǉo^
//    id : IDԍ(1-)
//@@sp : _ԕ
//    num: _(1-1000)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:o^OK@False:NG
function TDataClass.AddCCrvDataBspline(id,sp,num:integer;vx,vy:array of double) : Boolean;
var
   i,idn,dn : integer ;
   oc : integer ; // J敪(0: 1:J)
begin
   Result := False;
   idn := CCrvIDCheck(id);    // IDԍLǂ`FbN
   if (idn = -1) then exit ;  // IDԍ

   if (sp <  1)   then sp := 1 ;
   if (sp > 1000) then sp := 1000 ;
   if (num <= 2) then exit ;
   try
      for i:=1 to num-1 do
         if (SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ; // _
   except
      exit ;   // IzG[
   end;

   oc := 1;
   if (Abs(vx[0]-vx[num-1]) < LIMIT10)
   and(Abs(vy[0]-vy[num-1]) < LIMIT10) then oc := 0;  // 

   with cDef[idn] do begin
      dn := datn ;
   end;
   with cDefD[dn] do begin
      if (AddCCrvDataOrder(idn,10,mBspN)) then begin
         try
            Inc(mBspN);
            if ((mBspN mod 100) = 1) then SetLength(mBsp, mBspN+99);    // 100m
            with mBsp[mBspN-1] do begin
               exf         := True ;
               Layer       := 0 ;
               Color       := 0 ;
               Ltype       := 0 ;
               line_width  := 0 ;
               open_close  := oc ;
               sep         := sp ;
               Number      := num ;
               try
                  SetLength(X, Number);
                  SetLength(Y, Number);
               except
                  X := nil ;
                  Y := nil ;
                  Number := 0 ;
               end;
               for i:=0 to Number-1 do begin
                  X[i]     := vx[i];
                  Y[i]     := vy[i];
               end;
            end;
            OpAdd(7,idn,mOrdN-1);
            Result := True ;
         except
            Dec(mBspN);
            Dec(mOrdN);
         end;
      end;
   end;
end;

// Ȑ`@XvCȐ@f[^ڂ̒ǉo^
//    id : IDԍ(1-)
//    stp: Ȑ^Cv (1:CXvC 2:xWF 3:NUBS)
//@@sp : _ԕ
//    num: _(1-1000)
//    av : CXvĈ`l(0-1 ʏ0.5)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:o^OK@False:NG
function TDataClass.AddCCrvDataSpline(id,stp,sp,num:integer;av:double;vx,vy:array of double) : Boolean;
var
   i,idn,dn : integer ;
   oc : integer ; // J敪(0: 1:J)
begin
   Result := False;
   idn := CCrvIDCheck(id);    // IDԍLǂ`FbN
   if (idn = -1) then exit ;  // IDԍ

   if (stp < 1) or (stp > 3) then stp := 1 ;
   if (sp <  1)   then sp := 1 ;
   if (sp > 1000) then sp := 1000 ;
   if (num <= 2) then exit ;
   try
      for i:=1 to num-1 do
         if (SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ; // _
   except
      exit ;   // IzG[
   end;

   oc := 1;
   if (Abs(vx[0]-vx[num-1]) < LIMIT10)
   and(Abs(vy[0]-vy[num-1]) < LIMIT10) then oc := 0;  // 

   with cDef[idn] do begin
      dn := datn ;
   end;
   with cDefD[dn] do begin
      if (AddCCrvDataOrder(idn,11,mSplN)) then begin
         try
            Inc(mSplN);
            if ((mSplN mod 100) = 1) then SetLength(mSpl, mSplN+99);    // 100m
            with mSpl[mSplN-1] do begin
               exf         := True ;
               Layer       := 0 ;
               Color       := 0 ;
               Ltype       := 0 ;
               line_width  := 0 ;
               Stype       := stp ;
               Aval        := av ;
               open_close  := oc ;
               sep         := sp ;
               Number      := num ;
               try
                  SetLength(X, Number);
                  SetLength(Y, Number);
               except
                  X := nil ;
                  Y := nil ;
                  Number := 0 ;
               end;
               for i:=0 to Number-1 do begin
                  X[i]     := vx[i];
                  Y[i]     := vy[i];
               end;
            end;
            OpAdd(7,idn,mOrdN-1);
            Result := True ;
         except
            Dec(mSplN);
            Dec(mOrdN);
         end;
      end;
   end;
end;

// Ȑ`@vff[^@폜
//    id: Ȑ` IDԍ(1-)
//    o1: vff[^ԍ
//    o2: ef[^̓o^Index 0`
procedure TDataClass.DelCCrvDataId(id,o1,o2:integer) ;
var
   n : integer ;
begin
   n := CCrvIDCheck(id);   // IDԍLǂ`FbN
   if (n = -1) then exit;  // IDԍ
   DelCCrvDataNo(n,o1,o2);
end;

// Ȑ`@vff[^@폜
//    n : Ȑ` vfIndex (0-)
//    o1: vff[^ԍ
//    o2: ef[^̓o^Index 0`
procedure TDataClass.DelCCrvDataNo(n,o1,o2:integer) ;
var
   i,dn : integer ;
begin
   if (o1 <= 0)or(o2 < 0) then exit ;

   if (n >= 0)and(n < cDefN) then begin
      with cDef[n] do begin
         dn := datn ;
      end;
      with cDefD[dn] do begin
         for i:=mOrdN-1 downto 0 do begin
            if (o1 = mOrd[i].DataType)
            and(o2 = mOrd[i].DataNo) then begin
               OpAdd(8,n,i);
               break ;
            end;
         end;
         case (o1) of
         3: begin
               // ܐ
               if (o2 < mLnsN) then begin
                  with mLns[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         5: begin
               // ~
               if (o2 < mArcN) then begin
                  with mArc[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         7: begin
               // ȉ~
               if (o2 < mEArN) then begin
                  with mEAr[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         9: begin
               // xWFȐ
               if (o2 < mBezN) then begin
                  with mBez[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         10:begin
               // aXvCȐ
               if (o2 < mBspN) then begin
                  with mBsp[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         11:begin
               // XvCȐ
               if (o2 < mSplN) then begin
                  with mSpl[o2] do begin
                     exf := False ;
                  end;
               end;
            end;
         end;
      end;
   end;
end;

// Ȑ`@ܐ@f[^ڂ̎擾
//    id : Ȑ` IDԍ(1-)
//    n  : ܐ         vfIndex (0-)
//    ex : ݃tO
//    num: _
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y       nil ̏ꍇ͎擾Ȃ
// (ret) True:OK@False:NG
function TDataClass.GetCCrvDataLines(id,n:integer;var ex:Boolean;var num:integer;var vx,vy:array of double) : Boolean;
var
   idn,dn,i,lx,ly,nn : integer ;
begin
   Result := False;
   idn := CCrvIDCheck(id);    // IDԍLǂ`FbN
   if (idn = -1) then exit ;  // IDԍ

   dn := cDef[idn].datn ;
   lx := Length(vx) ;
   ly := Length(vy) ;

   with cDefD[dn] do begin
      if (n < 0)or(n >= mLnsN) then exit ;
      with mLns[n] do begin
         ex    := exf ;
         num   := Number ;
         if (lx > 0)and(ly > 0) then begin
            nn := num ;
            if (nn > lx) then nn := lx ;  // G[̒
            if (nn > ly) then nn := ly ;
            try
               for i:=0 to nn-1 do begin
                  vx[i] := X[i];
                  vy[i] := Y[i];
               end;
            except
               ;
            end;
         end;
      end;
   end;
   Result := True ;
end;

// Ȑ`@~ʁ@f[^ڂ̎擾
//    id : Ȑ` IDԍ(1-)
//    n  : ~         vfIndex (0-)
//    ex : ݃tO
//@@sp : 
//    dir: (0,1)
//    cx : S_X
//    cy : S_Y
//    cr : a
//    sa : np
//    ea : Ip
// (ret) True:OK@False:NG
function TDataClass.GetCCrvDataArc(id,n:integer;var ex:Boolean;var sp,dir:integer;var cx,cy,cr,sa,ea:double) : Boolean;
var
   idn,dn : integer ;
begin
   Result := False;
   idn := CCrvIDCheck(id);    // IDԍLǂ`FbN
   if (idn = -1) then exit ;  // IDԍ

   dn := cDef[idn].datn ;
   with cDefD[dn] do begin
      if (n < 0)or(n >= mArcN) then exit ;
      with mArc[n] do begin
         ex := exf ;
         sp := sep ;
         cx := Center_x ;
         cy := Center_y ;
         cr := Radius ;
         dir:= Direction ;
         sa := start_angle ;
         ea := end_angle ;
      end;
   end;
   Result := True ;
end;

// Ȑ`@ȉ~ʁ@f[^ڂ̎擾
//    id : Ȑ` IDԍ(1-)
//    n  : ȉ~       vfIndex (0-)
//    ex : ݃tO
//@@sp : 
//    dir: (0,1)
//    cx : S_X
//    cy : S_Y
//    rx : wa
//    ry : xa
//    ra : ]p
//    sa : np
//    ea : Ip
// (ret) True:OK@False:NG
function TDataClass.GetCCrvDataEllipseArc(id,n:integer;var ex:Boolean;var sp,dir:integer;var cx,cy,rx,ry,ra,sa,ea:double) : Boolean;
var
   idn,dn : integer ;
begin
   Result := False;
   idn := CCrvIDCheck(id);    // IDԍLǂ`FbN
   if (idn = -1) then exit ;  // IDԍ

   dn := cDef[idn].datn ;
   with cDefD[dn] do begin
      if (n < 0)or(n >= mEArN) then exit ;
      with mEAr[n] do begin
         ex := exf ;
         sp := sep ;
         cx := Center_x ;
         cy := Center_y ;
         rx := Radius_x ;
         ry := Radius_y ;
         dir:= Direction ;
         ra := rotation_angle ;
         sa := start_angle ;
         ea := end_angle ;
      end;
   end;
   Result := True ;
end;

// Ȑ`@xWFȐ@f[^ڂ̎擾
//    id : Ȑ` IDԍ(1-)
//    n  : xWFȐ   vfIndex (0-)
//    ex : ݃tO
//    oc : J敪F0: 1:J
//@@sp : _ԕ
//    num: _(1-1000)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y       nil ̏ꍇ͎擾Ȃ
// (ret) True:OK@False:NG
function TDataClass.GetCCrvDataBezier(id,n:integer;var ex:Boolean;var oc,sp,num:integer;var vx,vy:array of double) : Boolean;
var
   idn,dn,i,lx,ly,nn : integer ;
begin
   Result := False;
   idn := CCrvIDCheck(id);    // IDԍLǂ`FbN
   if (idn = -1) then exit ;  // IDԍ

   dn := cDef[idn].datn ;
   lx := Length(vx) ;
   ly := Length(vy) ;

   with cDefD[dn] do begin
      if (n < 0)or(n >= mBezN) then exit ;
      with mBez[n] do begin
         ex := exf ;
         oc := open_close ;
         sp := sep ;
         num:= Number ;
         if (lx > 0)and(ly > 0) then begin
            nn := num ;
            if (nn > lx) then nn := lx ;  // G[̒
            if (nn > ly) then nn := ly ;
            try
               for i:=0 to nn-1 do begin
                  vx[i] := X[i];
                  vy[i] := Y[i];
               end;
            except
               ;
            end;
         end;
      end;
   end;
   Result := True ;
end;

// Ȑ`@aXvCȐ@f[^ڂ̎擾
//    id : Ȑ` IDԍ(1-)
//    n  : BXvC  vfIndex (0-)
//    ex : ݃tO
//    oc : J敪F0: 1:J
//@@sp : _ԕ
//    num: _(1-1000)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y       nil ̏ꍇ͎擾Ȃ
// (ret) True:OK@False:NG
function TDataClass.GetCCrvDataBspline(id,n:integer;var ex:Boolean;var oc,sp,num:integer;var vx,vy:array of double) : Boolean;
var
   idn,dn,i,lx,ly,nn : integer ;
begin
   Result := False;
   idn := CCrvIDCheck(id);    // IDԍLǂ`FbN
   if (idn = -1) then exit ;  // IDԍ

   dn := cDef[idn].datn ;
   lx := Length(vx) ;
   ly := Length(vy) ;

   with cDefD[dn] do begin
      if (n < 0)or(n >= mBspN) then exit ;
      with mBsp[n] do begin
         ex := exf ;
         oc := open_close ;
         sp := sep ;
         num:= Number ;
         if (lx > 0)and(ly > 0) then begin
            nn := num ;
            if (nn > lx) then nn := lx ;  // G[̒
            if (nn > ly) then nn := ly ;
            try
               for i:=0 to nn-1 do begin
                  vx[i] := X[i];
                  vy[i] := Y[i];
               end;
            except
               ;
            end;
         end;
      end;
   end;
   Result := True ;
end;

// Ȑ`@XvCȐ@f[^ڂ̎擾
//    id : Ȑ` IDԍ(1-)
//    n  : XvC   vfIndex (0-)
//    ex : ݃tO
//    stp: Ȑ^Cv (1:CXvC 2:xWF 3:NUBS)
//    oc : J敪F0: 1:J
//@@sp : _ԕ
//    num: _(1-1000)
//    av : CXvĈ`l(0-1 ʏ0.5)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y       nil ̏ꍇ͎擾Ȃ
// (ret) True:OK@False:NG
function TDataClass.GetCCrvDataSpline(id,n:integer;var ex:Boolean;var stp,oc,sp,num:integer;var av:double;var vx,vy:array of double) : Boolean;
var
   idn,dn,i,lx,ly,nn : integer ;
begin
   Result := False;
   idn := CCrvIDCheck(id);    // IDԍLǂ`FbN
   if (idn = -1) then exit ;  // IDԍ

   dn := cDef[idn].datn ;
   lx := Length(vx) ;
   ly := Length(vy) ;

   with cDefD[dn] do begin
      if (n < 0)or(n >= mSplN) then exit ;
      with mSpl[n] do begin
         ex := exf ;
         stp:= Stype ;
         oc := open_close ;
         sp := sep ;
         num:= Number ;
         av := Aval ;
         if (lx > 0)and(ly > 0) then begin
            nn := num ;
            if (nn > lx) then nn := lx ;  // G[̒
            if (nn > ly) then nn := ly ;
            try
               for i:=0 to nn-1 do begin
                  vx[i] := X[i];
                  vy[i] := Y[i];
               end;
            except
               ;
            end;
         end;
      end;
   end;
   Result := True ;
end;

// Ȑ`@ܐ@f[^ڂ̕ҏWo^
//    id : Ȑ` IDԍ(1-)
//    n  : ܐ         vfIndex (0-)
//    num: _
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:o^OK@False:NG
function TDataClass.EditCCrvDataLines(id,n,num:integer;vx,vy:array of double) : Boolean;
var
   idn,dn,i : integer ;
begin
   Result := False;
   idn := CCrvIDCheck(id);    // IDԍLǂ`FbN
   if (idn = -1) then exit ;  // IDԍ

   dn := cDef[idn].datn ;
   if (n < 0)or(n >= cDefD[dn].mLnsN) then exit ;

   if (num <=0) then exit ;
   try
      for i:=1 to num-1 do
         if (SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ; // _
   except
      exit ;   // IzG[
   end;

   DelCCrvDataNo(idn,3,n);
   if (AddCCrvDataLines(id,num,vx,vy)) then Result := True ;
end;

// Ȑ`@~ʁ@f[^ڂ̕ҏWo^
//    id : Ȑ` IDԍ(1-)
//    n  : ~         vfIndex (0-)
//@@sp : 
//    dir: (0,1)
//    cx : S_X
//    cy : S_Y
//    cr : a
//    sa : np
//    ea : Ip
// (ret) True:o^OK@False:NG
function TDataClass.EditCCrvDataArc(id,n,sp,dir:integer;cx,cy,cr,sa,ea:double) : Boolean;
var
   idn,dn : integer ;
begin
   Result := False;
   idn := CCrvIDCheck(id);    // IDԍLǂ`FbN
   if (idn = -1) then exit ;  // IDԍ

   dn := cDef[idn].datn ;
   if (n < 0)or(n >= cDefD[dn].mArcN) then exit ;

   if (sp < 3) or (sp > 3600) then sp := 72;
   if (cr < LIMIT10) then exit ;          // a <= 0
   if (dir <> 0) then dir := 1 ;
   sa := SetAngle(sa);
   ea := SetAngle(ea);
   if (Abs(ea-sa) < LIMIT10) then exit ;  // np = Ip

   DelCCrvDataNo(idn,5,n);
   if (AddCCrvDataArc(id,sp,dir,cx,cy,cr,sa,ea)) then Result := True ;
end;

// Ȑ`@ȉ~ʁ@f[^ڂ̕ҏWo^
//    id : Ȑ` IDԍ(1-)
//    n  : ȉ~       vfIndex (0-)
//@@sp : 
//    dir: (0,1)
//    cx : S_X
//    cy : S_Y
//    rx : wa
//    ry : xa
//    ra : ]p
//    sa : np
//    ea : Ip
// (ret) True:o^OK@False:NG
function TDataClass.EditCCrvDataEllipseArc(id,n,sp,dir:integer;cx,cy,rx,ry,ra,sa,ea:double) : Boolean;
var
   idn,dn : integer ;
begin
   Result := False;
   idn := CCrvIDCheck(id);    // IDԍLǂ`FbN
   if (idn = -1) then exit ;  // IDԍ

   dn := cDef[idn].datn ;
   if (n < 0)or(n >= cDefD[dn].mEArN) then exit ;

   if (sp < 3) or (sp > 3600) then sp := 72;
   if (rx < LIMIT10)or(ry < LIMIT10) then exit ;   // a <= 0
   if (dir <> 0) then dir := 1 ;
   ra := SetAngle(ra);
   sa := SetAngle(sa);
   ea := SetAngle(ea);
   if (Abs(ea-sa) < LIMIT10) then exit ;  // np = Ip

   DelCCrvDataNo(idn,7,n);
   if (AddCCrvDataEllipseArc(id,sp,dir,cx,cy,rx,ry,ra,sa,ea)) then Result := True ;
end;

// Ȑ`@xWFȐ@f[^ڂ̕ҏWo^
//    id : Ȑ` IDԍ(1-)
//    n  : xWFȐ   vfIndex (0-)
//@@sp : _ԕ
//    num: _(1-1000)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:o^OK@False:NG
function TDataClass.EditCCrvDataBezier(id,n,sp,num:integer;vx,vy:array of double) : Boolean;
var
   idn,dn,i : integer ;
begin
   Result := False;
   idn := CCrvIDCheck(id);    // IDԍLǂ`FbN
   if (idn = -1) then exit ;  // IDԍ

   dn := cDef[idn].datn ;
   if (n < 0)or(n >= cDefD[dn].mBezN) then exit ;

   if (sp <  1)   then sp := 1 ;
   if (sp > 1000) then sp := 1000 ;
   if ( ((num-1)mod 3) > 0) then num := ((num-1) div 3)*3+1;
   if (num <= 1) then exit ;
   try
      for i:=1 to num-1 do
         if (((i-2) mod 3) > 0)
          and(SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ;   // _i_1Ɛ_2͓ł\Ȃj
   except
      exit ;   // IzG[
   end;

   DelCCrvDataNo(idn,9,n);
   if (AddCCrvDataBezier(id,sp,num,vx,vy)) then Result := True ;
end;

// Ȑ`@aXvCȐ@f[^ڂ̕ҏWo^
//    id : Ȑ` IDԍ(1-)
//    n  : BXvC  vfIndex (0-)
//@@sp : _ԕ
//    num: _(1-1000)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:o^OK@False:NG
function TDataClass.EditCCrvDataBspline(id,n,sp,num:integer;vx,vy:array of double) : Boolean;
var
   idn,dn,i : integer ;
begin
   Result := False;
   idn := CCrvIDCheck(id);    // IDԍLǂ`FbN
   if (idn = -1) then exit ;  // IDԍ

   dn := cDef[idn].datn ;
   if (n < 0)or(n >= cDefD[dn].mBspN) then exit ;

   if (sp <  1)   then sp := 1 ;
   if (sp > 1000) then sp := 1000 ;
   if (num <= 2) then exit ;
   try
      for i:=1 to num-1 do
         if (SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ; // _
   except
      exit ;   // IzG[
   end;

   DelCCrvDataNo(idn,10,n);
   if (AddCCrvDataBspline(id,sp,num,vx,vy)) then Result := True ;
end;

// Ȑ`@XvCȐ@f[^ڂ̕ҏWo^
//    id : Ȑ` IDԍ(1-)
//    n  : XvC   vfIndex (0-)
//    stp: Ȑ^Cv (1:CXvC 2:xWF 3:NUBS)
//@@sp : _ԕ
//    num: _(1-1000)
//    av : CXvĈ`l(0-1 ʏ0.5)
//    vx : _X     ĂяoœIzmۂsĂ鎖
//    vy : _Y
// (ret) True:o^OK@False:NG
function TDataClass.EditCCrvDataSpline(id,n,stp,sp,num:integer;av:double;vx,vy:array of double) : Boolean;
var
   idn,dn,i : integer ;
begin
   Result := False;
   idn := CCrvIDCheck(id);    // IDԍLǂ`FbN
   if (idn = -1) then exit ;  // IDԍ

   dn := cDef[idn].datn ;
   if (n < 0)or(n >= cDefD[dn].mSplN) then exit ;

   if (stp < 1) or (stp > 3) then stp := 1 ;
   if (sp <  1)   then sp := 1 ;
   if (sp > 1000) then sp := 1000 ;
   if (num <= 2) then exit ;
   try
      for i:=1 to num-1 do
         if (SamePosCheck(vx[i],vy[i], vx[i-1],vy[i-1])) then exit ; // _
   except
      exit ;   // IzG[
   end;

   DelCCrvDataNo(idn,11,n);
   if (AddCCrvDataSpline(id,stp,sp,num,av,vx,vy)) then Result := True ;
end;

// Ȑ`IDԍLǂ`FbN
//    id : IDԍ(1-)
//    (ret) Ȑ`̔z̓Y 0` -1:error
function TDataClass.CCrvIDCheck(id:integer) : integer ;
var
   i,idn : integer ;
begin
   idn := -1 ;
   for i:=0 to cDefN-1 do begin
      if not(cDef[i].exf) then continue ;
      if (cDef[i].number = id) then begin
         idn := i ;
         break ;
      end;
   end;
   Result := idn ;
end;

// Ȑ`IDԍLǂ`FbN
//    n  : `FbNOvfindex(-1:OȂ,0`)
//    id : IDԍ(1-)
//    (ret) Ȑ`̔z̓Y 0` -1:error
function TDataClass.CCrvIDCheck(n,id:integer) : integer ;
var
   i,idn : integer ;
begin
   idn := -1 ;
   for i:=0 to cDefN-1 do begin
      if not(cDef[i].exf) then continue ;
      if (n >= 0)and(i = n) then continue;   // wIndex̓`FbNX[
      if (cDef[i].number = id) then begin
         idn := i ;
         break ;
      end;
   end;
   Result := idn ;
end;

// Ȑ`f[^̐ڑ`FbN
//    id : IDԍ(1-)
//    (ret) True:OK@False:NG
function TDataClass.CCrvDataCheck(id:integer) : Boolean ;
var
   idn,o,o1,o2,dn : integer ;
   fl : Boolean ;
   wx0,wy0,wx1,wy1,wx2,wy2,wx3,wy3,wx4,wy4 : double ;
begin
   Result := False;
   idn := CCrvIDCheck(id);    // IDԍLǂ`FbN
   if (idn = -1) then exit ;  // IDԍ

   wx0 := 0.0; wy0 := 0.0;
   wx2 := 0.0; wy2 := 0.0;
   fl := True ;
   with cDef[idn] do begin
      dn := datn ;
   end;
   with cDefD[dn] do begin
      for o:=0 to mOrdN-1 do begin
         o1 := mOrd[o].DataType ;
         o2 := mOrd[o].DataNo ;
         case (o1) of
         3: begin
               // ܐf[^
               with mLns[o2] do begin
                  if not(exf) then continue ;
                  if (o = 0) then begin
                     wx0 := X[0] ;
                     wy0 := Y[0] ;
                  end
                  else begin
                     wx1 := X[0] ;
                     wy1 := Y[0] ;
                     if ((wx2-wx1)*(wx2-wx1)+(wy2-wy1)*(wy2-wy1) > LIMIT6) then begin
                        fl := False ;
                        break ;
                     end;
                  end;
                  wx2 := X[Number-1] ;
                  wy2 := Y[Number-1] ;
               end;
            end;
         5: begin
               // ~ʃf[^
               with mArc[o2] do begin
                  if not(exf) then continue ;
                  if (o = 0) then begin
                     wx0 := Center_x + Radius*Cos(start_angle/180.0*Pi) ;
                     wy0 := Center_y + Radius*Sin(start_angle/180.0*Pi) ;
                  end
                  else begin
                     wx1 := Center_x + Radius*Cos(start_angle/180.0*Pi) ;
                     wy1 := Center_y + Radius*Sin(start_angle/180.0*Pi) ;
                     if ((wx2-wx1)*(wx2-wx1)+(wy2-wy1)*(wy2-wy1) > LIMIT6) then begin
                        fl := False ;
                        break ;
                     end;
                  end;
                  wx2 := Center_x + Radius*Cos(  end_angle/180.0*Pi) ;
                  wy2 := Center_y + Radius*Sin(  end_angle/180.0*Pi) ;
               end;
            end;
         7: begin
               // ȉ~ʃf[^
               with mEAr[o2] do begin
                  if not(exf) then continue ;
                  if (o = 0) then begin
                     wx3 := Radius_x*Cos(start_angle/180.0*Pi) ;
                     wy3 := Radius_y*Sin(start_angle/180.0*Pi) ;
                     dRev(wx4,wy4, wx3,wy3, 0.0,0.0, rotation_angle);
                     wx0 := Center_x + wx4 ;
                     wy0 := Center_y + wy4 ;
                  end
                  else begin
                     wx3 := Radius_x*Cos(start_angle/180.0*Pi) ;
                     wy3 := Radius_y*Sin(start_angle/180.0*Pi) ;
                     dRev(wx4,wy4, wx3,wy3, 0.0,0.0, rotation_angle);
                     wx1 := Center_x + wx4 ;
                     wy1 := Center_y + wy4 ;
                     if ((wx2-wx1)*(wx2-wx1)+(wy2-wy1)*(wy2-wy1) > LIMIT6) then begin
                        fl := False ;
                        break ;
                     end;
                  end;
                  wx3 := Radius_x*Cos(  end_angle/180.0*Pi) ;
                  wy3 := Radius_y*Sin(  end_angle/180.0*Pi) ;
                  dRev(wx4,wy4, wx3,wy3, 0.0,0.0, rotation_angle);
                  wx2 := Center_x + wx4 ;
                  wy2 := Center_y + wy4 ;
               end;
            end;
         9: begin
               // xWFȐf[^
               with mBez[o2] do begin
                  if not(exf) then continue ;
                  if (o = 0) then begin
                     wx0 := X[0] ;
                     wy0 := Y[0] ;
                  end
                  else begin
                     wx1 := X[0] ;
                     wy1 := Y[0] ;
                     if ((wx2-wx1)*(wx2-wx1)+(wy2-wy1)*(wy2-wy1) > LIMIT6) then begin
                        fl := False ;
                        break ;
                     end;
                  end;
                  wx2 := X[Number-1] ;
                  wy2 := Y[Number-1] ;
               end;
            end;
         10:begin
               // aXvCȐf[^
               with mBsp[o2] do begin
                  if not(exf) then continue ;
                  if (o = 0) then begin
                     wx0 := X[0] ;
                     wy0 := Y[0] ;
                  end
                  else begin
                     wx1 := X[0] ;
                     wy1 := Y[0] ;
                     if ((wx2-wx1)*(wx2-wx1)+(wy2-wy1)*(wy2-wy1) > LIMIT6) then begin
                        fl := False ;
                        break ;
                     end;
                  end;
                  wx2 := X[Number-1] ;
                  wy2 := Y[Number-1] ;
               end;
            end;
         11:begin
               // XvCȐf[^
               with mSpl[o2] do begin
                  if not(exf) then continue ;
                  if (o = 0) then begin
                     wx0 := X[0] ;
                     wy0 := Y[0] ;
                  end
                  else begin
                     wx1 := X[0] ;
                     wy1 := Y[0] ;
                     if ((wx2-wx1)*(wx2-wx1)+(wy2-wy1)*(wy2-wy1) > LIMIT6) then begin
                        fl := False ;
                        break ;
                     end;
                  end;
                  wx2 := X[Number-1] ;
                  wy2 := Y[Number-1] ;
               end;
            end;
         end;
      end;
   end;
   if (fl) then begin
      if ((wx2-wx0)*(wx2-wx0)+(wy2-wy0)*(wy2-wy0) > LIMIT6) then
         fl := False ;
   end;
   Result := fl ;
end;

// Ȑ`f[^nb`Ö}`֘Af[^ƂēWJ
//    id : IDԍ(1-)
//    no : nb`Ö}`ԍ(1-)
//    (ret) True:OK@False:NG
// nb`Ö}` zHAr,zHArN ͗\߃ZbgEmۂĂ鎖
function TDataClass.CCrvDataToHAr(id,no:integer) : Boolean ;
var
   i,j,k,n,idn,o,o1,o2,dn : integer ;
   e : TMatrix ;
begin
   Result := False;
   idn := CCrvIDCheck(id);    // IDԍLǂ`FbN
   if (idn = -1) then exit ;  // IDԍ

   if (no < 1)or(no > zHArN) then exit ;  // nb`Ö}`ԍ
   zHAr[no-1].an := 0 ;
   zHAr[no-1].a  := nil;

   Result := True ;
   MtxSetE(e);
   with cDef[idn] do begin
      dn := datn ;
   end;
   with cDefD[dn] do begin
      for o:=0 to mOrdN-1 do begin
         o1 := mOrd[o].DataType ;
         o2 := mOrd[o].DataNo ;
         tLnsN := 0;
         case (o1) of
         3: begin
               // ܐf[^
               with mLns[o2] do begin
                  if not(exf) then continue ;
                  TransLinesToLines(Number,X,Y,e);
               end;
            end;
         5: begin
               // ~ʃf[^
               with mArc[o2] do begin
                  if not(exf) then continue ;
                  TransArcToLines(sep,Direction,Center_x,Center_y,Radius,start_angle,end_angle,e);
               end;
            end;
         7: begin
               // ȉ~ʃf[^
               with mEAr[o2] do begin
                  if not(exf) then continue ;
                  TransEllipseArcToLines(sep,Direction,Center_x,Center_y,Radius_x,Radius_y,rotation_angle,start_angle,end_angle,e);
               end;
            end;
         9: begin
               // xWFȐf[^
               with mBez[o2] do begin
                  if not(exf) then continue ;
                  TransBezierToLines(sep,Number,X,Y,e);
               end;
            end;
         10:begin
               // aXvCȐf[^
               with mBsp[o2] do begin
                  if not(exf) then continue ;
                  TransBsplineToLines(open_close,sep,Number,X,Y,e);
               end;
            end;
         11:begin
               // XvCȐf[^
               with mSpl[o2] do begin
                  if not(exf) then continue ;
                  TransSplineToLines(Stype,open_close,sep,Number,Aval,X,Y,e);
               end;
            end;
         end;
         if (tLnsN > 0) then begin
            j := 0 ;
            n := zHAr[no-1].an ;
            if (n > 0) then begin
               if (SamePosCheck(zHAr[no-1].a[n-1].x,zHAr[no-1].a[n-1].y,
                  tLns[0].x,tLns[0].y)) then
                  j := 1 ;
            end;
            zHAr[no-1].an := n + tLnsN - j ;
            SetLength(zHAr[no-1].a, zHAr[no-1].an);
            for i:=j to tLnsN-1 do begin
               zHAr[no-1].a[n].x := tLns[i].x ;
               zHAr[no-1].a[n].y := tLns[i].y ;
               Inc(n);
            end;
         end;
      end;
   end;
   tLnsN := 0;
   tLns  := nil;
   if (zHAr[no-1].an <= 1) then
      Result := False ; // AG[
end;

// nb`Ö}`@Af[^@̎Ȍ`FbN
//    no : nb`Ö}`ԍ(1-)
//    (ret) True:OK@False:NG
// nb`Ö}` zHAr,zHArN ͗\߃ZbgEmۂĂ鎖
function TDataClass.HArDataSelfIntersectCheck(no:integer) : Boolean ;
var
   i,j,k : integer ;
   rx,ry:double ;
begin
   Result := False ;
   if (no < 1)or(no > zHArN) then exit ;  // nb`Ö}`ԍ

   Result := True ;
   with zHAr[no-1] do begin
      for i:=0 to an-3 do begin
         for j:=i+2 to an-2 do begin
            if (i = 0)and(j = (an-2)) then continue;
            if (BoxAreaCheck(a[i].x,a[i].y, a[i+1].x,a[i+1].y,
                             a[j].x,a[j].y, a[j+1].x,a[j+1].y)) then continue ;
            k  := GetCrossLL(a[i].x,a[i].y, a[i+1].x,a[i+1].y,
                             a[j].x,a[j].y, a[j+1].x,a[j+1].y, rx,ry);
            if (k = 1) then begin
               Result := False ;
               exit ;
            end;
         end;
      end;
   end;
end;

// nb`Ö}`@Af[^@̏dȂ`FbN
//    O`ƒ̏dȂ`FbNs
//    Pł_Ƃ̎_ŏI܂
//    (ret) True:dȂĂ܂@False:dȂĂ܂
// nb`Ö}` zHAr,zHArN ͗\߃ZbgEmۂĂ鎖
function TDataClass.HArDataOverlapCheck1 : Boolean ;
var
   h,i,j,k : integer ;
   x1,y1,x2,y2,x3,y3,x4,y4,rx,ry:double ;
begin
   Result := True ;
   for h:=1 to zHArN-1 do begin
      for i:=0 to zHAr[0].an-2 do begin
         x1 := zHAr[0].a[i].x ;
         y1 := zHAr[0].a[i].y ;
         x2 := zHAr[0].a[i+1].x ;
         y2 := zHAr[0].a[i+1].y ;
         for j:=0 to zHAr[h].an-2 do begin
            x3 := zHAr[h].a[j].x ;
            y3 := zHAr[h].a[j].y ;
            x4 := zHAr[h].a[j+1].x ;
            y4 := zHAr[h].a[j+1].y ;
            if (BoxAreaCheck(x1,y1,x2,y2, x3,y3,x4,y4)) then continue ;
            k  := GetCrossLL(x1,y1,x2,y2, x3,y3,x4,y4, rx,ry);
            if (k = 1) then begin
               Result := False ;
               exit ;
            end;
         end;
      end;
   end;
end;

// nb`Ö}`@Af[^@̏dȂ`FbN
//    ƒ̏dȂ`FbNs
//    _QƂ̎_ŏI܂
//    (ret) True:dȂĂ܂@False:dȂĂ܂
// nb`Ö}` zHAr,zHArN ͗\߃ZbgEmۂĂ鎖
function TDataClass.HArDataOverlapCheck2 : Boolean ;
var
   g,h,i,j,k,l : integer ;
   x1,y1,x2,y2,x3,y3,x4,y4,rx,ry,sx,sy:double ;
begin
   Result := True ;
   sx := 0.0;
   sy := 0.0;
   for g:=1 to zHArN-2 do begin
      for h:=g+1 to zHArN-1 do begin
         l := 0;
         for i:=0 to zHAr[g].an-2 do begin
            x1 := zHAr[g].a[i].x ;
            y1 := zHAr[g].a[i].y ;
            x2 := zHAr[g].a[i+1].x ;
            y2 := zHAr[g].a[i+1].y ;
            for j:=0 to zHAr[h].an-2 do begin
               x3 := zHAr[h].a[j].x ;
               y3 := zHAr[h].a[j].y ;
               x4 := zHAr[h].a[j+1].x ;
               y4 := zHAr[h].a[j+1].y ;
               if (BoxAreaCheck(x1,y1,x2,y2, x3,y3,x4,y4)) then continue ;
               k  := GetCrossLL(x1,y1,x2,y2, x3,y3,x4,y4, rx,ry);
               if (k = 1) then begin
                  if (l = 0) then begin
                     Inc(l);
                     sx := rx ;
                     sy := ry ;
                  end
                  else begin
                     if not(SamePosCheck(rx,ry,sx,sy)) then begin
                        Result := False ;
                        exit ;
                     end;
                  end;
               end;
            end;
         end;
      end;
   end;
end;


// nb`Oƃnb`Ö}`Ƃ̌_vZ
// (in)
//    zHAr, zHArN : nb`Ö}`i̘Aj\ߓĂĉ
//    px,py : ʉߓ_W
//    pl    : inb`Ö}`Jo[钷j
//    pa    : px[]
// (out)
//    zHCp, zHCpN : _Q
//    (ret) _(zHCpNƓ)
function TDataClass.CalcHatch1Point(px,py,pl,pa:double) : integer ;
var
   x1,y1,x2,y2:double ;
begin
   x1 := px - pl*Cos(pa/180.0*Pi);
   y1 := py - pl*Sin(pa/180.0*Pi);
   x2 := px + pl*Cos(pa/180.0*Pi);
   y2 := py + pl*Sin(pa/180.0*Pi);
   Result := CalcHatch1Line(x1,y1,x2,y2,px,py,pa);
end;

// nb`Oƃnb`Ö}`Ƃ̌_vZ
// (in)
//    zHAr, zHArN : nb`Ö}`i̘Aj\ߓĂĉ
//    x1,y1 : n_W
//    x2,y2 : I_W@inb`Ö}`Jo[ĉj
//    px,py : ʉߓ_Wi_Ƃĉ]܂j
//    pa    : px[]
// (out)
//    zHCp, zHCpN : _Q
//    (ret) _(zHCpNƓ)
function TDataClass.CalcHatch1Line(x1,y1,x2,y2,px,py,pa:double) : integer ;
var
   i,j,k : integer ;
   x3,y3,x4,y4,wa,wx : double ;
   crp  : array of TWorkHatchCrossP ;
   crpn : integer ;
   crpf : Boolean ;
begin
   Result := 0 ;
   crp := nil ;
   crpn:= 0 ;
   for j:=0 to zHArN-1 do begin
      with zHAr[j] do begin
         for i:=0 to an-2 do begin
            k := GetCrossLL(a[i].x,a[i].y,a[i+1].x,a[i+1].y, x1,y1,x2,y2, x3,y3);
            if (k = 1) then begin
               Inc(crpn);
               if ((crpn mod 100) = 1) then SetLength(crp,crpn+99);
               dRev(x4,y4, x3,y3, px,py, -pa);
               crp[crpn-1].x := x4 ;
               crp[crpn-1].y := y4 ;
               crp[crpn-1].dir := 0 ;
               if (SamePosCheck(x3,y3, a[i].x,a[i].y)) then begin
                  k := i - 1;
                  if (k < 0) then k := an-2;
                  wa := SetAngle(dAngle(a[k].x-a[i].x, a[k].y-a[i].y) - pa) ;
                  if (Abs(wa) < LIMIT8)or(Abs(wa-180.0) < LIMIT8) then begin
                     crp[crpn-1].dir := 1;
                     Inc(crpn);
                     if ((crpn mod 100) = 1) then SetLength(crp,crpn+99);
                     crp[crpn-1].x := x4 ;
                     crp[crpn-1].y := y4 ;
                     crp[crpn-1].dir := 0 ;
                  end;
                  wa := SetAngle(dAngle(a[i+1].x-a[i].x, a[i+1].y-a[i].y) - pa) ;
                  if (wa < 180.0) then
                     crp[crpn-1].dir := 2
                  else
                     crp[crpn-1].dir := 3 ;
               end
               else if (SamePosCheck(x3,y3, a[i+1].x,a[i+1].y)) then begin
                  wa := SetAngle(dAngle(a[i].x-a[i+1].x, a[i].y-a[i+1].y) - pa) ;
                  if (wa < 180.0) then
                     crp[crpn-1].dir := 2
                  else
                     crp[crpn-1].dir := 3 ;
                  k := i + 2;
                  if (k > (an-1)) then k := 1;
                  wa := SetAngle(dAngle(a[k].x-a[i+1].x, a[k].y-a[i+1].y) - pa) ;
                  if (Abs(wa) < LIMIT8)or(Abs(wa-180.0) < LIMIT8) then begin
                     Inc(crpn);
                     if ((crpn mod 100) = 1) then SetLength(crp,crpn+99);
                     crp[crpn-1].x := x4 ;
                     crp[crpn-1].y := y4 ;
                     crp[crpn-1].dir := 1 ;
                  end;
               end;
            end;
         end;
      end;
   end;
   // SORT
   for i:=0 to crpn-2 do begin
      wx := crp[i].x ;
      k  := -1 ;
      for j:=i+1 to crpn-1 do begin
         if ((wx - crp[j].x) >= LIMIT10) then begin
            wx := crp[j].x ;
            k := j ;
         end;
      end;
      if (k <> -1) then begin
         SwapD(crp[i].x  , crp[k].x);
         SwapD(crp[i].y  , crp[k].y);
         SwapI(crp[i].dir, crp[k].dir);
      end;
   end;
   // _擾
   zHCpN := 0 ;
   zHCp  := nil ;
   crpf  := False ;
   i := 0 ;
   j := 0 ;
   while (i < crpn) do begin
      if (crp[i].dir = 0) then begin
         Inc(zHCpN);
         if ((zHCpN mod 100) = 1) then SetLength(zHCp,zHCpN+99);
         dRev(x4,y4, crp[i].x,crp[i].y, px,py, pa);
         zHCp[zHCpN-1].x := x4 ;
         zHCp[zHCpN-1].y := y4 ;
         crpf := not(crpf);
         j := 0 ;
      end
      else if ((i+1) < crpn) then begin
         if (crp[i].dir = 2)and(crp[i+1].dir = 3)
          or(crp[i].dir = 3)and(crp[i+1].dir = 2) then begin
            Inc(zHCpN);
            if ((zHCpN mod 100) = 1) then SetLength(zHCp,zHCpN+99);
            dRev(x4,y4, crp[i].x,crp[i].y, px,py, pa);
            zHCp[zHCpN-1].x := x4 ;
            zHCp[zHCpN-1].y := y4 ;
            crpf := not(crpf);
            j := 0 ;
         end
         else
         if (crp[i].dir = 2)and(crp[i+1].dir = 2)
          or(crp[i].dir = 3)and(crp[i+1].dir = 3) then begin
            // 
            j := 0 ;
         end
         else
         if (crp[i].dir = 2)and(crp[i+1].dir = 1)
          or(crp[i].dir = 3)and(crp[i+1].dir = 1)
          or(crp[i].dir = 1)and(crp[i+1].dir = 2)
          or(crp[i].dir = 1)and(crp[i+1].dir = 3) then begin
            if (crp[i+1].dir = 1) then begin
               x3 := crp[i].x ;
               y3 := crp[i].y ;
               k  := crp[i].dir ;
            end
            else begin
               x3 := crp[i+1].x ;
               y3 := crp[i+1].y ;
               k  := crp[i+1].dir ;
            end;
            //
            if (j = 0) then begin
               if (crpf) then begin
                  Inc(zHCpN);
                  if ((zHCpN mod 100) = 1) then SetLength(zHCp,zHCpN+99);
                  dRev(x4,y4, x3,y3, px,py, pa);
                  zHCp[zHCpN-1].x := x4 ;
                  zHCp[zHCpN-1].y := y4 ;
               end;
               j := k ;
            end
            else begin
               if (crpf) then begin
                  if (j = k) then begin
                     Inc(zHCpN);
                     if ((zHCpN mod 100) = 1) then SetLength(zHCp,zHCpN+99);
                     dRev(x4,y4, x3,y3, px,py, pa);
                     zHCp[zHCpN-1].x := x4 ;
                     zHCp[zHCpN-1].y := y4 ;
                     crpf := True ;
                  end
                  else begin
                     crpf := False ;
                  end;
               end
               else begin
                  if (j <> k) then begin
                     Inc(zHCpN);
                     if ((zHCpN mod 100) = 1) then SetLength(zHCp,zHCpN+99);
                     dRev(x4,y4, x3,y3, px,py, pa);
                     zHCp[zHCpN-1].x := x4 ;
                     zHCp[zHCpN-1].y := y4 ;
                     crpf := True ;
                  end
                  else begin
                     crpf := False ;
                  end;
               end;
               j := 0;
            end;
         end;
         Inc(i);
      end;
      Inc(i);
   end;
   Result := zHCpN ;
   crp := nil ;
end;

// nb`O(`)@nb`O̎Zo
//    s : nb`O
// (ret)
//    zHLn, zHLnN
procedure TDataClass.MakeHatch1(s:string) ;
var
   h,i,j,k : integer ;
   wx1,wy1,wx2,wy2 : double ;
   tl,tx,ty,ts,ta : double ;
   col,ltp,wid : integer ;
begin
   DataClearHLn ;
   h := HatchNameCheck(s);
   if (h = 0) then exit ;
   // min,max擾
   with zHAr[0] do begin
      wx1 := a[0].x ;
      wy1 := a[0].y ;
      wx2 := wx1;
      wy2 := wy1;
      for i:=1 to an-1 do begin
         if (wx1 > a[i].x) then wx1 := a[i].x ;
         if (wy1 > a[i].y) then wy1 := a[i].y ;
         if (wx2 < a[i].x) then wx2 := a[i].x ;
         if (wy2 < a[i].y) then wy2 := a[i].y ;
      end;
   end;
   tl := Dist(wx1,wy1,wx2,wy2);  // Ίp
   tx := (wx1+wx2)/2.0;    // ʉߓ_
   ty := (wy1+wy2)/2.0;
   //
   for k:=0 to (hDef[h-1].hatch1_number-1) do begin
      ts := hDef[h-1].hatch_spacing[k] ;  // nb`OԊu
      ta := hDef[h-1].hatch_angle[k] ;    // nb`Opx
      col:= hDef[h-1].hatch1_color[k] ;
      ltp:= hDef[h-1].hatch_type[k] ;
      wid:= hDef[h-1].hatch_line_width[k] ;
      // ʉߓ_ y ֑
      j  := 1 ;
      wx1:= tx ;
      wy1:= ty ;
      while (j > 0) do begin
         j := CalcHatch1Point(wx1,wy1,tl,ta);  // PC_vZ
         for i:=0 to (j div 2)-1 do begin
            if (zHLnN >= HATCH_LINE_MAX) then break ;    // nb`O̐𐧌iX^bNI[o[t[̃G[oׁj
            try
               Inc(zHLnN);
               if ((zHLnN mod 100) = 1) then SetLength(zHLn, zHLnN+99);    // 100m
               with zHLn[zHLnN-1] do begin
                  Color       := col ;
                  Ltype       := ltp ;
                  line_width  := wid ;
                  x1          := zHCp[i*2  ].x ;
                  y1          := zHCp[i*2  ].y ;
                  x2          := zHCp[i*2+1].x ;
                  y2          := zHCp[i*2+1].y ;
               end;
            except
               Dec(zHLnN);
               break ;
            end;
         end;
         wx1 := wx1 + ts*Cos((ta+90.0)/180.0*Pi);
         wy1 := wy1 + ts*Sin((ta+90.0)/180.0*Pi);
      end;
      // ֑
      wx1:= tx ;
      wy1:= ty ;
      j  := 1 ;
      while (j > 0) do begin
         wx1 := wx1 + ts*Cos((ta-90.0)/180.0*Pi);
         wy1 := wy1 + ts*Sin((ta-90.0)/180.0*Pi);
         j := CalcHatch1Point(wx1,wy1,tl,ta);  // PC_vZ
         for i:=0 to (j div 2)-1 do begin
            if (zHLnN >= HATCH_LINE_MAX) then break ;    // nb`O̐𐧌iX^bNI[o[t[̃G[oׁj
            try
               Inc(zHLnN);
               if ((zHLnN mod 100) = 1) then SetLength(zHLn, zHLnN+99);    // 100m
               with zHLn[zHLnN-1] do begin
                  Color       := col ;
                  Ltype       := ltp ;
                  line_width  := wid ;
                  x1          := zHCp[i*2  ].x ;
                  y1          := zHCp[i*2  ].y ;
                  x2          := zHCp[i*2+1].x ;
                  y2          := zHCp[i*2+1].y ;
               end;
            except
               Dec(zHLnN);
               break ;
            end;
         end;
      end;
   end;
   SetLength(zHLn, zHLnN);
   zHCp := nil;
   zHCpN:= 0;
end;

// nb`O([U`)@nb`O̎Zo
//    hnum : nb`Õp^[
//@@hcol : FR[h
//@@hltp : R[h
//@@hwid : R[h
//@@hx   : ʉߓ_wW
//@@hy   : ʉߓ_xW
//@@hs   : Ԋu
//@@ha   : px[]
// (ret)
//    zHLn, zHLnN
procedure TDataClass.MakeHatch3(hnum:integer;hcol,hltp,hwid:array of integer;hx,hy,hs,ha:array of double) ;
var
   i,j,k : integer ;
   w1,w2,wx1,wy1,wx2,wy2,wx3,wy3 : double ;
   tl,cx,cy,tx,ty,ts,ta : double ;
   col,ltp,wid : integer ;
begin
   DataClearHLn ;
   // min,max擾
   with zHAr[0] do begin
      wx1 := a[0].x ;
      wy1 := a[0].y ;
      wx2 := wx1;
      wy2 := wy1;
      for i:=1 to an-1 do begin
         if (wx1 > a[i].x) then wx1 := a[i].x ;
         if (wy1 > a[i].y) then wy1 := a[i].y ;
         if (wx2 < a[i].x) then wx2 := a[i].x ;
         if (wy2 < a[i].y) then wy2 := a[i].y ;
      end;
   end;
   tl := 10000.0*Dist(wx1,wy1,wx2,wy2);   // Ίpiꂽʉߓ_w肵ꍇłΉo悤ɑ傫߂Ɏw肷j
   cx := (wx1+wx2)/2.0;    // ΊpS_
   cy := (wy1+wy2)/2.0;
   //
   for k:=0 to (hnum-1) do begin
      tx := hx[k];   // ʉߓ_
      ty := hy[k];
      ts := hs[k];   // nb`OԊu
      ta := ha[k];   // nb`Opx
      col:= hcol[k]; // F
      ltp:= hltp[k]; // 
      wid:= hwid[k]; // 
      // ʉߓ_nb`ÖOɂꍇɑΉ邽߂̏
      wx1:= cx + 10.0*Cos(ta/180.0*Pi);
      wy1:= cy + 10.0*Sin(ta/180.0*Pi);
      wx2:= cx - 10.0*Cos(ta/180.0*Pi);
      wy2:= cy - 10.0*Sin(ta/180.0*Pi);
      w1 := GetCrossLP(wx1,wy1,wx2,wy2,tx,ty, wx3,wy3);
      w2 := Angle(wx3-tx,wy3-ty);
      tx := tx + Int(w1/ts)*ts * Cos(w2) ;
      ty := ty + Int(w1/ts)*ts * Sin(w2) ;
      // ʉߓ_ y ֑
      j  := 1 ;
      wx1:= tx ;
      wy1:= ty ;
      while (j > 0) do begin
         j := CalcHatch1Point(wx1,wy1,tl,ta);  // PC_vZ
         for i:=0 to (j div 2)-1 do begin
            if (zHLnN >= HATCH_LINE_MAX) then break ;    // nb`O̐𐧌iX^bNI[o[t[̃G[oׁj
            try
               Inc(zHLnN);
               if ((zHLnN mod 100) = 1) then SetLength(zHLn, zHLnN+99);    // 100m
               with zHLn[zHLnN-1] do begin
                  Color       := col ;
                  Ltype       := ltp ;
                  line_width  := wid ;
                  x1          := zHCp[i*2  ].x ;
                  y1          := zHCp[i*2  ].y ;
                  x2          := zHCp[i*2+1].x ;
                  y2          := zHCp[i*2+1].y ;
               end;
            except
               Dec(zHLnN);
               break ;
            end;
         end;
         wx1 := wx1 + ts*Cos((ta+90.0)/180.0*Pi);
         wy1 := wy1 + ts*Sin((ta+90.0)/180.0*Pi);
      end;
      // ֑
      wx1:= tx ;
      wy1:= ty ;
      j  := 1 ;
      while (j > 0) do begin
         wx1 := wx1 + ts*Cos((ta-90.0)/180.0*Pi);
         wy1 := wy1 + ts*Sin((ta-90.0)/180.0*Pi);
         j := CalcHatch1Point(wx1,wy1,tl,ta);  // PC_vZ
         for i:=0 to (j div 2)-1 do begin
            if (zHLnN >= HATCH_LINE_MAX) then break ;    // nb`O̐𐧌iX^bNI[o[t[̃G[oׁj
            try
               Inc(zHLnN);
               if ((zHLnN mod 100) = 1) then SetLength(zHLn, zHLnN+99);    // 100m
               with zHLn[zHLnN-1] do begin
                  Color       := col ;
                  Ltype       := ltp ;
                  line_width  := wid ;
                  x1          := zHCp[i*2  ].x ;
                  y1          := zHCp[i*2  ].y ;
                  x2          := zHCp[i*2+1].x ;
                  y2          := zHCp[i*2+1].y ;
               end;
            except
               Dec(zHLnN);
               break ;
            end;
         end;
      end;
   end;
   SetLength(zHLn, zHLnN);
   zHCp := nil;
   zHCpN:= 0;
end;

// nb`O(p^[)@nb`O̎Zo
//    n    : p^[V{}` ԍ(-1`)
//@@col  : FR[h
//    px   : nb`p^[zuʒuwW
//    py   : nb`p^[zuʒuxW
//    pv1  : nb`p^[̌JԂxNgP̑傫
//    pv1a : nb`p^[̌JԂxNgP̊px[]
//    pv2  : nb`p^[̌JԂxNgQ̑傫
//    pv2a : nb`p^[̌JԂxNgQ̊px[]
//    psx  : nb`p^[Xړx
//    psy  : nb`p^[Yړx
//    pa   : nb`p^[̌̊px[]
// (ret)
//    zHLn, zHLnN
procedure TDataClass.MakeHatch4(n,col:integer; px,py,pv1,pv1a,pv2,pv2a,psx,psy,pa:double) ;
var
   tr,tr1 : TMatrix ;
   i,o,o1,o2,dn : integer ;
   wx1,wy1,wx2,wy2 : double ;
   n1,n2,w1,w2,w3,w4,w5,w6,lx1,ly1,lx2,ly2 : double ;
   ltp,wid : integer ;
begin
   DataClearHLn ;
   if (n >= 0) then exit;
   // min,max擾
   with zHAr[0] do begin
      wx1 := a[0].x ;
      wy1 := a[0].y ;
      wx2 := wx1;
      wy2 := wy1;
      for i:=1 to an-1 do begin
         if (wx1 > a[i].x) then wx1 := a[i].x ;
         if (wy1 > a[i].y) then wy1 := a[i].y ;
         if (wx2 < a[i].x) then wx2 := a[i].x ;
         if (wy2 < a[i].y) then wy2 := a[i].y ;
      end;
   end;
   //
   w5 := pv1a/180.0*Pi ;
   w6 := pv2a/180.0*Pi ;
   w1 := pv2*Cos(w6-w5);
   w2 := pv2*Sin(w6-w5);
   w3 := pv1*Cos(w5-w6);
   w4 := pv1*Sin(w5-w6);
   //
   // ϊs쐬
   MtxScale(tr, psx,psy);
   MtxRotD(tr1, pa);
   tr := MtxMult(tr,tr1) ;
   MtxMove(tr1, px,py) ;
   tr := MtxMult(tr,tr1) ;
   //
   ltp := 0 ;
   wid := 0 ;
   with sDef[-n-1] do begin
      dn := datn ;
   end;
   with sDefD[dn] do begin
      for o:=0 to mOrdN-1 do begin
         o1 := mOrd[o].DataType ;
         o2 := mOrd[o].DataNo ;
         case (o1) of
         1: begin
               // _}[JEf[^
               with mTen[o2] do begin
                  ltp := 0 ;
                  wid := 0 ;
                  TransTenMarkerToLines(marker_code,start_x,start_y,rotate_angle,Scale,tr);
               end;
            end;
         2: begin
               // f[^
               with mLin[o2] do begin
                  ltp := Ltype ;
                  wid := line_width ;
                  MtxXY(lx1,ly1, start_x,start_y, tr);
                  MtxXY(lx2,ly2, end_x  ,end_y  , tr);
               end;
               MakeHatch4sub(col,ltp,wid, lx1,ly1,lx2,ly2,
                  wx1,wy1,wx2,wy2, pv1,w5,pv2,w6,w2,w4) ;
            end;
         3: begin
               // ܐf[^
               with mLns[o2] do begin
                  ltp := Ltype ;
                  wid := line_width ;
                  TransLinesToLines(Number,X,Y,tr);   // ܐA(tLns,tLnsN)
               end;
            end;
         4: begin
               // ~f[^
               with mCir[o2] do begin
                  ltp := Ltype ;
                  wid := line_width ;
                  TransCircleToLines(sep,Center_x,Center_y,Radius,tr);  // ~A(tLns,tLnsN)
               end;
            end;
         5: begin
               // ~ʃf[^
               with mArc[o2] do begin
                  ltp := Ltype ;
                  wid := line_width ;
                  TransArcToLines(sep,Direction,Center_x,Center_y,Radius,
                     start_angle,end_angle,tr);   // ~ʁA(tLns,tLnsN)
               end;
            end;
         6: begin
               // ȉ~f[^
               with mEll[o2] do begin
                  ltp := Ltype ;
                  wid := line_width ;
                  TransEllipseToLines(sep,Center_x,Center_y,Radius_x,Radius_y,
                     rotation_angle,tr);     // ȉ~A(tLns,tLnsN)
               end;
            end;
         7: begin
               // ȉ~ʃf[^
               with mEAr[o2] do begin
                  ltp := Ltype ;
                  wid := line_width ;
                  TransEllipseArcToLines(sep,Direction,Center_x,Center_y,
                     Radius_x,Radius_y,rotation_angle,start_angle,end_angle,tr); // ȉ~ʁA(tLns,tLnsN)
               end;
            end;
         9: begin
               // xWFȐf[^
               with mBez[o2] do begin
                  ltp := Ltype ;
                  wid := line_width ;
                  TransBezierToLines(sep,Number,X,Y,tr);    // xWFȐA(tLns,tLnsN)
               end;
            end;
         10:begin
               // aXvCȐf[^
               with mBsp[o2] do begin
                  ltp := Ltype ;
                  wid := line_width ;
                  TransBsplineToLines(open_close,sep,Number,X,Y,tr); // aXvCȐA(tLns,tLnsN)
               end;
            end;
         11:begin
               // XvCȐf[^
               with mSpl[o2] do begin
                  ltp := Ltype ;
                  wid := line_width ;
                  TransSplineToLines(Stype,open_close,sep,Number,Aval,X,Y,tr);   // XvCȐA(tLns,tLnsN)
               end;
            end;
         12:begin
               // N\ChȐf[^
               with mClo[o2] do begin
                  ltp := Ltype ;
                  wid := line_width ;
                  TransClothoidToLines(Direction,sep, base_x,base_y,Aval,
                     Angle,start_length,end_length,tr);     // N\ChȐA(tLns,tLnsN)
               end;
            end;
         13:begin
               // f[^
               with mArw[o2] do begin
                  ltp := 0 ;
                  wid := 0 ;
                  TransArrowToLines(arrow_code,start_x,start_y,rotate_angle,Scale,tr);
               end;
            end;
         end;
         if (o1 >= 3)and(o1 <= 7)or(o1 >= 9)and(o1 <= 13) then begin
            if (tLnsN > 0) then begin
               for i:=0 to tLnsN-2 do begin
                  MakeHatch4sub(col,ltp,wid, tLns[i].x,tLns[i].y, tLns[i+1].x,tLns[i+1].y,
                     wx1,wy1,wx2,wy2, pv1,w5,pv2,w6,w2,w4) ;
               end;
            end;
            TransLnsClear ;   // Af[^NA
         end
         else if (o1 = 1) then begin
            if (tLnsN > 0) then begin
               for i:=0 to ((tLnsN div 2)-1) do begin
                  MakeHatch4sub(col,ltp,wid, tLns[i*2].x,tLns[i*2].y, tLns[i*2+1].x,tLns[i*2+1].y,
                     wx1,wy1,wx2,wy2, pv1,w5,pv2,w6,w2,w4) ;
               end;
            end;
            TransLnsClear ;   // Af[^NA
         end;
      end;
   end;
   SetLength(zHLn, zHLnN);
   zHCp := nil;
   zHCpN:= 0;
end;

// nb`O(p^[)@nb`O̎Zo Tu
procedure TDataClass.MakeHatch4sub(col,ltp,wid:integer; lx1,ly1,lx2,ly2,
   wx1,wy1,wx2,wy2, pv1,pv1an,pv2,pv2an,py1,py2:double) ;
var
   cx,cy,tl,lxc,lyc,w1,w2,w3,w4,w5,w6,w7,w8,n1,n2 : double ;
   f1,f2 : Boolean ;
   nn1,nn2,i,j : integer ;
begin
   cx := (wx1+wx2)/2.0;    // ΊpS_
   cy := (wy1+wy2)/2.0;
   lxc:= (lx1+lx2)/2.0;    // S_
   lyc:= (ly1+ly2)/2.0;
   Rev(w1,w2, cx,cy, lxc,lyc, -pv1an);
   if (Abs(py1) > LIMIT8) then
      n2 := Int( (w2-lyc)/py1 )
   else
      n2 := 0.0;
   Rev(w1,w2, cx,cy, lxc,lyc, -pv2an);
   if (Abs(py2) > LIMIT8) then
      n1 := Int( (w2-lyc)/py2 )
   else
      n1 := 0.0;
   lx1 := lx1 + pv2*n2*Cos(pv2an) + pv1*n1*Cos(pv1an);
   ly1 := ly1 + pv2*n2*Sin(pv2an) + pv1*n1*Sin(pv1an);
   lx2 := lx2 + pv2*n2*Cos(pv2an) + pv1*n1*Cos(pv1an);
   ly2 := ly2 + pv2*n2*Sin(pv2an) + pv1*n1*Sin(pv1an);
   lxc := (lx1+lx2)/2.0;    // S_
   lyc := (ly1+ly2)/2.0;

   wx1 := wx1 - Abs(lx2-lx1) ;
   wy1 := wy1 - Abs(ly2-ly1) ;
   wx2 := wx2 + Abs(lx2-lx1) ;
   wy2 := wy2 + Abs(ly2-ly1) ;
   tl := Dist(wx1,wy1,wx2,wy2);  // Ίp

   nn2 := 0 ;
   f1  := True ;
   while (f1) do begin
      nn1 := 0 ;
      f2  := True ;
      while (f2) do begin
         w1 := lxc + pv2*nn2*Cos(pv2an) + pv1*nn1*Cos(pv1an) ;
         w2 := lyc + pv2*nn2*Sin(pv2an) + pv1*nn1*Sin(pv1an) ;
         w3 := dAngle(lx2-lx1,ly2-ly1);
         j  := CalcHatch1Point(w1,w2,tl,w3);  // PC_vZ
         w5 := w1 - Abs(lx2-lx1)/2.0 ;
         w6 := w2 - Abs(ly2-ly1)/2.0 ;
         w7 := w1 + Abs(lx2-lx1)/2.0 ;
         w8 := w2 + Abs(ly2-ly1)/2.0 ;
         if (Abs(w5-w7) < LIMIT10) then begin
            w5 := w5 - LIMIT10 ;
            w7 := w7 + LIMIT10 ;
         end;
         if (Abs(w6-w8) < LIMIT10) then begin
            w6 := w6 - LIMIT10 ;
            w8 := w8 + LIMIT10 ;
         end;
         for i:=0 to (j div 2)-1 do begin
            w1 := zHCp[i*2  ].x ;
            w2 := zHCp[i*2  ].y ;
            w3 := zHCp[i*2+1].x ;
            w4 := zHCp[i*2+1].y ;
            if (ClipLine(w1,w2,w3,w4, w5,w6,w7,w8) = 2) then continue ;
            if (zHLnN >= HATCH_LINE_MAX) then break ;    // nb`O̐𐧌iX^bNI[o[t[̃G[oׁj
            try
               Inc(zHLnN);
               if ((zHLnN mod 100) = 1) then SetLength(zHLn, zHLnN+99);    // 100m
               with zHLn[zHLnN-1] do begin
                  Color       := col ;
                  Ltype       := ltp ;
                  line_width  := wid ;
                  x1          := w1 ;
                  y1          := w2 ;
                  x2          := w3 ;
                  y2          := w4 ;
               end;
            except
               Dec(zHLnN);
               f1 := False ;
               f2 := False ;
               break ;
            end;
         end;

         if (nn1 >= 0) then
            Inc(nn1)
         else
            Dec(nn1) ;
         w1 := lxc + pv2*nn2*Cos(pv2an) + pv1*nn1*Cos(pv1an) - tl*Cos(pv2an);
         w2 := lyc + pv2*nn2*Sin(pv2an) + pv1*nn1*Sin(pv1an) - tl*Sin(pv2an);
         w3 := lxc + pv2*nn2*Cos(pv2an) + pv1*nn1*Cos(pv1an) + tl*Cos(pv2an);
         w4 := lyc + pv2*nn2*Sin(pv2an) + pv1*nn1*Sin(pv1an) + tl*Sin(pv2an);
         if (ClipPreLine(w1,w2,w3,w4, wx1,wy1,wx2,wy2) = 2) then begin
            if (nn1 >= 0) then
               nn1 := -1
            else
               f2 := False ;
         end;
      end;

      if (nn2 >= 0) then
         Inc(nn2)
      else
         Dec(nn2) ;
      w1 := lxc + pv2*nn2*Cos(pv2an) - tl*Cos(pv1an);
      w2 := lyc + pv2*nn2*Sin(pv2an) - tl*Sin(pv1an);
      w3 := lxc + pv2*nn2*Cos(pv2an) + tl*Cos(pv1an);
      w4 := lyc + pv2*nn2*Sin(pv2an) + tl*Sin(pv1an);
      if (ClipPreLine(w1,w2,w3,w4, wx1,wy1,wx2,wy2) = 2) then begin
         if (nn2 >= 0) then
            nn2 := -1
         else
            f1 := False ;
      end;
   end;
end;

end.
